#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeeexex04/header/ppeeexex04.phasespace.h"
void ppeeexex04_ag_psp_doublereal(int no_ps, int zero, phasespace_set & psi){
  static Logger logger("ppeeexex04_ag_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppeeexex04_ag_psp_240_gg_ememepepddx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  3){ppeeexex04_ag_psp_240_gg_ememepepuux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  4){ppeeexex04_ag_psp_240_gd_ememepepgd(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  5){ppeeexex04_ag_psp_240_gu_ememepepgu(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  6){ppeeexex04_ag_psp_240_gdx_ememepepgdx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  7){ppeeexex04_ag_psp_240_gux_ememepepgux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  8){ppeeexex04_ag_psp_240_dd_ememepepdd(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  9){ppeeexex04_ag_psp_240_du_ememepepdu(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 10){ppeeexex04_ag_psp_240_ds_ememepepds(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 11){ppeeexex04_ag_psp_240_dc_ememepepdc(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 13){ppeeexex04_ag_psp_240_ddx_ememepepgg(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 14){ppeeexex04_ag_psp_240_ddx_ememepepddx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 15){ppeeexex04_ag_psp_240_ddx_ememepepuux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 16){ppeeexex04_ag_psp_240_ddx_ememepepssx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 17){ppeeexex04_ag_psp_240_ddx_ememepepccx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 18){ppeeexex04_ag_psp_240_dux_ememepepdux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 20){ppeeexex04_ag_psp_240_dsx_ememepepdsx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 22){ppeeexex04_ag_psp_240_dcx_ememepepdcx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 23){ppeeexex04_ag_psp_240_uu_ememepepuu(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 24){ppeeexex04_ag_psp_240_uc_ememepepuc(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 25){ppeeexex04_ag_psp_240_udx_ememepepudx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 27){ppeeexex04_ag_psp_240_uux_ememepepgg(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 28){ppeeexex04_ag_psp_240_uux_ememepepddx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 29){ppeeexex04_ag_psp_240_uux_ememepepuux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 30){ppeeexex04_ag_psp_240_uux_ememepepssx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 31){ppeeexex04_ag_psp_240_uux_ememepepccx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 32){ppeeexex04_ag_psp_240_usx_ememepepusx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 34){ppeeexex04_ag_psp_240_ucx_ememepepucx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 35){ppeeexex04_ag_psp_240_dxdx_ememepepdxdx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 36){ppeeexex04_ag_psp_240_dxux_ememepepdxux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 37){ppeeexex04_ag_psp_240_dxsx_ememepepdxsx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 38){ppeeexex04_ag_psp_240_dxcx_ememepepdxcx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 40){ppeeexex04_ag_psp_240_uxux_ememepepuxux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 41){ppeeexex04_ag_psp_240_uxcx_ememepepuxcx(no_ps, zero, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
