#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeeexnex04/header/ppeeexnex04.phasespace.h"
void ppeeexnex04_ax_psp_240_dux_ememepvexssx(int no_ps, phasespace_set & psi){
  static Logger logger("ppeeexnex04_ax_psp_240_dux_ememepvexssx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(28);
  psi_needed_v_smin[no_ps].resize(28);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,    6,   16,   17,   20,   21,   22,   32,   33,   34,   35,   36,   37,   40,   41,   42,   43,   44,   45,   58,   59,   60,   61,   62,   63}; //  30
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 30);
  int needed_v_smin_1[] = {   0,    1,   32,   33}; //   4
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   0,    1,   32,   33}; //   4
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 4);
  int needed_v_smin_3[] = {   0,    1,    2,    3,   15,   16,   17,   31,   32,   33,   34,   35,   36,   37,   40,   41,   42,   43,   44,   45,   58,   59,   60,   61,   62,   63}; //  26
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 26);
  int needed_v_smin_4[] = {   2,    3,   34,   35}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {   2,    3,   34,   35}; //   4
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 4);
  int needed_v_smin_6[] = {   4,   20}; //   2
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 2);
  int needed_v_smin_7[] = {   4,    7,   20,   23}; //   4
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 4);
  int needed_v_smin_8[] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 48);
  int needed_v_smin_9[] = {   5,    6,   21,   22}; //   4
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 4);
  int needed_v_smin_10[] = {   5,    6,   13,   14,   21,   22,   29,   30}; //   8
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 8);
  int needed_v_smin_11[] = {   7,    8,    9,   10,   11,   18,   19,   23,   24,   25,   26,   27,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57}; //  26
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 26);
  int needed_v_smin_12[] = {   7,   23}; //   2
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 2);
  int needed_v_smin_13[] = {   8,    9,   10,   11,   12,   13,   14,   18,   19,   24,   25,   26,   27,   28,   29,   30,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57}; //  30
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 30);
  int needed_v_smin_14[] = {   8,    9,   24,   25}; //   4
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 4);
  int needed_v_smin_15[] = {   8,    9,   24,   25}; //   4
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 4);
  int needed_v_smin_16[] = {  10,   11,   26,   27}; //   4
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 4);
  int needed_v_smin_17[] = {  10,   11,   26,   27}; //   4
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 4);
  int needed_v_smin_18[] = {  12,   28}; //   2
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 2);
  int needed_v_smin_19[] = {  12,   15,   28,   31}; //   4
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 4);
  int needed_v_smin_20[] = {  13,   14,   29,   30}; //   4
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 4);
  int needed_v_smin_21[] = {  15,   31}; //   2
  psi_needed_v_smin[no_ps][ 21] = get_vector_from_array_int(needed_v_smin_21, 2);
  int needed_v_smin_22[] = {  16,   17,   36,   37,   44,   45,   62,   63}; //   8
  psi_needed_v_smin[no_ps][ 22] = get_vector_from_array_int(needed_v_smin_22, 8);
  int needed_v_smin_23[] = {  18,   19,   38,   39,   50,   51,   56,   57}; //   8
  psi_needed_v_smin[no_ps][ 23] = get_vector_from_array_int(needed_v_smin_23, 8);
  int needed_v_smin_24[] = {  40,   41,   42,   43}; //   4
  psi_needed_v_smin[no_ps][ 24] = get_vector_from_array_int(needed_v_smin_24, 4);
  int needed_v_smin_25[] = {  46,   47,   48,   49}; //   4
  psi_needed_v_smin[no_ps][ 25] = get_vector_from_array_int(needed_v_smin_25, 4);
  int needed_v_smin_26[] = {  52,   53,   54,   55}; //   4
  psi_needed_v_smin[no_ps][ 26] = get_vector_from_array_int(needed_v_smin_26, 4);
  int needed_v_smin_27[] = {  58,   59,   60,   61}; //   4
  psi_needed_v_smin[no_ps][ 27] = get_vector_from_array_int(needed_v_smin_27, 4);

  psi_v_smax[no_ps].resize(48);
  psi_needed_v_smax[no_ps].resize(48);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,    6,   16,   17,   42,   43,   44,   45}; //  13
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 13);
  int needed_v_smax_1[] = {   0,    1}; //   2
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 2);
  int needed_v_smax_2[] = {   0,    1,    2,    3}; //   4
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 4);
  int needed_v_smax_3[] = {   0,    1,    2,    3}; //   4
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 4);
  int needed_v_smax_4[] = {   2,    3}; //   2
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 2);
  int needed_v_smax_5[] = {   4,    7}; //   2
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 2);
  int needed_v_smax_6[] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19}; //  12
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 12);
  int needed_v_smax_7[] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19}; //  12
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 12);
  int needed_v_smax_8[] = {   5,    6,   13,   14}; //   4
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 4);
  int needed_v_smax_9[] = {   7,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51}; //  11
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 11);
  int needed_v_smax_10[] = {   8,    9,   10,   11,   12,   13,   14,   54,   55,   56,   57}; //  11
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 11);
  int needed_v_smax_11[] = {   8,    9}; //   2
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 2);
  int needed_v_smax_12[] = {   8,    9,   10,   11}; //   4
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 4);
  int needed_v_smax_13[] = {   8,    9,   10,   11}; //   4
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 4);
  int needed_v_smax_14[] = {  10,   11}; //   2
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 2);
  int needed_v_smax_15[] = {  12,   15}; //   2
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 2);
  int needed_v_smax_16[] = {  15,   32,   33,   34,   35,   60,   61,   62,   63}; //   9
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 9);
  int needed_v_smax_17[] = {  16,   17,   44,   45}; //   4
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 4);
  int needed_v_smax_18[] = {  18,   19,   24,   25,   26,   27,   50,   51}; //   8
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 8);
  int needed_v_smax_19[] = {  20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   40,   41,   46,   47,   52,   53,   58,   59}; //  20
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 20);
  int needed_v_smax_20[] = {  20,   21,   22,   36,   37,   40,   41}; //   7
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 7);
  int needed_v_smax_21[] = {  20,   23}; //   2
  psi_needed_v_smax[no_ps][ 21] = get_vector_from_array_int(needed_v_smax_21, 2);
  int needed_v_smax_22[] = {  20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   44,   45,   50,   51,   56,   57,   62,   63}; //  20
  psi_needed_v_smax[no_ps][ 22] = get_vector_from_array_int(needed_v_smax_22, 20);
  int needed_v_smax_23[] = {  21,   22,   29,   30}; //   4
  psi_needed_v_smax[no_ps][ 23] = get_vector_from_array_int(needed_v_smax_23, 4);
  int needed_v_smax_24[] = {  23,   38,   39,   46,   47}; //   5
  psi_needed_v_smax[no_ps][ 24] = get_vector_from_array_int(needed_v_smax_24, 5);
  int needed_v_smax_25[] = {  24,   25}; //   2
  psi_needed_v_smax[no_ps][ 25] = get_vector_from_array_int(needed_v_smax_25, 2);
  int needed_v_smax_26[] = {  24,   25,   26,   27,   52,   53,   54,   55}; //   8
  psi_needed_v_smax[no_ps][ 26] = get_vector_from_array_int(needed_v_smax_26, 8);
  int needed_v_smax_27[] = {  26,   27}; //   2
  psi_needed_v_smax[no_ps][ 27] = get_vector_from_array_int(needed_v_smax_27, 2);
  int needed_v_smax_28[] = {  28,   29,   30,   52,   53}; //   5
  psi_needed_v_smax[no_ps][ 28] = get_vector_from_array_int(needed_v_smax_28, 5);
  int needed_v_smax_29[] = {  28,   31}; //   2
  psi_needed_v_smax[no_ps][ 29] = get_vector_from_array_int(needed_v_smax_29, 2);
  int needed_v_smax_30[] = {  31,   58,   59}; //   3
  psi_needed_v_smax[no_ps][ 30] = get_vector_from_array_int(needed_v_smax_30, 3);
  int needed_v_smax_31[] = {  32,   33,   34,   35,   62,   63}; //   6
  psi_needed_v_smax[no_ps][ 31] = get_vector_from_array_int(needed_v_smax_31, 6);
  int needed_v_smax_32[] = {  32,   33}; //   2
  psi_needed_v_smax[no_ps][ 32] = get_vector_from_array_int(needed_v_smax_32, 2);
  int needed_v_smax_33[] = {  32,   33,   34,   35,   40,   41,   42,   43}; //   8
  psi_needed_v_smax[no_ps][ 33] = get_vector_from_array_int(needed_v_smax_33, 8);
  int needed_v_smax_34[] = {  34,   35}; //   2
  psi_needed_v_smax[no_ps][ 34] = get_vector_from_array_int(needed_v_smax_34, 2);
  int needed_v_smax_35[] = {  36,   37,   40,   41,   42,   43}; //   6
  psi_needed_v_smax[no_ps][ 35] = get_vector_from_array_int(needed_v_smax_35, 6);
  int needed_v_smax_36[] = {  38,   39,   46,   47,   48,   49}; //   6
  psi_needed_v_smax[no_ps][ 36] = get_vector_from_array_int(needed_v_smax_36, 6);
  int needed_v_smax_37[] = {  42,   43}; //   2
  psi_needed_v_smax[no_ps][ 37] = get_vector_from_array_int(needed_v_smax_37, 2);
  int needed_v_smax_38[] = {  44,   45,   62,   63}; //   4
  psi_needed_v_smax[no_ps][ 38] = get_vector_from_array_int(needed_v_smax_38, 4);
  int needed_v_smax_39[] = {  48,   49}; //   2
  psi_needed_v_smax[no_ps][ 39] = get_vector_from_array_int(needed_v_smax_39, 2);
  int needed_v_smax_40[] = {  50,   51,   56,   57}; //   4
  psi_needed_v_smax[no_ps][ 40] = get_vector_from_array_int(needed_v_smax_40, 4);
  int needed_v_smax_41[] = {  52,   53,   54,   55}; //   4
  psi_needed_v_smax[no_ps][ 41] = get_vector_from_array_int(needed_v_smax_41, 4);
  int needed_v_smax_42[] = {  54,   55}; //   2
  psi_needed_v_smax[no_ps][ 42] = get_vector_from_array_int(needed_v_smax_42, 2);
  int needed_v_smax_43[] = {  56,   57}; //   2
  psi_needed_v_smax[no_ps][ 43] = get_vector_from_array_int(needed_v_smax_43, 2);
  int needed_v_smax_44[] = {  58,   59,   60,   61}; //   4
  psi_needed_v_smax[no_ps][ 44] = get_vector_from_array_int(needed_v_smax_44, 4);
  int needed_v_smax_45[] = {  60,   61}; //   2
  psi_needed_v_smax[no_ps][ 45] = get_vector_from_array_int(needed_v_smax_45, 2);
  int needed_v_smax_46[] = {  46,   47,   48,   49}; //   4
  psi_needed_v_smax[no_ps][ 46] = get_vector_from_array_int(needed_v_smax_46, 4);
  int needed_v_smax_47[] = {  58,   59,   60,   61}; //   4
  psi_needed_v_smax[no_ps][ 47] = get_vector_from_array_int(needed_v_smax_47, 4);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(72);
  psi_needed_g_p[no_ps].resize(72);
  int needed_g_p_0[] = {   0,    2,    5,   16,   42,   44}; //   6
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 6);
  psi_container_IS_name.push_back("propagator_0_smin0_smax0");
  int needed_g_p_1[] = {   0,    1}; //   2
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    1}; //   2
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 2);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   0,    1,    2,    3}; //   4
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 4);
  psi_container_IS_name.push_back("propagator_24_smin3_smax3");
  int needed_g_p_4[] = {   1,    3,    4,    6,   17,   43,   45}; //   7
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 7);
  psi_container_IS_name.push_back("propagator_23_smin0_smax0");
  int needed_g_p_5[] = {   2,    3}; //   2
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_6[] = {   2,    3}; //   2
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax2");
  int needed_g_p_7[] = {   4}; //   1
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 1);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_8[] = {   4,    7}; //   2
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 2);
  psi_container_IS_name.push_back("propagator_24_smin7_smax6");
  int needed_g_p_9[] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19}; //  12
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 12);
  psi_container_IS_name.push_back("propagator_0_smin8_smax7");
  int needed_g_p_10[] = {   5,    6}; //   2
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 2);
  psi_container_IS_name.push_back("propagator_0_smin9_smax8");
  int needed_g_p_11[] = {   5,    6,   13,   14}; //   4
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 4);
  psi_container_IS_name.push_back("propagator_24_smin10_smax6");
  int needed_g_p_12[] = {   7,   18,   19,   24,   25,   26,   27,   48,   49,   50,   51}; //  11
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 11);
  psi_container_IS_name.push_back("propagator_24_smin11_smax9");
  int needed_g_p_13[] = {   7}; //   1
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 1);
  psi_container_IS_name.push_back("propagator_0_smin12_smax5");
  int needed_g_p_14[] = {   8,   10,   13,   54,   56}; //   5
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 5);
  psi_container_IS_name.push_back("propagator_0_smin13_smax10");
  int needed_g_p_15[] = {   8,    9}; //   2
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 2);
  psi_container_IS_name.push_back("propagator_0_smin14_smax11");
  int needed_g_p_16[] = {   8,    9}; //   2
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 2);
  psi_container_IS_name.push_back("propagator_0_smin15_smax12");
  int needed_g_p_17[] = {   8,    9,   10,   11}; //   4
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 4);
  psi_container_IS_name.push_back("propagator_24_smin11_smax13");
  int needed_g_p_18[] = {   9,   11,   12,   14,   55,   57}; //   6
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 6);
  psi_container_IS_name.push_back("propagator_23_smin13_smax10");
  int needed_g_p_19[] = {  10,   11}; //   2
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 2);
  psi_container_IS_name.push_back("propagator_0_smin16_smax14");
  int needed_g_p_20[] = {  10,   11}; //   2
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 2);
  psi_container_IS_name.push_back("propagator_0_smin17_smax12");
  int needed_g_p_21[] = {  12}; //   1
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 1);
  psi_container_IS_name.push_back("propagator_0_smin18_smax15");
  int needed_g_p_22[] = {  12,   15}; //   2
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 2);
  psi_container_IS_name.push_back("propagator_24_smin19_smax6");
  int needed_g_p_23[] = {  13,   14}; //   2
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 2);
  psi_container_IS_name.push_back("propagator_0_smin20_smax8");
  int needed_g_p_24[] = {  15,   32,   33,   34,   35,   60,   61,   62,   63}; //   9
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 9);
  psi_container_IS_name.push_back("propagator_24_smin3_smax16");
  int needed_g_p_25[] = {  15}; //   1
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 1);
  psi_container_IS_name.push_back("propagator_0_smin21_smax15");
  int needed_g_p_26[] = {  16,   17,   44,   45}; //   4
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 4);
  psi_container_IS_name.push_back("propagator_24_smin3_smax17");
  int needed_g_p_27[] = {  16,   17}; //   2
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 2);
  psi_container_IS_name.push_back("propagator_24_smin22_smax6");
  int needed_g_p_28[] = {  18,   24,   26,   50}; //   4
  psi_needed_g_p[no_ps][28] = get_vector_from_array_int(needed_g_p_28, 4);
  psi_container_IS_name.push_back("propagator_0_smin13_smax18");
  int needed_g_p_29[] = {  18,   19}; //   2
  psi_needed_g_p[no_ps][29] = get_vector_from_array_int(needed_g_p_29, 2);
  psi_container_IS_name.push_back("propagator_24_smin23_smax6");
  int needed_g_p_30[] = {  19,   25,   27,   51}; //   4
  psi_needed_g_p[no_ps][30] = get_vector_from_array_int(needed_g_p_30, 4);
  psi_container_IS_name.push_back("propagator_23_smin13_smax18");
  int needed_g_p_31[] = {  20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   40,   41,   46,   47,   52,   53,   58,   59}; //  20
  psi_needed_g_p[no_ps][31] = get_vector_from_array_int(needed_g_p_31, 20);
  psi_container_IS_name.push_back("propagator_0_smin8_smax19");
  int needed_g_p_32[] = {  20,   22,   37,   41}; //   4
  psi_needed_g_p[no_ps][32] = get_vector_from_array_int(needed_g_p_32, 4);
  psi_container_IS_name.push_back("propagator_23_smin0_smax20");
  int needed_g_p_33[] = {  20}; //   1
  psi_needed_g_p[no_ps][33] = get_vector_from_array_int(needed_g_p_33, 1);
  psi_container_IS_name.push_back("propagator_0_smin6_smax21");
  int needed_g_p_34[] = {  20,   23}; //   2
  psi_needed_g_p[no_ps][34] = get_vector_from_array_int(needed_g_p_34, 2);
  psi_container_IS_name.push_back("propagator_24_smin7_smax22");
  int needed_g_p_35[] = {  21,   36,   40}; //   3
  psi_needed_g_p[no_ps][35] = get_vector_from_array_int(needed_g_p_35, 3);
  psi_container_IS_name.push_back("propagator_0_smin0_smax20");
  int needed_g_p_36[] = {  21,   22}; //   2
  psi_needed_g_p[no_ps][36] = get_vector_from_array_int(needed_g_p_36, 2);
  psi_container_IS_name.push_back("propagator_0_smin9_smax23");
  int needed_g_p_37[] = {  21,   22,   29,   30}; //   4
  psi_needed_g_p[no_ps][37] = get_vector_from_array_int(needed_g_p_37, 4);
  psi_container_IS_name.push_back("propagator_24_smin10_smax22");
  int needed_g_p_38[] = {  23,   38,   39,   46,   47}; //   5
  psi_needed_g_p[no_ps][38] = get_vector_from_array_int(needed_g_p_38, 5);
  psi_container_IS_name.push_back("propagator_24_smin11_smax24");
  int needed_g_p_39[] = {  23}; //   1
  psi_needed_g_p[no_ps][39] = get_vector_from_array_int(needed_g_p_39, 1);
  psi_container_IS_name.push_back("propagator_0_smin12_smax21");
  int needed_g_p_40[] = {  24,   25}; //   2
  psi_needed_g_p[no_ps][40] = get_vector_from_array_int(needed_g_p_40, 2);
  psi_container_IS_name.push_back("propagator_0_smin14_smax25");
  int needed_g_p_41[] = {  24,   25}; //   2
  psi_needed_g_p[no_ps][41] = get_vector_from_array_int(needed_g_p_41, 2);
  psi_container_IS_name.push_back("propagator_0_smin15_smax26");
  int needed_g_p_42[] = {  26,   27}; //   2
  psi_needed_g_p[no_ps][42] = get_vector_from_array_int(needed_g_p_42, 2);
  psi_container_IS_name.push_back("propagator_0_smin16_smax27");
  int needed_g_p_43[] = {  26,   27}; //   2
  psi_needed_g_p[no_ps][43] = get_vector_from_array_int(needed_g_p_43, 2);
  psi_container_IS_name.push_back("propagator_0_smin17_smax26");
  int needed_g_p_44[] = {  28,   30,   53}; //   3
  psi_needed_g_p[no_ps][44] = get_vector_from_array_int(needed_g_p_44, 3);
  psi_container_IS_name.push_back("propagator_23_smin13_smax28");
  int needed_g_p_45[] = {  28}; //   1
  psi_needed_g_p[no_ps][45] = get_vector_from_array_int(needed_g_p_45, 1);
  psi_container_IS_name.push_back("propagator_0_smin18_smax29");
  int needed_g_p_46[] = {  28,   31}; //   2
  psi_needed_g_p[no_ps][46] = get_vector_from_array_int(needed_g_p_46, 2);
  psi_container_IS_name.push_back("propagator_24_smin19_smax22");
  int needed_g_p_47[] = {  29,   52}; //   2
  psi_needed_g_p[no_ps][47] = get_vector_from_array_int(needed_g_p_47, 2);
  psi_container_IS_name.push_back("propagator_0_smin13_smax28");
  int needed_g_p_48[] = {  29,   30}; //   2
  psi_needed_g_p[no_ps][48] = get_vector_from_array_int(needed_g_p_48, 2);
  psi_container_IS_name.push_back("propagator_0_smin20_smax23");
  int needed_g_p_49[] = {  31,   58,   59}; //   3
  psi_needed_g_p[no_ps][49] = get_vector_from_array_int(needed_g_p_49, 3);
  psi_container_IS_name.push_back("propagator_24_smin3_smax30");
  int needed_g_p_50[] = {  31}; //   1
  psi_needed_g_p[no_ps][50] = get_vector_from_array_int(needed_g_p_50, 1);
  psi_container_IS_name.push_back("propagator_0_smin21_smax29");
  int needed_g_p_51[] = {  32,   34,   62}; //   3
  psi_needed_g_p[no_ps][51] = get_vector_from_array_int(needed_g_p_51, 3);
  psi_container_IS_name.push_back("propagator_0_smin0_smax31");
  int needed_g_p_52[] = {  32,   33}; //   2
  psi_needed_g_p[no_ps][52] = get_vector_from_array_int(needed_g_p_52, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax32");
  int needed_g_p_53[] = {  32,   33}; //   2
  psi_needed_g_p[no_ps][53] = get_vector_from_array_int(needed_g_p_53, 2);
  psi_container_IS_name.push_back("propagator_0_smin2_smax33");
  int needed_g_p_54[] = {  33,   35,   63}; //   3
  psi_needed_g_p[no_ps][54] = get_vector_from_array_int(needed_g_p_54, 3);
  psi_container_IS_name.push_back("propagator_23_smin0_smax31");
  int needed_g_p_55[] = {  34,   35}; //   2
  psi_needed_g_p[no_ps][55] = get_vector_from_array_int(needed_g_p_55, 2);
  psi_container_IS_name.push_back("propagator_0_smin4_smax34");
  int needed_g_p_56[] = {  34,   35}; //   2
  psi_needed_g_p[no_ps][56] = get_vector_from_array_int(needed_g_p_56, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax33");
  int needed_g_p_57[] = {  36,   37,   40,   41,   42,   43}; //   6
  psi_needed_g_p[no_ps][57] = get_vector_from_array_int(needed_g_p_57, 6);
  psi_container_IS_name.push_back("propagator_24_smin3_smax35");
  int needed_g_p_58[] = {  36,   37}; //   2
  psi_needed_g_p[no_ps][58] = get_vector_from_array_int(needed_g_p_58, 2);
  psi_container_IS_name.push_back("propagator_24_smin22_smax22");
  int needed_g_p_59[] = {  38,   46,   48}; //   3
  psi_needed_g_p[no_ps][59] = get_vector_from_array_int(needed_g_p_59, 3);
  psi_container_IS_name.push_back("propagator_0_smin13_smax36");
  int needed_g_p_60[] = {  38,   39}; //   2
  psi_needed_g_p[no_ps][60] = get_vector_from_array_int(needed_g_p_60, 2);
  psi_container_IS_name.push_back("propagator_24_smin23_smax22");
  int needed_g_p_61[] = {  39,   47,   49}; //   3
  psi_needed_g_p[no_ps][61] = get_vector_from_array_int(needed_g_p_61, 3);
  psi_container_IS_name.push_back("propagator_23_smin13_smax36");
  int needed_g_p_62[] = {  42,   43}; //   2
  psi_needed_g_p[no_ps][62] = get_vector_from_array_int(needed_g_p_62, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax37");
  int needed_g_p_63[] = {  44,   45,   62,   63}; //   4
  psi_needed_g_p[no_ps][63] = get_vector_from_array_int(needed_g_p_63, 4);
  psi_container_IS_name.push_back("propagator_0_smin8_smax38");
  int needed_g_p_64[] = {  48,   49}; //   2
  psi_needed_g_p[no_ps][64] = get_vector_from_array_int(needed_g_p_64, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax39");
  int needed_g_p_65[] = {  50,   51,   56,   57}; //   4
  psi_needed_g_p[no_ps][65] = get_vector_from_array_int(needed_g_p_65, 4);
  psi_container_IS_name.push_back("propagator_0_smin8_smax40");
  int needed_g_p_66[] = {  52,   53,   54,   55}; //   4
  psi_needed_g_p[no_ps][66] = get_vector_from_array_int(needed_g_p_66, 4);
  psi_container_IS_name.push_back("propagator_24_smin11_smax41");
  int needed_g_p_67[] = {  54,   55}; //   2
  psi_needed_g_p[no_ps][67] = get_vector_from_array_int(needed_g_p_67, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax42");
  int needed_g_p_68[] = {  56,   57}; //   2
  psi_needed_g_p[no_ps][68] = get_vector_from_array_int(needed_g_p_68, 2);
  psi_container_IS_name.push_back("propagator_24_smin11_smax43");
  int needed_g_p_69[] = {  58,   60}; //   2
  psi_needed_g_p[no_ps][69] = get_vector_from_array_int(needed_g_p_69, 2);
  psi_container_IS_name.push_back("propagator_0_smin0_smax44");
  int needed_g_p_70[] = {  59,   61}; //   2
  psi_needed_g_p[no_ps][70] = get_vector_from_array_int(needed_g_p_70, 2);
  psi_container_IS_name.push_back("propagator_23_smin0_smax44");
  int needed_g_p_71[] = {  60,   61}; //   2
  psi_needed_g_p[no_ps][71] = get_vector_from_array_int(needed_g_p_71, 2);
  psi_container_IS_name.push_back("propagator_0_smin8_smax45");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(6);
  psi_needed_g_f[no_ps].resize(6);
  int needed_g_f_0[] = {  40,   41,   42,   43}; //   4
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin24_smax33");
  int needed_g_f_1[] = {  44,   45,   62,   63}; //   4
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin22_smax22");
  int needed_g_f_2[] = {  46,   47,   48,   49}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin25_smax46");
  int needed_g_f_3[] = {  50,   51,   56,   57}; //   4
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin23_smax22");
  int needed_g_f_4[] = {  52,   53,   54,   55}; //   4
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin26_smax26");
  int needed_g_f_5[] = {  58,   59,   60,   61}; //   4
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin27_smax47");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(20);
  psi_needed_g_t[no_ps].resize(20);
  int needed_g_t_0[] = {   0,    1,    2,    3,   40,   41,   42,   43}; //   8
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__36_216");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__36_216");
  int needed_g_t_1[] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19,   44,   45,   50,   51,   56,   57,   62,   63}; //  20
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 20);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__192_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__192_60");
  int needed_g_t_2[] = {   8,    9,   10,   11,   52,   53,   54,   55}; //   8
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__40_212");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__40_212");
  int needed_g_t_3[] = {  20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39}; //  12
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 12);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__192_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__192_60");
  int needed_g_t_4[] = {  24,   25,   26,   27}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__40_212");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__40_212");
  int needed_g_t_5[] = {  32,   33,   34,   35}; //   4
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__36_216");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__36_216");
  int needed_g_t_6[] = {  40,   41}; //   2
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_37__192_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_37__192_24");
  int needed_g_t_7[] = {  42,   43}; //   2
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_37__24_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_37__24_192");
  int needed_g_t_8[] = {  44,   45}; //   2
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__24_36");
  int needed_g_t_9[] = {  46,   47,   48,   49}; //   4
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__20_232");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__20_232");
  int needed_g_t_10[] = {  46,   47}; //   2
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_21__192_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_21__192_40");
  int needed_g_t_11[] = {  48,   49}; //   2
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_21__40_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_21__40_192");
  int needed_g_t_12[] = {  50,   51}; //   2
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__40_20");
  int needed_g_t_13[] = {  52,   53}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__192_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__192_20");
  int needed_g_t_14[] = {  54,   55}; //   2
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__20_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__20_192");
  int needed_g_t_15[] = {  56,   57}; //   2
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__20_40");
  int needed_g_t_16[] = {  58,   59,   60,   61}; //   4
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__24_228");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__24_228");
  int needed_g_t_17[] = {  58,   59}; //   2
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_25__192_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_25__192_36");
  int needed_g_t_18[] = {  60,   61}; //   2
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_25__36_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_25__36_192");
  int needed_g_t_19[] = {  62,   63}; //   2
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__36_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__36_24");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(24);
  psi_needed_g_d[no_ps].resize(24);
  int needed_g_d_0[] = {   0,    1,    2,    3,   15,   16,   17,   31,   32,   33,   34,   35,   36,   37,   40,   41,   42,   43,   44,   45,   58,   59,   60,   61,   62,   63}; //  26
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 26);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");
  int needed_g_d_1[] = {   0,    1,   32,   33}; //   4
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 4);
  psi_container_IS_name.push_back("costheta_of_decay_216__64_152");
  psi_container_IS_name.push_back("phi_of_decay_216__64_152");
  int needed_g_d_2[] = {   0,    1,   32,   33}; //   4
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 4);
  psi_container_IS_name.push_back("costheta_of_decay_152__128_24");
  psi_container_IS_name.push_back("phi_of_decay_152__128_24");
  int needed_g_d_3[] = {   0,    1,    2,    3,    4,    5,    6,   16,   17,   20,   21,   22,   32,   33,   34,   35,   36,   37,   40,   41,   42,   43,   44,   45,   58,   59,   60,   61,   62,   63}; //  30
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 30);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_4[] = {   2,    3,   34,   35}; //   4
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 4);
  psi_container_IS_name.push_back("costheta_of_decay_216__128_88");
  psi_container_IS_name.push_back("phi_of_decay_216__128_88");
  int needed_g_d_5[] = {   2,    3,   34,   35}; //   4
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 4);
  psi_container_IS_name.push_back("costheta_of_decay_88__64_24");
  psi_container_IS_name.push_back("phi_of_decay_88__64_24");
  int needed_g_d_6[] = {   4,    5,    6,    7,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   28,   29,   30,   31,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63}; //  48
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 48);
  psi_container_IS_name.push_back("costheta_of_decay_192__64_128");
  psi_container_IS_name.push_back("phi_of_decay_192__64_128");
  int needed_g_d_7[] = {   4,    7,   20,   23}; //   4
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_8[] = {   4,   20}; //   2
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 2);
  psi_container_IS_name.push_back("costheta_of_decay_56__32_24");
  psi_container_IS_name.push_back("phi_of_decay_56__32_24");
  int needed_g_d_9[] = {   5,    6,   13,   14,   21,   22,   29,   30}; //   8
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_10[] = {   5,    6,   21,   22}; //   4
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_11[] = {   7,   23}; //   2
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 2);
  psi_container_IS_name.push_back("costheta_of_decay_56__16_40");
  psi_container_IS_name.push_back("phi_of_decay_56__16_40");
  int needed_g_d_12[] = {   7,    8,    9,   10,   11,   18,   19,   23,   24,   25,   26,   27,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57}; //  26
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 26);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_13[] = {   8,    9,   24,   25}; //   4
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 4);
  psi_container_IS_name.push_back("costheta_of_decay_212__64_148");
  psi_container_IS_name.push_back("phi_of_decay_212__64_148");
  int needed_g_d_14[] = {   8,    9,   24,   25}; //   4
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 4);
  psi_container_IS_name.push_back("costheta_of_decay_148__128_20");
  psi_container_IS_name.push_back("phi_of_decay_148__128_20");
  int needed_g_d_15[] = {   8,    9,   10,   11,   12,   13,   14,   18,   19,   24,   25,   26,   27,   28,   29,   30,   38,   39,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57}; //  30
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 30);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_16[] = {  10,   11,   26,   27}; //   4
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 4);
  psi_container_IS_name.push_back("costheta_of_decay_212__128_84");
  psi_container_IS_name.push_back("phi_of_decay_212__128_84");
  int needed_g_d_17[] = {  10,   11,   26,   27}; //   4
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 4);
  psi_container_IS_name.push_back("costheta_of_decay_84__64_20");
  psi_container_IS_name.push_back("phi_of_decay_84__64_20");
  int needed_g_d_18[] = {  12,   15,   28,   31}; //   4
  psi_needed_g_d[no_ps][18] = get_vector_from_array_int(needed_g_d_18, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_19[] = {  12,   28}; //   2
  psi_needed_g_d[no_ps][19] = get_vector_from_array_int(needed_g_d_19, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__32_20");
  psi_container_IS_name.push_back("phi_of_decay_52__32_20");
  int needed_g_d_20[] = {  13,   14,   29,   30}; //   4
  psi_needed_g_d[no_ps][20] = get_vector_from_array_int(needed_g_d_20, 4);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_21[] = {  15,   31}; //   2
  psi_needed_g_d[no_ps][21] = get_vector_from_array_int(needed_g_d_21, 2);
  psi_container_IS_name.push_back("costheta_of_decay_52__16_36");
  psi_container_IS_name.push_back("phi_of_decay_52__16_36");
  int needed_g_d_22[] = {  16,   17,   36,   37}; //   4
  psi_needed_g_d[no_ps][22] = get_vector_from_array_int(needed_g_d_22, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__36_24");
  psi_container_IS_name.push_back("phi_of_decay_60__36_24");
  int needed_g_d_23[] = {  18,   19,   38,   39}; //   4
  psi_needed_g_d[no_ps][23] = get_vector_from_array_int(needed_g_d_23, 4);
  psi_container_IS_name.push_back("costheta_of_decay_60__20_40");
  psi_container_IS_name.push_back("phi_of_decay_60__20_40");

  psi_c_p[no_ps].resize(64);
  psi_c_f[no_ps].resize(64);
  psi_c_t[no_ps].resize(64);
  psi_c_d[no_ps].resize(64);

  int c_p_0[] = {  0,   1,   2,   3}; //   4
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 4);
  int c_f_0[] = {}; //   0
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 0);
  int c_t_0[] = {  0}; //   1
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 1);
  int c_d_0[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 4);

  int c_p_1[] = {  4,   1,   2,   3}; //   4
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 4);
  int c_f_1[] = {}; //   0
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 0);
  int c_t_1[] = {  0}; //   1
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 1);
  int c_d_1[] = {  0,   1,   2,   3}; //   4
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 4);

  int c_p_2[] = {  0,   5,   6,   3}; //   4
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 4);
  int c_f_2[] = {}; //   0
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 0);
  int c_t_2[] = {  0}; //   1
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 1);
  int c_d_2[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 4);

  int c_p_3[] = {  4,   5,   6,   3}; //   4
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 4);
  int c_f_3[] = {}; //   0
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 0);
  int c_t_3[] = {  0}; //   1
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 1);
  int c_d_3[] = {  0,   4,   5,   3}; //   4
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 4);

  int c_p_4[] = {  4,   7,   8,   9}; //   4
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 4);
  int c_f_4[] = {}; //   0
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 0);
  int c_t_4[] = {  1}; //   1
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 1);
  int c_d_4[] = {  6,   7,   8,   3}; //   4
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 4);

  int c_p_5[] = {  0,  10,  11,   9}; //   4
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 4);
  int c_f_5[] = {}; //   0
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 0);
  int c_t_5[] = {  1}; //   1
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 1);
  int c_d_5[] = {  6,   9,  10,   3}; //   4
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 4);

  int c_p_6[] = {  4,  10,  11,   9}; //   4
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 4);
  int c_f_6[] = {}; //   0
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 0);
  int c_t_6[] = {  1}; //   1
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 1);
  int c_d_6[] = {  6,   9,  10,   3}; //   4
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 4);

  int c_p_7[] = { 12,  13,   8,   9}; //   4
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 4);
  int c_f_7[] = {}; //   0
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 0);
  int c_t_7[] = {  1}; //   1
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 1);
  int c_d_7[] = {  6,   7,  11,  12}; //   4
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 4);

  int c_p_8[] = { 14,  15,  16,  17}; //   4
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 4);
  int c_f_8[] = {}; //   0
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 0);
  int c_t_8[] = {  2}; //   1
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 1);
  int c_d_8[] = { 12,  13,  14,  15}; //   4
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 4);

  int c_p_9[] = { 18,  15,  16,  17}; //   4
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 4);
  int c_f_9[] = {}; //   0
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 0);
  int c_t_9[] = {  2}; //   1
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 1);
  int c_d_9[] = { 12,  13,  14,  15}; //   4
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 4);

  int c_p_10[] = { 14,  19,  20,  17}; //   4
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 4);
  int c_f_10[] = {}; //   0
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 0);
  int c_t_10[] = {  2}; //   1
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 1);
  int c_d_10[] = { 12,  16,  17,  15}; //   4
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 4);

  int c_p_11[] = { 18,  19,  20,  17}; //   4
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 4);
  int c_f_11[] = {}; //   0
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 0);
  int c_t_11[] = {  2}; //   1
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 1);
  int c_d_11[] = { 12,  16,  17,  15}; //   4
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 4);

  int c_p_12[] = { 18,  21,  22,   9}; //   4
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 4);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  1}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = {  6,  18,  19,  15}; //   4
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 4);

  int c_p_13[] = { 14,  23,  11,   9}; //   4
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 4);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  1}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = {  6,   9,  20,  15}; //   4
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 4);

  int c_p_14[] = { 18,  23,  11,   9}; //   4
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 4);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  1}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = {  6,   9,  20,  15}; //   4
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 4);

  int c_p_15[] = { 24,  25,  22,   9}; //   4
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 4);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  1}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = {  6,  18,  21,   0}; //   4
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 4);

  int c_p_16[] = {  0,  26,  27,   9}; //   4
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 4);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  1}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = {  6,  22,   0,   3}; //   4
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 4);

  int c_p_17[] = {  4,  26,  27,   9}; //   4
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 4);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  1}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = {  6,  22,   0,   3}; //   4
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 4);

  int c_p_18[] = { 12,  28,  29,   9}; //   4
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 4);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {  1}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = {  6,  23,  15,  12}; //   4
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 4);

  int c_p_19[] = { 12,  30,  29,   9}; //   4
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 4);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {  1}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = {  6,  23,  15,  12}; //   4
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 4);

  int c_p_20[] = { 31,  32,  33,  34}; //   4
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 4);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {  3}; //   1
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 1);
  int c_d_20[] = {  7,   8,   3,   6}; //   4
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 4);

  int c_p_21[] = { 31,  35,  36,  37}; //   4
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 4);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {  3}; //   1
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 1);
  int c_d_21[] = {  9,  10,   3,   6}; //   4
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 4);

  int c_p_22[] = { 31,  32,  36,  37}; //   4
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 4);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {  3}; //   1
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 1);
  int c_d_22[] = {  9,  10,   3,   6}; //   4
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 4);

  int c_p_23[] = { 31,  38,  39,  34}; //   4
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 4);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {  3}; //   1
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 1);
  int c_d_23[] = {  7,  11,  12,   6}; //   4
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 4);

  int c_p_24[] = { 12,  28,  40,  41}; //   4
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 4);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  4}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = { 13,  14,  15,  12}; //   4
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 4);

  int c_p_25[] = { 12,  30,  40,  41}; //   4
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 4);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  4}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = { 13,  14,  15,  12}; //   4
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 4);

  int c_p_26[] = { 12,  28,  42,  43}; //   4
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 4);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  4}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = { 16,  17,  15,  12}; //   4
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 4);

  int c_p_27[] = { 12,  30,  42,  43}; //   4
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 4);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  4}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = { 16,  17,  15,  12}; //   4
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 4);

  int c_p_28[] = { 31,  44,  45,  46}; //   4
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 4);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  3}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = { 18,  19,  15,   6}; //   4
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 4);

  int c_p_29[] = { 31,  47,  48,  37}; //   4
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 4);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  3}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = {  9,  20,  15,   6}; //   4
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 4);

  int c_p_30[] = { 31,  44,  48,  37}; //   4
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 4);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {  3}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = {  9,  20,  15,   6}; //   4
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 4);

  int c_p_31[] = { 31,  49,  50,  46}; //   4
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 4);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {  3}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = { 18,  21,   0,   6}; //   4
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 4);

  int c_p_32[] = { 24,  51,  52,  53}; //   4
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 4);
  int c_f_32[] = {}; //   0
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 0);
  int c_t_32[] = {  5}; //   1
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 1);
  int c_d_32[] = {  1,   2,   3,   0}; //   4
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 4);

  int c_p_33[] = { 24,  54,  52,  53}; //   4
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 4);
  int c_f_33[] = {}; //   0
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 0);
  int c_t_33[] = {  5}; //   1
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 1);
  int c_d_33[] = {  1,   2,   3,   0}; //   4
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 4);

  int c_p_34[] = { 24,  51,  55,  56}; //   4
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 4);
  int c_f_34[] = {}; //   0
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 0);
  int c_t_34[] = {  5}; //   1
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 1);
  int c_d_34[] = {  4,   5,   3,   0}; //   4
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 4);

  int c_p_35[] = { 24,  54,  55,  56}; //   4
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 4);
  int c_f_35[] = {}; //   0
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 0);
  int c_t_35[] = {  5}; //   1
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 1);
  int c_d_35[] = {  4,   5,   3,   0}; //   4
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 4);

  int c_p_36[] = { 31,  35,  57,  58}; //   4
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 4);
  int c_f_36[] = {}; //   0
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 0);
  int c_t_36[] = {  3}; //   1
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 1);
  int c_d_36[] = { 22,   0,   3,   6}; //   4
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 4);

  int c_p_37[] = { 31,  32,  57,  58}; //   4
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 4);
  int c_f_37[] = {}; //   0
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 0);
  int c_t_37[] = {  3}; //   1
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 1);
  int c_d_37[] = { 22,   0,   3,   6}; //   4
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 4);

  int c_p_38[] = { 31,  38,  59,  60}; //   4
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 4);
  int c_f_38[] = {}; //   0
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 0);
  int c_t_38[] = {  3}; //   1
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 1);
  int c_d_38[] = { 23,  15,  12,   6}; //   4
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 4);

  int c_p_39[] = { 31,  38,  61,  60}; //   4
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 4);
  int c_f_39[] = {}; //   0
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 0);
  int c_t_39[] = {  3}; //   1
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 1);
  int c_d_39[] = { 23,  15,  12,   6}; //   4
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 4);

  int c_p_40[] = { 31,  35,  57}; //   3
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 3);
  int c_f_40[] = {  0}; //   1
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 1);
  int c_t_40[] = {  0,   6}; //   2
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 2);
  int c_d_40[] = {  0,   3,   6}; //   3
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 3);

  int c_p_41[] = { 31,  32,  57}; //   3
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 3);
  int c_f_41[] = {  0}; //   1
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 1);
  int c_t_41[] = {  0,   6}; //   2
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 2);
  int c_d_41[] = {  0,   3,   6}; //   3
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 3);

  int c_p_42[] = {  0,  62,  57}; //   3
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 3);
  int c_f_42[] = {  0}; //   1
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 1);
  int c_t_42[] = {  0,   7}; //   2
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 2);
  int c_d_42[] = {  0,   6,   3}; //   3
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 3);

  int c_p_43[] = {  4,  62,  57}; //   3
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 3);
  int c_f_43[] = {  0}; //   1
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 1);
  int c_t_43[] = {  0,   7}; //   2
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 2);
  int c_d_43[] = {  0,   6,   3}; //   3
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 3);

  int c_p_44[] = {  0,  26,  63}; //   3
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 3);
  int c_f_44[] = {  1}; //   1
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 1);
  int c_t_44[] = {  1,   8}; //   2
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 2);
  int c_d_44[] = {  6,   0,   3}; //   3
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 3);

  int c_p_45[] = {  4,  26,  63}; //   3
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 3);
  int c_f_45[] = {  1}; //   1
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 1);
  int c_t_45[] = {  1,   8}; //   2
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 2);
  int c_d_45[] = {  6,   0,   3}; //   3
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 3);

  int c_p_46[] = { 31,  38,  59}; //   3
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 3);
  int c_f_46[] = {  2}; //   1
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 1);
  int c_t_46[] = {  9,  10}; //   2
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 2);
  int c_d_46[] = { 15,  12,   6}; //   3
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 3);

  int c_p_47[] = { 31,  38,  61}; //   3
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 3);
  int c_f_47[] = {  2}; //   1
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 1);
  int c_t_47[] = {  9,  10}; //   2
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 2);
  int c_d_47[] = { 15,  12,   6}; //   3
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 3);

  int c_p_48[] = { 12,  64,  59}; //   3
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 3);
  int c_f_48[] = {  2}; //   1
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 1);
  int c_t_48[] = {  9,  11}; //   2
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 2);
  int c_d_48[] = { 15,   6,  12}; //   3
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 3);

  int c_p_49[] = { 12,  64,  61}; //   3
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 3);
  int c_f_49[] = {  2}; //   1
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 1);
  int c_t_49[] = {  9,  11}; //   2
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 2);
  int c_d_49[] = { 15,   6,  12}; //   3
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 3);

  int c_p_50[] = { 12,  28,  65}; //   3
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 3);
  int c_f_50[] = {  3}; //   1
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 1);
  int c_t_50[] = {  1,  12}; //   2
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 2);
  int c_d_50[] = {  6,  15,  12}; //   3
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 3);

  int c_p_51[] = { 12,  30,  65}; //   3
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 3);
  int c_f_51[] = {  3}; //   1
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 1);
  int c_t_51[] = {  1,  12}; //   2
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 2);
  int c_d_51[] = {  6,  15,  12}; //   3
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 3);

  int c_p_52[] = { 31,  47,  66}; //   3
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 3);
  int c_f_52[] = {  4}; //   1
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 1);
  int c_t_52[] = {  2,  13}; //   2
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 2);
  int c_d_52[] = { 12,  15,   6}; //   3
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 3);

  int c_p_53[] = { 31,  44,  66}; //   3
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 3);
  int c_f_53[] = {  4}; //   1
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 1);
  int c_t_53[] = {  2,  13}; //   2
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 2);
  int c_d_53[] = { 12,  15,   6}; //   3
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 3);

  int c_p_54[] = { 14,  67,  66}; //   3
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 3);
  int c_f_54[] = {  4}; //   1
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 1);
  int c_t_54[] = {  2,  14}; //   2
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 2);
  int c_d_54[] = { 12,   6,  15}; //   3
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 3);

  int c_p_55[] = { 18,  67,  66}; //   3
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 3);
  int c_f_55[] = {  4}; //   1
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 1);
  int c_t_55[] = {  2,  14}; //   2
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 2);
  int c_d_55[] = { 12,   6,  15}; //   3
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 3);

  int c_p_56[] = { 14,  68,  65}; //   3
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 3);
  int c_f_56[] = {  3}; //   1
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 1);
  int c_t_56[] = {  1,  15}; //   2
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 2);
  int c_d_56[] = {  6,  12,  15}; //   3
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 3);

  int c_p_57[] = { 18,  68,  65}; //   3
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 3);
  int c_f_57[] = {  3}; //   1
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 1);
  int c_t_57[] = {  1,  15}; //   2
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 2);
  int c_d_57[] = {  6,  12,  15}; //   3
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 3);

  int c_p_58[] = { 31,  49,  69}; //   3
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 3);
  int c_f_58[] = {  5}; //   1
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 1);
  int c_t_58[] = { 16,  17}; //   2
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 2);
  int c_d_58[] = {  3,   0,   6}; //   3
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 3);

  int c_p_59[] = { 31,  49,  70}; //   3
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 3);
  int c_f_59[] = {  5}; //   1
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 1);
  int c_t_59[] = { 16,  17}; //   2
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 2);
  int c_d_59[] = {  3,   0,   6}; //   3
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 3);

  int c_p_60[] = { 24,  71,  69}; //   3
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 3);
  int c_f_60[] = {  5}; //   1
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 1);
  int c_t_60[] = { 16,  18}; //   2
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 2);
  int c_d_60[] = {  3,   6,   0}; //   3
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 3);

  int c_p_61[] = { 24,  71,  70}; //   3
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 3);
  int c_f_61[] = {  5}; //   1
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 1);
  int c_t_61[] = { 16,  18}; //   2
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 2);
  int c_d_61[] = {  3,   6,   0}; //   3
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 3);

  int c_p_62[] = { 24,  51,  63}; //   3
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 3);
  int c_f_62[] = {  1}; //   1
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 1);
  int c_t_62[] = {  1,  19}; //   2
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 2);
  int c_d_62[] = {  6,   3,   0}; //   3
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 3);

  int c_p_63[] = { 24,  54,  63}; //   3
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 3);
  int c_f_63[] = {  1}; //   1
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 1);
  int c_t_63[] = {  1,  19}; //   2
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 2);
  int c_d_63[] = {  6,   3,   0}; //   3
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 3);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
