#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexa03/header/ppeexa03.phasespace.h"
void ppeexa03_ac_psp_230_dxdx_emepadxdx(int no_ps, int channel, phasespace_set & psi){
  static Logger logger("ppeexa03_ac_psp_230_dxdx_emepadxdx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  double g_IS_temp;
  int ran = 1;
  for (int i_p = 0; i_p < psi_c_p[no_ps][channel].size(); i_p++){
    if (psi_c_p[no_ps][channel][i_p] ==   0){
      psi_v_smin[no_ps][  0] = psi_smin_opt[no_ps][12];
      psi_v_smax[no_ps][  0] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][112], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 0] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 0]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  12, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==   1){
      psi_v_smin[no_ps][  0] = psi_smin_opt[no_ps][12];
      psi_v_smax[no_ps][  0] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][112], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 1] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 1]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,  23,  12, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==   2){
      psi_v_smin[no_ps][  1] = psi_smin_opt[no_ps][24];
      psi_v_smax[no_ps][  1] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][100], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 2] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 2]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  24, psi_v_smin[no_ps][  1], psi_v_smax[no_ps][  1], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==   3){
      psi_v_smin[no_ps][  2] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][4] + psi_xbsqrts[no_ps][24], 2), psi_smin_opt[no_ps][28]);
      psi_v_smax[no_ps][  2] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][96], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 3] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 3]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  28, psi_v_smin[no_ps][  2], psi_v_smax[no_ps][  2], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==   4){
      psi_v_smin[no_ps][  2] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][4] + psi_xbsqrts[no_ps][24], 2), psi_smin_opt[no_ps][28]);
      psi_v_smax[no_ps][  2] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][96], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 4] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 4]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,  23,  28, psi_v_smin[no_ps][  2], psi_v_smax[no_ps][  2], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==   5){
      psi_v_smin[no_ps][  3] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][12], 2), psi_smin_opt[no_ps][76]);
      psi_v_smax[no_ps][  3] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][48], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 5] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 5]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  76, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  3], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==   6){
      psi_v_smin[no_ps][  4] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][12], 2), psi_smin_opt[no_ps][44]);
      psi_v_smax[no_ps][  4] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][80], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 6] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 6]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  44, psi_v_smin[no_ps][  4], psi_v_smax[no_ps][  4], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==   7){
      psi_v_smin[no_ps][  5] = psi_smin_opt[no_ps][20];
      psi_v_smax[no_ps][  5] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][104], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 7] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 7]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  20, psi_v_smin[no_ps][  5], psi_v_smax[no_ps][  5], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==   8){
      psi_v_smin[no_ps][  6] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][8] + psi_xbsqrts[no_ps][20], 2), psi_smin_opt[no_ps][28]);
      psi_v_smax[no_ps][  2] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][96], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 8] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 8]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  28, psi_v_smin[no_ps][  6], psi_v_smax[no_ps][  2], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==   9){
      psi_v_smin[no_ps][  6] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][8] + psi_xbsqrts[no_ps][20], 2), psi_smin_opt[no_ps][28]);
      psi_v_smax[no_ps][  2] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][96], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 9] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 9]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,  23,  28, psi_v_smin[no_ps][  6], psi_v_smax[no_ps][  2], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  10){
      psi_v_smin[no_ps][  7] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][28], 2), psi_smin_opt[no_ps][92]);
      psi_v_smax[no_ps][  6] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][32], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 10] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 10]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  92, psi_v_smin[no_ps][  7], psi_v_smax[no_ps][  6], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  11){
      psi_v_smin[no_ps][  8] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][28], 2), psi_smin_opt[no_ps][60]);
      psi_v_smax[no_ps][  7] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][64], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 11] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 11]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  60, psi_v_smin[no_ps][  8], psi_v_smax[no_ps][  7], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  12){
      psi_v_smin[no_ps][  9] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][16] + psi_xbsqrts[no_ps][76], 2), psi_smin_opt[no_ps][92]);
      psi_v_smax[no_ps][  6] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][32], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 12] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 12]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  92, psi_v_smin[no_ps][  9], psi_v_smax[no_ps][  6], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  13){
      psi_v_smin[no_ps][ 10] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][16] + psi_xbsqrts[no_ps][44], 2), psi_smin_opt[no_ps][60]);
      psi_v_smax[no_ps][  7] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][64], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 13] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 13]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  60, psi_v_smin[no_ps][ 10], psi_v_smax[no_ps][  7], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  14){
      psi_v_smin[no_ps][ 11] = psi_smin_opt[no_ps][48];
      psi_v_smax[no_ps][  8] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][76], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 14] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 14]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  48, psi_v_smin[no_ps][ 11], psi_v_smax[no_ps][  8], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  15){
      psi_v_smin[no_ps][  0] = psi_smin_opt[no_ps][12];
      psi_v_smax[no_ps][  9] = pow(psi_xbsqrts[no_ps][0] - GSL_MAX_DBL(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][48], psi_sqrtsmin_opt[no_ps][112]), 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 15] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 15]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  12, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  9], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  16){
      psi_v_smin[no_ps][ 12] = GSL_MAX_DBL(pow(psi_xbsqrts[no_ps][12] + psi_xbsqrts[no_ps][48], 2), psi_smin_opt[no_ps][60]);
      psi_v_smax[no_ps][  7] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][64], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 16] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 16]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  60, psi_v_smin[no_ps][ 12], psi_v_smax[no_ps][  7], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  17){
      psi_v_smin[no_ps][  0] = psi_smin_opt[no_ps][12];
      psi_v_smax[no_ps][  9] = pow(psi_xbsqrts[no_ps][0] - GSL_MAX_DBL(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][48], psi_sqrtsmin_opt[no_ps][112]), 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 17] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 17]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,  23,  12, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  9], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  18){
      psi_v_smin[no_ps][ 13] = psi_smin_opt[no_ps][80];
      psi_v_smax[no_ps][ 10] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][44], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 18] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 18]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  80, psi_v_smin[no_ps][ 13], psi_v_smax[no_ps][ 10], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  19){
      psi_v_smin[no_ps][  0] = psi_smin_opt[no_ps][12];
      psi_v_smax[no_ps][ 11] = pow(psi_xbsqrts[no_ps][0] - GSL_MAX_DBL(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][80], psi_sqrtsmin_opt[no_ps][112]), 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 19] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 19]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  12, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][ 11], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  20){
      psi_v_smin[no_ps][ 14] = GSL_MAX_DBL(pow(psi_xbsqrts[no_ps][12] + psi_xbsqrts[no_ps][80], 2), psi_smin_opt[no_ps][92]);
      psi_v_smax[no_ps][  6] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][32], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 20] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 20]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  92, psi_v_smin[no_ps][ 14], psi_v_smax[no_ps][  6], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  21){
      psi_v_smin[no_ps][  0] = psi_smin_opt[no_ps][12];
      psi_v_smax[no_ps][ 11] = pow(psi_xbsqrts[no_ps][0] - GSL_MAX_DBL(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][80], psi_sqrtsmin_opt[no_ps][112]), 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 21] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 21]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,  23,  12, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][ 11], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  22){
      psi_v_smin[no_ps][ 11] = psi_smin_opt[no_ps][48];
      psi_v_smax[no_ps][ 12] = pow(psi_xbsqrts[no_ps][0] - psi_xbsqrts[no_ps][76], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 22] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 22]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  48, psi_v_smin[no_ps][ 11], psi_v_smax[no_ps][ 12], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  23){
      psi_v_smin[no_ps][ 13] = psi_smin_opt[no_ps][80];
      psi_v_smax[no_ps][ 13] = pow(psi_xbsqrts[no_ps][0] - psi_xbsqrts[no_ps][44], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 23] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 23]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  80, psi_v_smin[no_ps][ 13], psi_v_smax[no_ps][ 13], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  24){
      psi_v_smin[no_ps][ 11] = psi_smin_opt[no_ps][48];
      psi_v_smax[no_ps][ 14] = pow(psi_xbsqrts[no_ps][0] - GSL_MAX_DBL(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][12], psi_sqrtsmin_opt[no_ps][76]), 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 24] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 24]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  48, psi_v_smin[no_ps][ 11], psi_v_smax[no_ps][ 14], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  25){
      psi_v_smin[no_ps][ 13] = psi_smin_opt[no_ps][80];
      psi_v_smax[no_ps][ 15] = pow(psi_xbsqrts[no_ps][0] - GSL_MAX_DBL(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][12], psi_sqrtsmin_opt[no_ps][44]), 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 25] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 25]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  80, psi_v_smin[no_ps][ 13], psi_v_smax[no_ps][ 15], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  26){
      psi_v_smin[no_ps][  3] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][12], 2), psi_smin_opt[no_ps][76]);
      psi_v_smax[no_ps][ 16] = pow(psi_xbsqrts[no_ps][0] - psi_xbsqrts[no_ps][48], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 26] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 26]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  76, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][ 16], ran + i_p);
    }
    else if (psi_c_p[no_ps][channel][i_p] ==  27){
      psi_v_smin[no_ps][  4] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][12], 2), psi_smin_opt[no_ps][44]);
      psi_v_smax[no_ps][ 17] = pow(psi_xbsqrts[no_ps][0] - psi_xbsqrts[no_ps][80], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][0] + 27] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][0] + 27]->get_random(psi_r[ran + i_p], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_propagator(no_ps,   0,  44, psi_v_smin[no_ps][  4], psi_v_smax[no_ps][ 17], ran + i_p);
    }
  }
  ran += psi_c_p[no_ps][channel].size();

  for (int i_f = 0; i_f < psi_c_f[no_ps][channel].size(); i_f++){
    if (psi_c_f[no_ps][channel][i_f] ==   0){
      psi_v_smin[no_ps][ 11] = psi_smin_opt[no_ps][48];
      psi_v_smax[no_ps][ 14] = pow(psi_xbsqrts[no_ps][0] - GSL_MAX_DBL(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][12], psi_sqrtsmin_opt[no_ps][76]), 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 0] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 0]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  48, psi_v_smin[no_ps][ 11], psi_v_smax[no_ps][ 14], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==   1){
      psi_v_smin[no_ps][ 12] = GSL_MAX_DBL(pow(psi_xbsqrts[no_ps][12] + psi_xbsqrts[no_ps][48], 2), psi_smin_opt[no_ps][60]);
      psi_v_smax[no_ps][  7] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][64], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 1] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 1]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  60, psi_v_smin[no_ps][ 12], psi_v_smax[no_ps][  7], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==   2){
      psi_v_smin[no_ps][ 13] = psi_smin_opt[no_ps][80];
      psi_v_smax[no_ps][ 15] = pow(psi_xbsqrts[no_ps][0] - GSL_MAX_DBL(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][12], psi_sqrtsmin_opt[no_ps][44]), 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 2] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 2]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  80, psi_v_smin[no_ps][ 13], psi_v_smax[no_ps][ 15], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==   3){
      psi_v_smin[no_ps][ 14] = GSL_MAX_DBL(pow(psi_xbsqrts[no_ps][12] + psi_xbsqrts[no_ps][80], 2), psi_smin_opt[no_ps][92]);
      psi_v_smax[no_ps][  6] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][32], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 3] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 3]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  92, psi_v_smin[no_ps][ 14], psi_v_smax[no_ps][  6], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==   4){
      psi_v_smin[no_ps][ 15] = psi_smin_opt[no_ps][96];
      psi_v_smax[no_ps][ 18] = pow(psi_xbsqrts[no_ps][0] - GSL_MAX_DBL(psi_sqrtsmin_opt[no_ps][16] + psi_xbsqrts[no_ps][12], psi_sqrtsmin_opt[no_ps][28]), 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 4] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 4]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  96, psi_v_smin[no_ps][ 15], psi_v_smax[no_ps][ 18], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==   5){
      psi_v_smin[no_ps][ 16] = GSL_MAX_DBL(pow(psi_xbsqrts[no_ps][12] + psi_xbsqrts[no_ps][96], 2), psi_smin_opt[no_ps][108]);
      psi_v_smax[no_ps][ 19] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][16], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 5] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 5]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps, 108, psi_v_smin[no_ps][ 16], psi_v_smax[no_ps][ 19], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==   6){
      psi_v_smin[no_ps][  8] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][28], 2), psi_smin_opt[no_ps][60]);
      psi_v_smax[no_ps][  7] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][64], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 6] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 6]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  60, psi_v_smin[no_ps][  8], psi_v_smax[no_ps][  7], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==   7){
      psi_v_smin[no_ps][  7] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][28], 2), psi_smin_opt[no_ps][92]);
      psi_v_smax[no_ps][  6] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][32], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 7] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 7]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  92, psi_v_smin[no_ps][  7], psi_v_smax[no_ps][  6], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==   8){
      psi_v_smin[no_ps][ 17] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][76], 2), psi_smin_opt[no_ps][108]);
      psi_v_smax[no_ps][ 19] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][16], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 8] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 8]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps, 108, psi_v_smin[no_ps][ 17], psi_v_smax[no_ps][ 19], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==   9){
      psi_v_smin[no_ps][ 18] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][44], 2), psi_smin_opt[no_ps][108]);
      psi_v_smax[no_ps][ 19] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][16], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 9] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 9]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps, 108, psi_v_smin[no_ps][ 18], psi_v_smax[no_ps][ 19], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==  10){
      psi_v_smin[no_ps][  4] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][12], 2), psi_smin_opt[no_ps][44]);
      psi_v_smax[no_ps][  4] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][80], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 10] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 10]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  44, psi_v_smin[no_ps][  4], psi_v_smax[no_ps][  4], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==  11){
      psi_v_smin[no_ps][  3] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][12], 2), psi_smin_opt[no_ps][76]);
      psi_v_smax[no_ps][  3] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][48], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 11] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 11]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  76, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  3], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==  12){
      psi_v_smin[no_ps][  9] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][16] + psi_xbsqrts[no_ps][76], 2), psi_smin_opt[no_ps][92]);
      psi_v_smax[no_ps][  6] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][32], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 12] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 12]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  92, psi_v_smin[no_ps][  9], psi_v_smax[no_ps][  6], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==  13){
      psi_v_smin[no_ps][ 10] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][16] + psi_xbsqrts[no_ps][44], 2), psi_smin_opt[no_ps][60]);
      psi_v_smax[no_ps][  7] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][64], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 13] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 13]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  60, psi_v_smin[no_ps][ 10], psi_v_smax[no_ps][  7], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==  14){
      psi_v_smin[no_ps][ 19] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][48], 2), psi_smin_opt[no_ps][112]);
      psi_v_smax[no_ps][ 20] = pow(psi_xbsqrts[no_ps][0] - psi_xbsqrts[no_ps][12], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 14] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 14]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps, 112, psi_v_smin[no_ps][ 19], psi_v_smax[no_ps][ 20], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==  15){
      psi_v_smin[no_ps][ 20] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][80], 2), psi_smin_opt[no_ps][112]);
      psi_v_smax[no_ps][ 20] = pow(psi_xbsqrts[no_ps][0] - psi_xbsqrts[no_ps][12], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 15] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 15]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps, 112, psi_v_smin[no_ps][ 20], psi_v_smax[no_ps][ 20], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==  16){
      psi_v_smin[no_ps][  3] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][64] + psi_xbsqrts[no_ps][12], 2), psi_smin_opt[no_ps][76]);
      psi_v_smax[no_ps][ 16] = pow(psi_xbsqrts[no_ps][0] - psi_xbsqrts[no_ps][48], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 16] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 16]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  76, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][ 16], ran + i_f);
    }
    else if (psi_c_f[no_ps][channel][i_f] ==  17){
      psi_v_smin[no_ps][  4] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][12], 2), psi_smin_opt[no_ps][44]);
      psi_v_smax[no_ps][ 17] = pow(psi_xbsqrts[no_ps][0] - psi_xbsqrts[no_ps][80], 2);
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][1] + 17] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][1] + 17]->get_random(psi_r[ran + i_f], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_timelikeinvariant(no_ps,  44, psi_v_smin[no_ps][  4], psi_v_smax[no_ps][ 17], ran + i_f);
    }
  }
  ran += psi_c_f[no_ps][channel].size();

  for (int i_t = 0; i_t < psi_c_t[no_ps][channel].size(); i_t++){
    if      (psi_c_t[no_ps][channel][i_t] ==   0){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 0] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 0]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 0] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 1]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 124,   2,   1,  64,  60, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==   1){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 1] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 2]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 1] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 3]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  60,   1,  66,  12,  48, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==   2){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 2] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 4]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 2] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 5]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  48,  66,  13,  32,  16, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==   3){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 3] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 6]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 3] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 7]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 124,   2,   1,  32,  92, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==   4){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 4] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 8]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 4] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 9]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  92,   1,  34,  12,  80, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==   5){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 5] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 10]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 5] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 11]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  80,  34,  13,  64,  16, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==   6){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 6] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 12]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 6] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 13]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 124,   2,   1,  16, 108, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==   7){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 7] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 14]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 7] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 15]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 108,   1,  18,  12,  96, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==   8){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 8] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 16]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 8] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 17]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  96,  18,  13,  64,  32, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==   9){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 9] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 18]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 9] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 19]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  96,  18,  13,  32,  64, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  10){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 10] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 20]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 10] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 21]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  60,  66,   1,  32,  28, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  11){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 11] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 22]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 11] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 23]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  92,  34,   1,  64,  28, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  12){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 12] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 24]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 12] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 25]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 108,  18,   1,  32,  76, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  13){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 13] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 26]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 13] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 27]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 108,  18,   1,  64,  44, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  14){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 14] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 28]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 14] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 29]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 124,   1,   2,  16, 108, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  15){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 15] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 30]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 15] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 31]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 108,   2,  17,  64,  44, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  16){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 16] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 32]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 16] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 33]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  44,  66,  17,  32,  12, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  17){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 17] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 34]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 17] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 35]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 108,   2,  17,  32,  76, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  18){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 18] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 36]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 18] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 37]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  76,  34,  17,  64,  12, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  19){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 19] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 38]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 19] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 39]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 124,   1,   2,  32,  92, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  20){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 20] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 40]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 20] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 41]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  92,   2,  33,  16,  76, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  21){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 21] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 42]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 21] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 43]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 124,   1,   2,  64,  60, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  22){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 22] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 44]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 22] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 45]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  60,   2,  65,  16,  44, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  23){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 23] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 46]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 23] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 47]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  76,  33,  18,  64,  12, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  24){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 24] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 48]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 24] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 49]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  44,  65,  18,  32,  12, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  25){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 25] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 50]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 25] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 51]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  92,  33,   2,  64,  28, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  26){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 26] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 52]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 26] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 53]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  60,  65,   2,  32,  28, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  27){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 27] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 54]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 27] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 55]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 108,  17,   2,  32,  76, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  28){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 28] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 56]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 28] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 57]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 108,  17,   2,  64,  44, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  29){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 29] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 58]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 29] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 59]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 108,   2,  17,  12,  96, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  30){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 30] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 60]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 30] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 61]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  96,  17,  14,  32,  64, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  31){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 31] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 62]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 31] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 63]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  96,  17,  14,  64,  32, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  32){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 32] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 64]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 32] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 65]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  92,   2,  33,  12,  80, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  33){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 33] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 66]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 33] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 67]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  80,  33,  14,  64,  16, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  34){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 34] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 68]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 34] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 69]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  60,   2,  65,  12,  48, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  35){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 35] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 70]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 35] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 71]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel(no_ps,   0,  48,  65,  14,  32,  16, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  36){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 36] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 72]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 36] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 73]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 124,   1,   2,  48,  76, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  37){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 37] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 74]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 37] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 75]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 124,   1,   2,  80,  44, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  38){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 38] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 76]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 38] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 77]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 124,   1,   2,  12, 112, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  39){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 39] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 78]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 39] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 79]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 112,   2,  13,  48,  64, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  40){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 40] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 80]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 40] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 81]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 112,   2,  13,  80,  32, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  41){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 41] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 82]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 41] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 83]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  76,   2,  49,  12,  64, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  42){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 42] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 84]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 42] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 85]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0,  44,   2,  81,  12,  32, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  43){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 43] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 86]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 43] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 87]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 124,   2,   1,  48,  76, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
    else if (psi_c_t[no_ps][channel][i_t] ==  44){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 44] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 88]->get_random(psi_r[ran + 2 * i_t], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][2] + 44] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][2] + 89]->get_random(psi_r[ran + 2 * i_t + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_tchannel_opt(no_ps,   0, 124,   2,   1,  80,  44, ran + 2 * i_t, ran + 2 * i_t + 1);
    }
  }
  ran += 2 * psi_c_t[no_ps][channel].size();

  for (int i_d = 0; i_d < psi_c_d[no_ps][channel].size(); i_d++){
    if      (psi_c_d[no_ps][channel][i_d] ==   0){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 0] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 0]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 0] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 1]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  12,   4,   8, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==   1){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 1] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 2]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 1] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 3]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  28,   4,  24, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==   2){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 2] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 4]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 2] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 5]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  24,   8,  16, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==   3){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 3] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 6]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 3] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 7]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  76,  64,  12, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==   4){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 4] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 8]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 4] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 9]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  44,  32,  12, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==   5){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 5] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 10]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 5] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 11]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  28,   8,  20, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==   6){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 6] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 12]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 6] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 13]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  20,   4,  16, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==   7){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 7] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 14]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 7] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 15]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  92,  64,  28, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==   8){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 8] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 16]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 8] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 17]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  60,  32,  28, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==   9){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 9] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 18]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 9] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 19]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  92,  16,  76, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==  10){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 10] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 20]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 10] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 21]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  60,  16,  44, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==  11){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 11] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 22]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 11] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 23]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  60,  12,  48, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==  12){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 12] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 24]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 12] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 25]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  48,  16,  32, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==  13){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 13] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 26]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 13] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 27]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  92,  12,  80, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
    else if (psi_c_d[no_ps][channel][i_d] ==  14){
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 14] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 28]->get_random(psi_r[ran + 2 * i_d], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      if (psi_container_IS_switch[psi_container_IS_startvalue[no_ps][3] + 14] == 1){
        psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][3] + 29]->get_random(psi_r[ran + 2 * i_d + 1], g_IS_temp);
        psi_MC_g_IS_global *= g_IS_temp;
      }
      psi.c_decay(no_ps,  80,  16,  64, ran + 2 * i_d, ran + 2 * i_d + 1);
    }
  }
  ran += 2 * psi_c_d[no_ps][channel].size();

  /*
  if      (channel ==    0){ac_channel_2v111(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==    1){ac_channel_2v111(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==    2){ac_channel_2v111(r, 1, 2, 4, 8, 16, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==    3){ac_channel_2v111(r, 1, 2, 4, 8, 16, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==    4){ac_channel_2v111(r, 1, 2, 4, 8, 32, 64, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==    5){ac_channel_2v111(r, 1, 2, 4, 8, 32, 64, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==    6){ac_channel_2v111(r, 1, 2, 4, 8, 64, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==    7){ac_channel_2v111(r, 1, 2, 4, 8, 64, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==    8){ac_channel_3yv11(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==    9){ac_channel_3yv11(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   10){ac_channel_3yv11(r, 1, 2, 4, 8, 16, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   11){ac_channel_3yv11(r, 1, 2, 4, 8, 16, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   12){ac_channel_3yv11(r, 1, 2, 64, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   13){ac_channel_3yv11(r, 1, 2, 64, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   14){ac_channel_3yv11(r, 1, 2, 32, 4, 8, 64, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   15){ac_channel_3yv11(r, 1, 2, 32, 4, 8, 64, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   16){ac_channel_3yv11(r, 1, 2, 8, 4, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   17){ac_channel_3yv11(r, 1, 2, 8, 4, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   18){ac_channel_3yv11(r, 1, 2, 8, 4, 16, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   19){ac_channel_3yv11(r, 1, 2, 8, 4, 16, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   20){ac_channel_4yyv1(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   21){ac_channel_4yyv1(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   22){ac_channel_4yyv1(r, 1, 2, 32, 4, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   23){ac_channel_4yyv1(r, 1, 2, 32, 4, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   24){ac_channel_4yyv1(r, 1, 2, 16, 64, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   25){ac_channel_4yyv1(r, 1, 2, 16, 64, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   26){ac_channel_4yyv1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   27){ac_channel_4yyv1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   28){ac_channel_4yyv1(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   29){ac_channel_4yyv1(r, 1, 2, 64, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   30){ac_channel_4yyv1(r, 1, 2, 32, 8, 4, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   31){ac_channel_4yyv1(r, 1, 2, 32, 8, 4, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   32){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   33){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   34){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   35){ac_channel_42vv1(r, 1, 2, 4, 8, 16, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   36){ac_channel_12v11(r, 1, 2, 16, 4, 8, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   37){ac_channel_12v11(r, 1, 2, 16, 4, 8, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   38){ac_channel_12v11(r, 1, 2, 16, 4, 8, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   39){ac_channel_12v11(r, 1, 2, 16, 4, 8, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   40){ac_channel_13yv1(r, 1, 2, 32, 64, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   41){ac_channel_13yv1(r, 1, 2, 32, 64, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   42){ac_channel_13yv1(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   43){ac_channel_13yv1(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   44){ac_channel_13yv1(r, 1, 2, 16, 64, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   45){ac_channel_13yv1(r, 1, 2, 16, 64, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   46){ac_channel_13yv1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   47){ac_channel_13yv1(r, 1, 2, 16, 32, 4, 8, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   48){ac_channel_14yyv(r, 1, 2, 32, 64, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   49){ac_channel_14yyv(r, 1, 2, 32, 64, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   50){ac_channel_14yyv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   51){ac_channel_14yyv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   52){ac_channel_14yyv(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   53){ac_channel_14yyv(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   54){ac_channel_14yyv(r, 1, 2, 32, 16, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   55){ac_channel_14yyv(r, 1, 2, 32, 16, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   56){ac_channel_14yyv(r, 1, 2, 32, 64, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   57){ac_channel_14yyv(r, 1, 2, 32, 64, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   58){ac_channel_14yyv(r, 1, 2, 64, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   59){ac_channel_14yyv(r, 1, 2, 64, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   60){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   61){ac_channel_142vv(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   62){ac_channel_142vv(r, 1, 2, 32, 4, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   63){ac_channel_142vv(r, 1, 2, 32, 4, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   64){ac_channel_112v1(r, 1, 2, 32, 64, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   65){ac_channel_112v1(r, 1, 2, 32, 64, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   66){ac_channel_112v1(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   67){ac_channel_112v1(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   68){ac_channel_113yv(r, 1, 2, 32, 64, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   69){ac_channel_113yv(r, 1, 2, 32, 64, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   70){ac_channel_113yv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   71){ac_channel_113yv(r, 1, 2, 64, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   72){ac_channel_113yv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   73){ac_channel_113yv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   74){ac_channel_113yv(r, 1, 2, 16, 64, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   75){ac_channel_113yv(r, 1, 2, 16, 64, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   76){ac_channel_113yv(r, 1, 2, 32, 64, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   77){ac_channel_113yv(r, 1, 2, 32, 64, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   78){ac_channel_113yv(r, 1, 2, 64, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   79){ac_channel_113yv(r, 1, 2, 64, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   80){ac_channel_1112v(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   81){ac_channel_1112v(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   82){ac_channel_1112v(r, 1, 2, 16, 64, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   83){ac_channel_1112v(r, 1, 2, 16, 64, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   84){ac_channel_1112v(r, 1, 2, 32, 64, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   85){ac_channel_1112v(r, 1, 2, 32, 64, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   86){ac_channel_1112v(r, 1, 2, 64, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   87){ac_channel_1112v(r, 1, 2, 64, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   88){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   89){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 32, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   90){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   91){ac_channel_2v2v1(r, 1, 2, 4, 8, 16, 64, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   92){ac_channel_2v3yv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   93){ac_channel_2v3yv(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   94){ac_channel_2v3yv(r, 1, 2, 16, 64, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   95){ac_channel_2v3yv(r, 1, 2, 16, 64, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==   96){ac_channel_2v12v(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   97){ac_channel_2v12v(r, 1, 2, 4, 8, 64, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==   98){ac_channel_2v12v(r, 1, 2, 4, 8, 32, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==   99){ac_channel_2v12v(r, 1, 2, 4, 8, 32, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==  100){ac_channel_2v12v(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==  101){ac_channel_2v12v(r, 1, 2, 16, 32, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  102){ac_channel_2v12v(r, 1, 2, 16, 64, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==  103){ac_channel_2v12v(r, 1, 2, 16, 64, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  104){ac_channel_3yv2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==  105){ac_channel_3yv2v(r, 1, 2, 64, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==  106){ac_channel_3yv2v(r, 1, 2, 32, 4, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==  107){ac_channel_3yv2v(r, 1, 2, 32, 4, 8, 16, 64, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,  23,   0,   0, psi);}
  else if (channel ==  108){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==  109){ac_channel_12v2v(r, 1, 2, 64, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  else if (channel ==  110){ac_channel_12v2v(r, 1, 2, 32, 16, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0,   0, psi);}
  else if (channel ==  111){ac_channel_12v2v(r, 1, 2, 32, 16, 64, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,  23,   0,   0,   0, psi);}
  */

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
