#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexexne04/header/ppeexexne04.phasespace.h"
void ppeexexne04_optimize_minv_born(phasespace_set & psi){
  static Logger logger("ppeexexne04_optimize_minv_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

#include "user/specify.optimize.phasespace.minv.born.cxx"

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

int ppeexexne04_determination_MCchannels_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexexne04_determination_MCchannels_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  int n_channel = 0;
  if      (psi_no_map[no_ps] == 0){n_channel = 20;}
  else if (psi_no_map[no_ps] == 1){n_channel = 20;}
  return n_channel;

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexexne04_ac_tau_psp_born(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi){
  static Logger logger("ppeexexne04_ac_tau_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if      (psi.no_map[no_ps] == 0){}
  else if (psi.no_map[no_ps] == 1){
    tau_MC_map.push_back(0);
    tau_MC_map.push_back(-24);
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}

void ppeexexne04_ax_psp_born(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexexne04_ax_psp_born");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 1){ppeexexne04_ax_psp_040_udx_emepepve(no_ps, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
