#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexexne04/header/ppeexexne04.phasespace.h"
void ppeexexne04_ax_psp_240_udx_emepepveddx(int no_ps, phasespace_set & psi){
  static Logger logger("ppeexexne04_ax_psp_240_udx_emepepveddx");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(37);
  psi_needed_v_smin[no_ps].resize(37);
  int needed_v_smin_0[] = {   0,   10,   11,   12,   22,   23,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   48,   57,   58,   59,   60,   66,   67,   70,   71,   74,   75,   78,   79,   82,   83,   88,   89,   90,   91,   92,  102,  103,  110,  111,  112,  113,  114,  115,  122,  123,  124,  125,  126,  127}; //  52
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 52);
  int needed_v_smin_1[] = {   0,   12,   48,   92}; //   4
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 4);
  int needed_v_smin_2[] = {   0,    1,   12,   13,   48,   53,   92,   93}; //   8
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 8);
  int needed_v_smin_3[] = {   1,    2,    3,    8,    9,   13,   14,   15,   20,   21,   24,   25,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   49,   50,   51,   52,   53,   54,   55,   64,   65,   68,   69,   72,   73,   76,   77,   80,   81,   84,   85,   86,   87,   93,   94,   95,  100,  101,  104,  105,  106,  107,  108,  109,  116,  117,  118,  119,  120,  121}; //  60
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 60);
  int needed_v_smin_4[] = {   1,   13,   53,   93}; //   4
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 4);
  int needed_v_smin_5[] = {   2,    3,   14,   15,   54,   55,   94,   95}; //   8
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 8);
  int needed_v_smin_6[] = {   2,    3,    6,    7,   14,   15,   18,   19,   54,   55,   62,   63,   94,   95,   98,   99}; //  16
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 16);
  int needed_v_smin_7[] = {   4,    8,    9,   16,   20,   21,   24,   25,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   49,   50,   51,   52,   56,   64,   65,   68,   69,   72,   73,   76,   77,   80,   81,   84,   85,   86,   87,   96,  100,  101,  104,  105,  106,  107,  108,  109,  116,  117,  118,  119,  120,  121}; //  52
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 52);
  int needed_v_smin_8[] = {   4,   16,   56,   96}; //   4
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 4);
  int needed_v_smin_9[] = {   4,    5,   16,   17,   56,   61,   96,   97}; //   8
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 8);
  int needed_v_smin_10[] = {   5,    6,    7,   10,   11,   17,   18,   19,   22,   23,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   57,   58,   59,   60,   61,   62,   63,   66,   67,   70,   71,   74,   75,   78,   79,   82,   83,   88,   89,   90,   91,   97,   98,   99,  102,  103,  110,  111,  112,  113,  114,  115,  122,  123,  124,  125,  126,  127}; //  60
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 60);
  int needed_v_smin_11[] = {   5,   17,   61,   97}; //   4
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 4);
  int needed_v_smin_12[] = {   6,    7,   18,   19,   62,   63,   98,   99}; //   8
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 8);
  int needed_v_smin_13[] = {   8,    9,   20,   21,   64,   65,  100,  101,  108,  109,  120,  121}; //  12
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 12);
  int needed_v_smin_14[] = {  10,   11,   22,   23,   66,   67,  102,  103,  114,  115,  126,  127}; //  12
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 12);
  int needed_v_smin_15[] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  24
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 24);
  int needed_v_smin_16[] = {  24,   25,   40,   41,   76,   77,   80,   81,   32,   33}; //  10
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 10);
  int needed_v_smin_17[] = {  24,   25,   32,   33,   40,   41}; //   6
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 6);
  int needed_v_smin_18[] = {  26,   27,   42,   43,   78,   79,   82,   83,   34,   35}; //  10
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 10);
  int needed_v_smin_19[] = {  26,   27,   34,   35,   42,   43}; //   6
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 6);
  int needed_v_smin_20[] = {  28,   29,   44,   45,   51,   52,   86,   87,   36,   37}; //  10
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 10);
  int needed_v_smin_21[] = {  28,   29,   36,   37,   44,   45}; //   6
  psi_needed_v_smin[no_ps][ 21] = get_vector_from_array_int(needed_v_smin_21, 6);
  int needed_v_smin_22[] = {  30,   31,   46,   47,   59,   60,   90,   91,   38,   39}; //  10
  psi_needed_v_smin[no_ps][ 22] = get_vector_from_array_int(needed_v_smin_22, 10);
  int needed_v_smin_23[] = {  30,   31,   38,   39,   46,   47}; //   6
  psi_needed_v_smin[no_ps][ 23] = get_vector_from_array_int(needed_v_smin_23, 6);
  int needed_v_smin_24[] = {  48,   53,   54,   55,   56,   61,   62,   63,   64,   65,   66,   67,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111,  112,  113,  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,  124,  125,  126,  127,   72,   73,   74,   75}; //  52
  psi_needed_v_smin[no_ps][ 24] = get_vector_from_array_int(needed_v_smin_24, 52);
  int needed_v_smin_25[] = {  49,   50,   68,   69,   76,   77,   84,   85}; //   8
  psi_needed_v_smin[no_ps][ 25] = get_vector_from_array_int(needed_v_smin_25, 8);
  int needed_v_smin_26[] = {  49,   50,   84,   85,   68,   69}; //   6
  psi_needed_v_smin[no_ps][ 26] = get_vector_from_array_int(needed_v_smin_26, 6);
  int needed_v_smin_27[] = {  51,   52,   86,   87}; //   4
  psi_needed_v_smin[no_ps][ 27] = get_vector_from_array_int(needed_v_smin_27, 4);
  int needed_v_smin_28[] = {  57,   58,   70,   71,   78,   79,   88,   89}; //   8
  psi_needed_v_smin[no_ps][ 28] = get_vector_from_array_int(needed_v_smin_28, 8);
  int needed_v_smin_29[] = {  57,   58,   88,   89,   70,   71}; //   6
  psi_needed_v_smin[no_ps][ 29] = get_vector_from_array_int(needed_v_smin_29, 6);
  int needed_v_smin_30[] = {  59,   60,   90,   91}; //   4
  psi_needed_v_smin[no_ps][ 30] = get_vector_from_array_int(needed_v_smin_30, 4);
  int needed_v_smin_31[] = {  72,   73,  116,  117,  118,  119}; //   6
  psi_needed_v_smin[no_ps][ 31] = get_vector_from_array_int(needed_v_smin_31, 6);
  int needed_v_smin_32[] = {  74,   75,  122,  123,  124,  125}; //   6
  psi_needed_v_smin[no_ps][ 32] = get_vector_from_array_int(needed_v_smin_32, 6);
  int needed_v_smin_33[] = {  80,   81}; //   2
  psi_needed_v_smin[no_ps][ 33] = get_vector_from_array_int(needed_v_smin_33, 2);
  int needed_v_smin_34[] = {  82,   83}; //   2
  psi_needed_v_smin[no_ps][ 34] = get_vector_from_array_int(needed_v_smin_34, 2);
  int needed_v_smin_35[] = { 104,  105,  106,  107}; //   4
  psi_needed_v_smin[no_ps][ 35] = get_vector_from_array_int(needed_v_smin_35, 4);
  int needed_v_smin_36[] = { 110,  111,  112,  113}; //   4
  psi_needed_v_smin[no_ps][ 36] = get_vector_from_array_int(needed_v_smin_36, 4);

  psi_v_smax[no_ps].resize(61);
  psi_needed_v_smax[no_ps].resize(61);
  int needed_v_smax_0[] = {   0,   10,   11,   12,   22,   23,   26,   27,   34,   35,   42,   43,   48,   66,   67,   88,   89,   90,   91,  112,  113,  114,  115}; //  23
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 23);
  int needed_v_smax_1[] = {   0,    1,   12,   13,   48,   53}; //   6
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 6);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   48,   53,   54,   55,   56,   61,   62,   63,   64,   65,   66,   67}; //  36
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 36);
  int needed_v_smax_3[] = {   1,    2,    3,   13,   14,   15,   28,   29,   36,   37,   44,   45,   49,   50,   51,   52,   53,   54,   55,   68,   69,   72,   73,   76,   77,   80,   81,  118,  119,  120,  121}; //  31
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 31);
  int needed_v_smax_4[] = {   2,    3,    6,    7,   14,   15,   18,   19,   54,   55,   62,   63}; //  12
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 12);
  int needed_v_smax_5[] = {   4,    8,    9,   16,   20,   21,   24,   25,   32,   33,   40,   41,   56,   64,   65,   84,   85,   86,   87,  106,  107,  108,  109}; //  23
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 23);
  int needed_v_smax_6[] = {   4,    5,   16,   17,   56,   61}; //   6
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 6);
  int needed_v_smax_7[] = {   5,    6,    7,   17,   18,   19,   30,   31,   38,   39,   46,   47,   57,   58,   59,   60,   61,   62,   63,   70,   71,   74,   75,   78,   79,   82,   83,  124,  125,  126,  127}; //  31
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 31);
  int needed_v_smax_8[] = {   8,    9,   20,   21,   32,   33,   64,   65,   84,   85,   86,   87,  108,  109}; //  14
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 14);
  int needed_v_smax_9[] = {  10,   11,   22,   23,   34,   35,   66,   67,   88,   89,   90,   91,  114,  115}; //  14
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 14);
  int needed_v_smax_10[] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  48
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 48);
  int needed_v_smax_11[] = {  24,   25,   40,   41}; //   4
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 4);
  int needed_v_smax_12[] = {  24,   25,   40,   41}; //   4
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 4);
  int needed_v_smax_13[] = {  26,   27,   42,   43}; //   4
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 4);
  int needed_v_smax_14[] = {  26,   27,   42,   43}; //   4
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 4);
  int needed_v_smax_15[] = {  28,   29,   44,   45,   51,   52}; //   6
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 6);
  int needed_v_smax_16[] = {  28,   29,   44,   45}; //   4
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 4);
  int needed_v_smax_17[] = {  30,   31,   46,   47,   59,   60}; //   6
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 6);
  int needed_v_smax_18[] = {  30,   31,   46,   47}; //   4
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 4);
  int needed_v_smax_19[] = {  36,   37,   72,   73,   80,   81,  120,  121}; //   8
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 8);
  int needed_v_smax_20[] = {  38,   39,   74,   75,   82,   83,  126,  127}; //   8
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 8);
  int needed_v_smax_21[] = {  48,   53,   54,   55,   56,   61,   62,   63,   64,   65,   66,   67}; //  12
  psi_needed_v_smax[no_ps][ 21] = get_vector_from_array_int(needed_v_smax_21, 12);
  int needed_v_smax_22[] = {  49,   50,   68,   69,   76,   77}; //   6
  psi_needed_v_smax[no_ps][ 22] = get_vector_from_array_int(needed_v_smax_22, 6);
  int needed_v_smax_23[] = {  49,   50,   51,   52}; //   4
  psi_needed_v_smax[no_ps][ 23] = get_vector_from_array_int(needed_v_smax_23, 4);
  int needed_v_smax_24[] = {  49,   50,   51,   52}; //   4
  psi_needed_v_smax[no_ps][ 24] = get_vector_from_array_int(needed_v_smax_24, 4);
  int needed_v_smax_25[] = {  57,   58,   70,   71,   78,   79}; //   6
  psi_needed_v_smax[no_ps][ 25] = get_vector_from_array_int(needed_v_smax_25, 6);
  int needed_v_smax_26[] = {  57,   58,   59,   60}; //   4
  psi_needed_v_smax[no_ps][ 26] = get_vector_from_array_int(needed_v_smax_26, 4);
  int needed_v_smax_27[] = {  57,   58,   59,   60}; //   4
  psi_needed_v_smax[no_ps][ 27] = get_vector_from_array_int(needed_v_smax_27, 4);
  int needed_v_smax_28[] = {  68,   69,   76,   77}; //   4
  psi_needed_v_smax[no_ps][ 28] = get_vector_from_array_int(needed_v_smax_28, 4);
  int needed_v_smax_29[] = {  70,   71,   78,   79}; //   4
  psi_needed_v_smax[no_ps][ 29] = get_vector_from_array_int(needed_v_smax_29, 4);
  int needed_v_smax_30[] = {  76,   77}; //   2
  psi_needed_v_smax[no_ps][ 30] = get_vector_from_array_int(needed_v_smax_30, 2);
  int needed_v_smax_31[] = {  78,   79}; //   2
  psi_needed_v_smax[no_ps][ 31] = get_vector_from_array_int(needed_v_smax_31, 2);
  int needed_v_smax_32[] = {  80,   81,   32,   33}; //   4
  psi_needed_v_smax[no_ps][ 32] = get_vector_from_array_int(needed_v_smax_32, 4);
  int needed_v_smax_33[] = {  82,   83,   34,   35}; //   4
  psi_needed_v_smax[no_ps][ 33] = get_vector_from_array_int(needed_v_smax_33, 4);
  int needed_v_smax_34[] = {  84,   85}; //   2
  psi_needed_v_smax[no_ps][ 34] = get_vector_from_array_int(needed_v_smax_34, 2);
  int needed_v_smax_35[] = {  84,   85,   86,   87,   68,   69,   72,   73,  116,  117,  118,  119}; //  12
  psi_needed_v_smax[no_ps][ 35] = get_vector_from_array_int(needed_v_smax_35, 12);
  int needed_v_smax_36[] = {  86,   87,   36,   37}; //   4
  psi_needed_v_smax[no_ps][ 36] = get_vector_from_array_int(needed_v_smax_36, 4);
  int needed_v_smax_37[] = {  88,   89}; //   2
  psi_needed_v_smax[no_ps][ 37] = get_vector_from_array_int(needed_v_smax_37, 2);
  int needed_v_smax_38[] = {  88,   89,   90,   91,   70,   71,   74,   75,  122,  123,  124,  125}; //  12
  psi_needed_v_smax[no_ps][ 38] = get_vector_from_array_int(needed_v_smax_38, 12);
  int needed_v_smax_39[] = {  90,   91,   38,   39}; //   4
  psi_needed_v_smax[no_ps][ 39] = get_vector_from_array_int(needed_v_smax_39, 4);
  int needed_v_smax_40[] = {  92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  110,  111,  116,  117,  122,  123}; //  20
  psi_needed_v_smax[no_ps][ 40] = get_vector_from_array_int(needed_v_smax_40, 20);
  int needed_v_smax_41[] = {  92,  102,  103,  110,  111}; //   5
  psi_needed_v_smax[no_ps][ 41] = get_vector_from_array_int(needed_v_smax_41, 5);
  int needed_v_smax_42[] = {  92,   93}; //   2
  psi_needed_v_smax[no_ps][ 42] = get_vector_from_array_int(needed_v_smax_42, 2);
  int needed_v_smax_43[] = {  92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  108,  109,  114,  115,  120,  121,  126,  127}; //  20
  psi_needed_v_smax[no_ps][ 43] = get_vector_from_array_int(needed_v_smax_43, 20);
  int needed_v_smax_44[] = {  93,   94,   95,  116,  117}; //   5
  psi_needed_v_smax[no_ps][ 44] = get_vector_from_array_int(needed_v_smax_44, 5);
  int needed_v_smax_45[] = {  94,   95,   98,   99}; //   4
  psi_needed_v_smax[no_ps][ 45] = get_vector_from_array_int(needed_v_smax_45, 4);
  int needed_v_smax_46[] = {  96,  100,  101,  104,  105}; //   5
  psi_needed_v_smax[no_ps][ 46] = get_vector_from_array_int(needed_v_smax_46, 5);
  int needed_v_smax_47[] = {  96,   97}; //   2
  psi_needed_v_smax[no_ps][ 47] = get_vector_from_array_int(needed_v_smax_47, 2);
  int needed_v_smax_48[] = {  97,   98,   99,  122,  123}; //   5
  psi_needed_v_smax[no_ps][ 48] = get_vector_from_array_int(needed_v_smax_48, 5);
  int needed_v_smax_49[] = { 100,  101,  104,  105,  106,  107}; //   6
  psi_needed_v_smax[no_ps][ 49] = get_vector_from_array_int(needed_v_smax_49, 6);
  int needed_v_smax_50[] = { 102,  103,  110,  111,  112,  113}; //   6
  psi_needed_v_smax[no_ps][ 50] = get_vector_from_array_int(needed_v_smax_50, 6);
  int needed_v_smax_51[] = { 106,  107}; //   2
  psi_needed_v_smax[no_ps][ 51] = get_vector_from_array_int(needed_v_smax_51, 2);
  int needed_v_smax_52[] = { 108,  109,  120,  121,   72,   73}; //   6
  psi_needed_v_smax[no_ps][ 52] = get_vector_from_array_int(needed_v_smax_52, 6);
  int needed_v_smax_53[] = { 112,  113}; //   2
  psi_needed_v_smax[no_ps][ 53] = get_vector_from_array_int(needed_v_smax_53, 2);
  int needed_v_smax_54[] = { 114,  115,  126,  127,   74,   75}; //   6
  psi_needed_v_smax[no_ps][ 54] = get_vector_from_array_int(needed_v_smax_54, 6);
  int needed_v_smax_55[] = { 116,  117,  118,  119}; //   4
  psi_needed_v_smax[no_ps][ 55] = get_vector_from_array_int(needed_v_smax_55, 4);
  int needed_v_smax_56[] = { 118,  119}; //   2
  psi_needed_v_smax[no_ps][ 56] = get_vector_from_array_int(needed_v_smax_56, 2);
  int needed_v_smax_57[] = { 122,  123,  124,  125}; //   4
  psi_needed_v_smax[no_ps][ 57] = get_vector_from_array_int(needed_v_smax_57, 4);
  int needed_v_smax_58[] = { 124,  125}; //   2
  psi_needed_v_smax[no_ps][ 58] = get_vector_from_array_int(needed_v_smax_58, 2);
  int needed_v_smax_59[] = {  80,   81,  104,  105,  106,  107}; //   6
  psi_needed_v_smax[no_ps][ 59] = get_vector_from_array_int(needed_v_smax_59, 6);
  int needed_v_smax_60[] = {  82,   83,  110,  111,  112,  113}; //   6
  psi_needed_v_smax[no_ps][ 60] = get_vector_from_array_int(needed_v_smax_60, 6);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(91);
  psi_needed_g_p[no_ps].resize(91);
  int needed_g_p_0[] = {   0,   10,   11,   12,   22,   23,   26,   27,   34,   35,   42,   43,   48,   66,   67,   88,   89,   90,   91,  112,  113,  114,  115}; //  23
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 23);
  psi_container_IS_name.push_back("propagator_24_smin0_smax0");
  int needed_g_p_1[] = {   0,   12,   48}; //   3
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 3);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    1,   12,   13,   48,   53}; //   6
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 6);
  psi_container_IS_name.push_back("propagator_24_smin2_smax2");
  int needed_g_p_3[] = {   1,    3,   13,   15,   29,   37,   45,   50,   52,   53,   55,   69,   73,   77,   81,  119,  121}; //  17
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 17);
  psi_container_IS_name.push_back("propagator_23_smin3_smax3");
  int needed_g_p_4[] = {   1,   13,   53}; //   3
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 3);
  psi_container_IS_name.push_back("propagator_0_smin4_smax1");
  int needed_g_p_5[] = {   2,   14,   28,   36,   44,   49,   51,   54,   68,   72,   76,   80,  118,  120}; //  14
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 14);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_6[] = {   2,    3,   14,   15,   54,   55}; //   6
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 6);
  psi_container_IS_name.push_back("propagator_0_smin5_smax4");
  int needed_g_p_7[] = {   2,    3,    6,    7,   14,   15,   18,   19,   54,   55,   62,   63}; //  12
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 12);
  psi_container_IS_name.push_back("propagator_24_smin6_smax2");
  int needed_g_p_8[] = {   4,    8,    9,   16,   20,   21,   24,   25,   32,   33,   40,   41,   56,   64,   65,   84,   85,   86,   87,  106,  107,  108,  109}; //  23
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 23);
  psi_container_IS_name.push_back("propagator_24_smin7_smax5");
  int needed_g_p_9[] = {   4,   16,   56}; //   3
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 3);
  psi_container_IS_name.push_back("propagator_0_smin8_smax6");
  int needed_g_p_10[] = {   4,    5,   16,   17,   56,   61}; //   6
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 6);
  psi_container_IS_name.push_back("propagator_24_smin9_smax2");
  int needed_g_p_11[] = {   5,    7,   17,   19,   31,   39,   47,   58,   60,   61,   63,   71,   75,   79,   83,  125,  127}; //  17
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 17);
  psi_container_IS_name.push_back("propagator_23_smin10_smax7");
  int needed_g_p_12[] = {   5,   17,   61}; //   3
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 3);
  psi_container_IS_name.push_back("propagator_0_smin11_smax6");
  int needed_g_p_13[] = {   6,   18,   30,   38,   46,   57,   59,   62,   70,   74,   78,   82,  124,  126}; //  14
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 14);
  psi_container_IS_name.push_back("propagator_0_smin10_smax7");
  int needed_g_p_14[] = {   6,    7,   18,   19,   62,   63}; //   6
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 6);
  psi_container_IS_name.push_back("propagator_0_smin12_smax4");
  int needed_g_p_15[] = {   8,   20,   32,   64,   84,   86,  108}; //   7
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 7);
  psi_container_IS_name.push_back("propagator_0_smin3_smax8");
  int needed_g_p_16[] = {   8,    9,   20,   21,   64,   65}; //   6
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 6);
  psi_container_IS_name.push_back("propagator_24_smin13_smax2");
  int needed_g_p_17[] = {   9,   21,   33,   65,   85,   87,  109}; //   7
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 7);
  psi_container_IS_name.push_back("propagator_23_smin3_smax8");
  int needed_g_p_18[] = {  10,   22,   34,   66,   88,   90,  114}; //   7
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 7);
  psi_container_IS_name.push_back("propagator_0_smin10_smax9");
  int needed_g_p_19[] = {  10,   11,   22,   23,   66,   67}; //   6
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 6);
  psi_container_IS_name.push_back("propagator_24_smin14_smax2");
  int needed_g_p_20[] = {  11,   23,   35,   67,   89,   91,  115}; //   7
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 7);
  psi_container_IS_name.push_back("propagator_23_smin10_smax9");
  int needed_g_p_21[] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  12
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 12);
  psi_container_IS_name.push_back("propagator_0_smin15_smax10");
  int needed_g_p_22[] = {  24,   25,   40,   41}; //   4
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 4);
  psi_container_IS_name.push_back("propagator_0_smin16_smax11");
  int needed_g_p_23[] = {  24,   40}; //   2
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax12");
  int needed_g_p_24[] = {  24,   25}; //   2
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 2);
  psi_container_IS_name.push_back("propagator_0_smin17_smax10");
  int needed_g_p_25[] = {  25,   41}; //   2
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 2);
  psi_container_IS_name.push_back("propagator_23_smin3_smax12");
  int needed_g_p_26[] = {  26,   27,   42,   43}; //   4
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 4);
  psi_container_IS_name.push_back("propagator_0_smin18_smax13");
  int needed_g_p_27[] = {  26,   42}; //   2
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 2);
  psi_container_IS_name.push_back("propagator_0_smin10_smax14");
  int needed_g_p_28[] = {  26,   27}; //   2
  psi_needed_g_p[no_ps][28] = get_vector_from_array_int(needed_g_p_28, 2);
  psi_container_IS_name.push_back("propagator_0_smin19_smax10");
  int needed_g_p_29[] = {  27,   43}; //   2
  psi_needed_g_p[no_ps][29] = get_vector_from_array_int(needed_g_p_29, 2);
  psi_container_IS_name.push_back("propagator_23_smin10_smax14");
  int needed_g_p_30[] = {  28,   29,   44,   45,   51,   52}; //   6
  psi_needed_g_p[no_ps][30] = get_vector_from_array_int(needed_g_p_30, 6);
  psi_container_IS_name.push_back("propagator_0_smin20_smax15");
  int needed_g_p_31[] = {  28,   29,   44,   45}; //   4
  psi_needed_g_p[no_ps][31] = get_vector_from_array_int(needed_g_p_31, 4);
  psi_container_IS_name.push_back("propagator_24_smin7_smax16");
  int needed_g_p_32[] = {  28,   29}; //   2
  psi_needed_g_p[no_ps][32] = get_vector_from_array_int(needed_g_p_32, 2);
  psi_container_IS_name.push_back("propagator_0_smin21_smax10");
  int needed_g_p_33[] = {  30,   31,   46,   47,   59,   60}; //   6
  psi_needed_g_p[no_ps][33] = get_vector_from_array_int(needed_g_p_33, 6);
  psi_container_IS_name.push_back("propagator_0_smin22_smax17");
  int needed_g_p_34[] = {  30,   31,   46,   47}; //   4
  psi_needed_g_p[no_ps][34] = get_vector_from_array_int(needed_g_p_34, 4);
  psi_container_IS_name.push_back("propagator_24_smin0_smax18");
  int needed_g_p_35[] = {  30,   31}; //   2
  psi_needed_g_p[no_ps][35] = get_vector_from_array_int(needed_g_p_35, 2);
  psi_container_IS_name.push_back("propagator_0_smin23_smax10");
  int needed_g_p_36[] = {  36,   37,   72,   73,   80,   81,  120,  121}; //   8
  psi_needed_g_p[no_ps][36] = get_vector_from_array_int(needed_g_p_36, 8);
  psi_container_IS_name.push_back("propagator_24_smin7_smax19");
  int needed_g_p_37[] = {  38,   39,   74,   75,   82,   83,  126,  127}; //   8
  psi_needed_g_p[no_ps][37] = get_vector_from_array_int(needed_g_p_37, 8);
  psi_container_IS_name.push_back("propagator_24_smin0_smax20");
  int needed_g_p_38[] = {  48,   53,   54,   55,   56,   61,   62,   63,   64,   65,   66,   67}; //  12
  psi_needed_g_p[no_ps][38] = get_vector_from_array_int(needed_g_p_38, 12);
  psi_container_IS_name.push_back("propagator_0_smin24_smax21");
  int needed_g_p_39[] = {  49,   50,   68,   69,   76,   77}; //   6
  psi_needed_g_p[no_ps][39] = get_vector_from_array_int(needed_g_p_39, 6);
  psi_container_IS_name.push_back("propagator_0_smin25_smax22");
  int needed_g_p_40[] = {  49,   50}; //   2
  psi_needed_g_p[no_ps][40] = get_vector_from_array_int(needed_g_p_40, 2);
  psi_container_IS_name.push_back("propagator_0_smin26_smax23");
  int needed_g_p_41[] = {  49,   50,   51,   52}; //   4
  psi_needed_g_p[no_ps][41] = get_vector_from_array_int(needed_g_p_41, 4);
  psi_container_IS_name.push_back("propagator_24_smin7_smax24");
  int needed_g_p_42[] = {  51,   52}; //   2
  psi_needed_g_p[no_ps][42] = get_vector_from_array_int(needed_g_p_42, 2);
  psi_container_IS_name.push_back("propagator_0_smin27_smax23");
  int needed_g_p_43[] = {  57,   58,   70,   71,   78,   79}; //   6
  psi_needed_g_p[no_ps][43] = get_vector_from_array_int(needed_g_p_43, 6);
  psi_container_IS_name.push_back("propagator_0_smin28_smax25");
  int needed_g_p_44[] = {  57,   58}; //   2
  psi_needed_g_p[no_ps][44] = get_vector_from_array_int(needed_g_p_44, 2);
  psi_container_IS_name.push_back("propagator_0_smin29_smax26");
  int needed_g_p_45[] = {  57,   58,   59,   60}; //   4
  psi_needed_g_p[no_ps][45] = get_vector_from_array_int(needed_g_p_45, 4);
  psi_container_IS_name.push_back("propagator_24_smin0_smax27");
  int needed_g_p_46[] = {  59,   60}; //   2
  psi_needed_g_p[no_ps][46] = get_vector_from_array_int(needed_g_p_46, 2);
  psi_container_IS_name.push_back("propagator_0_smin30_smax26");
  int needed_g_p_47[] = {  68,   69,   76,   77}; //   4
  psi_needed_g_p[no_ps][47] = get_vector_from_array_int(needed_g_p_47, 4);
  psi_container_IS_name.push_back("propagator_24_smin7_smax28");
  int needed_g_p_48[] = {  70,   71,   78,   79}; //   4
  psi_needed_g_p[no_ps][48] = get_vector_from_array_int(needed_g_p_48, 4);
  psi_container_IS_name.push_back("propagator_24_smin0_smax29");
  int needed_g_p_49[] = {  76,   77}; //   2
  psi_needed_g_p[no_ps][49] = get_vector_from_array_int(needed_g_p_49, 2);
  psi_container_IS_name.push_back("propagator_0_smin16_smax30");
  int needed_g_p_50[] = {  78,   79}; //   2
  psi_needed_g_p[no_ps][50] = get_vector_from_array_int(needed_g_p_50, 2);
  psi_container_IS_name.push_back("propagator_0_smin18_smax31");
  int needed_g_p_51[] = {  80,   81}; //   2
  psi_needed_g_p[no_ps][51] = get_vector_from_array_int(needed_g_p_51, 2);
  psi_container_IS_name.push_back("propagator_0_smin16_smax32");
  int needed_g_p_52[] = {  82,   83}; //   2
  psi_needed_g_p[no_ps][52] = get_vector_from_array_int(needed_g_p_52, 2);
  psi_container_IS_name.push_back("propagator_0_smin18_smax33");
  int needed_g_p_53[] = {  84,   85}; //   2
  psi_needed_g_p[no_ps][53] = get_vector_from_array_int(needed_g_p_53, 2);
  psi_container_IS_name.push_back("propagator_0_smin25_smax34");
  int needed_g_p_54[] = {  84,   85}; //   2
  psi_needed_g_p[no_ps][54] = get_vector_from_array_int(needed_g_p_54, 2);
  psi_container_IS_name.push_back("propagator_0_smin26_smax35");
  int needed_g_p_55[] = {  86,   87}; //   2
  psi_needed_g_p[no_ps][55] = get_vector_from_array_int(needed_g_p_55, 2);
  psi_container_IS_name.push_back("propagator_0_smin20_smax36");
  int needed_g_p_56[] = {  86,   87}; //   2
  psi_needed_g_p[no_ps][56] = get_vector_from_array_int(needed_g_p_56, 2);
  psi_container_IS_name.push_back("propagator_0_smin27_smax35");
  int needed_g_p_57[] = {  88,   89}; //   2
  psi_needed_g_p[no_ps][57] = get_vector_from_array_int(needed_g_p_57, 2);
  psi_container_IS_name.push_back("propagator_0_smin28_smax37");
  int needed_g_p_58[] = {  88,   89}; //   2
  psi_needed_g_p[no_ps][58] = get_vector_from_array_int(needed_g_p_58, 2);
  psi_container_IS_name.push_back("propagator_0_smin29_smax38");
  int needed_g_p_59[] = {  90,   91}; //   2
  psi_needed_g_p[no_ps][59] = get_vector_from_array_int(needed_g_p_59, 2);
  psi_container_IS_name.push_back("propagator_0_smin22_smax39");
  int needed_g_p_60[] = {  90,   91}; //   2
  psi_needed_g_p[no_ps][60] = get_vector_from_array_int(needed_g_p_60, 2);
  psi_container_IS_name.push_back("propagator_0_smin30_smax38");
  int needed_g_p_61[] = {  92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  110,  111,  116,  117,  122,  123}; //  20
  psi_needed_g_p[no_ps][61] = get_vector_from_array_int(needed_g_p_61, 20);
  psi_container_IS_name.push_back("propagator_0_smin24_smax40");
  int needed_g_p_62[] = {  92,  102,  103,  110,  111}; //   5
  psi_needed_g_p[no_ps][62] = get_vector_from_array_int(needed_g_p_62, 5);
  psi_container_IS_name.push_back("propagator_24_smin0_smax41");
  int needed_g_p_63[] = {  92}; //   1
  psi_needed_g_p[no_ps][63] = get_vector_from_array_int(needed_g_p_63, 1);
  psi_container_IS_name.push_back("propagator_0_smin1_smax42");
  int needed_g_p_64[] = {  92,   93}; //   2
  psi_needed_g_p[no_ps][64] = get_vector_from_array_int(needed_g_p_64, 2);
  psi_container_IS_name.push_back("propagator_24_smin2_smax43");
  int needed_g_p_65[] = {  93,   95,  117}; //   3
  psi_needed_g_p[no_ps][65] = get_vector_from_array_int(needed_g_p_65, 3);
  psi_container_IS_name.push_back("propagator_23_smin3_smax44");
  int needed_g_p_66[] = {  93}; //   1
  psi_needed_g_p[no_ps][66] = get_vector_from_array_int(needed_g_p_66, 1);
  psi_container_IS_name.push_back("propagator_0_smin4_smax42");
  int needed_g_p_67[] = {  94,  116}; //   2
  psi_needed_g_p[no_ps][67] = get_vector_from_array_int(needed_g_p_67, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax44");
  int needed_g_p_68[] = {  94,   95}; //   2
  psi_needed_g_p[no_ps][68] = get_vector_from_array_int(needed_g_p_68, 2);
  psi_container_IS_name.push_back("propagator_0_smin5_smax45");
  int needed_g_p_69[] = {  94,   95,   98,   99}; //   4
  psi_needed_g_p[no_ps][69] = get_vector_from_array_int(needed_g_p_69, 4);
  psi_container_IS_name.push_back("propagator_24_smin6_smax43");
  int needed_g_p_70[] = {  96,  100,  101,  104,  105}; //   5
  psi_needed_g_p[no_ps][70] = get_vector_from_array_int(needed_g_p_70, 5);
  psi_container_IS_name.push_back("propagator_24_smin7_smax46");
  int needed_g_p_71[] = {  96}; //   1
  psi_needed_g_p[no_ps][71] = get_vector_from_array_int(needed_g_p_71, 1);
  psi_container_IS_name.push_back("propagator_0_smin8_smax47");
  int needed_g_p_72[] = {  96,   97}; //   2
  psi_needed_g_p[no_ps][72] = get_vector_from_array_int(needed_g_p_72, 2);
  psi_container_IS_name.push_back("propagator_24_smin9_smax43");
  int needed_g_p_73[] = {  97,   99,  123}; //   3
  psi_needed_g_p[no_ps][73] = get_vector_from_array_int(needed_g_p_73, 3);
  psi_container_IS_name.push_back("propagator_23_smin10_smax48");
  int needed_g_p_74[] = {  97}; //   1
  psi_needed_g_p[no_ps][74] = get_vector_from_array_int(needed_g_p_74, 1);
  psi_container_IS_name.push_back("propagator_0_smin11_smax47");
  int needed_g_p_75[] = {  98,  122}; //   2
  psi_needed_g_p[no_ps][75] = get_vector_from_array_int(needed_g_p_75, 2);
  psi_container_IS_name.push_back("propagator_0_smin10_smax48");
  int needed_g_p_76[] = {  98,   99}; //   2
  psi_needed_g_p[no_ps][76] = get_vector_from_array_int(needed_g_p_76, 2);
  psi_container_IS_name.push_back("propagator_0_smin12_smax45");
  int needed_g_p_77[] = { 100,  104,  106}; //   3
  psi_needed_g_p[no_ps][77] = get_vector_from_array_int(needed_g_p_77, 3);
  psi_container_IS_name.push_back("propagator_0_smin3_smax49");
  int needed_g_p_78[] = { 100,  101}; //   2
  psi_needed_g_p[no_ps][78] = get_vector_from_array_int(needed_g_p_78, 2);
  psi_container_IS_name.push_back("propagator_24_smin13_smax43");
  int needed_g_p_79[] = { 101,  105,  107}; //   3
  psi_needed_g_p[no_ps][79] = get_vector_from_array_int(needed_g_p_79, 3);
  psi_container_IS_name.push_back("propagator_23_smin3_smax49");
  int needed_g_p_80[] = { 102,  110,  112}; //   3
  psi_needed_g_p[no_ps][80] = get_vector_from_array_int(needed_g_p_80, 3);
  psi_container_IS_name.push_back("propagator_0_smin10_smax50");
  int needed_g_p_81[] = { 102,  103}; //   2
  psi_needed_g_p[no_ps][81] = get_vector_from_array_int(needed_g_p_81, 2);
  psi_container_IS_name.push_back("propagator_24_smin14_smax43");
  int needed_g_p_82[] = { 103,  111,  113}; //   3
  psi_needed_g_p[no_ps][82] = get_vector_from_array_int(needed_g_p_82, 3);
  psi_container_IS_name.push_back("propagator_23_smin10_smax50");
  int needed_g_p_83[] = { 106,  107}; //   2
  psi_needed_g_p[no_ps][83] = get_vector_from_array_int(needed_g_p_83, 2);
  psi_container_IS_name.push_back("propagator_0_smin24_smax51");
  int needed_g_p_84[] = { 108,  109,  120,  121}; //   4
  psi_needed_g_p[no_ps][84] = get_vector_from_array_int(needed_g_p_84, 4);
  psi_container_IS_name.push_back("propagator_0_smin24_smax52");
  int needed_g_p_85[] = { 112,  113}; //   2
  psi_needed_g_p[no_ps][85] = get_vector_from_array_int(needed_g_p_85, 2);
  psi_container_IS_name.push_back("propagator_0_smin24_smax53");
  int needed_g_p_86[] = { 114,  115,  126,  127}; //   4
  psi_needed_g_p[no_ps][86] = get_vector_from_array_int(needed_g_p_86, 4);
  psi_container_IS_name.push_back("propagator_0_smin24_smax54");
  int needed_g_p_87[] = { 116,  117,  118,  119}; //   4
  psi_needed_g_p[no_ps][87] = get_vector_from_array_int(needed_g_p_87, 4);
  psi_container_IS_name.push_back("propagator_24_smin7_smax55");
  int needed_g_p_88[] = { 118,  119}; //   2
  psi_needed_g_p[no_ps][88] = get_vector_from_array_int(needed_g_p_88, 2);
  psi_container_IS_name.push_back("propagator_0_smin24_smax56");
  int needed_g_p_89[] = { 122,  123,  124,  125}; //   4
  psi_needed_g_p[no_ps][89] = get_vector_from_array_int(needed_g_p_89, 4);
  psi_container_IS_name.push_back("propagator_24_smin0_smax57");
  int needed_g_p_90[] = { 124,  125}; //   2
  psi_needed_g_p[no_ps][90] = get_vector_from_array_int(needed_g_p_90, 2);
  psi_container_IS_name.push_back("propagator_0_smin24_smax58");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(21);
  psi_needed_g_f[no_ps].resize(21);
  int needed_g_f_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 12);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax10");
  int needed_g_f_1[] = {  32,   33}; //   2
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax32");
  int needed_g_f_2[] = {  32,   33,   40,   41}; //   4
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax10");
  int needed_g_f_3[] = {  34,   35}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin18_smax33");
  int needed_g_f_4[] = {  34,   35,   42,   43}; //   4
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin19_smax10");
  int needed_g_f_5[] = {  36,   37}; //   2
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin20_smax36");
  int needed_g_f_6[] = {  36,   37,   44,   45}; //   4
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin21_smax10");
  int needed_g_f_7[] = {  38,   39}; //   2
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin22_smax39");
  int needed_g_f_8[] = {  38,   39,   46,   47}; //   4
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin23_smax10");
  int needed_g_f_9[] = {  68,   69}; //   2
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin26_smax35");
  int needed_g_f_10[] = {  70,   71}; //   2
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin29_smax38");
  int needed_g_f_11[] = {  72,   73}; //   2
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin24_smax52");
  int needed_g_f_12[] = {  72,   73,  116,  117,  118,  119}; //   6
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 6);
  psi_container_IS_name.push_back("timelikeinvariant_smin31_smax35");
  int needed_g_f_13[] = {  74,   75}; //   2
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin24_smax54");
  int needed_g_f_14[] = {  74,   75,  122,  123,  124,  125}; //   6
  psi_needed_g_f[no_ps][14] = get_vector_from_array_int(needed_g_f_14, 6);
  psi_container_IS_name.push_back("timelikeinvariant_smin32_smax38");
  int needed_g_f_15[] = {  80,   81}; //   2
  psi_needed_g_f[no_ps][15] = get_vector_from_array_int(needed_g_f_15, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin33_smax59");
  int needed_g_f_16[] = {  82,   83}; //   2
  psi_needed_g_f[no_ps][16] = get_vector_from_array_int(needed_g_f_16, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin34_smax60");
  int needed_g_f_17[] = { 104,  105,  106,  107}; //   4
  psi_needed_g_f[no_ps][17] = get_vector_from_array_int(needed_g_f_17, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin35_smax59");
  int needed_g_f_18[] = { 108,  109,  120,  121}; //   4
  psi_needed_g_f[no_ps][18] = get_vector_from_array_int(needed_g_f_18, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax43");
  int needed_g_f_19[] = { 110,  111,  112,  113}; //   4
  psi_needed_g_f[no_ps][19] = get_vector_from_array_int(needed_g_f_19, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin36_smax60");
  int needed_g_f_20[] = { 114,  115,  126,  127}; //   4
  psi_needed_g_f[no_ps][20] = get_vector_from_array_int(needed_g_f_20, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin14_smax43");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(40);
  psi_needed_g_t[no_ps].resize(40);
  int needed_g_t_0[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47}; //  48
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 48);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__128_124");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__128_124");
  int needed_g_t_1[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11}; //  12
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 12);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__130_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__130_1__64_60");
  int needed_g_t_2[] = {  32,   33,   40,   41}; //   4
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__12_112");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__12_112");
  int needed_g_t_3[] = {  32,   33}; //   2
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_13__64_48");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_13__64_48");
  int needed_g_t_4[] = {  34,   35,   42,   43}; //   4
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__20_104");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__20_104");
  int needed_g_t_5[] = {  34,   35}; //   2
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_21__64_40");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_21__64_40");
  int needed_g_t_6[] = {  36,   37,   44,   45}; //   4
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__48_76");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__48_76");
  int needed_g_t_7[] = {  36,   37}; //   2
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_49__64_12");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_49__64_12");
  int needed_g_t_8[] = {  38,   39,   46,   47}; //   4
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__40_84");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__40_84");
  int needed_g_t_9[] = {  38,   39}; //   2
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_41__64_20");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_41__64_20");
  int needed_g_t_10[] = {  48,   53,   54,   55,   56,   61,   62,   63,   64,   65,   66,   67,  108,  109,  114,  115,  120,  121,  126,  127}; //  20
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 20);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__192_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__192_60");
  int needed_g_t_11[] = {  49,   50,   51,   52,   68,   69,   72,   73,  116,  117,  118,  119}; //  12
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 12);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__48_204");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__48_204");
  int needed_g_t_12[] = {  57,   58,   59,   60,   70,   71,   74,   75,  122,  123,  124,  125}; //  12
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 12);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__40_212");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__40_212");
  int needed_g_t_13[] = {  68,   69}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__140_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__140_64");
  int needed_g_t_14[] = {  70,   71}; //   2
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__148_64");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__148_64");
  int needed_g_t_15[] = {  72,   73,  118,  119}; //   4
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__12_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__12_192");
  int needed_g_t_16[] = {  72,   73}; //   2
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__49_14__64_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__49_14__64_128");
  int needed_g_t_17[] = {  74,   75,  124,  125}; //   4
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__20_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__20_192");
  int needed_g_t_18[] = {  74,   75}; //   2
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__41_22__64_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__41_22__64_128");
  int needed_g_t_19[] = {  76,   77}; //   2
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__112_140");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__112_140");
  int needed_g_t_20[] = {  78,   79}; //   2
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__104_148");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__104_148");
  int needed_g_t_21[] = {  80,   81}; //   2
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__12_240");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__12_240");
  int needed_g_t_22[] = {  80,   81}; //   2
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_14__112_128");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_14__112_128");
  int needed_g_t_23[] = {  82,   83}; //   2
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__20_232");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__20_232");
  int needed_g_t_24[] = {  82,   83}; //   2
  psi_needed_g_t[no_ps][24] = get_vector_from_array_int(needed_g_t_24, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_22__104_128");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_22__104_128");
  int needed_g_t_25[] = {  84,   85,   86,   87}; //   4
  psi_needed_g_t[no_ps][25] = get_vector_from_array_int(needed_g_t_25, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__48_204");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__48_204");
  int needed_g_t_26[] = {  88,   89,   90,   91}; //   4
  psi_needed_g_t[no_ps][26] = get_vector_from_array_int(needed_g_t_26, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__40_212");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__40_212");
  int needed_g_t_27[] = {  92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103}; //  12
  psi_needed_g_t[no_ps][27] = get_vector_from_array_int(needed_g_t_27, 12);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__192_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__192_60");
  int needed_g_t_28[] = { 104,  105,  106,  107}; //   4
  psi_needed_g_t[no_ps][28] = get_vector_from_array_int(needed_g_t_28, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__12_240");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__12_240");
  int needed_g_t_29[] = { 104,  105}; //   2
  psi_needed_g_t[no_ps][29] = get_vector_from_array_int(needed_g_t_29, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__192_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__192_48");
  int needed_g_t_30[] = { 106,  107}; //   2
  psi_needed_g_t[no_ps][30] = get_vector_from_array_int(needed_g_t_30, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_13__48_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_13__48_192");
  int needed_g_t_31[] = { 108,  109}; //   2
  psi_needed_g_t[no_ps][31] = get_vector_from_array_int(needed_g_t_31, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__48_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__48_12");
  int needed_g_t_32[] = { 110,  111,  112,  113}; //   4
  psi_needed_g_t[no_ps][32] = get_vector_from_array_int(needed_g_t_32, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__20_232");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__20_232");
  int needed_g_t_33[] = { 110,  111}; //   2
  psi_needed_g_t[no_ps][33] = get_vector_from_array_int(needed_g_t_33, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_21__192_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_21__192_40");
  int needed_g_t_34[] = { 112,  113}; //   2
  psi_needed_g_t[no_ps][34] = get_vector_from_array_int(needed_g_t_34, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_21__40_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_21__40_192");
  int needed_g_t_35[] = { 114,  115}; //   2
  psi_needed_g_t[no_ps][35] = get_vector_from_array_int(needed_g_t_35, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__40_20");
  int needed_g_t_36[] = { 116,  117}; //   2
  psi_needed_g_t[no_ps][36] = get_vector_from_array_int(needed_g_t_36, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_49__192_12");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_49__192_12");
  int needed_g_t_37[] = { 120,  121}; //   2
  psi_needed_g_t[no_ps][37] = get_vector_from_array_int(needed_g_t_37, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__12_48");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__12_48");
  int needed_g_t_38[] = { 122,  123}; //   2
  psi_needed_g_t[no_ps][38] = get_vector_from_array_int(needed_g_t_38, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__192_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__192_20");
  int needed_g_t_39[] = { 126,  127}; //   2
  psi_needed_g_t[no_ps][39] = get_vector_from_array_int(needed_g_t_39, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__20_40");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(31);
  psi_needed_g_d[no_ps].resize(31);
  int needed_g_d_0[] = {   0,    1,   12,   13,   48,   53,   92,   93}; //   8
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_1[] = {   0,   12,   48,   92}; //   4
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 4);
  psi_container_IS_name.push_back("costheta_of_decay_44__4_40");
  psi_container_IS_name.push_back("phi_of_decay_44__4_40");
  int needed_g_d_2[] = {   0,   10,   11,   12,   22,   23,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   48,   57,   58,   59,   60,   66,   67,   70,   71,   74,   75,   78,   79,   82,   83,   88,   89,   90,   91,   92,  102,  103,  110,  111,  112,  113,  114,  115,  122,  123,  124,  125,  126,  127}; //  52
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 52);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_3[] = {   1,   13,   53,   93}; //   4
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 4);
  psi_container_IS_name.push_back("costheta_of_decay_44__32_12");
  psi_container_IS_name.push_back("phi_of_decay_44__32_12");
  int needed_g_d_4[] = {   1,    2,    3,    8,    9,   13,   14,   15,   20,   21,   24,   25,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   49,   50,   51,   52,   53,   54,   55,   64,   65,   68,   69,   72,   73,   76,   77,   80,   81,   84,   85,   86,   87,   93,   94,   95,  100,  101,  104,  105,  106,  107,  108,  109,  116,  117,  118,  119,  120,  121}; //  60
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 60);
  psi_container_IS_name.push_back("costheta_of_decay_12__4_8");
  psi_container_IS_name.push_back("phi_of_decay_12__4_8");
  int needed_g_d_5[] = {   2,    3,    6,    7,   14,   15,   18,   19,   54,   55,   62,   63,   94,   95,   98,   99}; //  16
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_6[] = {   2,    3,   14,   15,   54,   55,   94,   95}; //   8
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 8);
  psi_container_IS_name.push_back("costheta_of_decay_28__16_12");
  psi_container_IS_name.push_back("phi_of_decay_28__16_12");
  int needed_g_d_7[] = {   4,    5,   16,   17,   56,   61,   96,   97}; //   8
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_8[] = {   4,   16,   56,   96}; //   4
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 4);
  psi_container_IS_name.push_back("costheta_of_decay_52__4_48");
  psi_container_IS_name.push_back("phi_of_decay_52__4_48");
  int needed_g_d_9[] = {   4,    8,    9,   16,   20,   21,   24,   25,   28,   29,   32,   33,   36,   37,   40,   41,   44,   45,   49,   50,   51,   52,   56,   64,   65,   68,   69,   72,   73,   76,   77,   80,   81,   84,   85,   86,   87,   96,  100,  101,  104,  105,  106,  107,  108,  109,  116,  117,  118,  119,  120,  121}; //  52
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 52);
  psi_container_IS_name.push_back("costheta_of_decay_48__16_32");
  psi_container_IS_name.push_back("phi_of_decay_48__16_32");
  int needed_g_d_10[] = {   5,   17,   61,   97}; //   4
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 4);
  psi_container_IS_name.push_back("costheta_of_decay_52__32_20");
  psi_container_IS_name.push_back("phi_of_decay_52__32_20");
  int needed_g_d_11[] = {   5,    6,    7,   10,   11,   17,   18,   19,   22,   23,   26,   27,   30,   31,   34,   35,   38,   39,   42,   43,   46,   47,   57,   58,   59,   60,   61,   62,   63,   66,   67,   70,   71,   74,   75,   78,   79,   82,   83,   88,   89,   90,   91,   97,   98,   99,  102,  103,  110,  111,  112,  113,  114,  115,  122,  123,  124,  125,  126,  127}; //  60
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 60);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_12[] = {   6,    7,   18,   19,   62,   63,   98,   99}; //   8
  psi_needed_g_d[no_ps][12] = get_vector_from_array_int(needed_g_d_12, 8);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_13[] = {   8,    9,   20,   21,   64,   65,  100,  101}; //   8
  psi_needed_g_d[no_ps][13] = get_vector_from_array_int(needed_g_d_13, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__12_48");
  psi_container_IS_name.push_back("phi_of_decay_60__12_48");
  int needed_g_d_14[] = {  10,   11,   22,   23,   66,   67,  102,  103}; //   8
  psi_needed_g_d[no_ps][14] = get_vector_from_array_int(needed_g_d_14, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__20_40");
  psi_container_IS_name.push_back("phi_of_decay_60__20_40");
  int needed_g_d_15[] = {  12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23}; //  12
  psi_needed_g_d[no_ps][15] = get_vector_from_array_int(needed_g_d_15, 12);
  psi_container_IS_name.push_back("costheta_of_decay_124__64_60");
  psi_container_IS_name.push_back("phi_of_decay_124__64_60");
  int needed_g_d_16[] = {  24,   25}; //   2
  psi_needed_g_d[no_ps][16] = get_vector_from_array_int(needed_g_d_16, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__12_112");
  psi_container_IS_name.push_back("phi_of_decay_124__12_112");
  int needed_g_d_17[] = {  24,   25,   40,   41,   76,   77,   80,   81}; //   8
  psi_needed_g_d[no_ps][17] = get_vector_from_array_int(needed_g_d_17, 8);
  psi_container_IS_name.push_back("costheta_of_decay_112__64_48");
  psi_container_IS_name.push_back("phi_of_decay_112__64_48");
  int needed_g_d_18[] = {  26,   27}; //   2
  psi_needed_g_d[no_ps][18] = get_vector_from_array_int(needed_g_d_18, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__20_104");
  psi_container_IS_name.push_back("phi_of_decay_124__20_104");
  int needed_g_d_19[] = {  26,   27,   42,   43,   78,   79,   82,   83}; //   8
  psi_needed_g_d[no_ps][19] = get_vector_from_array_int(needed_g_d_19, 8);
  psi_container_IS_name.push_back("costheta_of_decay_104__64_40");
  psi_container_IS_name.push_back("phi_of_decay_104__64_40");
  int needed_g_d_20[] = {  28,   29}; //   2
  psi_needed_g_d[no_ps][20] = get_vector_from_array_int(needed_g_d_20, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__48_76");
  psi_container_IS_name.push_back("phi_of_decay_124__48_76");
  int needed_g_d_21[] = {  28,   29,   44,   45,   51,   52,   86,   87}; //   8
  psi_needed_g_d[no_ps][21] = get_vector_from_array_int(needed_g_d_21, 8);
  psi_container_IS_name.push_back("costheta_of_decay_76__64_12");
  psi_container_IS_name.push_back("phi_of_decay_76__64_12");
  int needed_g_d_22[] = {  30,   31}; //   2
  psi_needed_g_d[no_ps][22] = get_vector_from_array_int(needed_g_d_22, 2);
  psi_container_IS_name.push_back("costheta_of_decay_124__40_84");
  psi_container_IS_name.push_back("phi_of_decay_124__40_84");
  int needed_g_d_23[] = {  30,   31,   46,   47,   59,   60,   90,   91}; //   8
  psi_needed_g_d[no_ps][23] = get_vector_from_array_int(needed_g_d_23, 8);
  psi_container_IS_name.push_back("costheta_of_decay_84__64_20");
  psi_container_IS_name.push_back("phi_of_decay_84__64_20");
  int needed_g_d_24[] = {  48,   53,   54,   55,   56,   61,   62,   63,   64,   65,   66,   67,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,  111,  112,  113,  114,  115,  116,  117,  118,  119,  120,  121,  122,  123,  124,  125,  126,  127}; //  48
  psi_needed_g_d[no_ps][24] = get_vector_from_array_int(needed_g_d_24, 48);
  psi_container_IS_name.push_back("costheta_of_decay_192__64_128");
  psi_container_IS_name.push_back("phi_of_decay_192__64_128");
  int needed_g_d_25[] = {  49,   50,   84,   85}; //   4
  psi_needed_g_d[no_ps][25] = get_vector_from_array_int(needed_g_d_25, 4);
  psi_container_IS_name.push_back("costheta_of_decay_204__64_140");
  psi_container_IS_name.push_back("phi_of_decay_204__64_140");
  int needed_g_d_26[] = {  49,   50,   68,   69,   76,   77,   84,   85}; //   8
  psi_needed_g_d[no_ps][26] = get_vector_from_array_int(needed_g_d_26, 8);
  psi_container_IS_name.push_back("costheta_of_decay_140__128_12");
  psi_container_IS_name.push_back("phi_of_decay_140__128_12");
  int needed_g_d_27[] = {  51,   52,   86,   87}; //   4
  psi_needed_g_d[no_ps][27] = get_vector_from_array_int(needed_g_d_27, 4);
  psi_container_IS_name.push_back("costheta_of_decay_204__128_76");
  psi_container_IS_name.push_back("phi_of_decay_204__128_76");
  int needed_g_d_28[] = {  57,   58,   88,   89}; //   4
  psi_needed_g_d[no_ps][28] = get_vector_from_array_int(needed_g_d_28, 4);
  psi_container_IS_name.push_back("costheta_of_decay_212__64_148");
  psi_container_IS_name.push_back("phi_of_decay_212__64_148");
  int needed_g_d_29[] = {  57,   58,   70,   71,   78,   79,   88,   89}; //   8
  psi_needed_g_d[no_ps][29] = get_vector_from_array_int(needed_g_d_29, 8);
  psi_container_IS_name.push_back("costheta_of_decay_148__128_20");
  psi_container_IS_name.push_back("phi_of_decay_148__128_20");
  int needed_g_d_30[] = {  59,   60,   90,   91}; //   4
  psi_needed_g_d[no_ps][30] = get_vector_from_array_int(needed_g_d_30, 4);
  psi_container_IS_name.push_back("costheta_of_decay_212__128_84");
  psi_container_IS_name.push_back("phi_of_decay_212__128_84");

  psi_c_p[no_ps].resize(128);
  psi_c_f[no_ps].resize(128);
  psi_c_t[no_ps].resize(128);
  psi_c_d[no_ps].resize(128);

  int c_p_0[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 3);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  3,   4,   2}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {  0}; //   1
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 1);
  int c_t_1[] = {  0,   1}; //   2
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 2);
  int c_d_1[] = {  0,   3,   4}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  5,   6,   7}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {  0}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  0,   1}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  5,   6,   4}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  3,   6,   7}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {  0}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  0,   1}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  5,   6,   4}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  8,   9,  10}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {  0}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  0,   1}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  7,   8,   9}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = { 11,  12,  10}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {  0}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = {  0,   1}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  7,  10,  11}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = { 13,  14,   7}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {  0}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = {  0,   1}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  5,  12,  11}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = { 11,  14,   7}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {  0}; //   1
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 1);
  int c_t_7[] = {  0,   1}; //   2
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 2);
  int c_d_7[] = {  5,  12,  11}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  8,  15,  16}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {  0}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = {  0,   1}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = { 13,   4,   9}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  8,  17,  16}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {  0}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = {  0,   1}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = { 13,   4,   9}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = {  0,  18,  19}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {  0}; //   1
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 1);
  int c_t_10[] = {  0,   1}; //   2
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 2);
  int c_d_10[] = { 14,  11,   2}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  0,  20,  19}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {  0}; //   1
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 1);
  int c_t_11[] = {  0,   1}; //   2
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 2);
  int c_d_11[] = { 14,  11,   2}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  0,   1,   2,  21}; //   4
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 4);
  int c_f_12[] = {}; //   0
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 0);
  int c_t_12[] = {  0}; //   1
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 1);
  int c_d_12[] = { 15,   0,   1,   2}; //   4
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 4);

  int c_p_13[] = {  3,   4,   2,  21}; //   4
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 4);
  int c_f_13[] = {}; //   0
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 0);
  int c_t_13[] = {  0}; //   1
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 1);
  int c_d_13[] = { 15,   0,   3,   4}; //   4
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 4);

  int c_p_14[] = {  5,   6,   7,  21}; //   4
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 4);
  int c_f_14[] = {}; //   0
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 0);
  int c_t_14[] = {  0}; //   1
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 1);
  int c_d_14[] = { 15,   5,   6,   4}; //   4
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 4);

  int c_p_15[] = {  3,   6,   7,  21}; //   4
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 4);
  int c_f_15[] = {}; //   0
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 0);
  int c_t_15[] = {  0}; //   1
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 1);
  int c_d_15[] = { 15,   5,   6,   4}; //   4
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 4);

  int c_p_16[] = {  8,   9,  10,  21}; //   4
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 4);
  int c_f_16[] = {}; //   0
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 0);
  int c_t_16[] = {  0}; //   1
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 1);
  int c_d_16[] = { 15,   7,   8,   9}; //   4
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 4);

  int c_p_17[] = { 11,  12,  10,  21}; //   4
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 4);
  int c_f_17[] = {}; //   0
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 0);
  int c_t_17[] = {  0}; //   1
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 1);
  int c_d_17[] = { 15,   7,  10,  11}; //   4
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 4);

  int c_p_18[] = { 13,  14,   7,  21}; //   4
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 4);
  int c_f_18[] = {}; //   0
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 0);
  int c_t_18[] = {  0}; //   1
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 1);
  int c_d_18[] = { 15,   5,  12,  11}; //   4
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 4);

  int c_p_19[] = { 11,  14,   7,  21}; //   4
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 4);
  int c_f_19[] = {}; //   0
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 0);
  int c_t_19[] = {  0}; //   1
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 1);
  int c_d_19[] = { 15,   5,  12,  11}; //   4
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 4);

  int c_p_20[] = {  8,  15,  16,  21}; //   4
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 4);
  int c_f_20[] = {}; //   0
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 0);
  int c_t_20[] = {  0}; //   1
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 1);
  int c_d_20[] = { 15,  13,   4,   9}; //   4
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 4);

  int c_p_21[] = {  8,  17,  16,  21}; //   4
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 4);
  int c_f_21[] = {}; //   0
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 0);
  int c_t_21[] = {  0}; //   1
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 1);
  int c_d_21[] = { 15,  13,   4,   9}; //   4
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 4);

  int c_p_22[] = {  0,  18,  19,  21}; //   4
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 4);
  int c_f_22[] = {}; //   0
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 0);
  int c_t_22[] = {  0}; //   1
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 1);
  int c_d_22[] = { 15,  14,  11,   2}; //   4
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 4);

  int c_p_23[] = {  0,  20,  19,  21}; //   4
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 4);
  int c_f_23[] = {}; //   0
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 0);
  int c_t_23[] = {  0}; //   1
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 1);
  int c_d_23[] = { 15,  14,  11,   2}; //   4
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 4);

  int c_p_24[] = {  8,  22,  23,  24}; //   4
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 4);
  int c_f_24[] = {}; //   0
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 0);
  int c_t_24[] = {  0}; //   1
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 1);
  int c_d_24[] = { 16,   4,  17,   9}; //   4
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 4);

  int c_p_25[] = {  8,  22,  25,  24}; //   4
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 4);
  int c_f_25[] = {}; //   0
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 0);
  int c_t_25[] = {  0}; //   1
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 1);
  int c_d_25[] = { 16,   4,  17,   9}; //   4
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 4);

  int c_p_26[] = {  0,  26,  27,  28}; //   4
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 4);
  int c_f_26[] = {}; //   0
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 0);
  int c_t_26[] = {  0}; //   1
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 1);
  int c_d_26[] = { 18,  11,  19,   2}; //   4
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 4);

  int c_p_27[] = {  0,  26,  29,  28}; //   4
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 4);
  int c_f_27[] = {}; //   0
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 0);
  int c_t_27[] = {  0}; //   1
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 1);
  int c_d_27[] = { 18,  11,  19,   2}; //   4
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 4);

  int c_p_28[] = {  5,  30,  31,  32}; //   4
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 4);
  int c_f_28[] = {}; //   0
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 0);
  int c_t_28[] = {  0}; //   1
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 1);
  int c_d_28[] = { 20,   9,  21,   4}; //   4
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 4);

  int c_p_29[] = {  3,  30,  31,  32}; //   4
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 4);
  int c_f_29[] = {}; //   0
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 0);
  int c_t_29[] = {  0}; //   1
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 1);
  int c_d_29[] = { 20,   9,  21,   4}; //   4
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 4);

  int c_p_30[] = { 13,  33,  34,  35}; //   4
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 4);
  int c_f_30[] = {}; //   0
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 0);
  int c_t_30[] = {  0}; //   1
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 1);
  int c_d_30[] = { 22,   2,  23,  11}; //   4
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 4);

  int c_p_31[] = { 11,  33,  34,  35}; //   4
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 4);
  int c_f_31[] = {}; //   0
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 0);
  int c_t_31[] = {  0}; //   1
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 1);
  int c_d_31[] = { 22,   2,  23,  11}; //   4
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 4);

  int c_p_32[] = {  8,  15}; //   2
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 2);
  int c_f_32[] = {  1,   2}; //   2
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 2);
  int c_t_32[] = {  0,   2,   3}; //   3
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 3);
  int c_d_32[] = {  4,   9}; //   2
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 2);

  int c_p_33[] = {  8,  17}; //   2
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 2);
  int c_f_33[] = {  1,   2}; //   2
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 2);
  int c_t_33[] = {  0,   2,   3}; //   3
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 3);
  int c_d_33[] = {  4,   9}; //   2
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 2);

  int c_p_34[] = {  0,  18}; //   2
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 2);
  int c_f_34[] = {  3,   4}; //   2
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 2);
  int c_t_34[] = {  0,   4,   5}; //   3
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 3);
  int c_d_34[] = { 11,   2}; //   2
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 2);

  int c_p_35[] = {  0,  20}; //   2
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 2);
  int c_f_35[] = {  3,   4}; //   2
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 2);
  int c_t_35[] = {  0,   4,   5}; //   3
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 3);
  int c_d_35[] = { 11,   2}; //   2
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 2);

  int c_p_36[] = {  5,  36}; //   2
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 2);
  int c_f_36[] = {  5,   6}; //   2
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 2);
  int c_t_36[] = {  0,   6,   7}; //   3
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 3);
  int c_d_36[] = {  9,   4}; //   2
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 2);

  int c_p_37[] = {  3,  36}; //   2
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 2);
  int c_f_37[] = {  5,   6}; //   2
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 2);
  int c_t_37[] = {  0,   6,   7}; //   3
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 3);
  int c_d_37[] = {  9,   4}; //   2
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 2);

  int c_p_38[] = { 13,  37}; //   2
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 2);
  int c_f_38[] = {  7,   8}; //   2
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 2);
  int c_t_38[] = {  0,   8,   9}; //   3
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 3);
  int c_d_38[] = {  2,  11}; //   2
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 2);

  int c_p_39[] = { 11,  37}; //   2
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 2);
  int c_f_39[] = {  7,   8}; //   2
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 2);
  int c_t_39[] = {  0,   8,   9}; //   3
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 3);
  int c_d_39[] = {  2,  11}; //   2
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 2);

  int c_p_40[] = {  8,  22,  23}; //   3
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 3);
  int c_f_40[] = {  2}; //   1
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 1);
  int c_t_40[] = {  0,   2}; //   2
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 2);
  int c_d_40[] = {  4,  17,   9}; //   3
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 3);

  int c_p_41[] = {  8,  22,  25}; //   3
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 3);
  int c_f_41[] = {  2}; //   1
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 1);
  int c_t_41[] = {  0,   2}; //   2
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 2);
  int c_d_41[] = {  4,  17,   9}; //   3
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 3);

  int c_p_42[] = {  0,  26,  27}; //   3
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 3);
  int c_f_42[] = {  4}; //   1
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 1);
  int c_t_42[] = {  0,   4}; //   2
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 2);
  int c_d_42[] = { 11,  19,   2}; //   3
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 3);

  int c_p_43[] = {  0,  26,  29}; //   3
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 3);
  int c_f_43[] = {  4}; //   1
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 1);
  int c_t_43[] = {  0,   4}; //   2
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 2);
  int c_d_43[] = { 11,  19,   2}; //   3
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 3);

  int c_p_44[] = {  5,  30,  31}; //   3
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 3);
  int c_f_44[] = {  6}; //   1
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 1);
  int c_t_44[] = {  0,   6}; //   2
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 2);
  int c_d_44[] = {  9,  21,   4}; //   3
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 3);

  int c_p_45[] = {  3,  30,  31}; //   3
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 3);
  int c_f_45[] = {  6}; //   1
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 1);
  int c_t_45[] = {  0,   6}; //   2
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 2);
  int c_d_45[] = {  9,  21,   4}; //   3
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 3);

  int c_p_46[] = { 13,  33,  34}; //   3
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 3);
  int c_f_46[] = {  8}; //   1
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 1);
  int c_t_46[] = {  0,   8}; //   2
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 2);
  int c_d_46[] = {  2,  23,  11}; //   3
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 3);

  int c_p_47[] = { 11,  33,  34}; //   3
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 3);
  int c_f_47[] = {  8}; //   1
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 1);
  int c_t_47[] = {  0,   8}; //   2
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 2);
  int c_d_47[] = {  2,  23,  11}; //   3
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 3);

  int c_p_48[] = {  0,   1,   2,  38}; //   4
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 4);
  int c_f_48[] = {}; //   0
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 0);
  int c_t_48[] = { 10}; //   1
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 1);
  int c_d_48[] = { 24,   0,   1,   2}; //   4
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 4);

  int c_p_49[] = {  5,  39,  40,  41}; //   4
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 4);
  int c_f_49[] = {}; //   0
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 0);
  int c_t_49[] = { 11}; //   1
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 1);
  int c_d_49[] = {  9,  25,  26,   4}; //   4
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 4);

  int c_p_50[] = {  3,  39,  40,  41}; //   4
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 4);
  int c_f_50[] = {}; //   0
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 0);
  int c_t_50[] = { 11}; //   1
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 1);
  int c_d_50[] = {  9,  25,  26,   4}; //   4
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 4);

  int c_p_51[] = {  5,  30,  42,  41}; //   4
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 4);
  int c_f_51[] = {}; //   0
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 0);
  int c_t_51[] = { 11}; //   1
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 1);
  int c_d_51[] = {  9,  27,  21,   4}; //   4
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 4);

  int c_p_52[] = {  3,  30,  42,  41}; //   4
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 4);
  int c_f_52[] = {}; //   0
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 0);
  int c_t_52[] = { 11}; //   1
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 1);
  int c_d_52[] = {  9,  27,  21,   4}; //   4
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 4);

  int c_p_53[] = {  3,   4,   2,  38}; //   4
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 4);
  int c_f_53[] = {}; //   0
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 0);
  int c_t_53[] = { 10}; //   1
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 1);
  int c_d_53[] = { 24,   0,   3,   4}; //   4
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 4);

  int c_p_54[] = {  5,   6,   7,  38}; //   4
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 4);
  int c_f_54[] = {}; //   0
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 0);
  int c_t_54[] = { 10}; //   1
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 1);
  int c_d_54[] = { 24,   5,   6,   4}; //   4
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 4);

  int c_p_55[] = {  3,   6,   7,  38}; //   4
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 4);
  int c_f_55[] = {}; //   0
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 0);
  int c_t_55[] = { 10}; //   1
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 1);
  int c_d_55[] = { 24,   5,   6,   4}; //   4
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 4);

  int c_p_56[] = {  8,   9,  10,  38}; //   4
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 4);
  int c_f_56[] = {}; //   0
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 0);
  int c_t_56[] = { 10}; //   1
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 1);
  int c_d_56[] = { 24,   7,   8,   9}; //   4
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 4);

  int c_p_57[] = { 13,  43,  44,  45}; //   4
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 4);
  int c_f_57[] = {}; //   0
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 0);
  int c_t_57[] = { 12}; //   1
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 1);
  int c_d_57[] = {  2,  28,  29,  11}; //   4
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 4);

  int c_p_58[] = { 11,  43,  44,  45}; //   4
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 4);
  int c_f_58[] = {}; //   0
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 0);
  int c_t_58[] = { 12}; //   1
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 1);
  int c_d_58[] = {  2,  28,  29,  11}; //   4
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 4);

  int c_p_59[] = { 13,  33,  46,  45}; //   4
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 4);
  int c_f_59[] = {}; //   0
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 0);
  int c_t_59[] = { 12}; //   1
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 1);
  int c_d_59[] = {  2,  30,  23,  11}; //   4
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 4);

  int c_p_60[] = { 11,  33,  46,  45}; //   4
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 4);
  int c_f_60[] = {}; //   0
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 0);
  int c_t_60[] = { 12}; //   1
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 1);
  int c_d_60[] = {  2,  30,  23,  11}; //   4
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 4);

  int c_p_61[] = { 11,  12,  10,  38}; //   4
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 4);
  int c_f_61[] = {}; //   0
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 0);
  int c_t_61[] = { 10}; //   1
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 1);
  int c_d_61[] = { 24,   7,  10,  11}; //   4
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 4);

  int c_p_62[] = { 13,  14,   7,  38}; //   4
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 4);
  int c_f_62[] = {}; //   0
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 0);
  int c_t_62[] = { 10}; //   1
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 1);
  int c_d_62[] = { 24,   5,  12,  11}; //   4
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 4);

  int c_p_63[] = { 11,  14,   7,  38}; //   4
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 4);
  int c_f_63[] = {}; //   0
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 0);
  int c_t_63[] = { 10}; //   1
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 1);
  int c_d_63[] = { 24,   5,  12,  11}; //   4
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 4);

  int c_p_64[] = {  8,  15,  16,  38}; //   4
  psi_c_p[no_ps][64] = get_vector_from_array_int(c_p_64, 4);
  int c_f_64[] = {}; //   0
  psi_c_f[no_ps][64] = get_vector_from_array_int(c_f_64, 0);
  int c_t_64[] = { 10}; //   1
  psi_c_t[no_ps][64] = get_vector_from_array_int(c_t_64, 1);
  int c_d_64[] = { 24,  13,   4,   9}; //   4
  psi_c_d[no_ps][64] = get_vector_from_array_int(c_d_64, 4);

  int c_p_65[] = {  8,  17,  16,  38}; //   4
  psi_c_p[no_ps][65] = get_vector_from_array_int(c_p_65, 4);
  int c_f_65[] = {}; //   0
  psi_c_f[no_ps][65] = get_vector_from_array_int(c_f_65, 0);
  int c_t_65[] = { 10}; //   1
  psi_c_t[no_ps][65] = get_vector_from_array_int(c_t_65, 1);
  int c_d_65[] = { 24,  13,   4,   9}; //   4
  psi_c_d[no_ps][65] = get_vector_from_array_int(c_d_65, 4);

  int c_p_66[] = {  0,  18,  19,  38}; //   4
  psi_c_p[no_ps][66] = get_vector_from_array_int(c_p_66, 4);
  int c_f_66[] = {}; //   0
  psi_c_f[no_ps][66] = get_vector_from_array_int(c_f_66, 0);
  int c_t_66[] = { 10}; //   1
  psi_c_t[no_ps][66] = get_vector_from_array_int(c_t_66, 1);
  int c_d_66[] = { 24,  14,  11,   2}; //   4
  psi_c_d[no_ps][66] = get_vector_from_array_int(c_d_66, 4);

  int c_p_67[] = {  0,  20,  19,  38}; //   4
  psi_c_p[no_ps][67] = get_vector_from_array_int(c_p_67, 4);
  int c_f_67[] = {}; //   0
  psi_c_f[no_ps][67] = get_vector_from_array_int(c_f_67, 0);
  int c_t_67[] = { 10}; //   1
  psi_c_t[no_ps][67] = get_vector_from_array_int(c_t_67, 1);
  int c_d_67[] = { 24,  14,  11,   2}; //   4
  psi_c_d[no_ps][67] = get_vector_from_array_int(c_d_67, 4);

  int c_p_68[] = {  5,  39,  47}; //   3
  psi_c_p[no_ps][68] = get_vector_from_array_int(c_p_68, 3);
  int c_f_68[] = {  9}; //   1
  psi_c_f[no_ps][68] = get_vector_from_array_int(c_f_68, 1);
  int c_t_68[] = { 11,  13}; //   2
  psi_c_t[no_ps][68] = get_vector_from_array_int(c_t_68, 2);
  int c_d_68[] = {  9,  26,   4}; //   3
  psi_c_d[no_ps][68] = get_vector_from_array_int(c_d_68, 3);

  int c_p_69[] = {  3,  39,  47}; //   3
  psi_c_p[no_ps][69] = get_vector_from_array_int(c_p_69, 3);
  int c_f_69[] = {  9}; //   1
  psi_c_f[no_ps][69] = get_vector_from_array_int(c_f_69, 1);
  int c_t_69[] = { 11,  13}; //   2
  psi_c_t[no_ps][69] = get_vector_from_array_int(c_t_69, 2);
  int c_d_69[] = {  9,  26,   4}; //   3
  psi_c_d[no_ps][69] = get_vector_from_array_int(c_d_69, 3);

  int c_p_70[] = { 13,  43,  48}; //   3
  psi_c_p[no_ps][70] = get_vector_from_array_int(c_p_70, 3);
  int c_f_70[] = { 10}; //   1
  psi_c_f[no_ps][70] = get_vector_from_array_int(c_f_70, 1);
  int c_t_70[] = { 12,  14}; //   2
  psi_c_t[no_ps][70] = get_vector_from_array_int(c_t_70, 2);
  int c_d_70[] = {  2,  29,  11}; //   3
  psi_c_d[no_ps][70] = get_vector_from_array_int(c_d_70, 3);

  int c_p_71[] = { 11,  43,  48}; //   3
  psi_c_p[no_ps][71] = get_vector_from_array_int(c_p_71, 3);
  int c_f_71[] = { 10}; //   1
  psi_c_f[no_ps][71] = get_vector_from_array_int(c_f_71, 1);
  int c_t_71[] = { 12,  14}; //   2
  psi_c_t[no_ps][71] = get_vector_from_array_int(c_t_71, 2);
  int c_d_71[] = {  2,  29,  11}; //   3
  psi_c_d[no_ps][71] = get_vector_from_array_int(c_d_71, 3);

  int c_p_72[] = {  5,  36}; //   2
  psi_c_p[no_ps][72] = get_vector_from_array_int(c_p_72, 2);
  int c_f_72[] = { 11,  12}; //   2
  psi_c_f[no_ps][72] = get_vector_from_array_int(c_f_72, 2);
  int c_t_72[] = { 11,  15,  16}; //   3
  psi_c_t[no_ps][72] = get_vector_from_array_int(c_t_72, 3);
  int c_d_72[] = {  9,   4}; //   2
  psi_c_d[no_ps][72] = get_vector_from_array_int(c_d_72, 2);

  int c_p_73[] = {  3,  36}; //   2
  psi_c_p[no_ps][73] = get_vector_from_array_int(c_p_73, 2);
  int c_f_73[] = { 11,  12}; //   2
  psi_c_f[no_ps][73] = get_vector_from_array_int(c_f_73, 2);
  int c_t_73[] = { 11,  15,  16}; //   3
  psi_c_t[no_ps][73] = get_vector_from_array_int(c_t_73, 3);
  int c_d_73[] = {  9,   4}; //   2
  psi_c_d[no_ps][73] = get_vector_from_array_int(c_d_73, 2);

  int c_p_74[] = { 13,  37}; //   2
  psi_c_p[no_ps][74] = get_vector_from_array_int(c_p_74, 2);
  int c_f_74[] = { 13,  14}; //   2
  psi_c_f[no_ps][74] = get_vector_from_array_int(c_f_74, 2);
  int c_t_74[] = { 12,  17,  18}; //   3
  psi_c_t[no_ps][74] = get_vector_from_array_int(c_t_74, 3);
  int c_d_74[] = {  2,  11}; //   2
  psi_c_d[no_ps][74] = get_vector_from_array_int(c_d_74, 2);

  int c_p_75[] = { 11,  37}; //   2
  psi_c_p[no_ps][75] = get_vector_from_array_int(c_p_75, 2);
  int c_f_75[] = { 13,  14}; //   2
  psi_c_f[no_ps][75] = get_vector_from_array_int(c_f_75, 2);
  int c_t_75[] = { 12,  17,  18}; //   3
  psi_c_t[no_ps][75] = get_vector_from_array_int(c_t_75, 3);
  int c_d_75[] = {  2,  11}; //   2
  psi_c_d[no_ps][75] = get_vector_from_array_int(c_d_75, 2);

  int c_p_76[] = {  5,  39,  47,  49}; //   4
  psi_c_p[no_ps][76] = get_vector_from_array_int(c_p_76, 4);
  int c_f_76[] = {}; //   0
  psi_c_f[no_ps][76] = get_vector_from_array_int(c_f_76, 0);
  int c_t_76[] = { 19}; //   1
  psi_c_t[no_ps][76] = get_vector_from_array_int(c_t_76, 1);
  int c_d_76[] = { 17,   9,  26,   4}; //   4
  psi_c_d[no_ps][76] = get_vector_from_array_int(c_d_76, 4);

  int c_p_77[] = {  3,  39,  47,  49}; //   4
  psi_c_p[no_ps][77] = get_vector_from_array_int(c_p_77, 4);
  int c_f_77[] = {}; //   0
  psi_c_f[no_ps][77] = get_vector_from_array_int(c_f_77, 0);
  int c_t_77[] = { 19}; //   1
  psi_c_t[no_ps][77] = get_vector_from_array_int(c_t_77, 1);
  int c_d_77[] = { 17,   9,  26,   4}; //   4
  psi_c_d[no_ps][77] = get_vector_from_array_int(c_d_77, 4);

  int c_p_78[] = { 13,  43,  48,  50}; //   4
  psi_c_p[no_ps][78] = get_vector_from_array_int(c_p_78, 4);
  int c_f_78[] = {}; //   0
  psi_c_f[no_ps][78] = get_vector_from_array_int(c_f_78, 0);
  int c_t_78[] = { 20}; //   1
  psi_c_t[no_ps][78] = get_vector_from_array_int(c_t_78, 1);
  int c_d_78[] = { 19,   2,  29,  11}; //   4
  psi_c_d[no_ps][78] = get_vector_from_array_int(c_d_78, 4);

  int c_p_79[] = { 11,  43,  48,  50}; //   4
  psi_c_p[no_ps][79] = get_vector_from_array_int(c_p_79, 4);
  int c_f_79[] = {}; //   0
  psi_c_f[no_ps][79] = get_vector_from_array_int(c_f_79, 0);
  int c_t_79[] = { 20}; //   1
  psi_c_t[no_ps][79] = get_vector_from_array_int(c_t_79, 1);
  int c_d_79[] = { 19,   2,  29,  11}; //   4
  psi_c_d[no_ps][79] = get_vector_from_array_int(c_d_79, 4);

  int c_p_80[] = {  5,  36,  51}; //   3
  psi_c_p[no_ps][80] = get_vector_from_array_int(c_p_80, 3);
  int c_f_80[] = { 15}; //   1
  psi_c_f[no_ps][80] = get_vector_from_array_int(c_f_80, 1);
  int c_t_80[] = { 21,  22}; //   2
  psi_c_t[no_ps][80] = get_vector_from_array_int(c_t_80, 2);
  int c_d_80[] = { 17,   9,   4}; //   3
  psi_c_d[no_ps][80] = get_vector_from_array_int(c_d_80, 3);

  int c_p_81[] = {  3,  36,  51}; //   3
  psi_c_p[no_ps][81] = get_vector_from_array_int(c_p_81, 3);
  int c_f_81[] = { 15}; //   1
  psi_c_f[no_ps][81] = get_vector_from_array_int(c_f_81, 1);
  int c_t_81[] = { 21,  22}; //   2
  psi_c_t[no_ps][81] = get_vector_from_array_int(c_t_81, 2);
  int c_d_81[] = { 17,   9,   4}; //   3
  psi_c_d[no_ps][81] = get_vector_from_array_int(c_d_81, 3);

  int c_p_82[] = { 13,  37,  52}; //   3
  psi_c_p[no_ps][82] = get_vector_from_array_int(c_p_82, 3);
  int c_f_82[] = { 16}; //   1
  psi_c_f[no_ps][82] = get_vector_from_array_int(c_f_82, 1);
  int c_t_82[] = { 23,  24}; //   2
  psi_c_t[no_ps][82] = get_vector_from_array_int(c_t_82, 2);
  int c_d_82[] = { 19,   2,  11}; //   3
  psi_c_d[no_ps][82] = get_vector_from_array_int(c_d_82, 3);

  int c_p_83[] = { 11,  37,  52}; //   3
  psi_c_p[no_ps][83] = get_vector_from_array_int(c_p_83, 3);
  int c_f_83[] = { 16}; //   1
  psi_c_f[no_ps][83] = get_vector_from_array_int(c_f_83, 1);
  int c_t_83[] = { 23,  24}; //   2
  psi_c_t[no_ps][83] = get_vector_from_array_int(c_t_83, 2);
  int c_d_83[] = { 19,   2,  11}; //   3
  psi_c_d[no_ps][83] = get_vector_from_array_int(c_d_83, 3);

  int c_p_84[] = {  8,  15,  53,  54}; //   4
  psi_c_p[no_ps][84] = get_vector_from_array_int(c_p_84, 4);
  int c_f_84[] = {}; //   0
  psi_c_f[no_ps][84] = get_vector_from_array_int(c_f_84, 0);
  int c_t_84[] = { 25}; //   1
  psi_c_t[no_ps][84] = get_vector_from_array_int(c_t_84, 1);
  int c_d_84[] = { 25,  26,   4,   9}; //   4
  psi_c_d[no_ps][84] = get_vector_from_array_int(c_d_84, 4);

  int c_p_85[] = {  8,  17,  53,  54}; //   4
  psi_c_p[no_ps][85] = get_vector_from_array_int(c_p_85, 4);
  int c_f_85[] = {}; //   0
  psi_c_f[no_ps][85] = get_vector_from_array_int(c_f_85, 0);
  int c_t_85[] = { 25}; //   1
  psi_c_t[no_ps][85] = get_vector_from_array_int(c_t_85, 1);
  int c_d_85[] = { 25,  26,   4,   9}; //   4
  psi_c_d[no_ps][85] = get_vector_from_array_int(c_d_85, 4);

  int c_p_86[] = {  8,  15,  55,  56}; //   4
  psi_c_p[no_ps][86] = get_vector_from_array_int(c_p_86, 4);
  int c_f_86[] = {}; //   0
  psi_c_f[no_ps][86] = get_vector_from_array_int(c_f_86, 0);
  int c_t_86[] = { 25}; //   1
  psi_c_t[no_ps][86] = get_vector_from_array_int(c_t_86, 1);
  int c_d_86[] = { 27,  21,   4,   9}; //   4
  psi_c_d[no_ps][86] = get_vector_from_array_int(c_d_86, 4);

  int c_p_87[] = {  8,  17,  55,  56}; //   4
  psi_c_p[no_ps][87] = get_vector_from_array_int(c_p_87, 4);
  int c_f_87[] = {}; //   0
  psi_c_f[no_ps][87] = get_vector_from_array_int(c_f_87, 0);
  int c_t_87[] = { 25}; //   1
  psi_c_t[no_ps][87] = get_vector_from_array_int(c_t_87, 1);
  int c_d_87[] = { 27,  21,   4,   9}; //   4
  psi_c_d[no_ps][87] = get_vector_from_array_int(c_d_87, 4);

  int c_p_88[] = {  0,  18,  57,  58}; //   4
  psi_c_p[no_ps][88] = get_vector_from_array_int(c_p_88, 4);
  int c_f_88[] = {}; //   0
  psi_c_f[no_ps][88] = get_vector_from_array_int(c_f_88, 0);
  int c_t_88[] = { 26}; //   1
  psi_c_t[no_ps][88] = get_vector_from_array_int(c_t_88, 1);
  int c_d_88[] = { 28,  29,  11,   2}; //   4
  psi_c_d[no_ps][88] = get_vector_from_array_int(c_d_88, 4);

  int c_p_89[] = {  0,  20,  57,  58}; //   4
  psi_c_p[no_ps][89] = get_vector_from_array_int(c_p_89, 4);
  int c_f_89[] = {}; //   0
  psi_c_f[no_ps][89] = get_vector_from_array_int(c_f_89, 0);
  int c_t_89[] = { 26}; //   1
  psi_c_t[no_ps][89] = get_vector_from_array_int(c_t_89, 1);
  int c_d_89[] = { 28,  29,  11,   2}; //   4
  psi_c_d[no_ps][89] = get_vector_from_array_int(c_d_89, 4);

  int c_p_90[] = {  0,  18,  59,  60}; //   4
  psi_c_p[no_ps][90] = get_vector_from_array_int(c_p_90, 4);
  int c_f_90[] = {}; //   0
  psi_c_f[no_ps][90] = get_vector_from_array_int(c_f_90, 0);
  int c_t_90[] = { 26}; //   1
  psi_c_t[no_ps][90] = get_vector_from_array_int(c_t_90, 1);
  int c_d_90[] = { 30,  23,  11,   2}; //   4
  psi_c_d[no_ps][90] = get_vector_from_array_int(c_d_90, 4);

  int c_p_91[] = {  0,  20,  59,  60}; //   4
  psi_c_p[no_ps][91] = get_vector_from_array_int(c_p_91, 4);
  int c_f_91[] = {}; //   0
  psi_c_f[no_ps][91] = get_vector_from_array_int(c_f_91, 0);
  int c_t_91[] = { 26}; //   1
  psi_c_t[no_ps][91] = get_vector_from_array_int(c_t_91, 1);
  int c_d_91[] = { 30,  23,  11,   2}; //   4
  psi_c_d[no_ps][91] = get_vector_from_array_int(c_d_91, 4);

  int c_p_92[] = { 61,  62,  63,  64}; //   4
  psi_c_p[no_ps][92] = get_vector_from_array_int(c_p_92, 4);
  int c_f_92[] = {}; //   0
  psi_c_f[no_ps][92] = get_vector_from_array_int(c_f_92, 0);
  int c_t_92[] = { 27}; //   1
  psi_c_t[no_ps][92] = get_vector_from_array_int(c_t_92, 1);
  int c_d_92[] = {  0,   1,   2,  24}; //   4
  psi_c_d[no_ps][92] = get_vector_from_array_int(c_d_92, 4);

  int c_p_93[] = { 61,  65,  66,  64}; //   4
  psi_c_p[no_ps][93] = get_vector_from_array_int(c_p_93, 4);
  int c_f_93[] = {}; //   0
  psi_c_f[no_ps][93] = get_vector_from_array_int(c_f_93, 0);
  int c_t_93[] = { 27}; //   1
  psi_c_t[no_ps][93] = get_vector_from_array_int(c_t_93, 1);
  int c_d_93[] = {  0,   3,   4,  24}; //   4
  psi_c_d[no_ps][93] = get_vector_from_array_int(c_d_93, 4);

  int c_p_94[] = { 61,  67,  68,  69}; //   4
  psi_c_p[no_ps][94] = get_vector_from_array_int(c_p_94, 4);
  int c_f_94[] = {}; //   0
  psi_c_f[no_ps][94] = get_vector_from_array_int(c_f_94, 0);
  int c_t_94[] = { 27}; //   1
  psi_c_t[no_ps][94] = get_vector_from_array_int(c_t_94, 1);
  int c_d_94[] = {  5,   6,   4,  24}; //   4
  psi_c_d[no_ps][94] = get_vector_from_array_int(c_d_94, 4);

  int c_p_95[] = { 61,  65,  68,  69}; //   4
  psi_c_p[no_ps][95] = get_vector_from_array_int(c_p_95, 4);
  int c_f_95[] = {}; //   0
  psi_c_f[no_ps][95] = get_vector_from_array_int(c_f_95, 0);
  int c_t_95[] = { 27}; //   1
  psi_c_t[no_ps][95] = get_vector_from_array_int(c_t_95, 1);
  int c_d_95[] = {  5,   6,   4,  24}; //   4
  psi_c_d[no_ps][95] = get_vector_from_array_int(c_d_95, 4);

  int c_p_96[] = { 61,  70,  71,  72}; //   4
  psi_c_p[no_ps][96] = get_vector_from_array_int(c_p_96, 4);
  int c_f_96[] = {}; //   0
  psi_c_f[no_ps][96] = get_vector_from_array_int(c_f_96, 0);
  int c_t_96[] = { 27}; //   1
  psi_c_t[no_ps][96] = get_vector_from_array_int(c_t_96, 1);
  int c_d_96[] = {  7,   8,   9,  24}; //   4
  psi_c_d[no_ps][96] = get_vector_from_array_int(c_d_96, 4);

  int c_p_97[] = { 61,  73,  74,  72}; //   4
  psi_c_p[no_ps][97] = get_vector_from_array_int(c_p_97, 4);
  int c_f_97[] = {}; //   0
  psi_c_f[no_ps][97] = get_vector_from_array_int(c_f_97, 0);
  int c_t_97[] = { 27}; //   1
  psi_c_t[no_ps][97] = get_vector_from_array_int(c_t_97, 1);
  int c_d_97[] = {  7,  10,  11,  24}; //   4
  psi_c_d[no_ps][97] = get_vector_from_array_int(c_d_97, 4);

  int c_p_98[] = { 61,  75,  76,  69}; //   4
  psi_c_p[no_ps][98] = get_vector_from_array_int(c_p_98, 4);
  int c_f_98[] = {}; //   0
  psi_c_f[no_ps][98] = get_vector_from_array_int(c_f_98, 0);
  int c_t_98[] = { 27}; //   1
  psi_c_t[no_ps][98] = get_vector_from_array_int(c_t_98, 1);
  int c_d_98[] = {  5,  12,  11,  24}; //   4
  psi_c_d[no_ps][98] = get_vector_from_array_int(c_d_98, 4);

  int c_p_99[] = { 61,  73,  76,  69}; //   4
  psi_c_p[no_ps][99] = get_vector_from_array_int(c_p_99, 4);
  int c_f_99[] = {}; //   0
  psi_c_f[no_ps][99] = get_vector_from_array_int(c_f_99, 0);
  int c_t_99[] = { 27}; //   1
  psi_c_t[no_ps][99] = get_vector_from_array_int(c_t_99, 1);
  int c_d_99[] = {  5,  12,  11,  24}; //   4
  psi_c_d[no_ps][99] = get_vector_from_array_int(c_d_99, 4);

  int c_p_100[] = { 61,  70,  77,  78}; //   4
  psi_c_p[no_ps][100] = get_vector_from_array_int(c_p_100, 4);
  int c_f_100[] = {}; //   0
  psi_c_f[no_ps][100] = get_vector_from_array_int(c_f_100, 0);
  int c_t_100[] = { 27}; //   1
  psi_c_t[no_ps][100] = get_vector_from_array_int(c_t_100, 1);
  int c_d_100[] = { 13,   4,   9,  24}; //   4
  psi_c_d[no_ps][100] = get_vector_from_array_int(c_d_100, 4);

  int c_p_101[] = { 61,  70,  79,  78}; //   4
  psi_c_p[no_ps][101] = get_vector_from_array_int(c_p_101, 4);
  int c_f_101[] = {}; //   0
  psi_c_f[no_ps][101] = get_vector_from_array_int(c_f_101, 0);
  int c_t_101[] = { 27}; //   1
  psi_c_t[no_ps][101] = get_vector_from_array_int(c_t_101, 1);
  int c_d_101[] = { 13,   4,   9,  24}; //   4
  psi_c_d[no_ps][101] = get_vector_from_array_int(c_d_101, 4);

  int c_p_102[] = { 61,  62,  80,  81}; //   4
  psi_c_p[no_ps][102] = get_vector_from_array_int(c_p_102, 4);
  int c_f_102[] = {}; //   0
  psi_c_f[no_ps][102] = get_vector_from_array_int(c_f_102, 0);
  int c_t_102[] = { 27}; //   1
  psi_c_t[no_ps][102] = get_vector_from_array_int(c_t_102, 1);
  int c_d_102[] = { 14,  11,   2,  24}; //   4
  psi_c_d[no_ps][102] = get_vector_from_array_int(c_d_102, 4);

  int c_p_103[] = { 61,  62,  82,  81}; //   4
  psi_c_p[no_ps][103] = get_vector_from_array_int(c_p_103, 4);
  int c_f_103[] = {}; //   0
  psi_c_f[no_ps][103] = get_vector_from_array_int(c_f_103, 0);
  int c_t_103[] = { 27}; //   1
  psi_c_t[no_ps][103] = get_vector_from_array_int(c_t_103, 1);
  int c_d_103[] = { 14,  11,   2,  24}; //   4
  psi_c_d[no_ps][103] = get_vector_from_array_int(c_d_103, 4);

  int c_p_104[] = { 61,  70,  77}; //   3
  psi_c_p[no_ps][104] = get_vector_from_array_int(c_p_104, 3);
  int c_f_104[] = { 17}; //   1
  psi_c_f[no_ps][104] = get_vector_from_array_int(c_f_104, 1);
  int c_t_104[] = { 28,  29}; //   2
  psi_c_t[no_ps][104] = get_vector_from_array_int(c_t_104, 2);
  int c_d_104[] = {  4,   9,  24}; //   3
  psi_c_d[no_ps][104] = get_vector_from_array_int(c_d_104, 3);

  int c_p_105[] = { 61,  70,  79}; //   3
  psi_c_p[no_ps][105] = get_vector_from_array_int(c_p_105, 3);
  int c_f_105[] = { 17}; //   1
  psi_c_f[no_ps][105] = get_vector_from_array_int(c_f_105, 1);
  int c_t_105[] = { 28,  29}; //   2
  psi_c_t[no_ps][105] = get_vector_from_array_int(c_t_105, 2);
  int c_d_105[] = {  4,   9,  24}; //   3
  psi_c_d[no_ps][105] = get_vector_from_array_int(c_d_105, 3);

  int c_p_106[] = {  8,  83,  77}; //   3
  psi_c_p[no_ps][106] = get_vector_from_array_int(c_p_106, 3);
  int c_f_106[] = { 17}; //   1
  psi_c_f[no_ps][106] = get_vector_from_array_int(c_f_106, 1);
  int c_t_106[] = { 28,  30}; //   2
  psi_c_t[no_ps][106] = get_vector_from_array_int(c_t_106, 2);
  int c_d_106[] = {  4,  24,   9}; //   3
  psi_c_d[no_ps][106] = get_vector_from_array_int(c_d_106, 3);

  int c_p_107[] = {  8,  83,  79}; //   3
  psi_c_p[no_ps][107] = get_vector_from_array_int(c_p_107, 3);
  int c_f_107[] = { 17}; //   1
  psi_c_f[no_ps][107] = get_vector_from_array_int(c_f_107, 1);
  int c_t_107[] = { 28,  30}; //   2
  psi_c_t[no_ps][107] = get_vector_from_array_int(c_t_107, 2);
  int c_d_107[] = {  4,  24,   9}; //   3
  psi_c_d[no_ps][107] = get_vector_from_array_int(c_d_107, 3);

  int c_p_108[] = {  8,  15,  84}; //   3
  psi_c_p[no_ps][108] = get_vector_from_array_int(c_p_108, 3);
  int c_f_108[] = { 18}; //   1
  psi_c_f[no_ps][108] = get_vector_from_array_int(c_f_108, 1);
  int c_t_108[] = { 10,  31}; //   2
  psi_c_t[no_ps][108] = get_vector_from_array_int(c_t_108, 2);
  int c_d_108[] = { 24,   4,   9}; //   3
  psi_c_d[no_ps][108] = get_vector_from_array_int(c_d_108, 3);

  int c_p_109[] = {  8,  17,  84}; //   3
  psi_c_p[no_ps][109] = get_vector_from_array_int(c_p_109, 3);
  int c_f_109[] = { 18}; //   1
  psi_c_f[no_ps][109] = get_vector_from_array_int(c_f_109, 1);
  int c_t_109[] = { 10,  31}; //   2
  psi_c_t[no_ps][109] = get_vector_from_array_int(c_t_109, 2);
  int c_d_109[] = { 24,   4,   9}; //   3
  psi_c_d[no_ps][109] = get_vector_from_array_int(c_d_109, 3);

  int c_p_110[] = { 61,  62,  80}; //   3
  psi_c_p[no_ps][110] = get_vector_from_array_int(c_p_110, 3);
  int c_f_110[] = { 19}; //   1
  psi_c_f[no_ps][110] = get_vector_from_array_int(c_f_110, 1);
  int c_t_110[] = { 32,  33}; //   2
  psi_c_t[no_ps][110] = get_vector_from_array_int(c_t_110, 2);
  int c_d_110[] = { 11,   2,  24}; //   3
  psi_c_d[no_ps][110] = get_vector_from_array_int(c_d_110, 3);

  int c_p_111[] = { 61,  62,  82}; //   3
  psi_c_p[no_ps][111] = get_vector_from_array_int(c_p_111, 3);
  int c_f_111[] = { 19}; //   1
  psi_c_f[no_ps][111] = get_vector_from_array_int(c_f_111, 1);
  int c_t_111[] = { 32,  33}; //   2
  psi_c_t[no_ps][111] = get_vector_from_array_int(c_t_111, 2);
  int c_d_111[] = { 11,   2,  24}; //   3
  psi_c_d[no_ps][111] = get_vector_from_array_int(c_d_111, 3);

  int c_p_112[] = {  0,  85,  80}; //   3
  psi_c_p[no_ps][112] = get_vector_from_array_int(c_p_112, 3);
  int c_f_112[] = { 19}; //   1
  psi_c_f[no_ps][112] = get_vector_from_array_int(c_f_112, 1);
  int c_t_112[] = { 32,  34}; //   2
  psi_c_t[no_ps][112] = get_vector_from_array_int(c_t_112, 2);
  int c_d_112[] = { 11,  24,   2}; //   3
  psi_c_d[no_ps][112] = get_vector_from_array_int(c_d_112, 3);

  int c_p_113[] = {  0,  85,  82}; //   3
  psi_c_p[no_ps][113] = get_vector_from_array_int(c_p_113, 3);
  int c_f_113[] = { 19}; //   1
  psi_c_f[no_ps][113] = get_vector_from_array_int(c_f_113, 1);
  int c_t_113[] = { 32,  34}; //   2
  psi_c_t[no_ps][113] = get_vector_from_array_int(c_t_113, 2);
  int c_d_113[] = { 11,  24,   2}; //   3
  psi_c_d[no_ps][113] = get_vector_from_array_int(c_d_113, 3);

  int c_p_114[] = {  0,  18,  86}; //   3
  psi_c_p[no_ps][114] = get_vector_from_array_int(c_p_114, 3);
  int c_f_114[] = { 20}; //   1
  psi_c_f[no_ps][114] = get_vector_from_array_int(c_f_114, 1);
  int c_t_114[] = { 10,  35}; //   2
  psi_c_t[no_ps][114] = get_vector_from_array_int(c_t_114, 2);
  int c_d_114[] = { 24,  11,   2}; //   3
  psi_c_d[no_ps][114] = get_vector_from_array_int(c_d_114, 3);

  int c_p_115[] = {  0,  20,  86}; //   3
  psi_c_p[no_ps][115] = get_vector_from_array_int(c_p_115, 3);
  int c_f_115[] = { 20}; //   1
  psi_c_f[no_ps][115] = get_vector_from_array_int(c_f_115, 1);
  int c_t_115[] = { 10,  35}; //   2
  psi_c_t[no_ps][115] = get_vector_from_array_int(c_t_115, 2);
  int c_d_115[] = { 24,  11,   2}; //   3
  psi_c_d[no_ps][115] = get_vector_from_array_int(c_d_115, 3);

  int c_p_116[] = { 61,  67,  87}; //   3
  psi_c_p[no_ps][116] = get_vector_from_array_int(c_p_116, 3);
  int c_f_116[] = { 12}; //   1
  psi_c_f[no_ps][116] = get_vector_from_array_int(c_f_116, 1);
  int c_t_116[] = { 11,  36}; //   2
  psi_c_t[no_ps][116] = get_vector_from_array_int(c_t_116, 2);
  int c_d_116[] = {  9,   4,  24}; //   3
  psi_c_d[no_ps][116] = get_vector_from_array_int(c_d_116, 3);

  int c_p_117[] = { 61,  65,  87}; //   3
  psi_c_p[no_ps][117] = get_vector_from_array_int(c_p_117, 3);
  int c_f_117[] = { 12}; //   1
  psi_c_f[no_ps][117] = get_vector_from_array_int(c_f_117, 1);
  int c_t_117[] = { 11,  36}; //   2
  psi_c_t[no_ps][117] = get_vector_from_array_int(c_t_117, 2);
  int c_d_117[] = {  9,   4,  24}; //   3
  psi_c_d[no_ps][117] = get_vector_from_array_int(c_d_117, 3);

  int c_p_118[] = {  5,  88,  87}; //   3
  psi_c_p[no_ps][118] = get_vector_from_array_int(c_p_118, 3);
  int c_f_118[] = { 12}; //   1
  psi_c_f[no_ps][118] = get_vector_from_array_int(c_f_118, 1);
  int c_t_118[] = { 11,  15}; //   2
  psi_c_t[no_ps][118] = get_vector_from_array_int(c_t_118, 2);
  int c_d_118[] = {  9,  24,   4}; //   3
  psi_c_d[no_ps][118] = get_vector_from_array_int(c_d_118, 3);

  int c_p_119[] = {  3,  88,  87}; //   3
  psi_c_p[no_ps][119] = get_vector_from_array_int(c_p_119, 3);
  int c_f_119[] = { 12}; //   1
  psi_c_f[no_ps][119] = get_vector_from_array_int(c_f_119, 1);
  int c_t_119[] = { 11,  15}; //   2
  psi_c_t[no_ps][119] = get_vector_from_array_int(c_t_119, 2);
  int c_d_119[] = {  9,  24,   4}; //   3
  psi_c_d[no_ps][119] = get_vector_from_array_int(c_d_119, 3);

  int c_p_120[] = {  5,  36,  84}; //   3
  psi_c_p[no_ps][120] = get_vector_from_array_int(c_p_120, 3);
  int c_f_120[] = { 18}; //   1
  psi_c_f[no_ps][120] = get_vector_from_array_int(c_f_120, 1);
  int c_t_120[] = { 10,  37}; //   2
  psi_c_t[no_ps][120] = get_vector_from_array_int(c_t_120, 2);
  int c_d_120[] = { 24,   9,   4}; //   3
  psi_c_d[no_ps][120] = get_vector_from_array_int(c_d_120, 3);

  int c_p_121[] = {  3,  36,  84}; //   3
  psi_c_p[no_ps][121] = get_vector_from_array_int(c_p_121, 3);
  int c_f_121[] = { 18}; //   1
  psi_c_f[no_ps][121] = get_vector_from_array_int(c_f_121, 1);
  int c_t_121[] = { 10,  37}; //   2
  psi_c_t[no_ps][121] = get_vector_from_array_int(c_t_121, 2);
  int c_d_121[] = { 24,   9,   4}; //   3
  psi_c_d[no_ps][121] = get_vector_from_array_int(c_d_121, 3);

  int c_p_122[] = { 61,  75,  89}; //   3
  psi_c_p[no_ps][122] = get_vector_from_array_int(c_p_122, 3);
  int c_f_122[] = { 14}; //   1
  psi_c_f[no_ps][122] = get_vector_from_array_int(c_f_122, 1);
  int c_t_122[] = { 12,  38}; //   2
  psi_c_t[no_ps][122] = get_vector_from_array_int(c_t_122, 2);
  int c_d_122[] = {  2,  11,  24}; //   3
  psi_c_d[no_ps][122] = get_vector_from_array_int(c_d_122, 3);

  int c_p_123[] = { 61,  73,  89}; //   3
  psi_c_p[no_ps][123] = get_vector_from_array_int(c_p_123, 3);
  int c_f_123[] = { 14}; //   1
  psi_c_f[no_ps][123] = get_vector_from_array_int(c_f_123, 1);
  int c_t_123[] = { 12,  38}; //   2
  psi_c_t[no_ps][123] = get_vector_from_array_int(c_t_123, 2);
  int c_d_123[] = {  2,  11,  24}; //   3
  psi_c_d[no_ps][123] = get_vector_from_array_int(c_d_123, 3);

  int c_p_124[] = { 13,  90,  89}; //   3
  psi_c_p[no_ps][124] = get_vector_from_array_int(c_p_124, 3);
  int c_f_124[] = { 14}; //   1
  psi_c_f[no_ps][124] = get_vector_from_array_int(c_f_124, 1);
  int c_t_124[] = { 12,  17}; //   2
  psi_c_t[no_ps][124] = get_vector_from_array_int(c_t_124, 2);
  int c_d_124[] = {  2,  24,  11}; //   3
  psi_c_d[no_ps][124] = get_vector_from_array_int(c_d_124, 3);

  int c_p_125[] = { 11,  90,  89}; //   3
  psi_c_p[no_ps][125] = get_vector_from_array_int(c_p_125, 3);
  int c_f_125[] = { 14}; //   1
  psi_c_f[no_ps][125] = get_vector_from_array_int(c_f_125, 1);
  int c_t_125[] = { 12,  17}; //   2
  psi_c_t[no_ps][125] = get_vector_from_array_int(c_t_125, 2);
  int c_d_125[] = {  2,  24,  11}; //   3
  psi_c_d[no_ps][125] = get_vector_from_array_int(c_d_125, 3);

  int c_p_126[] = { 13,  37,  86}; //   3
  psi_c_p[no_ps][126] = get_vector_from_array_int(c_p_126, 3);
  int c_f_126[] = { 20}; //   1
  psi_c_f[no_ps][126] = get_vector_from_array_int(c_f_126, 1);
  int c_t_126[] = { 10,  39}; //   2
  psi_c_t[no_ps][126] = get_vector_from_array_int(c_t_126, 2);
  int c_d_126[] = { 24,   2,  11}; //   3
  psi_c_d[no_ps][126] = get_vector_from_array_int(c_d_126, 3);

  int c_p_127[] = { 11,  37,  86}; //   3
  psi_c_p[no_ps][127] = get_vector_from_array_int(c_p_127, 3);
  int c_f_127[] = { 20}; //   1
  psi_c_f[no_ps][127] = get_vector_from_array_int(c_f_127, 1);
  int c_t_127[] = { 10,  39}; //   2
  psi_c_t[no_ps][127] = get_vector_from_array_int(c_t_127, 2);
  int c_d_127[] = { 24,   2,  11}; //   3
  psi_c_d[no_ps][127] = get_vector_from_array_int(c_d_127, 3);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
