#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppeexmxnm04/header/ppeexmxnm04.phasespace.h"
void ppeexmxnm04_ag_psp_doublereal(int no_ps, int zero, phasespace_set & psi){
  static Logger logger("ppeexmxnm04_ag_psp_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  1){ppeexmxnm04_ag_psp_240_gg_emepmupvmdux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  2){ppeexmxnm04_ag_psp_240_gu_emepmupvmgd(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  3){ppeexmxnm04_ag_psp_240_gdx_emepmupvmgux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  4){ppeexmxnm04_ag_psp_240_du_emepmupvmdd(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  5){ppeexmxnm04_ag_psp_240_dc_emepmupvmds(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  6){ppeexmxnm04_ag_psp_240_ddx_emepmupvmdux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  7){ppeexmxnm04_ag_psp_240_ddx_emepmupvmscx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  8){ppeexmxnm04_ag_psp_240_dsx_emepmupvmdcx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  9){ppeexmxnm04_ag_psp_240_uu_emepmupvmdu(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 10){ppeexmxnm04_ag_psp_240_uc_emepmupvmdc(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 11){ppeexmxnm04_ag_psp_240_udx_emepmupvmgg(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 12){ppeexmxnm04_ag_psp_240_udx_emepmupvmddx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 13){ppeexmxnm04_ag_psp_240_udx_emepmupvmuux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 14){ppeexmxnm04_ag_psp_240_udx_emepmupvmssx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 15){ppeexmxnm04_ag_psp_240_udx_emepmupvmccx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 16){ppeexmxnm04_ag_psp_240_uux_emepmupvmdux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 17){ppeexmxnm04_ag_psp_240_uux_emepmupvmscx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 18){ppeexmxnm04_ag_psp_240_usx_emepmupvmdsx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 19){ppeexmxnm04_ag_psp_240_usx_emepmupvmucx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 20){ppeexmxnm04_ag_psp_240_ucx_emepmupvmdcx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 21){ppeexmxnm04_ag_psp_240_dxdx_emepmupvmdxux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 22){ppeexmxnm04_ag_psp_240_dxux_emepmupvmuxux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 23){ppeexmxnm04_ag_psp_240_dxsx_emepmupvmdxcx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 24){ppeexmxnm04_ag_psp_240_dxcx_emepmupvmuxcx(no_ps, zero, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
