#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../pph21/header/pph21.phasespace.h"
void pph21_ag_psp_real(int no_ps, int zero, phasespace_set & psi){
  static Logger logger("pph21_ag_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] == 1){pph21_ag_psp_310_gg_hg(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 2){pph21_ag_psp_310_gd_hd(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 3){pph21_ag_psp_310_gu_hu(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 4){pph21_ag_psp_310_gdx_hdx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 5){pph21_ag_psp_310_gux_hux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 6){pph21_ag_psp_310_ddx_hg(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 7){pph21_ag_psp_310_uux_hg(no_ps, zero, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
