c#######################################################################
      subroutine pick(itype,s,smin,smax,r1,wt)
      implicit none
      include 'types.f'
      integer itype
      real(dp):: s,smin,smax,r1,wt
*
* itype=1  pick linearly
* itype=2  pick logarithmically
*
      if(itype.eq.1)then
        s =smin+r1*(smax-smin)
        wt=wt*(smax-smin)
      endif
      if(itype.eq.2)then
        s =smin*(smax/smin)**r1
        wt=wt*log(smax/smin)*s
      endif
      return
      end



c$$$c#######################################################################
c$$$      character*3 function getstr(no)
c$$$c     returns a string of length 3 from an integer::
c$$$      integer:: no,i1,i2,i3,izero
c$$$
c$$$      izero=ichar('0')
c$$$
c$$$      i1=abs(no)/100
c$$$      i2=(abs(no)-i1*100)/10
c$$$      i3=abs(no)-i1*100-i2*10
c$$$
c$$$      if    (i1==0.and.i2==0) then
c$$$         if (no < 0) then
c$$$            getstr='-'//char(i3+izero)//'_'
c$$$         else
c$$$            getstr=char(i3+izero)//'__'
c$$$         endif
c$$$      elseif(i1==0) then
c$$$         getstr=char(i2+izero)//char(i3+izero)//'_'
c$$$      else
c$$$         getstr=char(i1+izero)//char(i2+izero)//char(i3+izero)
c$$$      endif
c$$$
c$$$      return
c$$$      end
      
