#include "ppeeexex04.header.cxx"
void ppeeexex04_list_subprocess_born(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeeexex04_list_subprocess_born");
  logger << LOG_DEBUG << "called" << endl;
  if (contribution_order_alpha_s == 0 && contribution_order_alpha_e == 4 && contribution_order_interference == 0){
    subprocess.resize(3);
    subprocess[1] = "dd~_ememepep";
    subprocess[2] = "uu~_ememepep";
    int member_0[] = {1, 2};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  else if (contribution_order_alpha_s == 2 && contribution_order_alpha_e == 4 && contribution_order_interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_ememepep";
    int member_0[] = {1};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeeexex04_list_subprocess_C_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeeexex04_list_subprocess_C_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_ememepep";
  subprocess[2] = "uu~_ememepep";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeeexex04_list_subprocess_V_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeeexex04_list_subprocess_V_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_ememepep";
  subprocess[2] = "uu~_ememepep";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeeexex04_list_subprocess_R_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeeexex04_list_subprocess_R_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_ememepepd";
  subprocess[2] = "gu_ememepepu";
  subprocess[3] = "gd~_ememepepd~";
  subprocess[4] = "gu~_ememepepu~";
  subprocess[5] = "dd~_ememepepg";
  subprocess[6] = "uu~_ememepepg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeeexex04_list_subprocess_RC_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeeexex04_list_subprocess_RC_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_ememepepd";
  subprocess[2] = "gu_ememepepu";
  subprocess[3] = "gd~_ememepepd~";
  subprocess[4] = "gu~_ememepepu~";
  subprocess[5] = "dd~_ememepepg";
  subprocess[6] = "uu~_ememepepg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeeexex04_list_subprocess_RV_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeeexex04_list_subprocess_RV_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_ememepepd";
  subprocess[2] = "gu_ememepepu";
  subprocess[3] = "gd~_ememepepd~";
  subprocess[4] = "gu~_ememepepu~";
  subprocess[5] = "dd~_ememepepg";
  subprocess[6] = "uu~_ememepepg";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeeexex04_list_subprocess_RR_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeeexex04_list_subprocess_RR_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(35);
  subprocess[1] = "gg_ememepepdd~";
  subprocess[2] = "gg_ememepepuu~";
  subprocess[3] = "gd_ememepepgd";
  subprocess[4] = "gu_ememepepgu";
  subprocess[5] = "gd~_ememepepgd~";
  subprocess[6] = "gu~_ememepepgu~";
  subprocess[7] = "dd_ememepepdd";
  subprocess[8] = "du_ememepepdu";
  subprocess[9] = "ds_ememepepds";
  subprocess[10] = "dc_ememepepdc";
  subprocess[11] = "dd~_ememepepgg";
  subprocess[12] = "dd~_ememepepdd~";
  subprocess[13] = "dd~_ememepepuu~";
  subprocess[14] = "dd~_ememepepss~";
  subprocess[15] = "dd~_ememepepcc~";
  subprocess[16] = "du~_ememepepdu~";
  subprocess[17] = "ds~_ememepepds~";
  subprocess[18] = "dc~_ememepepdc~";
  subprocess[19] = "uu_ememepepuu";
  subprocess[20] = "uc_ememepepuc";
  subprocess[21] = "ud~_ememepepud~";
  subprocess[22] = "uu~_ememepepgg";
  subprocess[23] = "uu~_ememepepdd~";
  subprocess[24] = "uu~_ememepepuu~";
  subprocess[25] = "uu~_ememepepss~";
  subprocess[26] = "uu~_ememepepcc~";
  subprocess[27] = "us~_ememepepus~";
  subprocess[28] = "uc~_ememepepuc~";
  subprocess[29] = "d~d~_ememepepd~d~";
  subprocess[30] = "d~u~_ememepepd~u~";
  subprocess[31] = "d~s~_ememepepd~s~";
  subprocess[32] = "d~c~_ememepepd~c~";
  subprocess[33] = "u~u~_ememepepu~u~";
  subprocess[34] = "u~c~_ememepepu~c~";
  int member_0[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
