#include "ppeeexnex04.header.cxx"
void ppeeexnex04_determination_no_subprocess_doublereal(int & no_map, vector<int> & o_map, int & no_prc, vector<int> & o_prc, double & symmetry_factor, vector<int> & tp, int basic_order_alpha_s, int basic_order_alpha_e, int basic_order_interference){
  static Logger logger("ppeeexnex04_determination_no_subprocess_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  no_map = -1;
  vector<int> out(9);
  for (int i = 0; i < 2; i++){
    if (i == 0){out[1] = 1; out[2] = 2;}
    if (i == 1){out[1] = 2; out[2] = 1;}
    for (int o = 0; o < 2; o++){
      if (o == 0){out[7] = 7; out[8] = 8;}
      if (o == 1){out[7] = 8; out[8] = 7;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){no_map = 1; break;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){no_map = 1; break;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==   1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==   2)){no_map = 2; break;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==   3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==   4)){no_map = 2; break;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==  -1)){no_map = 3; break;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==  -3)){no_map = 3; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==   1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   1) && (tp[out[8]] ==   2)){no_map = 4; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==   3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   3) && (tp[out[8]] ==   4)){no_map = 4; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==   2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==   2)){no_map = 5; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==   4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==   4)){no_map = 5; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==   3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   1) && (tp[out[8]] ==   4)){no_map = 6; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==   1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   3) && (tp[out[8]] ==   2)){no_map = 6; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==   1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==   5)){no_map = 6; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==   3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==   5)){no_map = 6; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==   4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==   4)){no_map = 7; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==   2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==   2)){no_map = 7; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){no_map = 8; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){no_map = 8; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){no_map = 9; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){no_map = 9; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){no_map = 9; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){no_map = 9; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==   0)){no_map = 10; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==   0)){no_map = 10; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   1) && (tp[out[8]] ==  -1)){no_map = 11; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   3) && (tp[out[8]] ==  -3)){no_map = 11; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -2)){no_map = 12; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -4)){no_map = 12; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   3) && (tp[out[8]] ==  -3)){no_map = 13; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   1) && (tp[out[8]] ==  -1)){no_map = 13; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   5) && (tp[out[8]] ==  -5)){no_map = 13; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   5) && (tp[out[8]] ==  -5)){no_map = 13; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -4)){no_map = 14; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -2)){no_map = 14; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -3)){no_map = 15; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -1)){no_map = 15; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -5) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -5)){no_map = 15; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -5) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -5)){no_map = 15; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   1) && (tp[out[8]] ==  -3)){no_map = 16; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   3) && (tp[out[8]] ==  -1)){no_map = 16; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   5) && (tp[out[8]] ==  -1)){no_map = 16; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   5) && (tp[out[8]] ==  -3)){no_map = 16; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -4)){no_map = 17; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -2)){no_map = 17; break;}
      if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){no_map = 18; break;}
      if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){no_map = 18; break;}
      if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){no_map = 19; break;}
      if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){no_map = 19; break;}
      if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -3)){no_map = 20; break;}
      if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -1)){no_map = 20; break;}
      if ((tp[out[1]] ==  -1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -1) && (tp[out[8]] ==  -1)){no_map = 21; break;}
      if ((tp[out[1]] ==  -3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -3) && (tp[out[8]] ==  -3)){no_map = 21; break;}
      if ((tp[out[1]] ==  -1) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -1) && (tp[out[8]] ==  -3)){no_map = 22; break;}
      if ((tp[out[1]] ==  -3) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -3) && (tp[out[8]] ==  -1)){no_map = 22; break;}
      if ((tp[out[1]] ==  -5) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -1) && (tp[out[8]] ==  -5)){no_map = 22; break;}
      if ((tp[out[1]] ==  -5) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -3) && (tp[out[8]] ==  -5)){no_map = 22; break;}
      if ((tp[out[1]] ==  -2) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -1) && (tp[out[8]] ==  -2)){no_map = 23; break;}
      if ((tp[out[1]] ==  -4) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -3) && (tp[out[8]] ==  -4)){no_map = 23; break;}
      if ((tp[out[1]] ==  -2) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -1) && (tp[out[8]] ==  -4)){no_map = 24; break;}
      if ((tp[out[1]] ==  -4) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -3) && (tp[out[8]] ==  -2)){no_map = 24; break;}
    }
    if (no_map != -1){break;}
  }
  for (int o = 0; o < out.size(); o++){
    if (out[o] == 0){o_map[o] = o;}
    else {o_map[o] = out[o];}
  }
  no_prc = no_map;
  o_prc = o_map;
  if (no_map == 0){}
  else if (no_map == 1){symmetry_factor = 2;}
  else if (no_map == 2){symmetry_factor = 2;}
  else if (no_map == 3){symmetry_factor = 2;}
  else if (no_map == 4){symmetry_factor = 2;}
  else if (no_map == 5){symmetry_factor = 4;}
  else if (no_map == 6){symmetry_factor = 2;}
  else if (no_map == 7){symmetry_factor = 2;}
  else if (no_map == 8){symmetry_factor = 2;}
  else if (no_map == 9){symmetry_factor = 2;}
  else if (no_map == 10){symmetry_factor = 4;}
  else if (no_map == 11){symmetry_factor = 2;}
  else if (no_map == 12){symmetry_factor = 2;}
  else if (no_map == 13){symmetry_factor = 2;}
  else if (no_map == 14){symmetry_factor = 2;}
  else if (no_map == 15){symmetry_factor = 2;}
  else if (no_map == 16){symmetry_factor = 2;}
  else if (no_map == 17){symmetry_factor = 2;}
  else if (no_map == 18){symmetry_factor = 2;}
  else if (no_map == 19){symmetry_factor = 2;}
  else if (no_map == 20){symmetry_factor = 2;}
  else if (no_map == 21){symmetry_factor = 4;}
  else if (no_map == 22){symmetry_factor = 2;}
  else if (no_map == 23){symmetry_factor = 2;}
  else if (no_map == 24){symmetry_factor = 2;}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
void ppeeexnex04_determination_subprocess_doublereal(int i_a, phasespace_set & psi){
  static Logger logger("ppeeexnex04_determination_subprocess_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  vector<int> tp = psi.csi->basic_type_parton[i_a];
  //  ppeeexnex04_determination_no_subprocess_doublereal(psi_no_map[i_a], psi_o_map[i_a], psi_no_prc[i_a], psi_o_prc[i_a], psi_symmetry_factor, tp, psi_phasespace_order_alpha_s[i_a], psi_phasespace_order_alpha_e[i_a], psi_phasespace_order_interference[i_a]);

  psi_no_map[i_a] = -1;
  vector<int> out(9);
  for (int i = 0; i < 2; i++){
    if (i == 0){out[1] = 1; out[2] = 2;}
    if (i == 1){out[1] = 2; out[2] = 1;}
    for (int o = 0; o < 2; o++){
      if (o == 0){out[7] = 7; out[8] = 8;}
      if (o == 1){out[7] = 8; out[8] = 7;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 1; break;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==   0) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 1; break;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==   1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==   2)){psi_no_map[i_a] = 2; break;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==   3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==   4)){psi_no_map[i_a] = 2; break;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 3; break;}
      if ((tp[out[1]] ==   0) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 3; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==   1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   1) && (tp[out[8]] ==   2)){psi_no_map[i_a] = 4; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==   3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   3) && (tp[out[8]] ==   4)){psi_no_map[i_a] = 4; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==   2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==   2)){psi_no_map[i_a] = 5; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==   4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==   4)){psi_no_map[i_a] = 5; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==   3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   1) && (tp[out[8]] ==   4)){psi_no_map[i_a] = 6; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==   1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   3) && (tp[out[8]] ==   2)){psi_no_map[i_a] = 6; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==   1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==   5)){psi_no_map[i_a] = 6; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==   3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==   5)){psi_no_map[i_a] = 6; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==   4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==   4)){psi_no_map[i_a] = 7; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==   2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==   2)){psi_no_map[i_a] = 7; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 8; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 8; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 9; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 9; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 9; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -5) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 9; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==   0)){psi_no_map[i_a] = 10; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   0) && (tp[out[8]] ==   0)){psi_no_map[i_a] = 10; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   1) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 11; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   3) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 11; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -2)){psi_no_map[i_a] = 12; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -4)){psi_no_map[i_a] = 12; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   3) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 13; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   1) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 13; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   5) && (tp[out[8]] ==  -5)){psi_no_map[i_a] = 13; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   5) && (tp[out[8]] ==  -5)){psi_no_map[i_a] = 13; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -4)){psi_no_map[i_a] = 14; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -2)){psi_no_map[i_a] = 14; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -3) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 15; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -1) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 15; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -5) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -5)){psi_no_map[i_a] = 15; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -5) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -5)){psi_no_map[i_a] = 15; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   1) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 16; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   3) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 16; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   5) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 16; break;}
      if ((tp[out[1]] ==   5) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   5) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 16; break;}
      if ((tp[out[1]] ==   1) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -4)){psi_no_map[i_a] = 17; break;}
      if ((tp[out[1]] ==   3) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -2)){psi_no_map[i_a] = 17; break;}
      if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 18; break;}
      if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 18; break;}
      if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 19; break;}
      if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 19; break;}
      if ((tp[out[1]] ==   2) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   2) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 20; break;}
      if ((tp[out[1]] ==   4) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==   4) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 20; break;}
      if ((tp[out[1]] ==  -1) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -1) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 21; break;}
      if ((tp[out[1]] ==  -3) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -3) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 21; break;}
      if ((tp[out[1]] ==  -1) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -1) && (tp[out[8]] ==  -3)){psi_no_map[i_a] = 22; break;}
      if ((tp[out[1]] ==  -3) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -3) && (tp[out[8]] ==  -1)){psi_no_map[i_a] = 22; break;}
      if ((tp[out[1]] ==  -5) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -1) && (tp[out[8]] ==  -5)){psi_no_map[i_a] = 22; break;}
      if ((tp[out[1]] ==  -5) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -3) && (tp[out[8]] ==  -5)){psi_no_map[i_a] = 22; break;}
      if ((tp[out[1]] ==  -2) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -1) && (tp[out[8]] ==  -2)){psi_no_map[i_a] = 23; break;}
      if ((tp[out[1]] ==  -4) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -3) && (tp[out[8]] ==  -4)){psi_no_map[i_a] = 23; break;}
      if ((tp[out[1]] ==  -2) && (tp[out[2]] ==  -4) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -1) && (tp[out[8]] ==  -4)){psi_no_map[i_a] = 24; break;}
      if ((tp[out[1]] ==  -4) && (tp[out[2]] ==  -2) && (tp[3] ==  11) && (tp[4] ==  11) && (tp[5] == -11) && (tp[6] == -12) && (tp[out[7]] ==  -3) && (tp[out[8]] ==  -2)){psi_no_map[i_a] = 24; break;}
    }
    if (psi_no_map[i_a] != -1){break;}
  }
  for (int o = 0; o < out.size(); o++){
    if (out[o] == 0){psi_o_map[i_a][o] = o;}
    else {psi_o_map[i_a][o] = out[o];}
  }
  psi_no_prc[i_a] = psi_no_map[i_a];
  psi_o_prc[i_a] = psi_o_map[i_a];
  if (psi_no_map[i_a] == 0){}
  else if (psi_no_map[i_a] == 1){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 2){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 3){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 4){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 5){psi_symmetry_factor = 4;}
  else if (psi_no_map[i_a] == 6){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 7){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 8){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 9){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 10){psi_symmetry_factor = 4;}
  else if (psi_no_map[i_a] == 11){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 12){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 13){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 14){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 15){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 16){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 17){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 18){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 19){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 20){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 21){psi_symmetry_factor = 4;}
  else if (psi_no_map[i_a] == 22){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 23){psi_symmetry_factor = 2;}
  else if (psi_no_map[i_a] == 24){psi_symmetry_factor = 2;}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
void ppeeexnex04_combination_subprocess_doublereal(int i_a, phasespace_set & psi, observable_set & oset){
  static Logger logger("ppeeexnex04_combination_subprocess_doublereal");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;

  if (psi_no_map[i_a] == 0){}
  else if (psi_no_map[i_a] == 1){
    int pdf_1[] = { 1,   0,   0};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // g  g   -> e  e  ex nexu  dx 
    int pdf_2[] = { 1,   0,   0};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // g  g   -> e  e  ex nexc  sx 
  }
  else if (psi_no_map[i_a] == 2){
    int pdf_1[] = { 1,   0,   1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // g  d   -> e  e  ex nexg  u  
    int pdf_2[] = { 1,   0,   3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // g  s   -> e  e  ex nexg  c  
    int pdf_3[] = {-1,   0,   1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // d  g   -> e  e  ex nexg  u  
    int pdf_4[] = {-1,   0,   3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // s  g   -> e  e  ex nexg  c  
  }
  else if (psi_no_map[i_a] == 3){
    int pdf_1[] = { 1,   0,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // g  ux  -> e  e  ex nexg  dx 
    int pdf_2[] = { 1,   0,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // g  cx  -> e  e  ex nexg  sx 
    int pdf_3[] = {-1,   0,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // ux g   -> e  e  ex nexg  dx 
    int pdf_4[] = {-1,   0,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // cx g   -> e  e  ex nexg  sx 
  }
  else if (psi_no_map[i_a] == 4){
    int pdf_1[] = { 1,   1,   1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  d   -> e  e  ex nexd  u  
    int pdf_2[] = { 1,   3,   3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  s   -> e  e  ex nexs  c  
  }
  else if (psi_no_map[i_a] == 5){
    int pdf_1[] = { 1,   1,   2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  u   -> e  e  ex nexu  u  
    int pdf_2[] = { 1,   3,   4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  c   -> e  e  ex nexc  c  
    int pdf_3[] = {-1,   1,   2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // u  d   -> e  e  ex nexu  u  
    int pdf_4[] = {-1,   3,   4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // c  s   -> e  e  ex nexc  c  
  }
  else if (psi_no_map[i_a] == 6){
    int pdf_1[] = { 1,   1,   3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  s   -> e  e  ex nexd  c  
    int pdf_2[] = { 1,   3,   1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  d   -> e  e  ex nexu  s  
    int pdf_3[] = { 1,   5,   1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // b  d   -> e  e  ex nexu  b  
    int pdf_4[] = { 1,   5,   3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // b  s   -> e  e  ex nexc  b  
    int pdf_5[] = {-1,   3,   1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_5, 3));   // d  s   -> e  e  ex nexu  s  
    int pdf_6[] = {-1,   1,   3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_6, 3));   // s  d   -> e  e  ex nexd  c  
    int pdf_7[] = {-1,   5,   1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_7, 3));   // d  b   -> e  e  ex nexu  b  
    int pdf_8[] = {-1,   5,   3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_8, 3));   // s  b   -> e  e  ex nexc  b  
  }
  else if (psi_no_map[i_a] == 7){
    int pdf_1[] = { 1,   1,   4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  c   -> e  e  ex nexu  c  
    int pdf_2[] = { 1,   3,   2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  u   -> e  e  ex nexu  c  
    int pdf_3[] = {-1,   3,   2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // u  s   -> e  e  ex nexu  c  
    int pdf_4[] = {-1,   1,   4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // c  d   -> e  e  ex nexu  c  
  }
  else if (psi_no_map[i_a] == 8){
    int pdf_1[] = { 1,   1,  -1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  dx  -> e  e  ex nexu  dx 
    int pdf_2[] = { 1,   3,  -3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  sx  -> e  e  ex nexc  sx 
    int pdf_3[] = {-1,   1,  -1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // dx d   -> e  e  ex nexu  dx 
    int pdf_4[] = {-1,   3,  -3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // sx s   -> e  e  ex nexc  sx 
  }
  else if (psi_no_map[i_a] == 9){
    int pdf_1[] = { 1,   1,  -1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  dx  -> e  e  ex nexc  sx 
    int pdf_2[] = { 1,   3,  -3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  sx  -> e  e  ex nexu  dx 
    int pdf_3[] = { 1,   5,  -5};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // b  bx  -> e  e  ex nexu  dx 
    int pdf_4[] = { 1,   5,  -5};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // b  bx  -> e  e  ex nexc  sx 
    int pdf_5[] = {-1,   1,  -1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_5, 3));   // dx d   -> e  e  ex nexc  sx 
    int pdf_6[] = {-1,   3,  -3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_6, 3));   // sx s   -> e  e  ex nexu  dx 
    int pdf_7[] = {-1,   5,  -5};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_7, 3));   // bx b   -> e  e  ex nexu  dx 
    int pdf_8[] = {-1,   5,  -5};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_8, 3));   // bx b   -> e  e  ex nexc  sx 
  }
  else if (psi_no_map[i_a] == 10){
    int pdf_1[] = { 1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  ux  -> e  e  ex nexg  g  
    int pdf_2[] = { 1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  cx  -> e  e  ex nexg  g  
    int pdf_3[] = {-1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // ux d   -> e  e  ex nexg  g  
    int pdf_4[] = {-1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // cx s   -> e  e  ex nexg  g  
  }
  else if (psi_no_map[i_a] == 11){
    int pdf_1[] = { 1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  ux  -> e  e  ex nexd  dx 
    int pdf_2[] = { 1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  cx  -> e  e  ex nexs  sx 
    int pdf_3[] = {-1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // ux d   -> e  e  ex nexd  dx 
    int pdf_4[] = {-1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // cx s   -> e  e  ex nexs  sx 
  }
  else if (psi_no_map[i_a] == 12){
    int pdf_1[] = { 1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  ux  -> e  e  ex nexu  ux 
    int pdf_2[] = { 1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  cx  -> e  e  ex nexc  cx 
    int pdf_3[] = {-1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // ux d   -> e  e  ex nexu  ux 
    int pdf_4[] = {-1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // cx s   -> e  e  ex nexc  cx 
  }
  else if (psi_no_map[i_a] == 13){
    int pdf_1[] = { 1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  ux  -> e  e  ex nexs  sx 
    int pdf_2[] = { 1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  cx  -> e  e  ex nexd  dx 
    int pdf_3[] = { 1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // d  ux  -> e  e  ex nexb  bx 
    int pdf_4[] = { 1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // s  cx  -> e  e  ex nexb  bx 
    int pdf_5[] = {-1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_5, 3));   // ux d   -> e  e  ex nexs  sx 
    int pdf_6[] = {-1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_6, 3));   // cx s   -> e  e  ex nexd  dx 
    int pdf_7[] = {-1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_7, 3));   // ux d   -> e  e  ex nexb  bx 
    int pdf_8[] = {-1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_8, 3));   // cx s   -> e  e  ex nexb  bx 
  }
  else if (psi_no_map[i_a] == 14){
    int pdf_1[] = { 1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  ux  -> e  e  ex nexc  cx 
    int pdf_2[] = { 1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  cx  -> e  e  ex nexu  ux 
    int pdf_3[] = {-1,   1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // ux d   -> e  e  ex nexc  cx 
    int pdf_4[] = {-1,   3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // cx s   -> e  e  ex nexu  ux 
  }
  else if (psi_no_map[i_a] == 15){
    int pdf_1[] = { 1,   1,  -3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  sx  -> e  e  ex nexu  sx 
    int pdf_2[] = { 1,   3,  -1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  dx  -> e  e  ex nexc  dx 
    int pdf_3[] = { 1,   1,  -5};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // d  bx  -> e  e  ex nexu  bx 
    int pdf_4[] = { 1,   3,  -5};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // s  bx  -> e  e  ex nexc  bx 
    int pdf_5[] = {-1,   3,  -1};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_5, 3));   // dx s   -> e  e  ex nexc  dx 
    int pdf_6[] = {-1,   1,  -3};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_6, 3));   // sx d   -> e  e  ex nexu  sx 
    int pdf_7[] = {-1,   1,  -5};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_7, 3));   // bx d   -> e  e  ex nexu  bx 
    int pdf_8[] = {-1,   3,  -5};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_8, 3));   // bx s   -> e  e  ex nexc  bx 
  }
  else if (psi_no_map[i_a] == 16){
    int pdf_1[] = { 1,   1,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  cx  -> e  e  ex nexd  sx 
    int pdf_2[] = { 1,   3,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  ux  -> e  e  ex nexs  dx 
    int pdf_3[] = { 1,   5,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // b  ux  -> e  e  ex nexb  dx 
    int pdf_4[] = { 1,   5,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // b  cx  -> e  e  ex nexb  sx 
    int pdf_5[] = {-1,   3,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_5, 3));   // ux s   -> e  e  ex nexs  dx 
    int pdf_6[] = {-1,   1,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_6, 3));   // cx d   -> e  e  ex nexd  sx 
    int pdf_7[] = {-1,   5,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_7, 3));   // ux b   -> e  e  ex nexb  dx 
    int pdf_8[] = {-1,   5,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_8, 3));   // cx b   -> e  e  ex nexb  sx 
  }
  else if (psi_no_map[i_a] == 17){
    int pdf_1[] = { 1,   1,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // d  cx  -> e  e  ex nexu  cx 
    int pdf_2[] = { 1,   3,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // s  ux  -> e  e  ex nexc  ux 
    int pdf_3[] = {-1,   3,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // ux s   -> e  e  ex nexc  ux 
    int pdf_4[] = {-1,   1,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // cx d   -> e  e  ex nexu  cx 
  }
  else if (psi_no_map[i_a] == 18){
    int pdf_1[] = { 1,   2,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // u  ux  -> e  e  ex nexu  dx 
    int pdf_2[] = { 1,   4,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // c  cx  -> e  e  ex nexc  sx 
    int pdf_3[] = {-1,   2,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // ux u   -> e  e  ex nexu  dx 
    int pdf_4[] = {-1,   4,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // cx c   -> e  e  ex nexc  sx 
  }
  else if (psi_no_map[i_a] == 19){
    int pdf_1[] = { 1,   2,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // u  ux  -> e  e  ex nexc  sx 
    int pdf_2[] = { 1,   4,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // c  cx  -> e  e  ex nexu  dx 
    int pdf_3[] = {-1,   2,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // ux u   -> e  e  ex nexc  sx 
    int pdf_4[] = {-1,   4,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // cx c   -> e  e  ex nexu  dx 
  }
  else if (psi_no_map[i_a] == 20){
    int pdf_1[] = { 1,   2,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // u  cx  -> e  e  ex nexu  sx 
    int pdf_2[] = { 1,   4,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // c  ux  -> e  e  ex nexc  dx 
    int pdf_3[] = {-1,   4,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // ux c   -> e  e  ex nexc  dx 
    int pdf_4[] = {-1,   2,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // cx u   -> e  e  ex nexu  sx 
  }
  else if (psi_no_map[i_a] == 21){
    int pdf_1[] = { 1,  -1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // dx ux  -> e  e  ex nexdx dx 
    int pdf_2[] = { 1,  -3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // sx cx  -> e  e  ex nexsx sx 
    int pdf_3[] = {-1,  -1,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // ux dx  -> e  e  ex nexdx dx 
    int pdf_4[] = {-1,  -3,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // cx sx  -> e  e  ex nexsx sx 
  }
  else if (psi_no_map[i_a] == 22){
    int pdf_1[] = { 1,  -1,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // dx cx  -> e  e  ex nexdx sx 
    int pdf_2[] = { 1,  -3,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // sx ux  -> e  e  ex nexdx sx 
    int pdf_3[] = { 1,  -5,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // bx ux  -> e  e  ex nexdx bx 
    int pdf_4[] = { 1,  -5,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // bx cx  -> e  e  ex nexsx bx 
    int pdf_5[] = {-1,  -3,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_5, 3));   // ux sx  -> e  e  ex nexdx sx 
    int pdf_6[] = {-1,  -1,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_6, 3));   // cx dx  -> e  e  ex nexdx sx 
    int pdf_7[] = {-1,  -5,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_7, 3));   // ux bx  -> e  e  ex nexdx bx 
    int pdf_8[] = {-1,  -5,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_8, 3));   // cx bx  -> e  e  ex nexsx bx 
  }
  else if (psi_no_map[i_a] == 23){
    int pdf_1[] = { 1,  -2,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // ux ux  -> e  e  ex nexdx ux 
    int pdf_2[] = { 1,  -4,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // cx cx  -> e  e  ex nexsx cx 
  }
  else if (psi_no_map[i_a] == 24){
    int pdf_1[] = { 1,  -2,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_1, 3));   // ux cx  -> e  e  ex nexdx cx 
    int pdf_2[] = { 1,  -4,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_2, 3));   // cx ux  -> e  e  ex nexux sx 
    int pdf_3[] = {-1,  -4,  -2};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_3, 3));   // ux cx  -> e  e  ex nexux sx 
    int pdf_4[] = {-1,  -2,  -4};    osi_combination_pdf.push_back(get_vector_from_array_int(pdf_4, 3));   // cx ux  -> e  e  ex nexdx cx 
  }

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
