#include "ppeexa03.header.cxx"
void ppeexa03_list_subprocess_born(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexa03_list_subprocess_born");
  logger << LOG_DEBUG << "called" << endl;
  if (contribution_order_alpha_s == 0 && contribution_order_alpha_e == 3 && contribution_order_interference == 0){
    subprocess.resize(3);
    subprocess[1] = "dd~_emepa";
    subprocess[2] = "uu~_emepa";
    int member_0[] = {1, 2};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  else if (contribution_order_alpha_s == 2 && contribution_order_alpha_e == 3 && contribution_order_interference == 0){
    subprocess.resize(2);
    subprocess[1] = "gg_emepa";
    int member_0[] = {1};
    subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  }
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexa03_list_subprocess_C_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexa03_list_subprocess_C_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_emepa";
  subprocess[2] = "uu~_emepa";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexa03_list_subprocess_V_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexa03_list_subprocess_V_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(3);
  subprocess[1] = "dd~_emepa";
  subprocess[2] = "uu~_emepa";
  int member_0[] = {1, 2};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexa03_list_subprocess_R_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexa03_list_subprocess_R_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emepad";
  subprocess[2] = "gu_emepau";
  subprocess[3] = "gd~_emepad~";
  subprocess[4] = "gu~_emepau~";
  subprocess[5] = "dd~_emepag";
  subprocess[6] = "uu~_emepag";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexa03_list_subprocess_RC_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexa03_list_subprocess_RC_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emepad";
  subprocess[2] = "gu_emepau";
  subprocess[3] = "gd~_emepad~";
  subprocess[4] = "gu~_emepau~";
  subprocess[5] = "dd~_emepag";
  subprocess[6] = "uu~_emepag";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexa03_list_subprocess_RV_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexa03_list_subprocess_RV_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(7);
  subprocess[1] = "gd_emepad";
  subprocess[2] = "gu_emepau";
  subprocess[3] = "gd~_emepad~";
  subprocess[4] = "gu~_emepau~";
  subprocess[5] = "dd~_emepag";
  subprocess[6] = "uu~_emepag";
  int member_0[] = {1, 2, 3, 4, 5, 6};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
void ppeexa03_list_subprocess_RR_QCD(vector<string> & subprocess, vector<vector<int> > & subgroup_no_member, int contribution_order_alpha_s, int contribution_order_alpha_e, int contribution_order_interference){
  Logger logger("ppeexa03_list_subprocess_RR_QCD");
  logger << LOG_DEBUG << "called" << endl;
  subprocess.resize(35);
  subprocess[1] = "gg_emepadd~";
  subprocess[2] = "gg_emepauu~";
  subprocess[3] = "gd_emepagd";
  subprocess[4] = "gu_emepagu";
  subprocess[5] = "gd~_emepagd~";
  subprocess[6] = "gu~_emepagu~";
  subprocess[7] = "dd_emepadd";
  subprocess[8] = "du_emepadu";
  subprocess[9] = "ds_emepads";
  subprocess[10] = "dc_emepadc";
  subprocess[11] = "dd~_emepagg";
  subprocess[12] = "dd~_emepadd~";
  subprocess[13] = "dd~_emepauu~";
  subprocess[14] = "dd~_emepass~";
  subprocess[15] = "dd~_emepacc~";
  subprocess[16] = "du~_emepadu~";
  subprocess[17] = "ds~_emepads~";
  subprocess[18] = "dc~_emepadc~";
  subprocess[19] = "uu_emepauu";
  subprocess[20] = "uc_emepauc";
  subprocess[21] = "ud~_emepaud~";
  subprocess[22] = "uu~_emepagg";
  subprocess[23] = "uu~_emepadd~";
  subprocess[24] = "uu~_emepauu~";
  subprocess[25] = "uu~_emepass~";
  subprocess[26] = "uu~_emepacc~";
  subprocess[27] = "us~_emepaus~";
  subprocess[28] = "uc~_emepauc~";
  subprocess[29] = "d~d~_emepad~d~";
  subprocess[30] = "d~u~_emepad~u~";
  subprocess[31] = "d~s~_emepad~s~";
  subprocess[32] = "d~c~_emepad~c~";
  subprocess[33] = "u~u~_emepau~u~";
  subprocess[34] = "u~c~_emepau~c~";
  int member_0[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34};
  subgroup_no_member[0] = vector<int> (member_0, member_0 + sizeof(member_0) / sizeof(int));
  logger << LOG_DEBUG << "finished" << endl;
}
