void ppwxw02_particles(int i_a, observable_set & oset);

void ppwxw02_cuts(int i_a, observable_set & oset);
void ppwxw02_cuts_test(int i_a, observable_set & oset);

void ppwxw02_moments(observable_set & oset);

void ppwxw02_calculate_dynamic_scale(int i_a, observable_set & oset);
void ppwxw02_calculate_dynamic_scale_RA(int i_a, observable_set & oset);
void ppwxw02_calculate_dynamic_scale_TSV(int i_a, observable_set & oset);

void ppwxw02_optimize_minv_born(phasespace_set & psi);
int ppwxw02_determination_MCchannels_born(int no_ps, phasespace_set & psi);
void ppwxw02_ac_tau_psp_born(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi);
void ppwxw02_ag_psp_born(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_born(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_born(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ax_psp_020_ddx_wpwm(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_020_ddx_wpwm(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_020_ddx_wpwm(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_020_uux_wpwm(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_020_uux_wpwm(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_020_uux_wpwm(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_020_bbx_wpwm(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_020_bbx_wpwm(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_020_bbx_wpwm(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_gg_wpwm(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_gg_wpwm(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_gg_wpwm(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_phasespacepoint_born(observable_set & oset);

void ppwxw02_phasespacepoint_collinear(observable_set & oset);

void ppwxw02_optimize_minv_real(phasespace_set & psi);
int ppwxw02_determination_MCchannels_real(int no_ps, phasespace_set & psi);
void ppwxw02_ac_tau_psp_real(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi);
void ppwxw02_ag_psp_real(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_real(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_real(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ax_psp_120_gd_wpwmd(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_120_gd_wpwmd(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_120_gd_wpwmd(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_120_gu_wpwmu(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_120_gu_wpwmu(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_120_gu_wpwmu(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_120_gb_wpwmb(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_120_gb_wpwmb(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_120_gb_wpwmb(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_120_gdx_wpwmdx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_120_gdx_wpwmdx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_120_gdx_wpwmdx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_120_gux_wpwmux(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_120_gux_wpwmux(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_120_gux_wpwmux(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_120_gbx_wpwmbx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_120_gbx_wpwmbx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_120_gbx_wpwmbx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_120_ddx_wpwmg(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_120_ddx_wpwmg(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_120_ddx_wpwmg(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_120_uux_wpwmg(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_120_uux_wpwmg(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_120_uux_wpwmg(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_120_bbx_wpwmg(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_120_bbx_wpwmg(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_120_bbx_wpwmg(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_phasespacepoint_real(observable_set & oset);

void ppwxw02_phasespacepoint_realcollinear(observable_set & oset);

void ppwxw02_optimize_minv_doublereal(phasespace_set & psi);
int ppwxw02_determination_MCchannels_doublereal(int no_ps, phasespace_set & psi);
void ppwxw02_ac_tau_psp_doublereal(int no_ps, vector<int> & tau_MC_map, phasespace_set & psi);
void ppwxw02_ag_psp_doublereal(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_doublereal(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_doublereal(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ax_psp_220_gg_wpwmddx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_gg_wpwmddx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_gg_wpwmddx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_gg_wpwmuux(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_gg_wpwmuux(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_gg_wpwmuux(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_gg_wpwmbbx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_gg_wpwmbbx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_gg_wpwmbbx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_gd_wpwmgd(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_gd_wpwmgd(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_gd_wpwmgd(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_gu_wpwmgu(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_gu_wpwmgu(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_gu_wpwmgu(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_gb_wpwmgb(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_gb_wpwmgb(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_gb_wpwmgb(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_gdx_wpwmgdx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_gdx_wpwmgdx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_gdx_wpwmgdx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_gux_wpwmgux(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_gux_wpwmgux(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_gux_wpwmgux(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_gbx_wpwmgbx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_gbx_wpwmgbx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_gbx_wpwmgbx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dd_wpwmdd(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dd_wpwmdd(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dd_wpwmdd(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_du_wpwmdu(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_du_wpwmdu(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_du_wpwmdu(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_ds_wpwmds(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_ds_wpwmds(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_ds_wpwmds(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dc_wpwmdc(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dc_wpwmdc(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dc_wpwmdc(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dc_wpwmus(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dc_wpwmus(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dc_wpwmus(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_db_wpwmdb(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_db_wpwmdb(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_db_wpwmdb(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_ddx_wpwmgg(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_ddx_wpwmgg(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_ddx_wpwmgg(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_ddx_wpwmddx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_ddx_wpwmddx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_ddx_wpwmddx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_ddx_wpwmuux(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_ddx_wpwmuux(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_ddx_wpwmuux(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_ddx_wpwmssx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_ddx_wpwmssx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_ddx_wpwmssx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_ddx_wpwmccx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_ddx_wpwmccx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_ddx_wpwmccx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_ddx_wpwmbbx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_ddx_wpwmbbx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_ddx_wpwmbbx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dux_wpwmdux(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dux_wpwmdux(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dux_wpwmdux(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dux_wpwmscx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dux_wpwmscx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dux_wpwmscx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dsx_wpwmdsx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dsx_wpwmdsx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dsx_wpwmdsx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dsx_wpwmucx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dsx_wpwmucx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dsx_wpwmucx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dcx_wpwmdcx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dcx_wpwmdcx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dcx_wpwmdcx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dbx_wpwmdbx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dbx_wpwmdbx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dbx_wpwmdbx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_uu_wpwmuu(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_uu_wpwmuu(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_uu_wpwmuu(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_uc_wpwmuc(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_uc_wpwmuc(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_uc_wpwmuc(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_ub_wpwmub(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_ub_wpwmub(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_ub_wpwmub(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_udx_wpwmudx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_udx_wpwmudx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_udx_wpwmudx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_udx_wpwmcsx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_udx_wpwmcsx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_udx_wpwmcsx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_uux_wpwmgg(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_uux_wpwmgg(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_uux_wpwmgg(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_uux_wpwmddx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_uux_wpwmddx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_uux_wpwmddx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_uux_wpwmuux(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_uux_wpwmuux(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_uux_wpwmuux(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_uux_wpwmssx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_uux_wpwmssx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_uux_wpwmssx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_uux_wpwmccx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_uux_wpwmccx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_uux_wpwmccx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_uux_wpwmbbx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_uux_wpwmbbx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_uux_wpwmbbx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_usx_wpwmusx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_usx_wpwmusx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_usx_wpwmusx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_ucx_wpwmdsx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_ucx_wpwmdsx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_ucx_wpwmdsx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_ucx_wpwmucx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_ucx_wpwmucx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_ucx_wpwmucx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_ubx_wpwmubx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_ubx_wpwmubx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_ubx_wpwmubx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_bb_wpwmbb(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_bb_wpwmbb(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_bb_wpwmbb(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_bdx_wpwmbdx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_bdx_wpwmbdx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_bdx_wpwmbdx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_bux_wpwmbux(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_bux_wpwmbux(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_bux_wpwmbux(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_bbx_wpwmgg(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_bbx_wpwmgg(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_bbx_wpwmgg(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_bbx_wpwmddx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_bbx_wpwmddx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_bbx_wpwmddx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_bbx_wpwmuux(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_bbx_wpwmuux(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_bbx_wpwmuux(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_bbx_wpwmbbx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_bbx_wpwmbbx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_bbx_wpwmbbx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dxdx_wpwmdxdx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dxdx_wpwmdxdx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dxdx_wpwmdxdx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dxux_wpwmdxux(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dxux_wpwmdxux(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dxux_wpwmdxux(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dxsx_wpwmdxsx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dxsx_wpwmdxsx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dxsx_wpwmdxsx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dxcx_wpwmdxcx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dxcx_wpwmdxcx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dxcx_wpwmdxcx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dxcx_wpwmuxsx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dxcx_wpwmuxsx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dxcx_wpwmuxsx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_dxbx_wpwmdxbx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_dxbx_wpwmdxbx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_dxbx_wpwmdxbx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_uxux_wpwmuxux(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_uxux_wpwmuxux(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_uxux_wpwmuxux(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_uxcx_wpwmuxcx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_uxcx_wpwmuxcx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_uxcx_wpwmuxcx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_uxbx_wpwmuxbx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_uxbx_wpwmuxbx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_uxbx_wpwmuxbx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_ax_psp_220_bxbx_wpwmbxbx(int no_ps, phasespace_set & psi);
void ppwxw02_ac_psp_220_bxbx_wpwmbxbx(int no_ps, int channel, phasespace_set & psi);
void ppwxw02_ag_psp_220_bxbx_wpwmbxbx(int no_ps, int zero, phasespace_set & psi);
void ppwxw02_phasespacepoint_doublereal(observable_set & oset);

