#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemexnmx04/header/ppemexnmx04.phasespace.h"
void ppemexnmx04_ax_psp_240_dux_emmumepvmxgg(int no_ps, phasespace_set & psi){
  static Logger logger("ppemexnmx04_ax_psp_240_dux_emmumepvmxgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(22);
  psi_needed_v_smin[no_ps].resize(22);
  int needed_v_smin_0[] = {   0,    1,    8,    9,   10,   11,   12,   13,   20,   21,   22,   23,   24,   25,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; //  84
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 84);
  int needed_v_smin_1[] = {   0,    1,   12,   13,   24,   25,   44,   66}; //   8
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 8);
  int needed_v_smin_2[] = {   0,    1,   12,   13,   24,   25,   44,   66}; //   8
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 8);
  int needed_v_smin_3[] = {   2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; // 100
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 100);
  int needed_v_smin_4[] = {   2,    3,   14,   15,   26,   27,   45,   67}; //   8
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 8);
  int needed_v_smin_5[] = {   2,    3,   14,   15,   26,   27,   45,   67}; //   8
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 8);
  int needed_v_smin_6[] = {   4,    5,    6,    7,   16,   17,   18,   19,   28,   29,   30,   31,   46,   47,   68,   69}; //  16
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 16);
  int needed_v_smin_7[] = {   4,    5,    6,    7,   16,   17,   18,   19,   28,   29,   30,   31,   46,   47,   68,   69}; //  16
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 16);
  int needed_v_smin_8[] = {   8,    9,   10,   11,   20,   21,   22,   23,   32,   33,   34,   35,   48,   49,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,  100,  101,  106,  107}; //  28
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 28);
  int needed_v_smin_9[] = {  44,   45,   46,   47,   48,   49,   66,   67,   68,   69,   70,   71,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107,   58,   59,   60,   61,   62,   63,   64,   65}; //  32
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 32);
  int needed_v_smin_10[] = {   0,    2,    4,    5,    8,    9,   12,   14,   16,   17,   20,   21,   25,   27,   30,   31,   34,   35,   72,   73,   76,   77}; //  22
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 22);
  int needed_v_smin_11[] = {   1,    3,    6,    7,   10,   11,   13,   15,   18,   19,   22,   23,   24,   26,   28,   29,   32,   33,   74,   75,   78,   79}; //  22
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 22);
  int needed_v_smin_12[] = {  36,   37,   52,   53,   84,   85,   94,   95}; //   8
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 8);
  int needed_v_smin_13[] = {  36,   37,   52,   53,   84,   85,   94,   95}; //   8
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 8);
  int needed_v_smin_14[] = {  38,   39,   50,   51,   86,   87,   92,   93}; //   8
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 8);
  int needed_v_smin_15[] = {  38,   39,   50,   51,   86,   87,   92,   93}; //   8
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 8);
  int needed_v_smin_16[] = {  40,   41,   56,   57,   80,   81,   90,   91}; //   8
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 8);
  int needed_v_smin_17[] = {  40,   41,   56,   57,   80,   81,   90,   91}; //   8
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 8);
  int needed_v_smin_18[] = {  42,   43,   54,   55,   82,   83,   88,   89}; //   8
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 8);
  int needed_v_smin_19[] = {  42,   43,   54,   55,   82,   83,   88,   89}; //   8
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 8);
  int needed_v_smin_20[] = {  58,   59,   60,   61,   96,   97,   98,   99}; //   8
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 8);
  int needed_v_smin_21[] = {  62,   63,   64,   65,  102,  103,  104,  105}; //   8
  psi_needed_v_smin[no_ps][ 21] = get_vector_from_array_int(needed_v_smin_21, 8);

  psi_v_smax[no_ps].resize(29);
  psi_needed_v_smax[no_ps].resize(29);
  int needed_v_smax_0[] = {   0,    1,    8,    9,   10,   11,   12,   13,   20,   21,   22,   23,   24,   25,   32,   33,   34,   35,   36,   37,   38,   39,   44,   48,   49,   50,   51,   52,   53,   58,   59,   60,   61,   72,   73,   74,   75,   80,   81,   82,   83,   88,   89,   90,   91,   98,   99,  100,  101}; //  49
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 49);
  int needed_v_smax_1[] = {   0,    1,   12,   13,   24,   25,   44}; //   7
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 7);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   44,   45,   46,   47,   48,   49,   72,   73,   74,   75,   76,   77,   78,   79}; //  50
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 50);
  int needed_v_smax_3[] = {   2,    3,    4,    5,    6,    7,   14,   15,   16,   17,   18,   19,   26,   27,   28,   29,   30,   31,   40,   41,   42,   43,   45,   46,   47,   54,   55,   56,   57,   62,   63,   64,   65,   76,   77,   78,   79,   84,   85,   86,   87,   92,   93,   94,   95,  104,  105,  106,  107}; //  49
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 49);
  int needed_v_smax_4[] = {   2,    3,   14,   15,   26,   27,   45}; //   7
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 7);
  int needed_v_smax_5[] = {   4,    5,    6,    7,   16,   17,   18,   19,   28,   29,   30,   31,   46,   47}; //  14
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 14);
  int needed_v_smax_6[] = {   8,    9,   10,   11,   20,   21,   22,   23,   32,   33,   34,   35,   36,   37,   38,   39,   48,   49,   50,   51,   52,   53,   58,   59,   60,   61,   72,   73,   74,   75,   80,   81,   82,   83,   88,   89,   90,   91,  100,  101}; //  40
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 40);
  int needed_v_smax_7[] = {  40,   41,   42,   43,   54,   55,   56,   57,   62,   63,   64,   65,   76,   77,   78,   79,   84,   85,   86,   87,   92,   93,   94,   95,  106,  107}; //  26
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 26);
  int needed_v_smax_8[] = {  44,   45,   46,   47,   48,   49}; //   6
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 6);
  int needed_v_smax_9[] = {  66,   67,   68,   69,   70,   71,   96,   97,  102,  103}; //  10
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 10);
  int needed_v_smax_10[] = {  66,   70,   71,   96,   97}; //   5
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 5);
  int needed_v_smax_11[] = {  66}; //   1
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 1);
  int needed_v_smax_12[] = {  66,   67,   68,   69,   70,   71,  100,  101,  106,  107}; //  10
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 10);
  int needed_v_smax_13[] = {  67,   68,   69,  102,  103}; //   5
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 5);
  int needed_v_smax_14[] = {  67}; //   1
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 1);
  int needed_v_smax_15[] = {  68,   69}; //   2
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 2);
  int needed_v_smax_16[] = {  70,   71,   96,   97,   98,   99}; //   6
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 6);
  int needed_v_smax_17[] = {  98,   99}; //   2
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 2);
  int needed_v_smax_18[] = { 100,  101,  106,  107,   58,   59,   60,   61,   62,   63,   64,   65}; //  12
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 12);
  int needed_v_smax_19[] = { 102,  103,  104,  105}; //   4
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 4);
  int needed_v_smax_20[] = { 104,  105}; //   2
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 2);
  int needed_v_smax_21[] = {   0,    2,    4,    5,    8,    9,   12,   14,   16,   17,   20,   21,   25,   27,   30,   31,   34,   35,   36,   37,   40,   41,   52,   53,   56,   57,   72,   73,   76,   77,   80,   81,   84,   85,   90,   91,   94,   95}; //  38
  psi_needed_v_smax[no_ps][ 21] = get_vector_from_array_int(needed_v_smax_21, 38);
  int needed_v_smax_22[] = {   1,    3,    6,    7,   10,   11,   13,   15,   18,   19,   22,   23,   24,   26,   28,   29,   32,   33,   38,   39,   42,   43,   50,   51,   54,   55,   74,   75,   78,   79,   82,   83,   86,   87,   88,   89,   92,   93}; //  38
  psi_needed_v_smax[no_ps][ 22] = get_vector_from_array_int(needed_v_smax_22, 38);
  int needed_v_smax_23[] = {  36,   37,   52,   53,   84,   85,   94,   95}; //   8
  psi_needed_v_smax[no_ps][ 23] = get_vector_from_array_int(needed_v_smax_23, 8);
  int needed_v_smax_24[] = {  38,   39,   50,   51,   86,   87,   92,   93}; //   8
  psi_needed_v_smax[no_ps][ 24] = get_vector_from_array_int(needed_v_smax_24, 8);
  int needed_v_smax_25[] = {  40,   41,   56,   57,   80,   81,   90,   91}; //   8
  psi_needed_v_smax[no_ps][ 25] = get_vector_from_array_int(needed_v_smax_25, 8);
  int needed_v_smax_26[] = {  42,   43,   54,   55,   82,   83,   88,   89}; //   8
  psi_needed_v_smax[no_ps][ 26] = get_vector_from_array_int(needed_v_smax_26, 8);
  int needed_v_smax_27[] = {  58,   59,   60,   61,   96,   97,   98,   99}; //   8
  psi_needed_v_smax[no_ps][ 27] = get_vector_from_array_int(needed_v_smax_27, 8);
  int needed_v_smax_28[] = {  62,   63,   64,   65,  102,  103,  104,  105}; //   8
  psi_needed_v_smax[no_ps][ 28] = get_vector_from_array_int(needed_v_smax_28, 8);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(31);
  psi_needed_g_p[no_ps].resize(31);
  int needed_g_p_0[] = {   0,    1,    8,    9,   10,   11,   12,   13,   20,   21,   22,   23,   24,   25,   32,   33,   34,   35,   36,   37,   38,   39,   44,   48,   49,   50,   51,   52,   53,   58,   59,   60,   61,   72,   73,   74,   75,   80,   81,   82,   83,   88,   89,   90,   91,   98,   99,  100,  101}; //  49
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 49);
  psi_container_IS_name.push_back("propagator_24_smin0_smax0");
  int needed_g_p_1[] = {   0,    1,   12,   13,   24,   25,   44}; //   7
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 7);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    1,   12,   13,   24,   25,   44}; //   7
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 7);
  psi_container_IS_name.push_back("propagator_24_smin2_smax2");
  int needed_g_p_3[] = {   2,    3,    5,    7,   14,   15,   17,   19,   26,   27,   29,   31,   41,   43,   45,   47,   55,   57,   63,   65,   77,   79,   85,   87,   93,   95,  105,  107}; //  28
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 28);
  psi_container_IS_name.push_back("propagator_23_smin3_smax3");
  int needed_g_p_4[] = {   2,    3,   14,   15,   26,   27,   45}; //   7
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 7);
  psi_container_IS_name.push_back("propagator_0_smin4_smax4");
  int needed_g_p_5[] = {   2,    3,   14,   15,   26,   27,   45}; //   7
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 7);
  psi_container_IS_name.push_back("propagator_24_smin5_smax2");
  int needed_g_p_6[] = {   4,    6,   16,   18,   28,   30,   40,   42,   46,   54,   56,   62,   64,   76,   78,   84,   86,   92,   94,  104,  106}; //  21
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 21);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_7[] = {   4,    5,    6,    7,   16,   17,   18,   19,   28,   29,   30,   31,   46,   47}; //  14
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 14);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_8[] = {   4,    5,    6,    7,   16,   17,   18,   19,   28,   29,   30,   31,   46,   47}; //  14
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 14);
  psi_container_IS_name.push_back("propagator_24_smin7_smax2");
  int needed_g_p_9[] = {   8,   10,   20,   22,   32,   34,   36,   38,   48,   50,   52,   58,   60,   72,   74,   80,   82,   88,   90,  100}; //  20
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 20);
  psi_container_IS_name.push_back("propagator_0_smin3_smax6");
  int needed_g_p_10[] = {   8,    9,   10,   11,   20,   21,   22,   23,   32,   33,   34,   35,   48,   49}; //  14
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 14);
  psi_container_IS_name.push_back("propagator_24_smin8_smax2");
  int needed_g_p_11[] = {   9,   11,   21,   23,   33,   35,   37,   39,   49,   51,   53,   59,   61,   73,   75,   81,   83,   89,   91,  101}; //  20
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 20);
  psi_container_IS_name.push_back("propagator_23_smin3_smax6");
  int needed_g_p_12[] = {  40,   41,   42,   43,   54,   55,   56,   57,   62,   63,   64,   65,   76,   77,   78,   79,   84,   85,   86,   87,   92,   93,   94,   95,  106,  107}; //  26
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 26);
  psi_container_IS_name.push_back("propagator_24_smin0_smax7");
  int needed_g_p_13[] = {  44,   45,   46,   47,   48,   49}; //   6
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 6);
  psi_container_IS_name.push_back("propagator_0_smin9_smax8");
  int needed_g_p_14[] = {  66,   67,   68,   69,   70,   71,   96,   97,  102,  103}; //  10
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 10);
  psi_container_IS_name.push_back("propagator_0_smin9_smax9");
  int needed_g_p_15[] = {  66,   70,   71,   96,   97}; //   5
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 5);
  psi_container_IS_name.push_back("propagator_24_smin0_smax10");
  int needed_g_p_16[] = {  66}; //   1
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 1);
  psi_container_IS_name.push_back("propagator_0_smin1_smax11");
  int needed_g_p_17[] = {  66}; //   1
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 1);
  psi_container_IS_name.push_back("propagator_24_smin2_smax12");
  int needed_g_p_18[] = {  67,   69,  103}; //   3
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 3);
  psi_container_IS_name.push_back("propagator_23_smin3_smax13");
  int needed_g_p_19[] = {  67}; //   1
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 1);
  psi_container_IS_name.push_back("propagator_0_smin4_smax14");
  int needed_g_p_20[] = {  67}; //   1
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 1);
  psi_container_IS_name.push_back("propagator_24_smin5_smax12");
  int needed_g_p_21[] = {  68,  102}; //   2
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 2);
  psi_container_IS_name.push_back("propagator_0_smin3_smax13");
  int needed_g_p_22[] = {  68,   69}; //   2
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 2);
  psi_container_IS_name.push_back("propagator_0_smin6_smax15");
  int needed_g_p_23[] = {  68,   69}; //   2
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 2);
  psi_container_IS_name.push_back("propagator_24_smin7_smax12");
  int needed_g_p_24[] = {  70,   96,   98}; //   3
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 3);
  psi_container_IS_name.push_back("propagator_0_smin3_smax16");
  int needed_g_p_25[] = {  70,   71}; //   2
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 2);
  psi_container_IS_name.push_back("propagator_24_smin8_smax12");
  int needed_g_p_26[] = {  71,   97,   99}; //   3
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 3);
  psi_container_IS_name.push_back("propagator_23_smin3_smax16");
  int needed_g_p_27[] = {  98,   99}; //   2
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 2);
  psi_container_IS_name.push_back("propagator_0_smin9_smax17");
  int needed_g_p_28[] = { 100,  101,  106,  107}; //   4
  psi_needed_g_p[no_ps][28] = get_vector_from_array_int(needed_g_p_28, 4);
  psi_container_IS_name.push_back("propagator_0_smin9_smax18");
  int needed_g_p_29[] = { 102,  103,  104,  105}; //   4
  psi_needed_g_p[no_ps][29] = get_vector_from_array_int(needed_g_p_29, 4);
  psi_container_IS_name.push_back("propagator_24_smin0_smax19");
  int needed_g_p_30[] = { 104,  105}; //   2
  psi_needed_g_p[no_ps][30] = get_vector_from_array_int(needed_g_p_30, 2);
  psi_container_IS_name.push_back("propagator_0_smin9_smax20");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(15);
  psi_needed_g_f[no_ps].resize(15);
  int needed_g_f_0[] = {   0,    2,    4,    5,    8,    9,   12,   14,   16,   17,   20,   21,   25,   27,   30,   31,   34,   35,   72,   73,   76,   77}; //  22
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 22);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax21");
  int needed_g_f_1[] = {   1,    3,    6,    7,   10,   11,   13,   15,   18,   19,   22,   23,   24,   26,   28,   29,   32,   33,   74,   75,   78,   79}; //  22
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 22);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax22");
  int needed_g_f_2[] = {  36,   37,   52,   53,   84,   85,   94,   95}; //   8
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax23");
  int needed_g_f_3[] = {  36,   37,   52,   53,   84,   85,   94,   95}; //   8
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax21");
  int needed_g_f_4[] = {  38,   39,   50,   51,   86,   87,   92,   93}; //   8
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin14_smax24");
  int needed_g_f_5[] = {  38,   39,   50,   51,   86,   87,   92,   93}; //   8
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax22");
  int needed_g_f_6[] = {  40,   41,   56,   57,   80,   81,   90,   91}; //   8
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax25");
  int needed_g_f_7[] = {  40,   41,   56,   57,   80,   81,   90,   91}; //   8
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax21");
  int needed_g_f_8[] = {  42,   43,   54,   55,   82,   83,   88,   89}; //   8
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin18_smax26");
  int needed_g_f_9[] = {  42,   43,   54,   55,   82,   83,   88,   89}; //   8
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin19_smax22");
  int needed_g_f_10[] = {  58,   59,   60,   61,   62,   63,   64,   65}; //   8
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin9_smax18");
  int needed_g_f_11[] = {  58,   59,   60,   61,   96,   97,   98,   99}; //   8
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin20_smax27");
  int needed_g_f_12[] = {  62,   63,   64,   65,  102,  103,  104,  105}; //   8
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin21_smax28");
  int needed_g_f_13[] = {  72,   73,   74,   75,   76,   77,   78,   79}; //   8
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 8);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax2");
  int needed_g_f_14[] = { 100,  101,  106,  107}; //   4
  psi_needed_g_f[no_ps][14] = get_vector_from_array_int(needed_g_f_14, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin8_smax12");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(52);
  psi_needed_g_t[no_ps].resize(52);
  int needed_g_t_0[] = {   0,    2,    4,    5,    8,    9,   36,   37,   40,   41,   52,   53,   56,   57}; //  14
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 14);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__128_124");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__128_124");
  int needed_g_t_1[] = {   0,    2,    4,    5,    8,    9}; //   6
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__130_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__130_1__64_60");
  int needed_g_t_2[] = {   1,    3,    6,    7,   10,   11,   38,   39,   42,   43,   50,   51,   54,   55}; //  14
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 14);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_188");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_188");
  int needed_g_t_3[] = {   1,    3,    6,    7,   10,   11}; //   6
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__66_1__128_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__66_1__128_60");
  int needed_g_t_4[] = {  12,   14,   16,   17,   20,   21,   25,   27,   30,   31,   34,   35,   72,   73,   76,   77,   80,   81,   84,   85,   90,   91,   94,   95}; //  24
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 24);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__128_124");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__128_124");
  int needed_g_t_5[] = {  12,   14,   16,   17,   20,   21,   72,   73,   76,   77}; //  10
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 10);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_129__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_129__64_60");
  int needed_g_t_6[] = {  13,   15,   18,   19,   22,   23,   24,   26,   28,   29,   32,   33,   74,   75,   78,   79,   82,   83,   86,   87,   88,   89,   92,   93}; //  24
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 24);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_188");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_188");
  int needed_g_t_7[] = {  13,   15,   18,   19,   22,   23,   74,   75,   78,   79}; //  10
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 10);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__128_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__128_60");
  int needed_g_t_8[] = {  24,   26,   28,   29,   32,   33}; //   6
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__65_2__128_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__65_2__128_60");
  int needed_g_t_9[] = {  25,   27,   30,   31,   34,   35}; //   6
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__129_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__129_2__64_60");
  int needed_g_t_10[] = {  36,   37,   52,   53}; //   4
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__20_104");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__20_104");
  int needed_g_t_11[] = {  36,   37}; //   2
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_21__64_40");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_21__64_40");
  int needed_g_t_12[] = {  38,   39,   50,   51}; //   4
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__20_168");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__20_168");
  int needed_g_t_13[] = {  38,   39}; //   2
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_21__128_40");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_21__128_40");
  int needed_g_t_14[] = {  40,   41,   56,   57}; //   4
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__40_84");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__40_84");
  int needed_g_t_15[] = {  40,   41}; //   2
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_41__64_20");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_41__64_20");
  int needed_g_t_16[] = {  42,   43,   54,   55}; //   4
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__40_148");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__40_148");
  int needed_g_t_17[] = {  42,   43}; //   2
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_41__128_20");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_41__128_20");
  int needed_g_t_18[] = {  44,   45,   46,   47,   48,   49,  100,  101,  106,  107}; //  10
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 10);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__192_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__192_60");
  int needed_g_t_19[] = {  50,   51}; //   2
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_21__40_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_21__40_128");
  int needed_g_t_20[] = {  52,   53}; //   2
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_21__40_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_21__40_64");
  int needed_g_t_21[] = {  54,   55}; //   2
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_41__20_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_41__20_128");
  int needed_g_t_22[] = {  56,   57}; //   2
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_41__20_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_41__20_64");
  int needed_g_t_23[] = {  58,   59,   60,   61,   96,   97,   98,   99}; //   8
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__20_232");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__20_232");
  int needed_g_t_24[] = {  58,   59,   60,   61,   98,   99}; //   6
  psi_needed_g_t[no_ps][24] = get_vector_from_array_int(needed_g_t_24, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_21__40_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_21__40_192");
  int needed_g_t_25[] = {  58,   59}; //   2
  psi_needed_g_t[no_ps][25] = get_vector_from_array_int(needed_g_t_25, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__21_42__64_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__21_42__64_128");
  int needed_g_t_26[] = {  60,   61}; //   2
  psi_needed_g_t[no_ps][26] = get_vector_from_array_int(needed_g_t_26, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__21_42__128_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__21_42__128_64");
  int needed_g_t_27[] = {  62,   63,   64,   65,  102,  103,  104,  105}; //   8
  psi_needed_g_t[no_ps][27] = get_vector_from_array_int(needed_g_t_27, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__40_212");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__40_212");
  int needed_g_t_28[] = {  62,   63,   64,   65,  104,  105}; //   6
  psi_needed_g_t[no_ps][28] = get_vector_from_array_int(needed_g_t_28, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__20_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__20_192");
  int needed_g_t_29[] = {  62,   63}; //   2
  psi_needed_g_t[no_ps][29] = get_vector_from_array_int(needed_g_t_29, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__41_22__64_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__41_22__64_128");
  int needed_g_t_30[] = {  64,   65}; //   2
  psi_needed_g_t[no_ps][30] = get_vector_from_array_int(needed_g_t_30, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__41_22__128_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__41_22__128_64");
  int needed_g_t_31[] = {  66,   67,   68,   69,   70,   71}; //   6
  psi_needed_g_t[no_ps][31] = get_vector_from_array_int(needed_g_t_31, 6);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__192_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__192_60");
  int needed_g_t_32[] = {  72,   73}; //   2
  psi_needed_g_t[no_ps][32] = get_vector_from_array_int(needed_g_t_32, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__129_66__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_0__129_66__20_40");
  int needed_g_t_33[] = {  74,   75}; //   2
  psi_needed_g_t[no_ps][33] = get_vector_from_array_int(needed_g_t_33, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_130__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_130__20_40");
  int needed_g_t_34[] = {  76,   77}; //   2
  psi_needed_g_t[no_ps][34] = get_vector_from_array_int(needed_g_t_34, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__129_66__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_0__129_66__40_20");
  int needed_g_t_35[] = {  78,   79}; //   2
  psi_needed_g_t[no_ps][35] = get_vector_from_array_int(needed_g_t_35, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_130__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_130__40_20");
  int needed_g_t_36[] = {  80,   81,   90,   91}; //   4
  psi_needed_g_t[no_ps][36] = get_vector_from_array_int(needed_g_t_36, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_129__40_84");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_129__40_84");
  int needed_g_t_37[] = {  80,   81}; //   2
  psi_needed_g_t[no_ps][37] = get_vector_from_array_int(needed_g_t_37, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__129_42__20_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__129_42__20_64");
  int needed_g_t_38[] = {  82,   83,   88,   89}; //   4
  psi_needed_g_t[no_ps][38] = get_vector_from_array_int(needed_g_t_38, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__40_148");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__40_148");
  int needed_g_t_39[] = {  82,   83}; //   2
  psi_needed_g_t[no_ps][39] = get_vector_from_array_int(needed_g_t_39, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_42__20_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_42__20_128");
  int needed_g_t_40[] = {  84,   85,   94,   95}; //   4
  psi_needed_g_t[no_ps][40] = get_vector_from_array_int(needed_g_t_40, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_129__20_104");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_129__20_104");
  int needed_g_t_41[] = {  84,   85}; //   2
  psi_needed_g_t[no_ps][41] = get_vector_from_array_int(needed_g_t_41, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__129_22__40_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__129_22__40_64");
  int needed_g_t_42[] = {  86,   87,   92,   93}; //   4
  psi_needed_g_t[no_ps][42] = get_vector_from_array_int(needed_g_t_42, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__20_168");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__20_168");
  int needed_g_t_43[] = {  86,   87}; //   2
  psi_needed_g_t[no_ps][43] = get_vector_from_array_int(needed_g_t_43, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_22__40_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_22__40_128");
  int needed_g_t_44[] = {  88,   89}; //   2
  psi_needed_g_t[no_ps][44] = get_vector_from_array_int(needed_g_t_44, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_42__128_20");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_42__128_20");
  int needed_g_t_45[] = {  90,   91}; //   2
  psi_needed_g_t[no_ps][45] = get_vector_from_array_int(needed_g_t_45, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__129_42__64_20");
  psi_container_IS_name.push_back("phi_of_tchannel_0__129_42__64_20");
  int needed_g_t_46[] = {  92,   93}; //   2
  psi_needed_g_t[no_ps][46] = get_vector_from_array_int(needed_g_t_46, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_22__128_40");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_22__128_40");
  int needed_g_t_47[] = {  94,   95}; //   2
  psi_needed_g_t[no_ps][47] = get_vector_from_array_int(needed_g_t_47, 2);
  psi_container_IS_name.push_back("t_of_tchannel_0__129_22__64_40");
  psi_container_IS_name.push_back("phi_of_tchannel_0__129_22__64_40");
  int needed_g_t_48[] = {  96,   97}; //   2
  psi_needed_g_t[no_ps][48] = get_vector_from_array_int(needed_g_t_48, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_21__192_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_21__192_40");
  int needed_g_t_49[] = { 100,  101}; //   2
  psi_needed_g_t[no_ps][49] = get_vector_from_array_int(needed_g_t_49, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__40_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__40_20");
  int needed_g_t_50[] = { 102,  103}; //   2
  psi_needed_g_t[no_ps][50] = get_vector_from_array_int(needed_g_t_50, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_41__192_20");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_41__192_20");
  int needed_g_t_51[] = { 106,  107}; //   2
  psi_needed_g_t[no_ps][51] = get_vector_from_array_int(needed_g_t_51, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__20_40");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__20_40");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(10);
  psi_needed_g_d[no_ps].resize(10);
  int needed_g_d_0[] = {   0,    1,   12,   13,   24,   25,   44,   66}; //   8
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_1[] = {   0,    1,   12,   13,   24,   25,   44,   66}; //   8
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 8);
  psi_container_IS_name.push_back("costheta_of_decay_56__16_40");
  psi_container_IS_name.push_back("phi_of_decay_56__16_40");
  int needed_g_d_2[] = {   0,    1,    8,    9,   10,   11,   12,   13,   20,   21,   22,   23,   24,   25,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   66,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; //  84
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 84);
  psi_container_IS_name.push_back("costheta_of_decay_40__8_32");
  psi_container_IS_name.push_back("phi_of_decay_40__8_32");
  int needed_g_d_3[] = {   2,    3,   14,   15,   26,   27,   45,   67}; //   8
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_4[] = {   2,    3,   14,   15,   26,   27,   45,   67}; //   8
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 8);
  psi_container_IS_name.push_back("costheta_of_decay_52__32_20");
  psi_container_IS_name.push_back("phi_of_decay_52__32_20");
  int needed_g_d_5[] = {   2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   45,   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; // 100
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 100);
  psi_container_IS_name.push_back("costheta_of_decay_20__4_16");
  psi_container_IS_name.push_back("phi_of_decay_20__4_16");
  int needed_g_d_6[] = {   4,    5,    6,    7,   16,   17,   18,   19,   28,   29,   30,   31,   46,   47,   68,   69}; //  16
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_7[] = {   4,    5,    6,    7,   16,   17,   18,   19,   28,   29,   30,   31,   46,   47,   68,   69}; //  16
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 16);
  psi_container_IS_name.push_back("costheta_of_decay_28__8_20");
  psi_container_IS_name.push_back("phi_of_decay_28__8_20");
  int needed_g_d_8[] = {   8,    9,   10,   11,   20,   21,   22,   23,   32,   33,   34,   35,   48,   49,   70,   71}; //  16
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__20_40");
  psi_container_IS_name.push_back("phi_of_decay_60__20_40");
  int needed_g_d_9[] = {  44,   45,   46,   47,   48,   49,   66,   67,   68,   69,   70,   71,   96,   97,   98,   99,  100,  101,  102,  103,  104,  105,  106,  107}; //  24
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 24);
  psi_container_IS_name.push_back("costheta_of_decay_192__64_128");
  psi_container_IS_name.push_back("phi_of_decay_192__64_128");

  psi_c_p[no_ps].resize(108);
  psi_c_f[no_ps].resize(108);
  psi_c_t[no_ps].resize(108);
  psi_c_d[no_ps].resize(108);

  int c_p_0[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 3);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {  1}; //   1
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 1);
  int c_t_1[] = {  2,   3}; //   2
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 2);
  int c_d_1[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {  0}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  0,   1}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  3,   4,   5}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {  1}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  2,   3}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  3,   4,   5}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {  0}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  0,   1}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  3,   7,   8}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {  0}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = {  0,   1}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {  1}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = {  2,   3}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  3,   7,   8}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {  1}; //   1
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 1);
  int c_t_7[] = {  2,   3}; //   2
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 2);
  int c_d_7[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  0,   9,  10}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {  0}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = {  0,   1}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  0,  11,  10}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {  0}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = {  0,   1}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = {  0,   9,  10}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {  1}; //   1
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 1);
  int c_t_10[] = {  2,   3}; //   2
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 2);
  int c_d_10[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  0,  11,  10}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {  1}; //   1
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 1);
  int c_t_11[] = {  2,   3}; //   2
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 2);
  int c_d_11[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {  0}; //   1
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 1);
  int c_t_12[] = {  4,   5}; //   2
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 2);
  int c_d_12[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {  1}; //   1
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 1);
  int c_t_13[] = {  6,   7}; //   2
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 2);
  int c_d_13[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {  0}; //   1
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 1);
  int c_t_14[] = {  4,   5}; //   2
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 2);
  int c_d_14[] = {  3,   4,   5}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {  1}; //   1
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 1);
  int c_t_15[] = {  6,   7}; //   2
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 2);
  int c_d_15[] = {  3,   4,   5}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {  0}; //   1
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 1);
  int c_t_16[] = {  4,   5}; //   2
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 2);
  int c_d_16[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  3,   7,   8}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {  0}; //   1
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 1);
  int c_t_17[] = {  4,   5}; //   2
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 2);
  int c_d_17[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {  1}; //   1
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 1);
  int c_t_18[] = {  6,   7}; //   2
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 2);
  int c_d_18[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = {  3,   7,   8}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {  1}; //   1
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 1);
  int c_t_19[] = {  6,   7}; //   2
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 2);
  int c_d_19[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = {  0,   9,  10}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {  0}; //   1
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 1);
  int c_t_20[] = {  4,   5}; //   2
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 2);
  int c_d_20[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = {  0,  11,  10}; //   3
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 3);
  int c_f_21[] = {  0}; //   1
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 1);
  int c_t_21[] = {  4,   5}; //   2
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 2);
  int c_d_21[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 3);

  int c_p_22[] = {  0,   9,  10}; //   3
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 3);
  int c_f_22[] = {  1}; //   1
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 1);
  int c_t_22[] = {  6,   7}; //   2
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 2);
  int c_d_22[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 3);

  int c_p_23[] = {  0,  11,  10}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {  1}; //   1
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 1);
  int c_t_23[] = {  6,   7}; //   2
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 2);
  int c_d_23[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 3);

  int c_p_24[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {  1}; //   1
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 1);
  int c_t_24[] = {  6,   8}; //   2
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 2);
  int c_d_24[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {  0}; //   1
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 1);
  int c_t_25[] = {  4,   9}; //   2
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 2);
  int c_d_25[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 3);

  int c_p_26[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {  1}; //   1
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 1);
  int c_t_26[] = {  6,   8}; //   2
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 2);
  int c_d_26[] = {  3,   4,   5}; //   3
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 3);

  int c_p_27[] = {  3,   4,   5}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {  0}; //   1
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 1);
  int c_t_27[] = {  4,   9}; //   2
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 2);
  int c_d_27[] = {  3,   4,   5}; //   3
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 3);

  int c_p_28[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 3);
  int c_f_28[] = {  1}; //   1
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 1);
  int c_t_28[] = {  6,   8}; //   2
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 2);
  int c_d_28[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 3);

  int c_p_29[] = {  3,   7,   8}; //   3
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 3);
  int c_f_29[] = {  1}; //   1
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 1);
  int c_t_29[] = {  6,   8}; //   2
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 2);
  int c_d_29[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 3);

  int c_p_30[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {  0}; //   1
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 1);
  int c_t_30[] = {  4,   9}; //   2
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 2);
  int c_d_30[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 3);

  int c_p_31[] = {  3,   7,   8}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {  0}; //   1
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 1);
  int c_t_31[] = {  4,   9}; //   2
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 2);
  int c_d_31[] = {  6,   7,   5}; //   3
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 3);

  int c_p_32[] = {  0,   9,  10}; //   3
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 3);
  int c_f_32[] = {  1}; //   1
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 1);
  int c_t_32[] = {  6,   8}; //   2
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 2);
  int c_d_32[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 3);

  int c_p_33[] = {  0,  11,  10}; //   3
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 3);
  int c_f_33[] = {  1}; //   1
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 1);
  int c_t_33[] = {  6,   8}; //   2
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 2);
  int c_d_33[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 3);

  int c_p_34[] = {  0,   9,  10}; //   3
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 3);
  int c_f_34[] = {  0}; //   1
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 1);
  int c_t_34[] = {  4,   9}; //   2
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 2);
  int c_d_34[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 3);

  int c_p_35[] = {  0,  11,  10}; //   3
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 3);
  int c_f_35[] = {  0}; //   1
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 1);
  int c_t_35[] = {  4,   9}; //   2
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 2);
  int c_d_35[] = {  8,   5,   2}; //   3
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 3);

  int c_p_36[] = {  0,   9}; //   2
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 2);
  int c_f_36[] = {  2,   3}; //   2
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 2);
  int c_t_36[] = {  0,  10,  11}; //   3
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 3);
  int c_d_36[] = {  5,   2}; //   2
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 2);

  int c_p_37[] = {  0,  11}; //   2
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 2);
  int c_f_37[] = {  2,   3}; //   2
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 2);
  int c_t_37[] = {  0,  10,  11}; //   3
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 3);
  int c_d_37[] = {  5,   2}; //   2
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 2);

  int c_p_38[] = {  0,   9}; //   2
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 2);
  int c_f_38[] = {  4,   5}; //   2
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 2);
  int c_t_38[] = {  2,  12,  13}; //   3
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 3);
  int c_d_38[] = {  5,   2}; //   2
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 2);

  int c_p_39[] = {  0,  11}; //   2
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 2);
  int c_f_39[] = {  4,   5}; //   2
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 2);
  int c_t_39[] = {  2,  12,  13}; //   3
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 3);
  int c_d_39[] = {  5,   2}; //   2
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 2);

  int c_p_40[] = {  6,  12}; //   2
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 2);
  int c_f_40[] = {  6,   7}; //   2
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 2);
  int c_t_40[] = {  0,  14,  15}; //   3
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 3);
  int c_d_40[] = {  2,   5}; //   2
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 2);

  int c_p_41[] = {  3,  12}; //   2
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 2);
  int c_f_41[] = {  6,   7}; //   2
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 2);
  int c_t_41[] = {  0,  14,  15}; //   3
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 3);
  int c_d_41[] = {  2,   5}; //   2
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 2);

  int c_p_42[] = {  6,  12}; //   2
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 2);
  int c_f_42[] = {  8,   9}; //   2
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 2);
  int c_t_42[] = {  2,  16,  17}; //   3
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 3);
  int c_d_42[] = {  2,   5}; //   2
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 2);

  int c_p_43[] = {  3,  12}; //   2
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 2);
  int c_f_43[] = {  8,   9}; //   2
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 2);
  int c_t_43[] = {  2,  16,  17}; //   3
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 3);
  int c_d_43[] = {  2,   5}; //   2
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 2);

  int c_p_44[] = {  0,   1,   2,  13}; //   4
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 4);
  int c_f_44[] = {}; //   0
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 0);
  int c_t_44[] = { 18}; //   1
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 1);
  int c_d_44[] = {  9,   0,   1,   2}; //   4
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 4);

  int c_p_45[] = {  3,   4,   5,  13}; //   4
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 4);
  int c_f_45[] = {}; //   0
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 0);
  int c_t_45[] = { 18}; //   1
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 1);
  int c_d_45[] = {  9,   3,   4,   5}; //   4
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 4);

  int c_p_46[] = {  6,   7,   8,  13}; //   4
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 4);
  int c_f_46[] = {}; //   0
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 0);
  int c_t_46[] = { 18}; //   1
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 1);
  int c_d_46[] = {  9,   6,   7,   5}; //   4
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 4);

  int c_p_47[] = {  3,   7,   8,  13}; //   4
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 4);
  int c_f_47[] = {}; //   0
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 0);
  int c_t_47[] = { 18}; //   1
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 1);
  int c_d_47[] = {  9,   6,   7,   5}; //   4
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 4);

  int c_p_48[] = {  0,   9,  10,  13}; //   4
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 4);
  int c_f_48[] = {}; //   0
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 0);
  int c_t_48[] = { 18}; //   1
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 1);
  int c_d_48[] = {  9,   8,   5,   2}; //   4
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 4);

  int c_p_49[] = {  0,  11,  10,  13}; //   4
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 4);
  int c_f_49[] = {}; //   0
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 0);
  int c_t_49[] = { 18}; //   1
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 1);
  int c_d_49[] = {  9,   8,   5,   2}; //   4
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 4);

  int c_p_50[] = {  0,   9}; //   2
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 2);
  int c_f_50[] = {  4,   5}; //   2
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 2);
  int c_t_50[] = {  2,  12,  19}; //   3
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 3);
  int c_d_50[] = {  5,   2}; //   2
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 2);

  int c_p_51[] = {  0,  11}; //   2
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 2);
  int c_f_51[] = {  4,   5}; //   2
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 2);
  int c_t_51[] = {  2,  12,  19}; //   3
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 3);
  int c_d_51[] = {  5,   2}; //   2
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 2);

  int c_p_52[] = {  0,   9}; //   2
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 2);
  int c_f_52[] = {  2,   3}; //   2
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 2);
  int c_t_52[] = {  0,  10,  20}; //   3
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 3);
  int c_d_52[] = {  5,   2}; //   2
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 2);

  int c_p_53[] = {  0,  11}; //   2
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 2);
  int c_f_53[] = {  2,   3}; //   2
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 2);
  int c_t_53[] = {  0,  10,  20}; //   3
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 3);
  int c_d_53[] = {  5,   2}; //   2
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 2);

  int c_p_54[] = {  6,  12}; //   2
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 2);
  int c_f_54[] = {  8,   9}; //   2
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 2);
  int c_t_54[] = {  2,  16,  21}; //   3
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 3);
  int c_d_54[] = {  2,   5}; //   2
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 2);

  int c_p_55[] = {  3,  12}; //   2
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 2);
  int c_f_55[] = {  8,   9}; //   2
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 2);
  int c_t_55[] = {  2,  16,  21}; //   3
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 3);
  int c_d_55[] = {  2,   5}; //   2
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 2);

  int c_p_56[] = {  6,  12}; //   2
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 2);
  int c_f_56[] = {  6,   7}; //   2
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 2);
  int c_t_56[] = {  0,  14,  22}; //   3
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 3);
  int c_d_56[] = {  2,   5}; //   2
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 2);

  int c_p_57[] = {  3,  12}; //   2
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 2);
  int c_f_57[] = {  6,   7}; //   2
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 2);
  int c_t_57[] = {  0,  14,  22}; //   3
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 3);
  int c_d_57[] = {  2,   5}; //   2
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 2);

  int c_p_58[] = {  0,   9}; //   2
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 2);
  int c_f_58[] = { 10,  11}; //   2
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 2);
  int c_t_58[] = { 23,  24,  25}; //   3
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 3);
  int c_d_58[] = {  5,   2}; //   2
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 2);

  int c_p_59[] = {  0,  11}; //   2
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 2);
  int c_f_59[] = { 10,  11}; //   2
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 2);
  int c_t_59[] = { 23,  24,  25}; //   3
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 3);
  int c_d_59[] = {  5,   2}; //   2
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 2);

  int c_p_60[] = {  0,   9}; //   2
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 2);
  int c_f_60[] = { 10,  11}; //   2
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 2);
  int c_t_60[] = { 23,  24,  26}; //   3
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 3);
  int c_d_60[] = {  5,   2}; //   2
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 2);

  int c_p_61[] = {  0,  11}; //   2
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 2);
  int c_f_61[] = { 10,  11}; //   2
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 2);
  int c_t_61[] = { 23,  24,  26}; //   3
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 3);
  int c_d_61[] = {  5,   2}; //   2
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 2);

  int c_p_62[] = {  6,  12}; //   2
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 2);
  int c_f_62[] = { 10,  12}; //   2
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 2);
  int c_t_62[] = { 27,  28,  29}; //   3
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 3);
  int c_d_62[] = {  2,   5}; //   2
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 2);

  int c_p_63[] = {  3,  12}; //   2
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 2);
  int c_f_63[] = { 10,  12}; //   2
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 2);
  int c_t_63[] = { 27,  28,  29}; //   3
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 3);
  int c_d_63[] = {  2,   5}; //   2
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 2);

  int c_p_64[] = {  6,  12}; //   2
  psi_c_p[no_ps][64] = get_vector_from_array_int(c_p_64, 2);
  int c_f_64[] = { 10,  12}; //   2
  psi_c_f[no_ps][64] = get_vector_from_array_int(c_f_64, 2);
  int c_t_64[] = { 27,  28,  30}; //   3
  psi_c_t[no_ps][64] = get_vector_from_array_int(c_t_64, 3);
  int c_d_64[] = {  2,   5}; //   2
  psi_c_d[no_ps][64] = get_vector_from_array_int(c_d_64, 2);

  int c_p_65[] = {  3,  12}; //   2
  psi_c_p[no_ps][65] = get_vector_from_array_int(c_p_65, 2);
  int c_f_65[] = { 10,  12}; //   2
  psi_c_f[no_ps][65] = get_vector_from_array_int(c_f_65, 2);
  int c_t_65[] = { 27,  28,  30}; //   3
  psi_c_t[no_ps][65] = get_vector_from_array_int(c_t_65, 3);
  int c_d_65[] = {  2,   5}; //   2
  psi_c_d[no_ps][65] = get_vector_from_array_int(c_d_65, 2);

  int c_p_66[] = { 14,  15,  16,  17}; //   4
  psi_c_p[no_ps][66] = get_vector_from_array_int(c_p_66, 4);
  int c_f_66[] = {}; //   0
  psi_c_f[no_ps][66] = get_vector_from_array_int(c_f_66, 0);
  int c_t_66[] = { 31}; //   1
  psi_c_t[no_ps][66] = get_vector_from_array_int(c_t_66, 1);
  int c_d_66[] = {  0,   1,   2,   9}; //   4
  psi_c_d[no_ps][66] = get_vector_from_array_int(c_d_66, 4);

  int c_p_67[] = { 14,  18,  19,  20}; //   4
  psi_c_p[no_ps][67] = get_vector_from_array_int(c_p_67, 4);
  int c_f_67[] = {}; //   0
  psi_c_f[no_ps][67] = get_vector_from_array_int(c_f_67, 0);
  int c_t_67[] = { 31}; //   1
  psi_c_t[no_ps][67] = get_vector_from_array_int(c_t_67, 1);
  int c_d_67[] = {  3,   4,   5,   9}; //   4
  psi_c_d[no_ps][67] = get_vector_from_array_int(c_d_67, 4);

  int c_p_68[] = { 14,  21,  22,  23}; //   4
  psi_c_p[no_ps][68] = get_vector_from_array_int(c_p_68, 4);
  int c_f_68[] = {}; //   0
  psi_c_f[no_ps][68] = get_vector_from_array_int(c_f_68, 0);
  int c_t_68[] = { 31}; //   1
  psi_c_t[no_ps][68] = get_vector_from_array_int(c_t_68, 1);
  int c_d_68[] = {  6,   7,   5,   9}; //   4
  psi_c_d[no_ps][68] = get_vector_from_array_int(c_d_68, 4);

  int c_p_69[] = { 14,  18,  22,  23}; //   4
  psi_c_p[no_ps][69] = get_vector_from_array_int(c_p_69, 4);
  int c_f_69[] = {}; //   0
  psi_c_f[no_ps][69] = get_vector_from_array_int(c_f_69, 0);
  int c_t_69[] = { 31}; //   1
  psi_c_t[no_ps][69] = get_vector_from_array_int(c_t_69, 1);
  int c_d_69[] = {  6,   7,   5,   9}; //   4
  psi_c_d[no_ps][69] = get_vector_from_array_int(c_d_69, 4);

  int c_p_70[] = { 14,  15,  24,  25}; //   4
  psi_c_p[no_ps][70] = get_vector_from_array_int(c_p_70, 4);
  int c_f_70[] = {}; //   0
  psi_c_f[no_ps][70] = get_vector_from_array_int(c_f_70, 0);
  int c_t_70[] = { 31}; //   1
  psi_c_t[no_ps][70] = get_vector_from_array_int(c_t_70, 1);
  int c_d_70[] = {  8,   5,   2,   9}; //   4
  psi_c_d[no_ps][70] = get_vector_from_array_int(c_d_70, 4);

  int c_p_71[] = { 14,  15,  26,  25}; //   4
  psi_c_p[no_ps][71] = get_vector_from_array_int(c_p_71, 4);
  int c_f_71[] = {}; //   0
  psi_c_f[no_ps][71] = get_vector_from_array_int(c_f_71, 0);
  int c_t_71[] = { 31}; //   1
  psi_c_t[no_ps][71] = get_vector_from_array_int(c_t_71, 1);
  int c_d_71[] = {  8,   5,   2,   9}; //   4
  psi_c_d[no_ps][71] = get_vector_from_array_int(c_d_71, 4);

  int c_p_72[] = {  0,   9}; //   2
  psi_c_p[no_ps][72] = get_vector_from_array_int(c_p_72, 2);
  int c_f_72[] = { 13,   0}; //   2
  psi_c_f[no_ps][72] = get_vector_from_array_int(c_f_72, 2);
  int c_t_72[] = {  4,   5,  32}; //   3
  psi_c_t[no_ps][72] = get_vector_from_array_int(c_t_72, 3);
  int c_d_72[] = {  5,   2}; //   2
  psi_c_d[no_ps][72] = get_vector_from_array_int(c_d_72, 2);

  int c_p_73[] = {  0,  11}; //   2
  psi_c_p[no_ps][73] = get_vector_from_array_int(c_p_73, 2);
  int c_f_73[] = { 13,   0}; //   2
  psi_c_f[no_ps][73] = get_vector_from_array_int(c_f_73, 2);
  int c_t_73[] = {  4,   5,  32}; //   3
  psi_c_t[no_ps][73] = get_vector_from_array_int(c_t_73, 3);
  int c_d_73[] = {  5,   2}; //   2
  psi_c_d[no_ps][73] = get_vector_from_array_int(c_d_73, 2);

  int c_p_74[] = {  0,   9}; //   2
  psi_c_p[no_ps][74] = get_vector_from_array_int(c_p_74, 2);
  int c_f_74[] = { 13,   1}; //   2
  psi_c_f[no_ps][74] = get_vector_from_array_int(c_f_74, 2);
  int c_t_74[] = {  6,   7,  33}; //   3
  psi_c_t[no_ps][74] = get_vector_from_array_int(c_t_74, 3);
  int c_d_74[] = {  5,   2}; //   2
  psi_c_d[no_ps][74] = get_vector_from_array_int(c_d_74, 2);

  int c_p_75[] = {  0,  11}; //   2
  psi_c_p[no_ps][75] = get_vector_from_array_int(c_p_75, 2);
  int c_f_75[] = { 13,   1}; //   2
  psi_c_f[no_ps][75] = get_vector_from_array_int(c_f_75, 2);
  int c_t_75[] = {  6,   7,  33}; //   3
  psi_c_t[no_ps][75] = get_vector_from_array_int(c_t_75, 3);
  int c_d_75[] = {  5,   2}; //   2
  psi_c_d[no_ps][75] = get_vector_from_array_int(c_d_75, 2);

  int c_p_76[] = {  6,  12}; //   2
  psi_c_p[no_ps][76] = get_vector_from_array_int(c_p_76, 2);
  int c_f_76[] = { 13,   0}; //   2
  psi_c_f[no_ps][76] = get_vector_from_array_int(c_f_76, 2);
  int c_t_76[] = {  4,   5,  34}; //   3
  psi_c_t[no_ps][76] = get_vector_from_array_int(c_t_76, 3);
  int c_d_76[] = {  2,   5}; //   2
  psi_c_d[no_ps][76] = get_vector_from_array_int(c_d_76, 2);

  int c_p_77[] = {  3,  12}; //   2
  psi_c_p[no_ps][77] = get_vector_from_array_int(c_p_77, 2);
  int c_f_77[] = { 13,   0}; //   2
  psi_c_f[no_ps][77] = get_vector_from_array_int(c_f_77, 2);
  int c_t_77[] = {  4,   5,  34}; //   3
  psi_c_t[no_ps][77] = get_vector_from_array_int(c_t_77, 3);
  int c_d_77[] = {  2,   5}; //   2
  psi_c_d[no_ps][77] = get_vector_from_array_int(c_d_77, 2);

  int c_p_78[] = {  6,  12}; //   2
  psi_c_p[no_ps][78] = get_vector_from_array_int(c_p_78, 2);
  int c_f_78[] = { 13,   1}; //   2
  psi_c_f[no_ps][78] = get_vector_from_array_int(c_f_78, 2);
  int c_t_78[] = {  6,   7,  35}; //   3
  psi_c_t[no_ps][78] = get_vector_from_array_int(c_t_78, 3);
  int c_d_78[] = {  2,   5}; //   2
  psi_c_d[no_ps][78] = get_vector_from_array_int(c_d_78, 2);

  int c_p_79[] = {  3,  12}; //   2
  psi_c_p[no_ps][79] = get_vector_from_array_int(c_p_79, 2);
  int c_f_79[] = { 13,   1}; //   2
  psi_c_f[no_ps][79] = get_vector_from_array_int(c_f_79, 2);
  int c_t_79[] = {  6,   7,  35}; //   3
  psi_c_t[no_ps][79] = get_vector_from_array_int(c_t_79, 3);
  int c_d_79[] = {  2,   5}; //   2
  psi_c_d[no_ps][79] = get_vector_from_array_int(c_d_79, 2);

  int c_p_80[] = {  0,   9}; //   2
  psi_c_p[no_ps][80] = get_vector_from_array_int(c_p_80, 2);
  int c_f_80[] = {  6,   7}; //   2
  psi_c_f[no_ps][80] = get_vector_from_array_int(c_f_80, 2);
  int c_t_80[] = {  4,  36,  37}; //   3
  psi_c_t[no_ps][80] = get_vector_from_array_int(c_t_80, 3);
  int c_d_80[] = {  5,   2}; //   2
  psi_c_d[no_ps][80] = get_vector_from_array_int(c_d_80, 2);

  int c_p_81[] = {  0,  11}; //   2
  psi_c_p[no_ps][81] = get_vector_from_array_int(c_p_81, 2);
  int c_f_81[] = {  6,   7}; //   2
  psi_c_f[no_ps][81] = get_vector_from_array_int(c_f_81, 2);
  int c_t_81[] = {  4,  36,  37}; //   3
  psi_c_t[no_ps][81] = get_vector_from_array_int(c_t_81, 3);
  int c_d_81[] = {  5,   2}; //   2
  psi_c_d[no_ps][81] = get_vector_from_array_int(c_d_81, 2);

  int c_p_82[] = {  0,   9}; //   2
  psi_c_p[no_ps][82] = get_vector_from_array_int(c_p_82, 2);
  int c_f_82[] = {  8,   9}; //   2
  psi_c_f[no_ps][82] = get_vector_from_array_int(c_f_82, 2);
  int c_t_82[] = {  6,  38,  39}; //   3
  psi_c_t[no_ps][82] = get_vector_from_array_int(c_t_82, 3);
  int c_d_82[] = {  5,   2}; //   2
  psi_c_d[no_ps][82] = get_vector_from_array_int(c_d_82, 2);

  int c_p_83[] = {  0,  11}; //   2
  psi_c_p[no_ps][83] = get_vector_from_array_int(c_p_83, 2);
  int c_f_83[] = {  8,   9}; //   2
  psi_c_f[no_ps][83] = get_vector_from_array_int(c_f_83, 2);
  int c_t_83[] = {  6,  38,  39}; //   3
  psi_c_t[no_ps][83] = get_vector_from_array_int(c_t_83, 3);
  int c_d_83[] = {  5,   2}; //   2
  psi_c_d[no_ps][83] = get_vector_from_array_int(c_d_83, 2);

  int c_p_84[] = {  6,  12}; //   2
  psi_c_p[no_ps][84] = get_vector_from_array_int(c_p_84, 2);
  int c_f_84[] = {  2,   3}; //   2
  psi_c_f[no_ps][84] = get_vector_from_array_int(c_f_84, 2);
  int c_t_84[] = {  4,  40,  41}; //   3
  psi_c_t[no_ps][84] = get_vector_from_array_int(c_t_84, 3);
  int c_d_84[] = {  2,   5}; //   2
  psi_c_d[no_ps][84] = get_vector_from_array_int(c_d_84, 2);

  int c_p_85[] = {  3,  12}; //   2
  psi_c_p[no_ps][85] = get_vector_from_array_int(c_p_85, 2);
  int c_f_85[] = {  2,   3}; //   2
  psi_c_f[no_ps][85] = get_vector_from_array_int(c_f_85, 2);
  int c_t_85[] = {  4,  40,  41}; //   3
  psi_c_t[no_ps][85] = get_vector_from_array_int(c_t_85, 3);
  int c_d_85[] = {  2,   5}; //   2
  psi_c_d[no_ps][85] = get_vector_from_array_int(c_d_85, 2);

  int c_p_86[] = {  6,  12}; //   2
  psi_c_p[no_ps][86] = get_vector_from_array_int(c_p_86, 2);
  int c_f_86[] = {  4,   5}; //   2
  psi_c_f[no_ps][86] = get_vector_from_array_int(c_f_86, 2);
  int c_t_86[] = {  6,  42,  43}; //   3
  psi_c_t[no_ps][86] = get_vector_from_array_int(c_t_86, 3);
  int c_d_86[] = {  2,   5}; //   2
  psi_c_d[no_ps][86] = get_vector_from_array_int(c_d_86, 2);

  int c_p_87[] = {  3,  12}; //   2
  psi_c_p[no_ps][87] = get_vector_from_array_int(c_p_87, 2);
  int c_f_87[] = {  4,   5}; //   2
  psi_c_f[no_ps][87] = get_vector_from_array_int(c_f_87, 2);
  int c_t_87[] = {  6,  42,  43}; //   3
  psi_c_t[no_ps][87] = get_vector_from_array_int(c_t_87, 3);
  int c_d_87[] = {  2,   5}; //   2
  psi_c_d[no_ps][87] = get_vector_from_array_int(c_d_87, 2);

  int c_p_88[] = {  0,   9}; //   2
  psi_c_p[no_ps][88] = get_vector_from_array_int(c_p_88, 2);
  int c_f_88[] = {  8,   9}; //   2
  psi_c_f[no_ps][88] = get_vector_from_array_int(c_f_88, 2);
  int c_t_88[] = {  6,  38,  44}; //   3
  psi_c_t[no_ps][88] = get_vector_from_array_int(c_t_88, 3);
  int c_d_88[] = {  5,   2}; //   2
  psi_c_d[no_ps][88] = get_vector_from_array_int(c_d_88, 2);

  int c_p_89[] = {  0,  11}; //   2
  psi_c_p[no_ps][89] = get_vector_from_array_int(c_p_89, 2);
  int c_f_89[] = {  8,   9}; //   2
  psi_c_f[no_ps][89] = get_vector_from_array_int(c_f_89, 2);
  int c_t_89[] = {  6,  38,  44}; //   3
  psi_c_t[no_ps][89] = get_vector_from_array_int(c_t_89, 3);
  int c_d_89[] = {  5,   2}; //   2
  psi_c_d[no_ps][89] = get_vector_from_array_int(c_d_89, 2);

  int c_p_90[] = {  0,   9}; //   2
  psi_c_p[no_ps][90] = get_vector_from_array_int(c_p_90, 2);
  int c_f_90[] = {  6,   7}; //   2
  psi_c_f[no_ps][90] = get_vector_from_array_int(c_f_90, 2);
  int c_t_90[] = {  4,  36,  45}; //   3
  psi_c_t[no_ps][90] = get_vector_from_array_int(c_t_90, 3);
  int c_d_90[] = {  5,   2}; //   2
  psi_c_d[no_ps][90] = get_vector_from_array_int(c_d_90, 2);

  int c_p_91[] = {  0,  11}; //   2
  psi_c_p[no_ps][91] = get_vector_from_array_int(c_p_91, 2);
  int c_f_91[] = {  6,   7}; //   2
  psi_c_f[no_ps][91] = get_vector_from_array_int(c_f_91, 2);
  int c_t_91[] = {  4,  36,  45}; //   3
  psi_c_t[no_ps][91] = get_vector_from_array_int(c_t_91, 3);
  int c_d_91[] = {  5,   2}; //   2
  psi_c_d[no_ps][91] = get_vector_from_array_int(c_d_91, 2);

  int c_p_92[] = {  6,  12}; //   2
  psi_c_p[no_ps][92] = get_vector_from_array_int(c_p_92, 2);
  int c_f_92[] = {  4,   5}; //   2
  psi_c_f[no_ps][92] = get_vector_from_array_int(c_f_92, 2);
  int c_t_92[] = {  6,  42,  46}; //   3
  psi_c_t[no_ps][92] = get_vector_from_array_int(c_t_92, 3);
  int c_d_92[] = {  2,   5}; //   2
  psi_c_d[no_ps][92] = get_vector_from_array_int(c_d_92, 2);

  int c_p_93[] = {  3,  12}; //   2
  psi_c_p[no_ps][93] = get_vector_from_array_int(c_p_93, 2);
  int c_f_93[] = {  4,   5}; //   2
  psi_c_f[no_ps][93] = get_vector_from_array_int(c_f_93, 2);
  int c_t_93[] = {  6,  42,  46}; //   3
  psi_c_t[no_ps][93] = get_vector_from_array_int(c_t_93, 3);
  int c_d_93[] = {  2,   5}; //   2
  psi_c_d[no_ps][93] = get_vector_from_array_int(c_d_93, 2);

  int c_p_94[] = {  6,  12}; //   2
  psi_c_p[no_ps][94] = get_vector_from_array_int(c_p_94, 2);
  int c_f_94[] = {  2,   3}; //   2
  psi_c_f[no_ps][94] = get_vector_from_array_int(c_f_94, 2);
  int c_t_94[] = {  4,  40,  47}; //   3
  psi_c_t[no_ps][94] = get_vector_from_array_int(c_t_94, 3);
  int c_d_94[] = {  2,   5}; //   2
  psi_c_d[no_ps][94] = get_vector_from_array_int(c_d_94, 2);

  int c_p_95[] = {  3,  12}; //   2
  psi_c_p[no_ps][95] = get_vector_from_array_int(c_p_95, 2);
  int c_f_95[] = {  2,   3}; //   2
  psi_c_f[no_ps][95] = get_vector_from_array_int(c_f_95, 2);
  int c_t_95[] = {  4,  40,  47}; //   3
  psi_c_t[no_ps][95] = get_vector_from_array_int(c_t_95, 3);
  int c_d_95[] = {  2,   5}; //   2
  psi_c_d[no_ps][95] = get_vector_from_array_int(c_d_95, 2);

  int c_p_96[] = { 14,  15,  24}; //   3
  psi_c_p[no_ps][96] = get_vector_from_array_int(c_p_96, 3);
  int c_f_96[] = { 11}; //   1
  psi_c_f[no_ps][96] = get_vector_from_array_int(c_f_96, 1);
  int c_t_96[] = { 23,  48}; //   2
  psi_c_t[no_ps][96] = get_vector_from_array_int(c_t_96, 2);
  int c_d_96[] = {  5,   2,   9}; //   3
  psi_c_d[no_ps][96] = get_vector_from_array_int(c_d_96, 3);

  int c_p_97[] = { 14,  15,  26}; //   3
  psi_c_p[no_ps][97] = get_vector_from_array_int(c_p_97, 3);
  int c_f_97[] = { 11}; //   1
  psi_c_f[no_ps][97] = get_vector_from_array_int(c_f_97, 1);
  int c_t_97[] = { 23,  48}; //   2
  psi_c_t[no_ps][97] = get_vector_from_array_int(c_t_97, 2);
  int c_d_97[] = {  5,   2,   9}; //   3
  psi_c_d[no_ps][97] = get_vector_from_array_int(c_d_97, 3);

  int c_p_98[] = {  0,  27,  24}; //   3
  psi_c_p[no_ps][98] = get_vector_from_array_int(c_p_98, 3);
  int c_f_98[] = { 11}; //   1
  psi_c_f[no_ps][98] = get_vector_from_array_int(c_f_98, 1);
  int c_t_98[] = { 23,  24}; //   2
  psi_c_t[no_ps][98] = get_vector_from_array_int(c_t_98, 2);
  int c_d_98[] = {  5,   9,   2}; //   3
  psi_c_d[no_ps][98] = get_vector_from_array_int(c_d_98, 3);

  int c_p_99[] = {  0,  27,  26}; //   3
  psi_c_p[no_ps][99] = get_vector_from_array_int(c_p_99, 3);
  int c_f_99[] = { 11}; //   1
  psi_c_f[no_ps][99] = get_vector_from_array_int(c_f_99, 1);
  int c_t_99[] = { 23,  24}; //   2
  psi_c_t[no_ps][99] = get_vector_from_array_int(c_t_99, 2);
  int c_d_99[] = {  5,   9,   2}; //   3
  psi_c_d[no_ps][99] = get_vector_from_array_int(c_d_99, 3);

  int c_p_100[] = {  0,   9,  28}; //   3
  psi_c_p[no_ps][100] = get_vector_from_array_int(c_p_100, 3);
  int c_f_100[] = { 14}; //   1
  psi_c_f[no_ps][100] = get_vector_from_array_int(c_f_100, 1);
  int c_t_100[] = { 18,  49}; //   2
  psi_c_t[no_ps][100] = get_vector_from_array_int(c_t_100, 2);
  int c_d_100[] = {  9,   5,   2}; //   3
  psi_c_d[no_ps][100] = get_vector_from_array_int(c_d_100, 3);

  int c_p_101[] = {  0,  11,  28}; //   3
  psi_c_p[no_ps][101] = get_vector_from_array_int(c_p_101, 3);
  int c_f_101[] = { 14}; //   1
  psi_c_f[no_ps][101] = get_vector_from_array_int(c_f_101, 1);
  int c_t_101[] = { 18,  49}; //   2
  psi_c_t[no_ps][101] = get_vector_from_array_int(c_t_101, 2);
  int c_d_101[] = {  9,   5,   2}; //   3
  psi_c_d[no_ps][101] = get_vector_from_array_int(c_d_101, 3);

  int c_p_102[] = { 14,  21,  29}; //   3
  psi_c_p[no_ps][102] = get_vector_from_array_int(c_p_102, 3);
  int c_f_102[] = { 12}; //   1
  psi_c_f[no_ps][102] = get_vector_from_array_int(c_f_102, 1);
  int c_t_102[] = { 27,  50}; //   2
  psi_c_t[no_ps][102] = get_vector_from_array_int(c_t_102, 2);
  int c_d_102[] = {  2,   5,   9}; //   3
  psi_c_d[no_ps][102] = get_vector_from_array_int(c_d_102, 3);

  int c_p_103[] = { 14,  18,  29}; //   3
  psi_c_p[no_ps][103] = get_vector_from_array_int(c_p_103, 3);
  int c_f_103[] = { 12}; //   1
  psi_c_f[no_ps][103] = get_vector_from_array_int(c_f_103, 1);
  int c_t_103[] = { 27,  50}; //   2
  psi_c_t[no_ps][103] = get_vector_from_array_int(c_t_103, 2);
  int c_d_103[] = {  2,   5,   9}; //   3
  psi_c_d[no_ps][103] = get_vector_from_array_int(c_d_103, 3);

  int c_p_104[] = {  6,  30,  29}; //   3
  psi_c_p[no_ps][104] = get_vector_from_array_int(c_p_104, 3);
  int c_f_104[] = { 12}; //   1
  psi_c_f[no_ps][104] = get_vector_from_array_int(c_f_104, 1);
  int c_t_104[] = { 27,  28}; //   2
  psi_c_t[no_ps][104] = get_vector_from_array_int(c_t_104, 2);
  int c_d_104[] = {  2,   9,   5}; //   3
  psi_c_d[no_ps][104] = get_vector_from_array_int(c_d_104, 3);

  int c_p_105[] = {  3,  30,  29}; //   3
  psi_c_p[no_ps][105] = get_vector_from_array_int(c_p_105, 3);
  int c_f_105[] = { 12}; //   1
  psi_c_f[no_ps][105] = get_vector_from_array_int(c_f_105, 1);
  int c_t_105[] = { 27,  28}; //   2
  psi_c_t[no_ps][105] = get_vector_from_array_int(c_t_105, 2);
  int c_d_105[] = {  2,   9,   5}; //   3
  psi_c_d[no_ps][105] = get_vector_from_array_int(c_d_105, 3);

  int c_p_106[] = {  6,  12,  28}; //   3
  psi_c_p[no_ps][106] = get_vector_from_array_int(c_p_106, 3);
  int c_f_106[] = { 14}; //   1
  psi_c_f[no_ps][106] = get_vector_from_array_int(c_f_106, 1);
  int c_t_106[] = { 18,  51}; //   2
  psi_c_t[no_ps][106] = get_vector_from_array_int(c_t_106, 2);
  int c_d_106[] = {  9,   2,   5}; //   3
  psi_c_d[no_ps][106] = get_vector_from_array_int(c_d_106, 3);

  int c_p_107[] = {  3,  12,  28}; //   3
  psi_c_p[no_ps][107] = get_vector_from_array_int(c_p_107, 3);
  int c_f_107[] = { 14}; //   1
  psi_c_f[no_ps][107] = get_vector_from_array_int(c_f_107, 1);
  int c_t_107[] = { 18,  51}; //   2
  psi_c_t[no_ps][107] = get_vector_from_array_int(c_t_107, 2);
  int c_d_107[] = {  9,   2,   5}; //   3
  psi_c_d[no_ps][107] = get_vector_from_array_int(c_d_107, 3);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
