#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppemxnmnex04/header/ppemxnmnex04.phasespace.h"
void ppemxnmnex04_ax_psp_240_uux_emmupvmvexgg(int no_ps, phasespace_set & psi){
  static Logger logger("ppemxnmnex04_ax_psp_240_uux_emmupvmvexgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  psi_v_smin[no_ps].resize(23);
  psi_needed_v_smin[no_ps].resize(23);
  int needed_v_smin_0[] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   46,   47,   48,   49,   50,   51,   52,   56,   57,   58,   59,   60,   61,   62,   63,   64,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  psi_needed_v_smin[no_ps][  0] = get_vector_from_array_int(needed_v_smin_0, 55);
  int needed_v_smin_1[] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51,   62,   63}; //  16
  psi_needed_v_smin[no_ps][  1] = get_vector_from_array_int(needed_v_smin_1, 16);
  int needed_v_smin_2[] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51,   62,   63}; //  16
  psi_needed_v_smin[no_ps][  2] = get_vector_from_array_int(needed_v_smin_2, 16);
  int needed_v_smin_3[] = {   4,    5,   20,   21,   36,   37,   52,   64}; //   8
  psi_needed_v_smin[no_ps][  3] = get_vector_from_array_int(needed_v_smin_3, 8);
  int needed_v_smin_4[] = {   4,    5,   20,   21,   36,   37,   52,   64}; //   8
  psi_needed_v_smin[no_ps][  4] = get_vector_from_array_int(needed_v_smin_4, 8);
  int needed_v_smin_5[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   53,   54,   55,   56,   57,   58,   59,   60,   61,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  psi_needed_v_smin[no_ps][  5] = get_vector_from_array_int(needed_v_smin_5, 55);
  int needed_v_smin_6[] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54,   65,   66}; //  16
  psi_needed_v_smin[no_ps][  6] = get_vector_from_array_int(needed_v_smin_6, 16);
  int needed_v_smin_7[] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54,   65,   66}; //  16
  psi_needed_v_smin[no_ps][  7] = get_vector_from_array_int(needed_v_smin_7, 16);
  int needed_v_smin_8[] = {  10,   11,   26,   27,   42,   43,   55,   67}; //   8
  psi_needed_v_smin[no_ps][  8] = get_vector_from_array_int(needed_v_smin_8, 8);
  int needed_v_smin_9[] = {  10,   11,   26,   27,   42,   43,   55,   67}; //   8
  psi_needed_v_smin[no_ps][  9] = get_vector_from_array_int(needed_v_smin_9, 8);
  int needed_v_smin_10[] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   56,   57,   68,   69,   70,   71,   78}; //  19
  psi_needed_v_smin[no_ps][ 10] = get_vector_from_array_int(needed_v_smin_10, 19);
  int needed_v_smin_11[] = {  50,   51,   52,   53,   54,   55,   56,   57,   62,   63,   64,   65,   66,   67,   68,   69,   76,   77,   78,   60,   61}; //  21
  psi_needed_v_smin[no_ps][ 11] = get_vector_from_array_int(needed_v_smin_11, 21);
  int needed_v_smin_12[] = {   0,    1,    4,    6,    7,   10,   12,   13,   16,   17,   20,   22,   23,   26,   28,   29,   34,   35,   37,   40,   41,   43,   46,   47,   70}; //  25
  psi_needed_v_smin[no_ps][ 12] = get_vector_from_array_int(needed_v_smin_12, 25);
  int needed_v_smin_13[] = {   2,    3,    5,    8,    9,   11,   14,   15,   18,   19,   21,   24,   25,   27,   30,   31,   32,   33,   36,   38,   39,   42,   44,   45,   71}; //  25
  psi_needed_v_smin[no_ps][ 13] = get_vector_from_array_int(needed_v_smin_13, 25);
  int needed_v_smin_14[] = {  48,   59}; //   2
  psi_needed_v_smin[no_ps][ 14] = get_vector_from_array_int(needed_v_smin_14, 2);
  int needed_v_smin_15[] = {  48,   59}; //   2
  psi_needed_v_smin[no_ps][ 15] = get_vector_from_array_int(needed_v_smin_15, 2);
  int needed_v_smin_16[] = {  49,   58}; //   2
  psi_needed_v_smin[no_ps][ 16] = get_vector_from_array_int(needed_v_smin_16, 2);
  int needed_v_smin_17[] = {  49,   58}; //   2
  psi_needed_v_smin[no_ps][ 17] = get_vector_from_array_int(needed_v_smin_17, 2);
  int needed_v_smin_18[] = {  60,   61,   76,   77}; //   4
  psi_needed_v_smin[no_ps][ 18] = get_vector_from_array_int(needed_v_smin_18, 4);
  int needed_v_smin_19[] = {  72,   75}; //   2
  psi_needed_v_smin[no_ps][ 19] = get_vector_from_array_int(needed_v_smin_19, 2);
  int needed_v_smin_20[] = {  72,   75}; //   2
  psi_needed_v_smin[no_ps][ 20] = get_vector_from_array_int(needed_v_smin_20, 2);
  int needed_v_smin_21[] = {  73,   74}; //   2
  psi_needed_v_smin[no_ps][ 21] = get_vector_from_array_int(needed_v_smin_21, 2);
  int needed_v_smin_22[] = {  73,   74}; //   2
  psi_needed_v_smin[no_ps][ 22] = get_vector_from_array_int(needed_v_smin_22, 2);

  psi_v_smax[no_ps].resize(29);
  psi_needed_v_smax[no_ps].resize(29);
  int needed_v_smax_0[] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   46,   47,   50,   51,   52,   56,   57}; //  35
  psi_needed_v_smax[no_ps][  0] = get_vector_from_array_int(needed_v_smax_0, 35);
  int needed_v_smax_1[] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51}; //  14
  psi_needed_v_smax[no_ps][  1] = get_vector_from_array_int(needed_v_smax_1, 14);
  int needed_v_smax_2[] = {   0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   50,   51,   52,   53,   54,   55,   56,   57,   70,   71}; //  58
  psi_needed_v_smax[no_ps][  2] = get_vector_from_array_int(needed_v_smax_2, 58);
  int needed_v_smax_3[] = {   4,    5,   20,   21,   36,   37,   52}; //   7
  psi_needed_v_smax[no_ps][  3] = get_vector_from_array_int(needed_v_smax_3, 7);
  int needed_v_smax_4[] = {   6,    7,    8,    9,   10,   11,   22,   23,   24,   25,   26,   27,   38,   39,   40,   41,   42,   43,   48,   49,   53,   54,   55,   58,   59,   60,   61,   70,   71,   72,   73,   74,   75,   77,   78}; //  35
  psi_needed_v_smax[no_ps][  4] = get_vector_from_array_int(needed_v_smax_4, 35);
  int needed_v_smax_5[] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54}; //  14
  psi_needed_v_smax[no_ps][  5] = get_vector_from_array_int(needed_v_smax_5, 14);
  int needed_v_smax_6[] = {  10,   11,   26,   27,   42,   43,   55}; //   7
  psi_needed_v_smax[no_ps][  6] = get_vector_from_array_int(needed_v_smax_6, 7);
  int needed_v_smax_7[] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   56,   57}; //  14
  psi_needed_v_smax[no_ps][  7] = get_vector_from_array_int(needed_v_smax_7, 14);
  int needed_v_smax_8[] = {  48,   49,   58,   59,   60,   61,   70,   71,   72,   73,   74,   75,   78}; //  13
  psi_needed_v_smax[no_ps][  8] = get_vector_from_array_int(needed_v_smax_8, 13);
  int needed_v_smax_9[] = {  50,   51,   52,   53,   54,   55,   56,   57}; //   8
  psi_needed_v_smax[no_ps][  9] = get_vector_from_array_int(needed_v_smax_9, 8);
  int needed_v_smax_10[] = {  62,   63,   64,   65,   66,   67,   68,   69,   76}; //   9
  psi_needed_v_smax[no_ps][ 10] = get_vector_from_array_int(needed_v_smax_10, 9);
  int needed_v_smax_11[] = {  62,   63,   64,   68,   69}; //   5
  psi_needed_v_smax[no_ps][ 11] = get_vector_from_array_int(needed_v_smax_11, 5);
  int needed_v_smax_12[] = {  62,   63}; //   2
  psi_needed_v_smax[no_ps][ 12] = get_vector_from_array_int(needed_v_smax_12, 2);
  int needed_v_smax_13[] = {  62,   63,   64,   65,   66,   67,   68,   69,   78}; //   9
  psi_needed_v_smax[no_ps][ 13] = get_vector_from_array_int(needed_v_smax_13, 9);
  int needed_v_smax_14[] = {  64}; //   1
  psi_needed_v_smax[no_ps][ 14] = get_vector_from_array_int(needed_v_smax_14, 1);
  int needed_v_smax_15[] = {  65,   66,   67,   76}; //   4
  psi_needed_v_smax[no_ps][ 15] = get_vector_from_array_int(needed_v_smax_15, 4);
  int needed_v_smax_16[] = {  65,   66}; //   2
  psi_needed_v_smax[no_ps][ 16] = get_vector_from_array_int(needed_v_smax_16, 2);
  int needed_v_smax_17[] = {  67}; //   1
  psi_needed_v_smax[no_ps][ 17] = get_vector_from_array_int(needed_v_smax_17, 1);
  int needed_v_smax_18[] = {  68,   69}; //   2
  psi_needed_v_smax[no_ps][ 18] = get_vector_from_array_int(needed_v_smax_18, 2);
  int needed_v_smax_19[] = {  76,   77}; //   2
  psi_needed_v_smax[no_ps][ 19] = get_vector_from_array_int(needed_v_smax_19, 2);
  int needed_v_smax_20[] = {  77}; //   1
  psi_needed_v_smax[no_ps][ 20] = get_vector_from_array_int(needed_v_smax_20, 1);
  int needed_v_smax_21[] = {  78,   60,   61}; //   3
  psi_needed_v_smax[no_ps][ 21] = get_vector_from_array_int(needed_v_smax_21, 3);
  int needed_v_smax_22[] = {   0,    1,    4,    6,    7,   10,   12,   13,   16,   17,   20,   22,   23,   26,   28,   29,   34,   35,   37,   40,   41,   43,   46,   47,   48,   59,   70,   72,   75}; //  29
  psi_needed_v_smax[no_ps][ 22] = get_vector_from_array_int(needed_v_smax_22, 29);
  int needed_v_smax_23[] = {   2,    3,    5,    8,    9,   11,   14,   15,   18,   19,   21,   24,   25,   27,   30,   31,   32,   33,   36,   38,   39,   42,   44,   45,   49,   58,   71,   73,   74}; //  29
  psi_needed_v_smax[no_ps][ 23] = get_vector_from_array_int(needed_v_smax_23, 29);
  int needed_v_smax_24[] = {  48,   59}; //   2
  psi_needed_v_smax[no_ps][ 24] = get_vector_from_array_int(needed_v_smax_24, 2);
  int needed_v_smax_25[] = {  49,   58}; //   2
  psi_needed_v_smax[no_ps][ 25] = get_vector_from_array_int(needed_v_smax_25, 2);
  int needed_v_smax_26[] = {  60,   61,   76,   77}; //   4
  psi_needed_v_smax[no_ps][ 26] = get_vector_from_array_int(needed_v_smax_26, 4);
  int needed_v_smax_27[] = {  72,   75}; //   2
  psi_needed_v_smax[no_ps][ 27] = get_vector_from_array_int(needed_v_smax_27, 2);
  int needed_v_smax_28[] = {  73,   74}; //   2
  psi_needed_v_smax[no_ps][ 28] = get_vector_from_array_int(needed_v_smax_28, 2);

  psi_container_IS_startvalue[no_ps][0] = psi_container_IS_name.size();
  psi_g_p[no_ps].resize(36);
  psi_needed_g_p[no_ps].resize(36);
  int needed_g_p_0[] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   46,   47,   50,   51,   52,   56,   57}; //  35
  psi_needed_g_p[no_ps][0] = get_vector_from_array_int(needed_g_p_0, 35);
  psi_container_IS_name.push_back("propagator_24_smin0_smax0");
  int needed_g_p_1[] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51}; //  14
  psi_needed_g_p[no_ps][1] = get_vector_from_array_int(needed_g_p_1, 14);
  psi_container_IS_name.push_back("propagator_0_smin1_smax1");
  int needed_g_p_2[] = {   0,    2,   16,   18,   32,   34,   50}; //   7
  psi_needed_g_p[no_ps][2] = get_vector_from_array_int(needed_g_p_2, 7);
  psi_container_IS_name.push_back("propagator_0_smin2_smax2");
  int needed_g_p_3[] = {   1,    3,   17,   19,   33,   35,   51}; //   7
  psi_needed_g_p[no_ps][3] = get_vector_from_array_int(needed_g_p_3, 7);
  psi_container_IS_name.push_back("propagator_23_smin2_smax2");
  int needed_g_p_4[] = {   4,    5,   20,   21,   36,   37,   52}; //   7
  psi_needed_g_p[no_ps][4] = get_vector_from_array_int(needed_g_p_4, 7);
  psi_container_IS_name.push_back("propagator_0_smin3_smax3");
  int needed_g_p_5[] = {   4,    5,   20,   21,   36,   37,   52}; //   7
  psi_needed_g_p[no_ps][5] = get_vector_from_array_int(needed_g_p_5, 7);
  psi_container_IS_name.push_back("propagator_23_smin4_smax2");
  int needed_g_p_6[] = {   6,    7,    8,    9,   10,   11,   22,   23,   24,   25,   26,   27,   38,   39,   40,   41,   42,   43,   48,   49,   53,   54,   55,   58,   59,   60,   61,   70,   71,   72,   73,   74,   75,   77,   78}; //  35
  psi_needed_g_p[no_ps][6] = get_vector_from_array_int(needed_g_p_6, 35);
  psi_container_IS_name.push_back("propagator_24_smin5_smax4");
  int needed_g_p_7[] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54}; //  14
  psi_needed_g_p[no_ps][7] = get_vector_from_array_int(needed_g_p_7, 14);
  psi_container_IS_name.push_back("propagator_0_smin6_smax5");
  int needed_g_p_8[] = {   6,    8,   22,   24,   38,   40,   53}; //   7
  psi_needed_g_p[no_ps][8] = get_vector_from_array_int(needed_g_p_8, 7);
  psi_container_IS_name.push_back("propagator_0_smin7_smax2");
  int needed_g_p_9[] = {   7,    9,   23,   25,   39,   41,   54}; //   7
  psi_needed_g_p[no_ps][9] = get_vector_from_array_int(needed_g_p_9, 7);
  psi_container_IS_name.push_back("propagator_23_smin7_smax2");
  int needed_g_p_10[] = {  10,   11,   26,   27,   42,   43,   55}; //   7
  psi_needed_g_p[no_ps][10] = get_vector_from_array_int(needed_g_p_10, 7);
  psi_container_IS_name.push_back("propagator_0_smin8_smax6");
  int needed_g_p_11[] = {  10,   11,   26,   27,   42,   43,   55}; //   7
  psi_needed_g_p[no_ps][11] = get_vector_from_array_int(needed_g_p_11, 7);
  psi_container_IS_name.push_back("propagator_23_smin9_smax2");
  int needed_g_p_12[] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   56,   57}; //  14
  psi_needed_g_p[no_ps][12] = get_vector_from_array_int(needed_g_p_12, 14);
  psi_container_IS_name.push_back("propagator_24_smin5_smax7");
  int needed_g_p_13[] = {  12,   14,   28,   30,   44,   46,   56}; //   7
  psi_needed_g_p[no_ps][13] = get_vector_from_array_int(needed_g_p_13, 7);
  psi_container_IS_name.push_back("propagator_0_smin10_smax2");
  int needed_g_p_14[] = {  13,   15,   29,   31,   45,   47,   57}; //   7
  psi_needed_g_p[no_ps][14] = get_vector_from_array_int(needed_g_p_14, 7);
  psi_container_IS_name.push_back("propagator_23_smin10_smax2");
  int needed_g_p_15[] = {  48,   49,   58,   59,   60,   61,   70,   71,   72,   73,   74,   75,   78}; //  13
  psi_needed_g_p[no_ps][15] = get_vector_from_array_int(needed_g_p_15, 13);
  psi_container_IS_name.push_back("propagator_24_smin0_smax8");
  int needed_g_p_16[] = {  50,   51,   52,   53,   54,   55,   56,   57}; //   8
  psi_needed_g_p[no_ps][16] = get_vector_from_array_int(needed_g_p_16, 8);
  psi_container_IS_name.push_back("propagator_0_smin11_smax9");
  int needed_g_p_17[] = {  62,   63,   64,   65,   66,   67,   68,   69,   76}; //   9
  psi_needed_g_p[no_ps][17] = get_vector_from_array_int(needed_g_p_17, 9);
  psi_container_IS_name.push_back("propagator_0_smin11_smax10");
  int needed_g_p_18[] = {  62,   63,   64,   68,   69}; //   5
  psi_needed_g_p[no_ps][18] = get_vector_from_array_int(needed_g_p_18, 5);
  psi_container_IS_name.push_back("propagator_24_smin0_smax11");
  int needed_g_p_19[] = {  62,   63}; //   2
  psi_needed_g_p[no_ps][19] = get_vector_from_array_int(needed_g_p_19, 2);
  psi_container_IS_name.push_back("propagator_0_smin1_smax12");
  int needed_g_p_20[] = {  62}; //   1
  psi_needed_g_p[no_ps][20] = get_vector_from_array_int(needed_g_p_20, 1);
  psi_container_IS_name.push_back("propagator_0_smin2_smax13");
  int needed_g_p_21[] = {  63}; //   1
  psi_needed_g_p[no_ps][21] = get_vector_from_array_int(needed_g_p_21, 1);
  psi_container_IS_name.push_back("propagator_23_smin2_smax13");
  int needed_g_p_22[] = {  64}; //   1
  psi_needed_g_p[no_ps][22] = get_vector_from_array_int(needed_g_p_22, 1);
  psi_container_IS_name.push_back("propagator_0_smin3_smax14");
  int needed_g_p_23[] = {  64}; //   1
  psi_needed_g_p[no_ps][23] = get_vector_from_array_int(needed_g_p_23, 1);
  psi_container_IS_name.push_back("propagator_23_smin4_smax13");
  int needed_g_p_24[] = {  65,   66,   67,   76}; //   4
  psi_needed_g_p[no_ps][24] = get_vector_from_array_int(needed_g_p_24, 4);
  psi_container_IS_name.push_back("propagator_24_smin5_smax15");
  int needed_g_p_25[] = {  65,   66}; //   2
  psi_needed_g_p[no_ps][25] = get_vector_from_array_int(needed_g_p_25, 2);
  psi_container_IS_name.push_back("propagator_0_smin6_smax16");
  int needed_g_p_26[] = {  65}; //   1
  psi_needed_g_p[no_ps][26] = get_vector_from_array_int(needed_g_p_26, 1);
  psi_container_IS_name.push_back("propagator_0_smin7_smax13");
  int needed_g_p_27[] = {  66}; //   1
  psi_needed_g_p[no_ps][27] = get_vector_from_array_int(needed_g_p_27, 1);
  psi_container_IS_name.push_back("propagator_23_smin7_smax13");
  int needed_g_p_28[] = {  67}; //   1
  psi_needed_g_p[no_ps][28] = get_vector_from_array_int(needed_g_p_28, 1);
  psi_container_IS_name.push_back("propagator_0_smin8_smax17");
  int needed_g_p_29[] = {  67}; //   1
  psi_needed_g_p[no_ps][29] = get_vector_from_array_int(needed_g_p_29, 1);
  psi_container_IS_name.push_back("propagator_23_smin9_smax13");
  int needed_g_p_30[] = {  68,   69}; //   2
  psi_needed_g_p[no_ps][30] = get_vector_from_array_int(needed_g_p_30, 2);
  psi_container_IS_name.push_back("propagator_24_smin5_smax18");
  int needed_g_p_31[] = {  68}; //   1
  psi_needed_g_p[no_ps][31] = get_vector_from_array_int(needed_g_p_31, 1);
  psi_container_IS_name.push_back("propagator_0_smin10_smax13");
  int needed_g_p_32[] = {  69}; //   1
  psi_needed_g_p[no_ps][32] = get_vector_from_array_int(needed_g_p_32, 1);
  psi_container_IS_name.push_back("propagator_23_smin10_smax13");
  int needed_g_p_33[] = {  76,   77}; //   2
  psi_needed_g_p[no_ps][33] = get_vector_from_array_int(needed_g_p_33, 2);
  psi_container_IS_name.push_back("propagator_24_smin0_smax19");
  int needed_g_p_34[] = {  77}; //   1
  psi_needed_g_p[no_ps][34] = get_vector_from_array_int(needed_g_p_34, 1);
  psi_container_IS_name.push_back("propagator_0_smin11_smax20");
  int needed_g_p_35[] = {  78}; //   1
  psi_needed_g_p[no_ps][35] = get_vector_from_array_int(needed_g_p_35, 1);
  psi_container_IS_name.push_back("propagator_0_smin11_smax21");

  psi_container_IS_startvalue[no_ps][1] = psi_container_IS_name.size();
  psi_g_f[no_ps].resize(14);
  psi_needed_g_f[no_ps].resize(14);
  int needed_g_f_0[] = {   0,    1,    4,    6,    7,   10,   12,   13,   16,   17,   20,   22,   23,   26,   28,   29,   34,   35,   37,   40,   41,   43,   46,   47,   70}; //  25
  psi_needed_g_f[no_ps][0] = get_vector_from_array_int(needed_g_f_0, 25);
  psi_container_IS_name.push_back("timelikeinvariant_smin12_smax22");
  int needed_g_f_1[] = {   2,    3,    5,    8,    9,   11,   14,   15,   18,   19,   21,   24,   25,   27,   30,   31,   32,   33,   36,   38,   39,   42,   44,   45,   71}; //  25
  psi_needed_g_f[no_ps][1] = get_vector_from_array_int(needed_g_f_1, 25);
  psi_container_IS_name.push_back("timelikeinvariant_smin13_smax23");
  int needed_g_f_2[] = {  48,   59}; //   2
  psi_needed_g_f[no_ps][2] = get_vector_from_array_int(needed_g_f_2, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin14_smax24");
  int needed_g_f_3[] = {  48,   59}; //   2
  psi_needed_g_f[no_ps][3] = get_vector_from_array_int(needed_g_f_3, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin15_smax22");
  int needed_g_f_4[] = {  49,   58}; //   2
  psi_needed_g_f[no_ps][4] = get_vector_from_array_int(needed_g_f_4, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin16_smax25");
  int needed_g_f_5[] = {  49,   58}; //   2
  psi_needed_g_f[no_ps][5] = get_vector_from_array_int(needed_g_f_5, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin17_smax23");
  int needed_g_f_6[] = {  60,   61}; //   2
  psi_needed_g_f[no_ps][6] = get_vector_from_array_int(needed_g_f_6, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin11_smax21");
  int needed_g_f_7[] = {  60,   61,   76,   77}; //   4
  psi_needed_g_f[no_ps][7] = get_vector_from_array_int(needed_g_f_7, 4);
  psi_container_IS_name.push_back("timelikeinvariant_smin18_smax26");
  int needed_g_f_8[] = {  70,   71}; //   2
  psi_needed_g_f[no_ps][8] = get_vector_from_array_int(needed_g_f_8, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax2");
  int needed_g_f_9[] = {  72,   75}; //   2
  psi_needed_g_f[no_ps][9] = get_vector_from_array_int(needed_g_f_9, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin19_smax27");
  int needed_g_f_10[] = {  72,   75}; //   2
  psi_needed_g_f[no_ps][10] = get_vector_from_array_int(needed_g_f_10, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin20_smax22");
  int needed_g_f_11[] = {  73,   74}; //   2
  psi_needed_g_f[no_ps][11] = get_vector_from_array_int(needed_g_f_11, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin21_smax28");
  int needed_g_f_12[] = {  73,   74}; //   2
  psi_needed_g_f[no_ps][12] = get_vector_from_array_int(needed_g_f_12, 2);
  psi_container_IS_name.push_back("timelikeinvariant_smin22_smax23");
  int needed_g_f_13[] = {  78}; //   1
  psi_needed_g_f[no_ps][13] = get_vector_from_array_int(needed_g_f_13, 1);
  psi_container_IS_name.push_back("timelikeinvariant_smin10_smax13");

  psi_container_IS_startvalue[no_ps][2] = psi_container_IS_name.size();
  psi_g_t[no_ps].resize(32);
  psi_needed_g_t[no_ps].resize(32);
  int needed_g_t_0[] = {   0,    1,    4,    6,    7,   10,   12,   13,   48,   59}; //  10
  psi_needed_g_t[no_ps][0] = get_vector_from_array_int(needed_g_t_0, 10);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__128_124");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__128_124");
  int needed_g_t_1[] = {   0,    1,    4,    6,    7,   10,   12,   13}; //   8
  psi_needed_g_t[no_ps][1] = get_vector_from_array_int(needed_g_t_1, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__130_1__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__130_1__64_60");
  int needed_g_t_2[] = {   2,    3,    5,    8,    9,   11,   14,   15,   49,   58}; //  10
  psi_needed_g_t[no_ps][2] = get_vector_from_array_int(needed_g_t_2, 10);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__64_188");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__64_188");
  int needed_g_t_3[] = {   2,    3,    5,    8,    9,   11,   14,   15}; //   8
  psi_needed_g_t[no_ps][3] = get_vector_from_array_int(needed_g_t_3, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__66_1__128_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__66_1__128_60");
  int needed_g_t_4[] = {  16,   17,   20,   22,   23,   26,   28,   29,   34,   35,   37,   40,   41,   43,   46,   47,   70,   72,   75}; //  19
  psi_needed_g_t[no_ps][4] = get_vector_from_array_int(needed_g_t_4, 19);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__128_124");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__128_124");
  int needed_g_t_5[] = {  16,   17,   20,   22,   23,   26,   28,   29,   70}; //   9
  psi_needed_g_t[no_ps][5] = get_vector_from_array_int(needed_g_t_5, 9);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_129__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_129__64_60");
  int needed_g_t_6[] = {  18,   19,   21,   24,   25,   27,   30,   31,   32,   33,   36,   38,   39,   42,   44,   45,   71,   73,   74}; //  19
  psi_needed_g_t[no_ps][6] = get_vector_from_array_int(needed_g_t_6, 19);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__64_188");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__64_188");
  int needed_g_t_7[] = {  18,   19,   21,   24,   25,   27,   30,   31,   71}; //   9
  psi_needed_g_t[no_ps][7] = get_vector_from_array_int(needed_g_t_7, 9);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__128_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__128_60");
  int needed_g_t_8[] = {  32,   33,   36,   38,   39,   42,   44,   45}; //   8
  psi_needed_g_t[no_ps][8] = get_vector_from_array_int(needed_g_t_8, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__65_2__128_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__65_2__128_60");
  int needed_g_t_9[] = {  34,   35,   37,   40,   41,   43,   46,   47}; //   8
  psi_needed_g_t[no_ps][9] = get_vector_from_array_int(needed_g_t_9, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__129_2__64_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__129_2__64_60");
  int needed_g_t_10[] = {  48,   59}; //   2
  psi_needed_g_t[no_ps][10] = get_vector_from_array_int(needed_g_t_10, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_130__24_100");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_130__24_100");
  int needed_g_t_11[] = {  48}; //   1
  psi_needed_g_t[no_ps][11] = get_vector_from_array_int(needed_g_t_11, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_25__64_36");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_25__64_36");
  int needed_g_t_12[] = {  49,   58}; //   2
  psi_needed_g_t[no_ps][12] = get_vector_from_array_int(needed_g_t_12, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_66__24_164");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_66__24_164");
  int needed_g_t_13[] = {  49}; //   1
  psi_needed_g_t[no_ps][13] = get_vector_from_array_int(needed_g_t_13, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_25__128_36");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_25__128_36");
  int needed_g_t_14[] = {  50,   51,   52,   53,   54,   55,   56,   57,   78}; //   9
  psi_needed_g_t[no_ps][14] = get_vector_from_array_int(needed_g_t_14, 9);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__192_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__192_60");
  int needed_g_t_15[] = {  58}; //   1
  psi_needed_g_t[no_ps][15] = get_vector_from_array_int(needed_g_t_15, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__66_25__36_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__66_25__36_128");
  int needed_g_t_16[] = {  59}; //   1
  psi_needed_g_t[no_ps][16] = get_vector_from_array_int(needed_g_t_16, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__130_25__36_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__130_25__36_64");
  int needed_g_t_17[] = {  60,   61,   76,   77}; //   4
  psi_needed_g_t[no_ps][17] = get_vector_from_array_int(needed_g_t_17, 4);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__1_2__24_228");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__1_2__24_228");
  int needed_g_t_18[] = {  60,   61,   77}; //   3
  psi_needed_g_t[no_ps][18] = get_vector_from_array_int(needed_g_t_18, 3);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_25__36_192");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_25__36_192");
  int needed_g_t_19[] = {  60}; //   1
  psi_needed_g_t[no_ps][19] = get_vector_from_array_int(needed_g_t_19, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__25_38__64_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__25_38__64_128");
  int needed_g_t_20[] = {  61}; //   1
  psi_needed_g_t[no_ps][20] = get_vector_from_array_int(needed_g_t_20, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__25_38__128_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__25_38__128_64");
  int needed_g_t_21[] = {  62,   63,   64,   65,   66,   67,   68,   69}; //   8
  psi_needed_g_t[no_ps][21] = get_vector_from_array_int(needed_g_t_21, 8);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_1__192_60");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_1__192_60");
  int needed_g_t_22[] = {  70}; //   1
  psi_needed_g_t[no_ps][22] = get_vector_from_array_int(needed_g_t_22, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__129_66__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_0__129_66__24_36");
  int needed_g_t_23[] = {  71}; //   1
  psi_needed_g_t[no_ps][23] = get_vector_from_array_int(needed_g_t_23, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_130__24_36");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_130__24_36");
  int needed_g_t_24[] = {  72,   75}; //   2
  psi_needed_g_t[no_ps][24] = get_vector_from_array_int(needed_g_t_24, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_129__36_88");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_129__36_88");
  int needed_g_t_25[] = {  72}; //   1
  psi_needed_g_t[no_ps][25] = get_vector_from_array_int(needed_g_t_25, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__129_38__24_64");
  psi_container_IS_name.push_back("phi_of_tchannel_0__129_38__24_64");
  int needed_g_t_26[] = {  73,   74}; //   2
  psi_needed_g_t[no_ps][26] = get_vector_from_array_int(needed_g_t_26, 2);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_65__36_152");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_65__36_152");
  int needed_g_t_27[] = {  73}; //   1
  psi_needed_g_t[no_ps][27] = get_vector_from_array_int(needed_g_t_27, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_38__24_128");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_38__24_128");
  int needed_g_t_28[] = {  74}; //   1
  psi_needed_g_t[no_ps][28] = get_vector_from_array_int(needed_g_t_28, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__65_38__128_24");
  psi_container_IS_name.push_back("phi_of_tchannel_0__65_38__128_24");
  int needed_g_t_29[] = {  75}; //   1
  psi_needed_g_t[no_ps][29] = get_vector_from_array_int(needed_g_t_29, 1);
  psi_container_IS_name.push_back("t_of_tchannel_0__129_38__64_24");
  psi_container_IS_name.push_back("phi_of_tchannel_0__129_38__64_24");
  int needed_g_t_30[] = {  76}; //   1
  psi_needed_g_t[no_ps][30] = get_vector_from_array_int(needed_g_t_30, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_25__192_36");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_25__192_36");
  int needed_g_t_31[] = {  78}; //   1
  psi_needed_g_t[no_ps][31] = get_vector_from_array_int(needed_g_t_31, 1);
  psi_container_IS_name.push_back("t_of_tchannel_opt_0__2_193__36_24");
  psi_container_IS_name.push_back("phi_of_tchannel_opt_0__2_193__36_24");

  psi_container_IS_startvalue[no_ps][3] = psi_container_IS_name.size();
  psi_g_d[no_ps].resize(12);
  psi_needed_g_d[no_ps].resize(12);
  int needed_g_d_0[] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51,   62,   63}; //  16
  psi_needed_g_d[no_ps][0] = get_vector_from_array_int(needed_g_d_0, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__4_56");
  psi_container_IS_name.push_back("phi_of_decay_60__4_56");
  int needed_g_d_1[] = {   0,    1,    2,    3,   16,   17,   18,   19,   32,   33,   34,   35,   50,   51,   62,   63}; //  16
  psi_needed_g_d[no_ps][1] = get_vector_from_array_int(needed_g_d_1, 16);
  psi_container_IS_name.push_back("costheta_of_decay_56__32_24");
  psi_container_IS_name.push_back("phi_of_decay_56__32_24");
  int needed_g_d_2[] = {   0,    1,    2,    3,    4,    5,   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   44,   45,   46,   47,   48,   49,   50,   51,   52,   56,   57,   58,   59,   60,   61,   62,   63,   64,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  psi_needed_g_d[no_ps][2] = get_vector_from_array_int(needed_g_d_2, 55);
  psi_container_IS_name.push_back("costheta_of_decay_24__8_16");
  psi_container_IS_name.push_back("phi_of_decay_24__8_16");
  int needed_g_d_3[] = {   4,    5,   20,   21,   36,   37,   52,   64}; //   8
  psi_needed_g_d[no_ps][3] = get_vector_from_array_int(needed_g_d_3, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__32_28");
  psi_container_IS_name.push_back("phi_of_decay_60__32_28");
  int needed_g_d_4[] = {   4,    5,   20,   21,   36,   37,   52,   64}; //   8
  psi_needed_g_d[no_ps][4] = get_vector_from_array_int(needed_g_d_4, 8);
  psi_container_IS_name.push_back("costheta_of_decay_28__4_24");
  psi_container_IS_name.push_back("phi_of_decay_28__4_24");
  int needed_g_d_5[] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54,   65,   66}; //  16
  psi_needed_g_d[no_ps][5] = get_vector_from_array_int(needed_g_d_5, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__8_52");
  psi_container_IS_name.push_back("phi_of_decay_60__8_52");
  int needed_g_d_6[] = {   6,    7,    8,    9,   22,   23,   24,   25,   38,   39,   40,   41,   53,   54,   65,   66}; //  16
  psi_needed_g_d[no_ps][6] = get_vector_from_array_int(needed_g_d_6, 16);
  psi_container_IS_name.push_back("costheta_of_decay_52__16_36");
  psi_container_IS_name.push_back("phi_of_decay_52__16_36");
  int needed_g_d_7[] = {   6,    7,    8,    9,   10,   11,   12,   13,   14,   15,   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,   38,   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,   49,   53,   54,   55,   56,   57,   58,   59,   60,   61,   65,   66,   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,   78}; //  55
  psi_needed_g_d[no_ps][7] = get_vector_from_array_int(needed_g_d_7, 55);
  psi_container_IS_name.push_back("costheta_of_decay_36__4_32");
  psi_container_IS_name.push_back("phi_of_decay_36__4_32");
  int needed_g_d_8[] = {  10,   11,   26,   27,   42,   43,   55,   67}; //   8
  psi_needed_g_d[no_ps][8] = get_vector_from_array_int(needed_g_d_8, 8);
  psi_container_IS_name.push_back("costheta_of_decay_60__16_44");
  psi_container_IS_name.push_back("phi_of_decay_60__16_44");
  int needed_g_d_9[] = {  10,   11,   26,   27,   42,   43,   55,   67}; //   8
  psi_needed_g_d[no_ps][9] = get_vector_from_array_int(needed_g_d_9, 8);
  psi_container_IS_name.push_back("costheta_of_decay_44__8_36");
  psi_container_IS_name.push_back("phi_of_decay_44__8_36");
  int needed_g_d_10[] = {  12,   13,   14,   15,   28,   29,   30,   31,   44,   45,   46,   47,   56,   57,   68,   69}; //  16
  psi_needed_g_d[no_ps][10] = get_vector_from_array_int(needed_g_d_10, 16);
  psi_container_IS_name.push_back("costheta_of_decay_60__36_24");
  psi_container_IS_name.push_back("phi_of_decay_60__36_24");
  int needed_g_d_11[] = {  50,   51,   52,   53,   54,   55,   56,   57,   62,   63,   64,   65,   66,   67,   68,   69,   76,   77,   78}; //  19
  psi_needed_g_d[no_ps][11] = get_vector_from_array_int(needed_g_d_11, 19);
  psi_container_IS_name.push_back("costheta_of_decay_192__64_128");
  psi_container_IS_name.push_back("phi_of_decay_192__64_128");

  psi_c_p[no_ps].resize(79);
  psi_c_f[no_ps].resize(79);
  psi_c_t[no_ps].resize(79);
  psi_c_d[no_ps].resize(79);

  int c_p_0[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][0] = get_vector_from_array_int(c_p_0, 3);
  int c_f_0[] = {  0}; //   1
  psi_c_f[no_ps][0] = get_vector_from_array_int(c_f_0, 1);
  int c_t_0[] = {  0,   1}; //   2
  psi_c_t[no_ps][0] = get_vector_from_array_int(c_t_0, 2);
  int c_d_0[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][0] = get_vector_from_array_int(c_d_0, 3);

  int c_p_1[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][1] = get_vector_from_array_int(c_p_1, 3);
  int c_f_1[] = {  0}; //   1
  psi_c_f[no_ps][1] = get_vector_from_array_int(c_f_1, 1);
  int c_t_1[] = {  0,   1}; //   2
  psi_c_t[no_ps][1] = get_vector_from_array_int(c_t_1, 2);
  int c_d_1[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][1] = get_vector_from_array_int(c_d_1, 3);

  int c_p_2[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][2] = get_vector_from_array_int(c_p_2, 3);
  int c_f_2[] = {  1}; //   1
  psi_c_f[no_ps][2] = get_vector_from_array_int(c_f_2, 1);
  int c_t_2[] = {  2,   3}; //   2
  psi_c_t[no_ps][2] = get_vector_from_array_int(c_t_2, 2);
  int c_d_2[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][2] = get_vector_from_array_int(c_d_2, 3);

  int c_p_3[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][3] = get_vector_from_array_int(c_p_3, 3);
  int c_f_3[] = {  1}; //   1
  psi_c_f[no_ps][3] = get_vector_from_array_int(c_f_3, 1);
  int c_t_3[] = {  2,   3}; //   2
  psi_c_t[no_ps][3] = get_vector_from_array_int(c_t_3, 2);
  int c_d_3[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][3] = get_vector_from_array_int(c_d_3, 3);

  int c_p_4[] = {  0,   4,   5}; //   3
  psi_c_p[no_ps][4] = get_vector_from_array_int(c_p_4, 3);
  int c_f_4[] = {  0}; //   1
  psi_c_f[no_ps][4] = get_vector_from_array_int(c_f_4, 1);
  int c_t_4[] = {  0,   1}; //   2
  psi_c_t[no_ps][4] = get_vector_from_array_int(c_t_4, 2);
  int c_d_4[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][4] = get_vector_from_array_int(c_d_4, 3);

  int c_p_5[] = {  0,   4,   5}; //   3
  psi_c_p[no_ps][5] = get_vector_from_array_int(c_p_5, 3);
  int c_f_5[] = {  1}; //   1
  psi_c_f[no_ps][5] = get_vector_from_array_int(c_f_5, 1);
  int c_t_5[] = {  2,   3}; //   2
  psi_c_t[no_ps][5] = get_vector_from_array_int(c_t_5, 2);
  int c_d_5[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][5] = get_vector_from_array_int(c_d_5, 3);

  int c_p_6[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][6] = get_vector_from_array_int(c_p_6, 3);
  int c_f_6[] = {  0}; //   1
  psi_c_f[no_ps][6] = get_vector_from_array_int(c_f_6, 1);
  int c_t_6[] = {  0,   1}; //   2
  psi_c_t[no_ps][6] = get_vector_from_array_int(c_t_6, 2);
  int c_d_6[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][6] = get_vector_from_array_int(c_d_6, 3);

  int c_p_7[] = {  6,   7,   9}; //   3
  psi_c_p[no_ps][7] = get_vector_from_array_int(c_p_7, 3);
  int c_f_7[] = {  0}; //   1
  psi_c_f[no_ps][7] = get_vector_from_array_int(c_f_7, 1);
  int c_t_7[] = {  0,   1}; //   2
  psi_c_t[no_ps][7] = get_vector_from_array_int(c_t_7, 2);
  int c_d_7[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][7] = get_vector_from_array_int(c_d_7, 3);

  int c_p_8[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][8] = get_vector_from_array_int(c_p_8, 3);
  int c_f_8[] = {  1}; //   1
  psi_c_f[no_ps][8] = get_vector_from_array_int(c_f_8, 1);
  int c_t_8[] = {  2,   3}; //   2
  psi_c_t[no_ps][8] = get_vector_from_array_int(c_t_8, 2);
  int c_d_8[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][8] = get_vector_from_array_int(c_d_8, 3);

  int c_p_9[] = {  6,   7,   9}; //   3
  psi_c_p[no_ps][9] = get_vector_from_array_int(c_p_9, 3);
  int c_f_9[] = {  1}; //   1
  psi_c_f[no_ps][9] = get_vector_from_array_int(c_f_9, 1);
  int c_t_9[] = {  2,   3}; //   2
  psi_c_t[no_ps][9] = get_vector_from_array_int(c_t_9, 2);
  int c_d_9[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][9] = get_vector_from_array_int(c_d_9, 3);

  int c_p_10[] = {  6,  10,  11}; //   3
  psi_c_p[no_ps][10] = get_vector_from_array_int(c_p_10, 3);
  int c_f_10[] = {  0}; //   1
  psi_c_f[no_ps][10] = get_vector_from_array_int(c_f_10, 1);
  int c_t_10[] = {  0,   1}; //   2
  psi_c_t[no_ps][10] = get_vector_from_array_int(c_t_10, 2);
  int c_d_10[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][10] = get_vector_from_array_int(c_d_10, 3);

  int c_p_11[] = {  6,  10,  11}; //   3
  psi_c_p[no_ps][11] = get_vector_from_array_int(c_p_11, 3);
  int c_f_11[] = {  1}; //   1
  psi_c_f[no_ps][11] = get_vector_from_array_int(c_f_11, 1);
  int c_t_11[] = {  2,   3}; //   2
  psi_c_t[no_ps][11] = get_vector_from_array_int(c_t_11, 2);
  int c_d_11[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][11] = get_vector_from_array_int(c_d_11, 3);

  int c_p_12[] = {  0,  12,  13}; //   3
  psi_c_p[no_ps][12] = get_vector_from_array_int(c_p_12, 3);
  int c_f_12[] = {  0}; //   1
  psi_c_f[no_ps][12] = get_vector_from_array_int(c_f_12, 1);
  int c_t_12[] = {  0,   1}; //   2
  psi_c_t[no_ps][12] = get_vector_from_array_int(c_t_12, 2);
  int c_d_12[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][12] = get_vector_from_array_int(c_d_12, 3);

  int c_p_13[] = {  0,  12,  14}; //   3
  psi_c_p[no_ps][13] = get_vector_from_array_int(c_p_13, 3);
  int c_f_13[] = {  0}; //   1
  psi_c_f[no_ps][13] = get_vector_from_array_int(c_f_13, 1);
  int c_t_13[] = {  0,   1}; //   2
  psi_c_t[no_ps][13] = get_vector_from_array_int(c_t_13, 2);
  int c_d_13[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][13] = get_vector_from_array_int(c_d_13, 3);

  int c_p_14[] = {  0,  12,  13}; //   3
  psi_c_p[no_ps][14] = get_vector_from_array_int(c_p_14, 3);
  int c_f_14[] = {  1}; //   1
  psi_c_f[no_ps][14] = get_vector_from_array_int(c_f_14, 1);
  int c_t_14[] = {  2,   3}; //   2
  psi_c_t[no_ps][14] = get_vector_from_array_int(c_t_14, 2);
  int c_d_14[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][14] = get_vector_from_array_int(c_d_14, 3);

  int c_p_15[] = {  0,  12,  14}; //   3
  psi_c_p[no_ps][15] = get_vector_from_array_int(c_p_15, 3);
  int c_f_15[] = {  1}; //   1
  psi_c_f[no_ps][15] = get_vector_from_array_int(c_f_15, 1);
  int c_t_15[] = {  2,   3}; //   2
  psi_c_t[no_ps][15] = get_vector_from_array_int(c_t_15, 2);
  int c_d_15[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][15] = get_vector_from_array_int(c_d_15, 3);

  int c_p_16[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][16] = get_vector_from_array_int(c_p_16, 3);
  int c_f_16[] = {  0}; //   1
  psi_c_f[no_ps][16] = get_vector_from_array_int(c_f_16, 1);
  int c_t_16[] = {  4,   5}; //   2
  psi_c_t[no_ps][16] = get_vector_from_array_int(c_t_16, 2);
  int c_d_16[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][16] = get_vector_from_array_int(c_d_16, 3);

  int c_p_17[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][17] = get_vector_from_array_int(c_p_17, 3);
  int c_f_17[] = {  0}; //   1
  psi_c_f[no_ps][17] = get_vector_from_array_int(c_f_17, 1);
  int c_t_17[] = {  4,   5}; //   2
  psi_c_t[no_ps][17] = get_vector_from_array_int(c_t_17, 2);
  int c_d_17[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][17] = get_vector_from_array_int(c_d_17, 3);

  int c_p_18[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][18] = get_vector_from_array_int(c_p_18, 3);
  int c_f_18[] = {  1}; //   1
  psi_c_f[no_ps][18] = get_vector_from_array_int(c_f_18, 1);
  int c_t_18[] = {  6,   7}; //   2
  psi_c_t[no_ps][18] = get_vector_from_array_int(c_t_18, 2);
  int c_d_18[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][18] = get_vector_from_array_int(c_d_18, 3);

  int c_p_19[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][19] = get_vector_from_array_int(c_p_19, 3);
  int c_f_19[] = {  1}; //   1
  psi_c_f[no_ps][19] = get_vector_from_array_int(c_f_19, 1);
  int c_t_19[] = {  6,   7}; //   2
  psi_c_t[no_ps][19] = get_vector_from_array_int(c_t_19, 2);
  int c_d_19[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][19] = get_vector_from_array_int(c_d_19, 3);

  int c_p_20[] = {  0,   4,   5}; //   3
  psi_c_p[no_ps][20] = get_vector_from_array_int(c_p_20, 3);
  int c_f_20[] = {  0}; //   1
  psi_c_f[no_ps][20] = get_vector_from_array_int(c_f_20, 1);
  int c_t_20[] = {  4,   5}; //   2
  psi_c_t[no_ps][20] = get_vector_from_array_int(c_t_20, 2);
  int c_d_20[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][20] = get_vector_from_array_int(c_d_20, 3);

  int c_p_21[] = {  0,   4,   5}; //   3
  psi_c_p[no_ps][21] = get_vector_from_array_int(c_p_21, 3);
  int c_f_21[] = {  1}; //   1
  psi_c_f[no_ps][21] = get_vector_from_array_int(c_f_21, 1);
  int c_t_21[] = {  6,   7}; //   2
  psi_c_t[no_ps][21] = get_vector_from_array_int(c_t_21, 2);
  int c_d_21[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][21] = get_vector_from_array_int(c_d_21, 3);

  int c_p_22[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][22] = get_vector_from_array_int(c_p_22, 3);
  int c_f_22[] = {  0}; //   1
  psi_c_f[no_ps][22] = get_vector_from_array_int(c_f_22, 1);
  int c_t_22[] = {  4,   5}; //   2
  psi_c_t[no_ps][22] = get_vector_from_array_int(c_t_22, 2);
  int c_d_22[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][22] = get_vector_from_array_int(c_d_22, 3);

  int c_p_23[] = {  6,   7,   9}; //   3
  psi_c_p[no_ps][23] = get_vector_from_array_int(c_p_23, 3);
  int c_f_23[] = {  0}; //   1
  psi_c_f[no_ps][23] = get_vector_from_array_int(c_f_23, 1);
  int c_t_23[] = {  4,   5}; //   2
  psi_c_t[no_ps][23] = get_vector_from_array_int(c_t_23, 2);
  int c_d_23[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][23] = get_vector_from_array_int(c_d_23, 3);

  int c_p_24[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][24] = get_vector_from_array_int(c_p_24, 3);
  int c_f_24[] = {  1}; //   1
  psi_c_f[no_ps][24] = get_vector_from_array_int(c_f_24, 1);
  int c_t_24[] = {  6,   7}; //   2
  psi_c_t[no_ps][24] = get_vector_from_array_int(c_t_24, 2);
  int c_d_24[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][24] = get_vector_from_array_int(c_d_24, 3);

  int c_p_25[] = {  6,   7,   9}; //   3
  psi_c_p[no_ps][25] = get_vector_from_array_int(c_p_25, 3);
  int c_f_25[] = {  1}; //   1
  psi_c_f[no_ps][25] = get_vector_from_array_int(c_f_25, 1);
  int c_t_25[] = {  6,   7}; //   2
  psi_c_t[no_ps][25] = get_vector_from_array_int(c_t_25, 2);
  int c_d_25[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][25] = get_vector_from_array_int(c_d_25, 3);

  int c_p_26[] = {  6,  10,  11}; //   3
  psi_c_p[no_ps][26] = get_vector_from_array_int(c_p_26, 3);
  int c_f_26[] = {  0}; //   1
  psi_c_f[no_ps][26] = get_vector_from_array_int(c_f_26, 1);
  int c_t_26[] = {  4,   5}; //   2
  psi_c_t[no_ps][26] = get_vector_from_array_int(c_t_26, 2);
  int c_d_26[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][26] = get_vector_from_array_int(c_d_26, 3);

  int c_p_27[] = {  6,  10,  11}; //   3
  psi_c_p[no_ps][27] = get_vector_from_array_int(c_p_27, 3);
  int c_f_27[] = {  1}; //   1
  psi_c_f[no_ps][27] = get_vector_from_array_int(c_f_27, 1);
  int c_t_27[] = {  6,   7}; //   2
  psi_c_t[no_ps][27] = get_vector_from_array_int(c_t_27, 2);
  int c_d_27[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][27] = get_vector_from_array_int(c_d_27, 3);

  int c_p_28[] = {  0,  12,  13}; //   3
  psi_c_p[no_ps][28] = get_vector_from_array_int(c_p_28, 3);
  int c_f_28[] = {  0}; //   1
  psi_c_f[no_ps][28] = get_vector_from_array_int(c_f_28, 1);
  int c_t_28[] = {  4,   5}; //   2
  psi_c_t[no_ps][28] = get_vector_from_array_int(c_t_28, 2);
  int c_d_28[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][28] = get_vector_from_array_int(c_d_28, 3);

  int c_p_29[] = {  0,  12,  14}; //   3
  psi_c_p[no_ps][29] = get_vector_from_array_int(c_p_29, 3);
  int c_f_29[] = {  0}; //   1
  psi_c_f[no_ps][29] = get_vector_from_array_int(c_f_29, 1);
  int c_t_29[] = {  4,   5}; //   2
  psi_c_t[no_ps][29] = get_vector_from_array_int(c_t_29, 2);
  int c_d_29[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][29] = get_vector_from_array_int(c_d_29, 3);

  int c_p_30[] = {  0,  12,  13}; //   3
  psi_c_p[no_ps][30] = get_vector_from_array_int(c_p_30, 3);
  int c_f_30[] = {  1}; //   1
  psi_c_f[no_ps][30] = get_vector_from_array_int(c_f_30, 1);
  int c_t_30[] = {  6,   7}; //   2
  psi_c_t[no_ps][30] = get_vector_from_array_int(c_t_30, 2);
  int c_d_30[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][30] = get_vector_from_array_int(c_d_30, 3);

  int c_p_31[] = {  0,  12,  14}; //   3
  psi_c_p[no_ps][31] = get_vector_from_array_int(c_p_31, 3);
  int c_f_31[] = {  1}; //   1
  psi_c_f[no_ps][31] = get_vector_from_array_int(c_f_31, 1);
  int c_t_31[] = {  6,   7}; //   2
  psi_c_t[no_ps][31] = get_vector_from_array_int(c_t_31, 2);
  int c_d_31[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][31] = get_vector_from_array_int(c_d_31, 3);

  int c_p_32[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][32] = get_vector_from_array_int(c_p_32, 3);
  int c_f_32[] = {  1}; //   1
  psi_c_f[no_ps][32] = get_vector_from_array_int(c_f_32, 1);
  int c_t_32[] = {  6,   8}; //   2
  psi_c_t[no_ps][32] = get_vector_from_array_int(c_t_32, 2);
  int c_d_32[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][32] = get_vector_from_array_int(c_d_32, 3);

  int c_p_33[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][33] = get_vector_from_array_int(c_p_33, 3);
  int c_f_33[] = {  1}; //   1
  psi_c_f[no_ps][33] = get_vector_from_array_int(c_f_33, 1);
  int c_t_33[] = {  6,   8}; //   2
  psi_c_t[no_ps][33] = get_vector_from_array_int(c_t_33, 2);
  int c_d_33[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][33] = get_vector_from_array_int(c_d_33, 3);

  int c_p_34[] = {  0,   1,   2}; //   3
  psi_c_p[no_ps][34] = get_vector_from_array_int(c_p_34, 3);
  int c_f_34[] = {  0}; //   1
  psi_c_f[no_ps][34] = get_vector_from_array_int(c_f_34, 1);
  int c_t_34[] = {  4,   9}; //   2
  psi_c_t[no_ps][34] = get_vector_from_array_int(c_t_34, 2);
  int c_d_34[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][34] = get_vector_from_array_int(c_d_34, 3);

  int c_p_35[] = {  0,   1,   3}; //   3
  psi_c_p[no_ps][35] = get_vector_from_array_int(c_p_35, 3);
  int c_f_35[] = {  0}; //   1
  psi_c_f[no_ps][35] = get_vector_from_array_int(c_f_35, 1);
  int c_t_35[] = {  4,   9}; //   2
  psi_c_t[no_ps][35] = get_vector_from_array_int(c_t_35, 2);
  int c_d_35[] = {  0,   1,   2}; //   3
  psi_c_d[no_ps][35] = get_vector_from_array_int(c_d_35, 3);

  int c_p_36[] = {  0,   4,   5}; //   3
  psi_c_p[no_ps][36] = get_vector_from_array_int(c_p_36, 3);
  int c_f_36[] = {  1}; //   1
  psi_c_f[no_ps][36] = get_vector_from_array_int(c_f_36, 1);
  int c_t_36[] = {  6,   8}; //   2
  psi_c_t[no_ps][36] = get_vector_from_array_int(c_t_36, 2);
  int c_d_36[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][36] = get_vector_from_array_int(c_d_36, 3);

  int c_p_37[] = {  0,   4,   5}; //   3
  psi_c_p[no_ps][37] = get_vector_from_array_int(c_p_37, 3);
  int c_f_37[] = {  0}; //   1
  psi_c_f[no_ps][37] = get_vector_from_array_int(c_f_37, 1);
  int c_t_37[] = {  4,   9}; //   2
  psi_c_t[no_ps][37] = get_vector_from_array_int(c_t_37, 2);
  int c_d_37[] = {  3,   4,   2}; //   3
  psi_c_d[no_ps][37] = get_vector_from_array_int(c_d_37, 3);

  int c_p_38[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][38] = get_vector_from_array_int(c_p_38, 3);
  int c_f_38[] = {  1}; //   1
  psi_c_f[no_ps][38] = get_vector_from_array_int(c_f_38, 1);
  int c_t_38[] = {  6,   8}; //   2
  psi_c_t[no_ps][38] = get_vector_from_array_int(c_t_38, 2);
  int c_d_38[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][38] = get_vector_from_array_int(c_d_38, 3);

  int c_p_39[] = {  6,   7,   9}; //   3
  psi_c_p[no_ps][39] = get_vector_from_array_int(c_p_39, 3);
  int c_f_39[] = {  1}; //   1
  psi_c_f[no_ps][39] = get_vector_from_array_int(c_f_39, 1);
  int c_t_39[] = {  6,   8}; //   2
  psi_c_t[no_ps][39] = get_vector_from_array_int(c_t_39, 2);
  int c_d_39[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][39] = get_vector_from_array_int(c_d_39, 3);

  int c_p_40[] = {  6,   7,   8}; //   3
  psi_c_p[no_ps][40] = get_vector_from_array_int(c_p_40, 3);
  int c_f_40[] = {  0}; //   1
  psi_c_f[no_ps][40] = get_vector_from_array_int(c_f_40, 1);
  int c_t_40[] = {  4,   9}; //   2
  psi_c_t[no_ps][40] = get_vector_from_array_int(c_t_40, 2);
  int c_d_40[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][40] = get_vector_from_array_int(c_d_40, 3);

  int c_p_41[] = {  6,   7,   9}; //   3
  psi_c_p[no_ps][41] = get_vector_from_array_int(c_p_41, 3);
  int c_f_41[] = {  0}; //   1
  psi_c_f[no_ps][41] = get_vector_from_array_int(c_f_41, 1);
  int c_t_41[] = {  4,   9}; //   2
  psi_c_t[no_ps][41] = get_vector_from_array_int(c_t_41, 2);
  int c_d_41[] = {  5,   6,   7}; //   3
  psi_c_d[no_ps][41] = get_vector_from_array_int(c_d_41, 3);

  int c_p_42[] = {  6,  10,  11}; //   3
  psi_c_p[no_ps][42] = get_vector_from_array_int(c_p_42, 3);
  int c_f_42[] = {  1}; //   1
  psi_c_f[no_ps][42] = get_vector_from_array_int(c_f_42, 1);
  int c_t_42[] = {  6,   8}; //   2
  psi_c_t[no_ps][42] = get_vector_from_array_int(c_t_42, 2);
  int c_d_42[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][42] = get_vector_from_array_int(c_d_42, 3);

  int c_p_43[] = {  6,  10,  11}; //   3
  psi_c_p[no_ps][43] = get_vector_from_array_int(c_p_43, 3);
  int c_f_43[] = {  0}; //   1
  psi_c_f[no_ps][43] = get_vector_from_array_int(c_f_43, 1);
  int c_t_43[] = {  4,   9}; //   2
  psi_c_t[no_ps][43] = get_vector_from_array_int(c_t_43, 2);
  int c_d_43[] = {  8,   9,   7}; //   3
  psi_c_d[no_ps][43] = get_vector_from_array_int(c_d_43, 3);

  int c_p_44[] = {  0,  12,  13}; //   3
  psi_c_p[no_ps][44] = get_vector_from_array_int(c_p_44, 3);
  int c_f_44[] = {  1}; //   1
  psi_c_f[no_ps][44] = get_vector_from_array_int(c_f_44, 1);
  int c_t_44[] = {  6,   8}; //   2
  psi_c_t[no_ps][44] = get_vector_from_array_int(c_t_44, 2);
  int c_d_44[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][44] = get_vector_from_array_int(c_d_44, 3);

  int c_p_45[] = {  0,  12,  14}; //   3
  psi_c_p[no_ps][45] = get_vector_from_array_int(c_p_45, 3);
  int c_f_45[] = {  1}; //   1
  psi_c_f[no_ps][45] = get_vector_from_array_int(c_f_45, 1);
  int c_t_45[] = {  6,   8}; //   2
  psi_c_t[no_ps][45] = get_vector_from_array_int(c_t_45, 2);
  int c_d_45[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][45] = get_vector_from_array_int(c_d_45, 3);

  int c_p_46[] = {  0,  12,  13}; //   3
  psi_c_p[no_ps][46] = get_vector_from_array_int(c_p_46, 3);
  int c_f_46[] = {  0}; //   1
  psi_c_f[no_ps][46] = get_vector_from_array_int(c_f_46, 1);
  int c_t_46[] = {  4,   9}; //   2
  psi_c_t[no_ps][46] = get_vector_from_array_int(c_t_46, 2);
  int c_d_46[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][46] = get_vector_from_array_int(c_d_46, 3);

  int c_p_47[] = {  0,  12,  14}; //   3
  psi_c_p[no_ps][47] = get_vector_from_array_int(c_p_47, 3);
  int c_f_47[] = {  0}; //   1
  psi_c_f[no_ps][47] = get_vector_from_array_int(c_f_47, 1);
  int c_t_47[] = {  4,   9}; //   2
  psi_c_t[no_ps][47] = get_vector_from_array_int(c_t_47, 2);
  int c_d_47[] = { 10,   7,   2}; //   3
  psi_c_d[no_ps][47] = get_vector_from_array_int(c_d_47, 3);

  int c_p_48[] = {  6,  15}; //   2
  psi_c_p[no_ps][48] = get_vector_from_array_int(c_p_48, 2);
  int c_f_48[] = {  2,   3}; //   2
  psi_c_f[no_ps][48] = get_vector_from_array_int(c_f_48, 2);
  int c_t_48[] = {  0,  10,  11}; //   3
  psi_c_t[no_ps][48] = get_vector_from_array_int(c_t_48, 3);
  int c_d_48[] = {  2,   7}; //   2
  psi_c_d[no_ps][48] = get_vector_from_array_int(c_d_48, 2);

  int c_p_49[] = {  6,  15}; //   2
  psi_c_p[no_ps][49] = get_vector_from_array_int(c_p_49, 2);
  int c_f_49[] = {  4,   5}; //   2
  psi_c_f[no_ps][49] = get_vector_from_array_int(c_f_49, 2);
  int c_t_49[] = {  2,  12,  13}; //   3
  psi_c_t[no_ps][49] = get_vector_from_array_int(c_t_49, 3);
  int c_d_49[] = {  2,   7}; //   2
  psi_c_d[no_ps][49] = get_vector_from_array_int(c_d_49, 2);

  int c_p_50[] = {  0,   1,   2,  16}; //   4
  psi_c_p[no_ps][50] = get_vector_from_array_int(c_p_50, 4);
  int c_f_50[] = {}; //   0
  psi_c_f[no_ps][50] = get_vector_from_array_int(c_f_50, 0);
  int c_t_50[] = { 14}; //   1
  psi_c_t[no_ps][50] = get_vector_from_array_int(c_t_50, 1);
  int c_d_50[] = { 11,   0,   1,   2}; //   4
  psi_c_d[no_ps][50] = get_vector_from_array_int(c_d_50, 4);

  int c_p_51[] = {  0,   1,   3,  16}; //   4
  psi_c_p[no_ps][51] = get_vector_from_array_int(c_p_51, 4);
  int c_f_51[] = {}; //   0
  psi_c_f[no_ps][51] = get_vector_from_array_int(c_f_51, 0);
  int c_t_51[] = { 14}; //   1
  psi_c_t[no_ps][51] = get_vector_from_array_int(c_t_51, 1);
  int c_d_51[] = { 11,   0,   1,   2}; //   4
  psi_c_d[no_ps][51] = get_vector_from_array_int(c_d_51, 4);

  int c_p_52[] = {  0,   4,   5,  16}; //   4
  psi_c_p[no_ps][52] = get_vector_from_array_int(c_p_52, 4);
  int c_f_52[] = {}; //   0
  psi_c_f[no_ps][52] = get_vector_from_array_int(c_f_52, 0);
  int c_t_52[] = { 14}; //   1
  psi_c_t[no_ps][52] = get_vector_from_array_int(c_t_52, 1);
  int c_d_52[] = { 11,   3,   4,   2}; //   4
  psi_c_d[no_ps][52] = get_vector_from_array_int(c_d_52, 4);

  int c_p_53[] = {  6,   7,   8,  16}; //   4
  psi_c_p[no_ps][53] = get_vector_from_array_int(c_p_53, 4);
  int c_f_53[] = {}; //   0
  psi_c_f[no_ps][53] = get_vector_from_array_int(c_f_53, 0);
  int c_t_53[] = { 14}; //   1
  psi_c_t[no_ps][53] = get_vector_from_array_int(c_t_53, 1);
  int c_d_53[] = { 11,   5,   6,   7}; //   4
  psi_c_d[no_ps][53] = get_vector_from_array_int(c_d_53, 4);

  int c_p_54[] = {  6,   7,   9,  16}; //   4
  psi_c_p[no_ps][54] = get_vector_from_array_int(c_p_54, 4);
  int c_f_54[] = {}; //   0
  psi_c_f[no_ps][54] = get_vector_from_array_int(c_f_54, 0);
  int c_t_54[] = { 14}; //   1
  psi_c_t[no_ps][54] = get_vector_from_array_int(c_t_54, 1);
  int c_d_54[] = { 11,   5,   6,   7}; //   4
  psi_c_d[no_ps][54] = get_vector_from_array_int(c_d_54, 4);

  int c_p_55[] = {  6,  10,  11,  16}; //   4
  psi_c_p[no_ps][55] = get_vector_from_array_int(c_p_55, 4);
  int c_f_55[] = {}; //   0
  psi_c_f[no_ps][55] = get_vector_from_array_int(c_f_55, 0);
  int c_t_55[] = { 14}; //   1
  psi_c_t[no_ps][55] = get_vector_from_array_int(c_t_55, 1);
  int c_d_55[] = { 11,   8,   9,   7}; //   4
  psi_c_d[no_ps][55] = get_vector_from_array_int(c_d_55, 4);

  int c_p_56[] = {  0,  12,  13,  16}; //   4
  psi_c_p[no_ps][56] = get_vector_from_array_int(c_p_56, 4);
  int c_f_56[] = {}; //   0
  psi_c_f[no_ps][56] = get_vector_from_array_int(c_f_56, 0);
  int c_t_56[] = { 14}; //   1
  psi_c_t[no_ps][56] = get_vector_from_array_int(c_t_56, 1);
  int c_d_56[] = { 11,  10,   7,   2}; //   4
  psi_c_d[no_ps][56] = get_vector_from_array_int(c_d_56, 4);

  int c_p_57[] = {  0,  12,  14,  16}; //   4
  psi_c_p[no_ps][57] = get_vector_from_array_int(c_p_57, 4);
  int c_f_57[] = {}; //   0
  psi_c_f[no_ps][57] = get_vector_from_array_int(c_f_57, 0);
  int c_t_57[] = { 14}; //   1
  psi_c_t[no_ps][57] = get_vector_from_array_int(c_t_57, 1);
  int c_d_57[] = { 11,  10,   7,   2}; //   4
  psi_c_d[no_ps][57] = get_vector_from_array_int(c_d_57, 4);

  int c_p_58[] = {  6,  15}; //   2
  psi_c_p[no_ps][58] = get_vector_from_array_int(c_p_58, 2);
  int c_f_58[] = {  4,   5}; //   2
  psi_c_f[no_ps][58] = get_vector_from_array_int(c_f_58, 2);
  int c_t_58[] = {  2,  12,  15}; //   3
  psi_c_t[no_ps][58] = get_vector_from_array_int(c_t_58, 3);
  int c_d_58[] = {  2,   7}; //   2
  psi_c_d[no_ps][58] = get_vector_from_array_int(c_d_58, 2);

  int c_p_59[] = {  6,  15}; //   2
  psi_c_p[no_ps][59] = get_vector_from_array_int(c_p_59, 2);
  int c_f_59[] = {  2,   3}; //   2
  psi_c_f[no_ps][59] = get_vector_from_array_int(c_f_59, 2);
  int c_t_59[] = {  0,  10,  16}; //   3
  psi_c_t[no_ps][59] = get_vector_from_array_int(c_t_59, 3);
  int c_d_59[] = {  2,   7}; //   2
  psi_c_d[no_ps][59] = get_vector_from_array_int(c_d_59, 2);

  int c_p_60[] = {  6,  15}; //   2
  psi_c_p[no_ps][60] = get_vector_from_array_int(c_p_60, 2);
  int c_f_60[] = {  6,   7}; //   2
  psi_c_f[no_ps][60] = get_vector_from_array_int(c_f_60, 2);
  int c_t_60[] = { 17,  18,  19}; //   3
  psi_c_t[no_ps][60] = get_vector_from_array_int(c_t_60, 3);
  int c_d_60[] = {  2,   7}; //   2
  psi_c_d[no_ps][60] = get_vector_from_array_int(c_d_60, 2);

  int c_p_61[] = {  6,  15}; //   2
  psi_c_p[no_ps][61] = get_vector_from_array_int(c_p_61, 2);
  int c_f_61[] = {  6,   7}; //   2
  psi_c_f[no_ps][61] = get_vector_from_array_int(c_f_61, 2);
  int c_t_61[] = { 17,  18,  20}; //   3
  psi_c_t[no_ps][61] = get_vector_from_array_int(c_t_61, 3);
  int c_d_61[] = {  2,   7}; //   2
  psi_c_d[no_ps][61] = get_vector_from_array_int(c_d_61, 2);

  int c_p_62[] = { 17,  18,  19,  20}; //   4
  psi_c_p[no_ps][62] = get_vector_from_array_int(c_p_62, 4);
  int c_f_62[] = {}; //   0
  psi_c_f[no_ps][62] = get_vector_from_array_int(c_f_62, 0);
  int c_t_62[] = { 21}; //   1
  psi_c_t[no_ps][62] = get_vector_from_array_int(c_t_62, 1);
  int c_d_62[] = {  0,   1,   2,  11}; //   4
  psi_c_d[no_ps][62] = get_vector_from_array_int(c_d_62, 4);

  int c_p_63[] = { 17,  18,  19,  21}; //   4
  psi_c_p[no_ps][63] = get_vector_from_array_int(c_p_63, 4);
  int c_f_63[] = {}; //   0
  psi_c_f[no_ps][63] = get_vector_from_array_int(c_f_63, 0);
  int c_t_63[] = { 21}; //   1
  psi_c_t[no_ps][63] = get_vector_from_array_int(c_t_63, 1);
  int c_d_63[] = {  0,   1,   2,  11}; //   4
  psi_c_d[no_ps][63] = get_vector_from_array_int(c_d_63, 4);

  int c_p_64[] = { 17,  18,  22,  23}; //   4
  psi_c_p[no_ps][64] = get_vector_from_array_int(c_p_64, 4);
  int c_f_64[] = {}; //   0
  psi_c_f[no_ps][64] = get_vector_from_array_int(c_f_64, 0);
  int c_t_64[] = { 21}; //   1
  psi_c_t[no_ps][64] = get_vector_from_array_int(c_t_64, 1);
  int c_d_64[] = {  3,   4,   2,  11}; //   4
  psi_c_d[no_ps][64] = get_vector_from_array_int(c_d_64, 4);

  int c_p_65[] = { 17,  24,  25,  26}; //   4
  psi_c_p[no_ps][65] = get_vector_from_array_int(c_p_65, 4);
  int c_f_65[] = {}; //   0
  psi_c_f[no_ps][65] = get_vector_from_array_int(c_f_65, 0);
  int c_t_65[] = { 21}; //   1
  psi_c_t[no_ps][65] = get_vector_from_array_int(c_t_65, 1);
  int c_d_65[] = {  5,   6,   7,  11}; //   4
  psi_c_d[no_ps][65] = get_vector_from_array_int(c_d_65, 4);

  int c_p_66[] = { 17,  24,  25,  27}; //   4
  psi_c_p[no_ps][66] = get_vector_from_array_int(c_p_66, 4);
  int c_f_66[] = {}; //   0
  psi_c_f[no_ps][66] = get_vector_from_array_int(c_f_66, 0);
  int c_t_66[] = { 21}; //   1
  psi_c_t[no_ps][66] = get_vector_from_array_int(c_t_66, 1);
  int c_d_66[] = {  5,   6,   7,  11}; //   4
  psi_c_d[no_ps][66] = get_vector_from_array_int(c_d_66, 4);

  int c_p_67[] = { 17,  24,  28,  29}; //   4
  psi_c_p[no_ps][67] = get_vector_from_array_int(c_p_67, 4);
  int c_f_67[] = {}; //   0
  psi_c_f[no_ps][67] = get_vector_from_array_int(c_f_67, 0);
  int c_t_67[] = { 21}; //   1
  psi_c_t[no_ps][67] = get_vector_from_array_int(c_t_67, 1);
  int c_d_67[] = {  8,   9,   7,  11}; //   4
  psi_c_d[no_ps][67] = get_vector_from_array_int(c_d_67, 4);

  int c_p_68[] = { 17,  18,  30,  31}; //   4
  psi_c_p[no_ps][68] = get_vector_from_array_int(c_p_68, 4);
  int c_f_68[] = {}; //   0
  psi_c_f[no_ps][68] = get_vector_from_array_int(c_f_68, 0);
  int c_t_68[] = { 21}; //   1
  psi_c_t[no_ps][68] = get_vector_from_array_int(c_t_68, 1);
  int c_d_68[] = { 10,   7,   2,  11}; //   4
  psi_c_d[no_ps][68] = get_vector_from_array_int(c_d_68, 4);

  int c_p_69[] = { 17,  18,  30,  32}; //   4
  psi_c_p[no_ps][69] = get_vector_from_array_int(c_p_69, 4);
  int c_f_69[] = {}; //   0
  psi_c_f[no_ps][69] = get_vector_from_array_int(c_f_69, 0);
  int c_t_69[] = { 21}; //   1
  psi_c_t[no_ps][69] = get_vector_from_array_int(c_t_69, 1);
  int c_d_69[] = { 10,   7,   2,  11}; //   4
  psi_c_d[no_ps][69] = get_vector_from_array_int(c_d_69, 4);

  int c_p_70[] = {  6,  15}; //   2
  psi_c_p[no_ps][70] = get_vector_from_array_int(c_p_70, 2);
  int c_f_70[] = {  8,   0}; //   2
  psi_c_f[no_ps][70] = get_vector_from_array_int(c_f_70, 2);
  int c_t_70[] = {  4,   5,  22}; //   3
  psi_c_t[no_ps][70] = get_vector_from_array_int(c_t_70, 3);
  int c_d_70[] = {  2,   7}; //   2
  psi_c_d[no_ps][70] = get_vector_from_array_int(c_d_70, 2);

  int c_p_71[] = {  6,  15}; //   2
  psi_c_p[no_ps][71] = get_vector_from_array_int(c_p_71, 2);
  int c_f_71[] = {  8,   1}; //   2
  psi_c_f[no_ps][71] = get_vector_from_array_int(c_f_71, 2);
  int c_t_71[] = {  6,   7,  23}; //   3
  psi_c_t[no_ps][71] = get_vector_from_array_int(c_t_71, 3);
  int c_d_71[] = {  2,   7}; //   2
  psi_c_d[no_ps][71] = get_vector_from_array_int(c_d_71, 2);

  int c_p_72[] = {  6,  15}; //   2
  psi_c_p[no_ps][72] = get_vector_from_array_int(c_p_72, 2);
  int c_f_72[] = {  9,  10}; //   2
  psi_c_f[no_ps][72] = get_vector_from_array_int(c_f_72, 2);
  int c_t_72[] = {  4,  24,  25}; //   3
  psi_c_t[no_ps][72] = get_vector_from_array_int(c_t_72, 3);
  int c_d_72[] = {  2,   7}; //   2
  psi_c_d[no_ps][72] = get_vector_from_array_int(c_d_72, 2);

  int c_p_73[] = {  6,  15}; //   2
  psi_c_p[no_ps][73] = get_vector_from_array_int(c_p_73, 2);
  int c_f_73[] = { 11,  12}; //   2
  psi_c_f[no_ps][73] = get_vector_from_array_int(c_f_73, 2);
  int c_t_73[] = {  6,  26,  27}; //   3
  psi_c_t[no_ps][73] = get_vector_from_array_int(c_t_73, 3);
  int c_d_73[] = {  2,   7}; //   2
  psi_c_d[no_ps][73] = get_vector_from_array_int(c_d_73, 2);

  int c_p_74[] = {  6,  15}; //   2
  psi_c_p[no_ps][74] = get_vector_from_array_int(c_p_74, 2);
  int c_f_74[] = { 11,  12}; //   2
  psi_c_f[no_ps][74] = get_vector_from_array_int(c_f_74, 2);
  int c_t_74[] = {  6,  26,  28}; //   3
  psi_c_t[no_ps][74] = get_vector_from_array_int(c_t_74, 3);
  int c_d_74[] = {  2,   7}; //   2
  psi_c_d[no_ps][74] = get_vector_from_array_int(c_d_74, 2);

  int c_p_75[] = {  6,  15}; //   2
  psi_c_p[no_ps][75] = get_vector_from_array_int(c_p_75, 2);
  int c_f_75[] = {  9,  10}; //   2
  psi_c_f[no_ps][75] = get_vector_from_array_int(c_f_75, 2);
  int c_t_75[] = {  4,  24,  29}; //   3
  psi_c_t[no_ps][75] = get_vector_from_array_int(c_t_75, 3);
  int c_d_75[] = {  2,   7}; //   2
  psi_c_d[no_ps][75] = get_vector_from_array_int(c_d_75, 2);

  int c_p_76[] = { 17,  24,  33}; //   3
  psi_c_p[no_ps][76] = get_vector_from_array_int(c_p_76, 3);
  int c_f_76[] = {  7}; //   1
  psi_c_f[no_ps][76] = get_vector_from_array_int(c_f_76, 1);
  int c_t_76[] = { 17,  30}; //   2
  psi_c_t[no_ps][76] = get_vector_from_array_int(c_t_76, 2);
  int c_d_76[] = {  2,   7,  11}; //   3
  psi_c_d[no_ps][76] = get_vector_from_array_int(c_d_76, 3);

  int c_p_77[] = {  6,  34,  33}; //   3
  psi_c_p[no_ps][77] = get_vector_from_array_int(c_p_77, 3);
  int c_f_77[] = {  7}; //   1
  psi_c_f[no_ps][77] = get_vector_from_array_int(c_f_77, 1);
  int c_t_77[] = { 17,  18}; //   2
  psi_c_t[no_ps][77] = get_vector_from_array_int(c_t_77, 2);
  int c_d_77[] = {  2,  11,   7}; //   3
  psi_c_d[no_ps][77] = get_vector_from_array_int(c_d_77, 3);

  int c_p_78[] = {  6,  15,  35}; //   3
  psi_c_p[no_ps][78] = get_vector_from_array_int(c_p_78, 3);
  int c_f_78[] = { 13}; //   1
  psi_c_f[no_ps][78] = get_vector_from_array_int(c_f_78, 1);
  int c_t_78[] = { 14,  31}; //   2
  psi_c_t[no_ps][78] = get_vector_from_array_int(c_t_78, 2);
  int c_d_78[] = { 11,   2,   7}; //   3
  psi_c_d[no_ps][78] = get_vector_from_array_int(c_d_78, 3);

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
