#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppwxw02/header/ppwxw02.phasespace.h"
void ppwxw02_ag_psp_real(int no_ps, int zero, phasespace_set & psi){
  static Logger logger("ppwxw02_ag_psp_real");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_no_map[no_ps] == 0){}
  else if (psi_no_map[no_ps] ==  2){ppwxw02_ag_psp_120_gd_wpwmd(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  3){ppwxw02_ag_psp_120_gu_wpwmu(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  4){ppwxw02_ag_psp_120_gb_wpwmb(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  5){ppwxw02_ag_psp_120_gdx_wpwmdx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  6){ppwxw02_ag_psp_120_gux_wpwmux(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  7){ppwxw02_ag_psp_120_gbx_wpwmbx(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  8){ppwxw02_ag_psp_120_ddx_wpwmg(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] ==  9){ppwxw02_ag_psp_120_uux_wpwmg(no_ps, zero, psi);}
  else if (psi_no_map[no_ps] == 10){ppwxw02_ag_psp_120_bbx_wpwmg(no_ps, zero, psi);}

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
