#include "../include/classes.cxx"
#include "../include/definitions.phasespace.set.cxx"
#include "../ppzz02/header/ppzz02.phasespace.h"
void ppzz02_ag_psp_220_uux_zzgg(int no_ps, int zero, phasespace_set & psi){
  static Logger logger("ppzz02_ag_psp_220_uux_zzgg");
  logger << LOG_DEBUG_VERBOSE << "called" << endl;
  if (psi_xbp[no_ps][5] == nullvector){psi_xbp[no_ps][5] = psi_xbp[no_ps][1] - psi_xbp[no_ps][4];}
  if (psi_xbs[no_ps][5] == 0.){psi_xbs[no_ps][5] = psi_xbp[no_ps][5].m2();}
  if (psi_xbp[no_ps][6] == nullvector){psi_xbp[no_ps][6] = psi_xbp[no_ps][2] - psi_xbp[no_ps][4];}
  if (psi_xbs[no_ps][6] == 0.){psi_xbs[no_ps][6] = psi_xbp[no_ps][6].m2();}
  if (psi_xbp[no_ps][9] == nullvector){psi_xbp[no_ps][9] = psi_xbp[no_ps][1] - psi_xbp[no_ps][8];}
  if (psi_xbs[no_ps][9] == 0.){psi_xbs[no_ps][9] = psi_xbp[no_ps][9].m2();}
  if (psi_xbp[no_ps][10] == nullvector){psi_xbp[no_ps][10] = psi_xbp[no_ps][2] - psi_xbp[no_ps][8];}
  if (psi_xbs[no_ps][10] == 0.){psi_xbs[no_ps][10] = psi_xbp[no_ps][10].m2();}
  if (psi_xbp[no_ps][12] == nullvector){psi_xbp[no_ps][12] = psi_xbp[no_ps][4] + psi_xbp[no_ps][8];}
  if (psi_xbs[no_ps][12] == 0.){psi_xbs[no_ps][12] = psi_xbp[no_ps][12].m2();}
  if (psi_xbsqrts[no_ps][12] == 0.){psi_xbsqrts[no_ps][12] = sqrt(psi_xbs[no_ps][12]);}
  if (psi_xbp[no_ps][17] == nullvector){psi_xbp[no_ps][17] = psi_xbp[no_ps][1] - psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][17] == 0.){psi_xbs[no_ps][17] = psi_xbp[no_ps][17].m2();}
  if (psi_xbp[no_ps][18] == nullvector){psi_xbp[no_ps][18] = psi_xbp[no_ps][2] - psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][18] == 0.){psi_xbs[no_ps][18] = psi_xbp[no_ps][18].m2();}
  if (psi_xbp[no_ps][20] == nullvector){psi_xbp[no_ps][20] = psi_xbp[no_ps][4] + psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][20] == 0.){psi_xbs[no_ps][20] = psi_xbp[no_ps][20].m2();}
  if (psi_xbsqrts[no_ps][20] == 0.){psi_xbsqrts[no_ps][20] = sqrt(psi_xbs[no_ps][20]);}
  if (psi_xbp[no_ps][24] == nullvector){psi_xbp[no_ps][24] = psi_xbp[no_ps][8] + psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][24] == 0.){psi_xbs[no_ps][24] = psi_xbp[no_ps][24].m2();}
  if (psi_xbsqrts[no_ps][24] == 0.){psi_xbsqrts[no_ps][24] = sqrt(psi_xbs[no_ps][24]);}
  if (psi_xbp[no_ps][33] == nullvector){psi_xbp[no_ps][33] = psi_xbp[no_ps][1] - psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][33] == 0.){psi_xbs[no_ps][33] = psi_xbp[no_ps][33].m2();}
  if (psi_xbp[no_ps][34] == nullvector){psi_xbp[no_ps][34] = psi_xbp[no_ps][2] - psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][34] == 0.){psi_xbs[no_ps][34] = psi_xbp[no_ps][34].m2();}
  if (psi_xbp[no_ps][36] == nullvector){psi_xbp[no_ps][36] = psi_xbp[no_ps][4] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][36] == 0.){psi_xbs[no_ps][36] = psi_xbp[no_ps][36].m2();}
  if (psi_xbsqrts[no_ps][36] == 0.){psi_xbsqrts[no_ps][36] = sqrt(psi_xbs[no_ps][36]);}
  if (psi_xbp[no_ps][40] == nullvector){psi_xbp[no_ps][40] = psi_xbp[no_ps][8] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][40] == 0.){psi_xbs[no_ps][40] = psi_xbp[no_ps][40].m2();}
  if (psi_xbsqrts[no_ps][40] == 0.){psi_xbsqrts[no_ps][40] = sqrt(psi_xbs[no_ps][40]);}
  if (psi_xbp[no_ps][48] == nullvector){psi_xbp[no_ps][48] = psi_xbp[no_ps][16] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][48] == 0.){psi_xbs[no_ps][48] = psi_xbp[no_ps][48].m2();}
  if (psi_xbsqrts[no_ps][48] == 0.){psi_xbsqrts[no_ps][48] = sqrt(psi_xbs[no_ps][48]);}
  if (psi_xbp[no_ps][13] == nullvector){psi_xbp[no_ps][13] = psi_xbp[no_ps][1] - psi_xbp[no_ps][4] - psi_xbp[no_ps][8];}
  if (psi_xbs[no_ps][13] == 0.){psi_xbs[no_ps][13] = psi_xbp[no_ps][13].m2();}
  if (psi_xbp[no_ps][21] == nullvector){psi_xbp[no_ps][21] = psi_xbp[no_ps][1] - psi_xbp[no_ps][4] - psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][21] == 0.){psi_xbs[no_ps][21] = psi_xbp[no_ps][21].m2();}
  if (psi_xbp[no_ps][25] == nullvector){psi_xbp[no_ps][25] = psi_xbp[no_ps][1] - psi_xbp[no_ps][8] - psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][25] == 0.){psi_xbs[no_ps][25] = psi_xbp[no_ps][25].m2();}
  if (psi_xbp[no_ps][28] == nullvector){psi_xbp[no_ps][28] = psi_xbp[no_ps][4] + psi_xbp[no_ps][8] + psi_xbp[no_ps][16];}
  if (psi_xbs[no_ps][28] == 0.){psi_xbs[no_ps][28] = psi_xbp[no_ps][28].m2();}
  if (psi_xbp[no_ps][37] == nullvector){psi_xbp[no_ps][37] = psi_xbp[no_ps][1] - psi_xbp[no_ps][4] - psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][37] == 0.){psi_xbs[no_ps][37] = psi_xbp[no_ps][37].m2();}
  if (psi_xbp[no_ps][41] == nullvector){psi_xbp[no_ps][41] = psi_xbp[no_ps][1] - psi_xbp[no_ps][8] - psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][41] == 0.){psi_xbs[no_ps][41] = psi_xbp[no_ps][41].m2();}
  if (psi_xbp[no_ps][44] == nullvector){psi_xbp[no_ps][44] = psi_xbp[no_ps][4] + psi_xbp[no_ps][8] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][44] == 0.){psi_xbs[no_ps][44] = psi_xbp[no_ps][44].m2();}
  if (psi_xbp[no_ps][49] == nullvector){psi_xbp[no_ps][49] = psi_xbp[no_ps][1] - psi_xbp[no_ps][16] - psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][49] == 0.){psi_xbs[no_ps][49] = psi_xbp[no_ps][49].m2();}
  if (psi_xbp[no_ps][50] == nullvector){psi_xbp[no_ps][50] = psi_xbp[no_ps][2] - psi_xbp[no_ps][16] - psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][50] == 0.){psi_xbs[no_ps][50] = psi_xbp[no_ps][50].m2();}
  if (psi_xbp[no_ps][52] == nullvector){psi_xbp[no_ps][52] = psi_xbp[no_ps][4] + psi_xbp[no_ps][16] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][52] == 0.){psi_xbs[no_ps][52] = psi_xbp[no_ps][52].m2();}
  if (psi_xbp[no_ps][56] == nullvector){psi_xbp[no_ps][56] = psi_xbp[no_ps][8] + psi_xbp[no_ps][16] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][56] == 0.){psi_xbs[no_ps][56] = psi_xbp[no_ps][56].m2();}
  if (psi_xbp[no_ps][60] == nullvector){psi_xbp[no_ps][60] = psi_xbp[no_ps][4] + psi_xbp[no_ps][8] + psi_xbp[no_ps][16] + psi_xbp[no_ps][32];}
  if (psi_xbs[no_ps][60] == 0.){psi_xbs[no_ps][60] = psi_xbp[no_ps][60].m2();}

  psi_v_smin[no_ps][  0] = psi_smin_opt[no_ps][48]; // 10 times
  psi_v_smin[no_ps][  1] = psi_smin_opt[no_ps][24]; // 4 times
  psi_v_smin[no_ps][  2] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][24], 2), psi_smin_opt[no_ps][56]); // 2 times
  psi_v_smin[no_ps][  3] = psi_smin_opt[no_ps][40]; // 4 times
  psi_v_smin[no_ps][  4] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][16] + psi_xbsqrts[no_ps][40], 2), psi_smin_opt[no_ps][56]); // 2 times
  psi_v_smin[no_ps][  5] = psi_smin_opt[no_ps][12]; // 4 times
  psi_v_smin[no_ps][  6] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][16] + psi_xbsqrts[no_ps][12], 2), psi_smin_opt[no_ps][28]); // 2 times
  psi_v_smin[no_ps][  7] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][8] + psi_xbsqrts[no_ps][48], 2), psi_smin_opt[no_ps][56]); // 5 times
  psi_v_smin[no_ps][  8] = psi_smin_opt[no_ps][20]; // 4 times
  psi_v_smin[no_ps][  9] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][8] + psi_xbsqrts[no_ps][20], 2), psi_smin_opt[no_ps][28]); // 2 times
  psi_v_smin[no_ps][ 10] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][12], 2), psi_smin_opt[no_ps][44]); // 2 times
  psi_v_smin[no_ps][ 11] = psi_smin_opt[no_ps][36]; // 4 times
  psi_v_smin[no_ps][ 12] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][8] + psi_xbsqrts[no_ps][36], 2), psi_smin_opt[no_ps][44]); // 2 times
  psi_v_smin[no_ps][ 13] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][32] + psi_xbsqrts[no_ps][20], 2), psi_smin_opt[no_ps][52]); // 2 times
  psi_v_smin[no_ps][ 14] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][16] + psi_xbsqrts[no_ps][36], 2), psi_smin_opt[no_ps][52]); // 2 times
  psi_v_smin[no_ps][ 15] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][4] + psi_xbsqrts[no_ps][48], 2), psi_smin_opt[no_ps][52]); // 5 times
  psi_v_smin[no_ps][ 16] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][4] + psi_xbsqrts[no_ps][24], 2), psi_smin_opt[no_ps][28]); // 2 times
  psi_v_smin[no_ps][ 17] = GSL_MAX_DBL(pow(psi_sqrtsmin_opt[no_ps][4] + psi_xbsqrts[no_ps][40], 2), psi_smin_opt[no_ps][44]); // 2 times

  psi_v_smax[no_ps][  0] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][12], 2); // 10 times
  psi_v_smax[no_ps][  1] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][36], 2); // 4 times
  psi_v_smax[no_ps][  2] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][4], 2); // 9 times
  psi_v_smax[no_ps][  3] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][20], 2); // 4 times
  psi_v_smax[no_ps][  4] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][48], 2); // 4 times
  psi_v_smax[no_ps][  5] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][32], 2); // 6 times
  psi_v_smax[no_ps][  6] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][40], 2); // 4 times
  psi_v_smax[no_ps][  7] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][16], 2); // 6 times
  psi_v_smax[no_ps][  8] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][24], 2); // 4 times
  psi_v_smax[no_ps][  9] = pow(psi_xbsqrts[no_ps][0] - psi_sqrtsmin_opt[no_ps][8], 2); // 9 times

  //  vector<double> g_p(1);
  {psi_g_p[no_ps][  0] = psi.g_propagator(no_ps,   0,  48, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0]); /* npp 2 */} // 6 times

  //  vector<double> g_f(18);
  {psi_g_f[no_ps][  0] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  1], psi_v_smax[no_ps][  1]); /* nfp 2 */} // 4 times
  {psi_g_f[no_ps][  1] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  2], psi_v_smax[no_ps][  2]); /* nfp 3 */} // 2 times
  {psi_g_f[no_ps][  2] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  3]); /* nfp 2 */} // 4 times
  {psi_g_f[no_ps][  3] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  4], psi_v_smax[no_ps][  2]); /* nfp 3 */} // 2 times
  {psi_g_f[no_ps][  4] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  5], psi_v_smax[no_ps][  4]); /* nfp 2 */} // 4 times
  {psi_g_f[no_ps][  5] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  6], psi_v_smax[no_ps][  5]); /* nfp 3 */} // 2 times
  {psi_g_f[no_ps][  6] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0]); /* nfp 2 */} // 4 times
  {psi_g_f[no_ps][  7] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  7], psi_v_smax[no_ps][  2]); /* nfp 3 */} // 5 times
  {psi_g_f[no_ps][  8] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  8], psi_v_smax[no_ps][  6]); /* nfp 2 */} // 4 times
  {psi_g_f[no_ps][  9] = psi.g_timelikeinvariant(psi_v_smin[no_ps][  9], psi_v_smax[no_ps][  5]); /* nfp 3 */} // 2 times
  {psi_g_f[no_ps][ 10] = psi.g_timelikeinvariant(psi_v_smin[no_ps][ 10], psi_v_smax[no_ps][  7]); /* nfp 3 */} // 2 times
  {psi_g_f[no_ps][ 11] = psi.g_timelikeinvariant(psi_v_smin[no_ps][ 11], psi_v_smax[no_ps][  8]); /* nfp 2 */} // 4 times
  {psi_g_f[no_ps][ 12] = psi.g_timelikeinvariant(psi_v_smin[no_ps][ 12], psi_v_smax[no_ps][  7]); /* nfp 3 */} // 2 times
  {psi_g_f[no_ps][ 13] = psi.g_timelikeinvariant(psi_v_smin[no_ps][ 13], psi_v_smax[no_ps][  9]); /* nfp 3 */} // 2 times
  {psi_g_f[no_ps][ 14] = psi.g_timelikeinvariant(psi_v_smin[no_ps][ 14], psi_v_smax[no_ps][  9]); /* nfp 3 */} // 2 times
  {psi_g_f[no_ps][ 15] = psi.g_timelikeinvariant(psi_v_smin[no_ps][ 15], psi_v_smax[no_ps][  9]); /* nfp 3 */} // 5 times
  {psi_g_f[no_ps][ 16] = psi.g_timelikeinvariant(psi_v_smin[no_ps][ 16], psi_v_smax[no_ps][  5]); /* nfp 3 */} // 2 times
  {psi_g_f[no_ps][ 17] = psi.g_timelikeinvariant(psi_v_smin[no_ps][ 17], psi_v_smax[no_ps][  7]); /* nfp 3 */} // 2 times

  //  vector<double> g_t(46);
  {psi_g_t[no_ps][  0] = psi.g_tchannel_opt(no_ps,   0,  60,   1,   2,   4,  56); /* ntp 0 */} // 8 times
  {psi_g_t[no_ps][  1] = psi.g_tchannel_opt(no_ps,   0,  56,   2,   5,  32,  24); /* ntp 1 */} // 2 times
  {psi_g_t[no_ps][  2] = psi.g_tchannel(no_ps,   0,  24,   5,  34,   8,  16); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][  3] = psi.g_tchannel_opt(no_ps,   0,  56,   2,   5,  16,  40); /* ntp 1 */} // 2 times
  {psi_g_t[no_ps][  4] = psi.g_tchannel(no_ps,   0,  40,   5,  18,   8,  32); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][  5] = psi.g_tchannel(no_ps,   0,  40,   5,  18,  32,   8); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][  6] = psi.g_tchannel_opt(no_ps,   0,  60,   1,   2,  32,  28); /* ntp 0 */} // 6 times
  {psi_g_t[no_ps][  7] = psi.g_tchannel_opt(no_ps,   0,  28,   2,  33,  16,  12); /* ntp 1 */} // 2 times
  {psi_g_t[no_ps][  8] = psi.g_tchannel(no_ps,   0,  12,  33,  18,   4,   8); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][  9] = psi.g_tchannel(no_ps,   0,  24,   5,  34,  16,   8); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 10] = psi.g_tchannel_opt(no_ps,   0,  56,   2,   5,   8,  48); /* ntp 1 */} // 3 times
  {psi_g_t[no_ps][ 11] = psi.g_tchannel(no_ps,   0,  48,   5,  10,  16,  32); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 12] = psi.g_tchannel(no_ps,   0,  48,   5,  10,  32,  16); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 13] = psi.g_tchannel_opt(no_ps,   0,  28,   2,  33,   8,  20); /* ntp 1 */} // 2 times
  {psi_g_t[no_ps][ 14] = psi.g_tchannel(no_ps,   0,  20,  33,  10,   4,  16); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 15] = psi.g_tchannel_opt(no_ps,   0,  60,   1,   2,  16,  44); /* ntp 0 */} // 6 times
  {psi_g_t[no_ps][ 16] = psi.g_tchannel_opt(no_ps,   0,  44,   2,  17,  32,  12); /* ntp 1 */} // 2 times
  {psi_g_t[no_ps][ 17] = psi.g_tchannel(no_ps,   0,  12,  17,  34,   4,   8); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 18] = psi.g_tchannel_opt(no_ps,   0,  44,   2,  17,   8,  36); /* ntp 1 */} // 2 times
  {psi_g_t[no_ps][ 19] = psi.g_tchannel(no_ps,   0,  36,  17,  10,   4,  32); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 20] = psi.g_tchannel(no_ps,   0,  36,  17,  10,  32,   4); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 21] = psi.g_tchannel(no_ps,   0,  20,  33,  10,  16,   4); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 22] = psi.g_tchannel_opt(no_ps,   0,  60,   1,   2,   8,  52); /* ntp 0 */} // 8 times
  {psi_g_t[no_ps][ 23] = psi.g_tchannel_opt(no_ps,   0,  52,   2,   9,  32,  20); /* ntp 1 */} // 2 times
  {psi_g_t[no_ps][ 24] = psi.g_tchannel(no_ps,   0,  20,   9,  34,   4,  16); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 25] = psi.g_tchannel_opt(no_ps,   0,  52,   2,   9,  16,  36); /* ntp 1 */} // 2 times
  {psi_g_t[no_ps][ 26] = psi.g_tchannel(no_ps,   0,  36,   9,  18,   4,  32); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 27] = psi.g_tchannel(no_ps,   0,  36,   9,  18,  32,   4); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 28] = psi.g_tchannel(no_ps,   0,  12,  33,  18,   8,   4); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 29] = psi.g_tchannel(no_ps,   0,  20,   9,  34,  16,   4); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 30] = psi.g_tchannel_opt(no_ps,   0,  52,   2,   9,   4,  48); /* ntp 1 */} // 3 times
  {psi_g_t[no_ps][ 31] = psi.g_tchannel(no_ps,   0,  48,   9,   6,  16,  32); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 32] = psi.g_tchannel(no_ps,   0,  48,   9,   6,  32,  16); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 33] = psi.g_tchannel_opt(no_ps,   0,  28,   2,  33,   4,  24); /* ntp 1 */} // 2 times
  {psi_g_t[no_ps][ 34] = psi.g_tchannel(no_ps,   0,  24,  33,   6,   8,  16); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 35] = psi.g_tchannel(no_ps,   0,  12,  17,  34,   8,   4); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 36] = psi.g_tchannel_opt(no_ps,   0,  44,   2,  17,   4,  40); /* ntp 1 */} // 2 times
  {psi_g_t[no_ps][ 37] = psi.g_tchannel(no_ps,   0,  40,  17,   6,   8,  32); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 38] = psi.g_tchannel(no_ps,   0,  40,  17,   6,  32,   8); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 39] = psi.g_tchannel(no_ps,   0,  24,  33,   6,  16,   8); /* ntp 2 */} // 1 times
  {psi_g_t[no_ps][ 40] = psi.g_tchannel_opt(no_ps,   0,  60,   2,   1,   8,  52); /* ntp 0 */} // 1 times
  {psi_g_t[no_ps][ 41] = psi.g_tchannel_opt(no_ps,   0,  52,   1,  10,  48,   4); /* ntp 1 */} // 1 times
  {psi_g_t[no_ps][ 42] = psi.g_tchannel_opt(no_ps,   0,  60,   2,   1,   4,  56); /* ntp 0 */} // 1 times
  {psi_g_t[no_ps][ 43] = psi.g_tchannel_opt(no_ps,   0,  56,   1,   6,  48,   8); /* ntp 1 */} // 1 times
  {psi_g_t[no_ps][ 44] = psi.g_tchannel_opt(no_ps,   0,  56,   2,   5,  48,   8); /* ntp 1 */} // 1 times
  {psi_g_t[no_ps][ 45] = psi.g_tchannel_opt(no_ps,   0,  52,   2,   9,  48,   4); /* ntp 1 */} // 1 times

  //  vector<double> g_d(1);
  {psi_g_d[no_ps][  0] = psi.g_decay(no_ps,  48,  16,  32); /* ndp 2 */} // 6 times


  if (psi_weight_IS == 2 || psi_weight_IS == 4){
    double g_IS_temp;
    vector<vector<double> > inv_r(4);
    inv_r[0].resize(1);
    inv_r[1].resize(18);
    inv_r[2].resize(92);
    inv_r[3].resize(2);

    {psi.inv_propagator(no_ps,   0,  48, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0], inv_r[0][0]);} // 6 times

    {psi.inv_timelikeinvariant(no_ps,  24, psi_v_smin[no_ps][  1], psi_v_smax[no_ps][  1], inv_r[1][0]);} // 4 times
    {psi.inv_timelikeinvariant(no_ps,  56, psi_v_smin[no_ps][  2], psi_v_smax[no_ps][  2], inv_r[1][1]);} // 2 times
    {psi.inv_timelikeinvariant(no_ps,  40, psi_v_smin[no_ps][  3], psi_v_smax[no_ps][  3], inv_r[1][2]);} // 4 times
    {psi.inv_timelikeinvariant(no_ps,  56, psi_v_smin[no_ps][  4], psi_v_smax[no_ps][  2], inv_r[1][3]);} // 2 times
    {psi.inv_timelikeinvariant(no_ps,  12, psi_v_smin[no_ps][  5], psi_v_smax[no_ps][  4], inv_r[1][4]);} // 4 times
    {psi.inv_timelikeinvariant(no_ps,  28, psi_v_smin[no_ps][  6], psi_v_smax[no_ps][  5], inv_r[1][5]);} // 2 times
    {psi.inv_timelikeinvariant(no_ps,  48, psi_v_smin[no_ps][  0], psi_v_smax[no_ps][  0], inv_r[1][6]);} // 4 times
    {psi.inv_timelikeinvariant(no_ps,  56, psi_v_smin[no_ps][  7], psi_v_smax[no_ps][  2], inv_r[1][7]);} // 5 times
    {psi.inv_timelikeinvariant(no_ps,  20, psi_v_smin[no_ps][  8], psi_v_smax[no_ps][  6], inv_r[1][8]);} // 4 times
    {psi.inv_timelikeinvariant(no_ps,  28, psi_v_smin[no_ps][  9], psi_v_smax[no_ps][  5], inv_r[1][9]);} // 2 times
    {psi.inv_timelikeinvariant(no_ps,  44, psi_v_smin[no_ps][ 10], psi_v_smax[no_ps][  7], inv_r[1][10]);} // 2 times
    {psi.inv_timelikeinvariant(no_ps,  36, psi_v_smin[no_ps][ 11], psi_v_smax[no_ps][  8], inv_r[1][11]);} // 4 times
    {psi.inv_timelikeinvariant(no_ps,  44, psi_v_smin[no_ps][ 12], psi_v_smax[no_ps][  7], inv_r[1][12]);} // 2 times
    {psi.inv_timelikeinvariant(no_ps,  52, psi_v_smin[no_ps][ 13], psi_v_smax[no_ps][  9], inv_r[1][13]);} // 2 times
    {psi.inv_timelikeinvariant(no_ps,  52, psi_v_smin[no_ps][ 14], psi_v_smax[no_ps][  9], inv_r[1][14]);} // 2 times
    {psi.inv_timelikeinvariant(no_ps,  52, psi_v_smin[no_ps][ 15], psi_v_smax[no_ps][  9], inv_r[1][15]);} // 5 times
    {psi.inv_timelikeinvariant(no_ps,  28, psi_v_smin[no_ps][ 16], psi_v_smax[no_ps][  5], inv_r[1][16]);} // 2 times
    {psi.inv_timelikeinvariant(no_ps,  44, psi_v_smin[no_ps][ 17], psi_v_smax[no_ps][  7], inv_r[1][17]);} // 2 times

    {psi.inv_tchannel_opt(no_ps,   0,  60,   1,   2,   4,  56, inv_r[2][0], inv_r[2][1]);} // 8 times
    {psi.inv_tchannel_opt(no_ps,   0,  56,   2,   5,  32,  24, inv_r[2][2], inv_r[2][3]);} // 2 times
    {psi.inv_tchannel(no_ps,   0,  24,   5,  34,   8,  16, inv_r[2][4], inv_r[2][5]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  56,   2,   5,  16,  40, inv_r[2][6], inv_r[2][7]);} // 2 times
    {psi.inv_tchannel(no_ps,   0,  40,   5,  18,   8,  32, inv_r[2][8], inv_r[2][9]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  40,   5,  18,  32,   8, inv_r[2][10], inv_r[2][11]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  60,   1,   2,  32,  28, inv_r[2][12], inv_r[2][13]);} // 6 times
    {psi.inv_tchannel_opt(no_ps,   0,  28,   2,  33,  16,  12, inv_r[2][14], inv_r[2][15]);} // 2 times
    {psi.inv_tchannel(no_ps,   0,  12,  33,  18,   4,   8, inv_r[2][16], inv_r[2][17]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  24,   5,  34,  16,   8, inv_r[2][18], inv_r[2][19]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  56,   2,   5,   8,  48, inv_r[2][20], inv_r[2][21]);} // 3 times
    {psi.inv_tchannel(no_ps,   0,  48,   5,  10,  16,  32, inv_r[2][22], inv_r[2][23]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  48,   5,  10,  32,  16, inv_r[2][24], inv_r[2][25]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  28,   2,  33,   8,  20, inv_r[2][26], inv_r[2][27]);} // 2 times
    {psi.inv_tchannel(no_ps,   0,  20,  33,  10,   4,  16, inv_r[2][28], inv_r[2][29]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  60,   1,   2,  16,  44, inv_r[2][30], inv_r[2][31]);} // 6 times
    {psi.inv_tchannel_opt(no_ps,   0,  44,   2,  17,  32,  12, inv_r[2][32], inv_r[2][33]);} // 2 times
    {psi.inv_tchannel(no_ps,   0,  12,  17,  34,   4,   8, inv_r[2][34], inv_r[2][35]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  44,   2,  17,   8,  36, inv_r[2][36], inv_r[2][37]);} // 2 times
    {psi.inv_tchannel(no_ps,   0,  36,  17,  10,   4,  32, inv_r[2][38], inv_r[2][39]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  36,  17,  10,  32,   4, inv_r[2][40], inv_r[2][41]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  20,  33,  10,  16,   4, inv_r[2][42], inv_r[2][43]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  60,   1,   2,   8,  52, inv_r[2][44], inv_r[2][45]);} // 8 times
    {psi.inv_tchannel_opt(no_ps,   0,  52,   2,   9,  32,  20, inv_r[2][46], inv_r[2][47]);} // 2 times
    {psi.inv_tchannel(no_ps,   0,  20,   9,  34,   4,  16, inv_r[2][48], inv_r[2][49]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  52,   2,   9,  16,  36, inv_r[2][50], inv_r[2][51]);} // 2 times
    {psi.inv_tchannel(no_ps,   0,  36,   9,  18,   4,  32, inv_r[2][52], inv_r[2][53]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  36,   9,  18,  32,   4, inv_r[2][54], inv_r[2][55]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  12,  33,  18,   8,   4, inv_r[2][56], inv_r[2][57]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  20,   9,  34,  16,   4, inv_r[2][58], inv_r[2][59]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  52,   2,   9,   4,  48, inv_r[2][60], inv_r[2][61]);} // 3 times
    {psi.inv_tchannel(no_ps,   0,  48,   9,   6,  16,  32, inv_r[2][62], inv_r[2][63]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  48,   9,   6,  32,  16, inv_r[2][64], inv_r[2][65]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  28,   2,  33,   4,  24, inv_r[2][66], inv_r[2][67]);} // 2 times
    {psi.inv_tchannel(no_ps,   0,  24,  33,   6,   8,  16, inv_r[2][68], inv_r[2][69]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  12,  17,  34,   8,   4, inv_r[2][70], inv_r[2][71]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  44,   2,  17,   4,  40, inv_r[2][72], inv_r[2][73]);} // 2 times
    {psi.inv_tchannel(no_ps,   0,  40,  17,   6,   8,  32, inv_r[2][74], inv_r[2][75]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  40,  17,   6,  32,   8, inv_r[2][76], inv_r[2][77]);} // 1 times
    {psi.inv_tchannel(no_ps,   0,  24,  33,   6,  16,   8, inv_r[2][78], inv_r[2][79]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  60,   2,   1,   8,  52, inv_r[2][80], inv_r[2][81]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  52,   1,  10,  48,   4, inv_r[2][82], inv_r[2][83]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  60,   2,   1,   4,  56, inv_r[2][84], inv_r[2][85]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  56,   1,   6,  48,   8, inv_r[2][86], inv_r[2][87]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  56,   2,   5,  48,   8, inv_r[2][88], inv_r[2][89]);} // 1 times
    {psi.inv_tchannel_opt(no_ps,   0,  52,   2,   9,  48,   4, inv_r[2][90], inv_r[2][91]);} // 1 times

    {psi.inv_decay(no_ps,  48,  16,  32, inv_r[3][0], inv_r[3][1]);} // 6 times

    if (psi_weight_IS == 2){
      int n_random = 3 * psi_n_particle - 4;;
      vector<vector<double> > inv_channel_r(30, vector<double> (8));
      vector<double> g_IS(30, 1.);
      for (int i_c = 0; i_c < 30; i_c++){
        int ran = 0;
        if (psi_MC_alpha[zero + i_c] != 0.){
          for (int i_p = 0; i_p < psi_c_p[no_ps][i_c].size(); i_p++){
            inv_channel_r[i_c][i_p] = inv_r[0][psi_c_p[no_ps][i_c][i_p]];
          }
          ran += psi_c_p[no_ps][i_c].size();
          for (int i_f = 0; i_f < psi_c_f[no_ps][i_c].size(); i_f++){
            inv_channel_r[i_c][ran + i_f] = inv_r[1][psi_c_f[no_ps][i_c][i_f]];
          }
          ran += psi_c_f[no_ps][i_c].size();
          for (int i_t = 0; i_t < psi_c_t[no_ps][i_c].size(); i_t++){
            inv_channel_r[i_c][ran + 2 * i_t] = inv_r[2][2 * psi_c_t[no_ps][i_c][i_t]];
            inv_channel_r[i_c][ran + 2 * i_t + 1] = inv_r[2][2 * psi_c_t[no_ps][i_c][i_t] + 1];
          }
          ran += 2 * psi_c_t[no_ps][i_c].size();
          for (int i_d = 0; i_d < psi_c_d[no_ps][i_c].size(); i_d++){
            inv_channel_r[i_c][ran + 2 * i_d] = inv_r[3][2 * psi_c_d[no_ps][i_c][i_d]];
            inv_channel_r[i_c][ran + 2 * i_d + 1] = inv_r[3][2 * psi_c_d[no_ps][i_c][i_d] + 1];
          }
          ran += 2 * psi_c_d[no_ps][i_c].size();
          for (int i_r = 0; i_r < 8; i_r++){
            psi_phasespace_randoms[(zero + i_c) * n_random + i_r]->get_g_IS(inv_channel_r[i_c][i_r], g_IS_temp);
            g_IS[i_c] *= g_IS_temp;
          }
        }
      }
      if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = g_IS[  0] * psi_g_f[no_ps][  0] * psi_g_f[no_ps][  1] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  1] * psi_g_t[no_ps][  2];}
      if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = g_IS[  1] * psi_g_f[no_ps][  2] * psi_g_f[no_ps][  3] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  3] * psi_g_t[no_ps][  4];}
      if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = g_IS[  2] * psi_g_f[no_ps][  2] * psi_g_f[no_ps][  3] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  3] * psi_g_t[no_ps][  5];}
      if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = g_IS[  3] * psi_g_f[no_ps][  4] * psi_g_f[no_ps][  5] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][  7] * psi_g_t[no_ps][  8];}
      if (psi_MC_alpha[zero +   4] != 0.){psi_MC_g_channel[zero +   4] = g_IS[  4] * psi_g_f[no_ps][  0] * psi_g_f[no_ps][  1] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  1] * psi_g_t[no_ps][  9];}
      if (psi_MC_alpha[zero +   5] != 0.){psi_MC_g_channel[zero +   5] = g_IS[  5] * psi_g_f[no_ps][  6] * psi_g_f[no_ps][  7] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][ 10] * psi_g_t[no_ps][ 11];}
      if (psi_MC_alpha[zero +   6] != 0.){psi_MC_g_channel[zero +   6] = g_IS[  6] * psi_g_f[no_ps][  6] * psi_g_f[no_ps][  7] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][ 10] * psi_g_t[no_ps][ 12];}
      if (psi_MC_alpha[zero +   7] != 0.){psi_MC_g_channel[zero +   7] = g_IS[  7] * psi_g_f[no_ps][  8] * psi_g_f[no_ps][  9] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][ 13] * psi_g_t[no_ps][ 14];}
      if (psi_MC_alpha[zero +   8] != 0.){psi_MC_g_channel[zero +   8] = g_IS[  8] * psi_g_f[no_ps][  4] * psi_g_f[no_ps][ 10] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 16] * psi_g_t[no_ps][ 17];}
      if (psi_MC_alpha[zero +   9] != 0.){psi_MC_g_channel[zero +   9] = g_IS[  9] * psi_g_f[no_ps][ 11] * psi_g_f[no_ps][ 12] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 18] * psi_g_t[no_ps][ 19];}
      if (psi_MC_alpha[zero +  10] != 0.){psi_MC_g_channel[zero +  10] = g_IS[ 10] * psi_g_f[no_ps][ 11] * psi_g_f[no_ps][ 12] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 18] * psi_g_t[no_ps][ 20];}
      if (psi_MC_alpha[zero +  11] != 0.){psi_MC_g_channel[zero +  11] = g_IS[ 11] * psi_g_f[no_ps][  8] * psi_g_f[no_ps][  9] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][ 13] * psi_g_t[no_ps][ 21];}
      if (psi_MC_alpha[zero +  12] != 0.){psi_MC_g_channel[zero +  12] = g_IS[ 12] * psi_g_f[no_ps][  8] * psi_g_f[no_ps][ 13] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 23] * psi_g_t[no_ps][ 24];}
      if (psi_MC_alpha[zero +  13] != 0.){psi_MC_g_channel[zero +  13] = g_IS[ 13] * psi_g_f[no_ps][ 11] * psi_g_f[no_ps][ 14] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 25] * psi_g_t[no_ps][ 26];}
      if (psi_MC_alpha[zero +  14] != 0.){psi_MC_g_channel[zero +  14] = g_IS[ 14] * psi_g_f[no_ps][ 11] * psi_g_f[no_ps][ 14] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 25] * psi_g_t[no_ps][ 27];}
      if (psi_MC_alpha[zero +  15] != 0.){psi_MC_g_channel[zero +  15] = g_IS[ 15] * psi_g_f[no_ps][  4] * psi_g_f[no_ps][  5] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][  7] * psi_g_t[no_ps][ 28];}
      if (psi_MC_alpha[zero +  16] != 0.){psi_MC_g_channel[zero +  16] = g_IS[ 16] * psi_g_f[no_ps][  8] * psi_g_f[no_ps][ 13] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 23] * psi_g_t[no_ps][ 29];}
      if (psi_MC_alpha[zero +  17] != 0.){psi_MC_g_channel[zero +  17] = g_IS[ 17] * psi_g_f[no_ps][  6] * psi_g_f[no_ps][ 15] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 30] * psi_g_t[no_ps][ 31];}
      if (psi_MC_alpha[zero +  18] != 0.){psi_MC_g_channel[zero +  18] = g_IS[ 18] * psi_g_f[no_ps][  6] * psi_g_f[no_ps][ 15] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 30] * psi_g_t[no_ps][ 32];}
      if (psi_MC_alpha[zero +  19] != 0.){psi_MC_g_channel[zero +  19] = g_IS[ 19] * psi_g_f[no_ps][  0] * psi_g_f[no_ps][ 16] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][ 33] * psi_g_t[no_ps][ 34];}
      if (psi_MC_alpha[zero +  20] != 0.){psi_MC_g_channel[zero +  20] = g_IS[ 20] * psi_g_f[no_ps][  4] * psi_g_f[no_ps][ 10] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 16] * psi_g_t[no_ps][ 35];}
      if (psi_MC_alpha[zero +  21] != 0.){psi_MC_g_channel[zero +  21] = g_IS[ 21] * psi_g_f[no_ps][  2] * psi_g_f[no_ps][ 17] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 36] * psi_g_t[no_ps][ 37];}
      if (psi_MC_alpha[zero +  22] != 0.){psi_MC_g_channel[zero +  22] = g_IS[ 22] * psi_g_f[no_ps][  2] * psi_g_f[no_ps][ 17] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 36] * psi_g_t[no_ps][ 38];}
      if (psi_MC_alpha[zero +  23] != 0.){psi_MC_g_channel[zero +  23] = g_IS[ 23] * psi_g_f[no_ps][  0] * psi_g_f[no_ps][ 16] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][ 33] * psi_g_t[no_ps][ 39];}
      if (psi_MC_alpha[zero +  24] != 0.){psi_MC_g_channel[zero +  24] = g_IS[ 24] * psi_g_p[no_ps][  0] * psi_g_f[no_ps][ 15] * psi_g_t[no_ps][ 40] * psi_g_t[no_ps][ 41] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +  25] != 0.){psi_MC_g_channel[zero +  25] = g_IS[ 25] * psi_g_p[no_ps][  0] * psi_g_f[no_ps][  7] * psi_g_t[no_ps][ 42] * psi_g_t[no_ps][ 43] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +  26] != 0.){psi_MC_g_channel[zero +  26] = g_IS[ 26] * psi_g_p[no_ps][  0] * psi_g_f[no_ps][  7] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][ 10] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +  27] != 0.){psi_MC_g_channel[zero +  27] = g_IS[ 27] * psi_g_p[no_ps][  0] * psi_g_f[no_ps][ 15] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 30] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +  28] != 0.){psi_MC_g_channel[zero +  28] = g_IS[ 28] * psi_g_p[no_ps][  0] * psi_g_f[no_ps][  7] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][ 44] * psi_g_d[no_ps][  0];}
      if (psi_MC_alpha[zero +  29] != 0.){psi_MC_g_channel[zero +  29] = g_IS[ 29] * psi_g_p[no_ps][  0] * psi_g_f[no_ps][ 15] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 45] * psi_g_d[no_ps][  0];}

    }
    else if (psi_weight_IS == 4){
      vector<vector<double> > g_IS(4);
      g_IS[0].resize(1, 1.);
      g_IS[1].resize(18, 1.);
      g_IS[2].resize(46, 1.);
      g_IS[3].resize(1, 1.);

      for (int i_m = 0; i_m < 4; i_m++){
        for (int i_r = 0; i_r < inv_r[i_m].size(); i_r++){
          psi_phasespace_randoms[psi_container_IS_startvalue[no_ps][i_m] + i_r]->get_g_IS(inv_r[i_m][i_r], g_IS_temp);
          int i_g = i_r;
          if (i_m > 1){i_g = i_r / 2;}
          g_IS[i_m][i_g] *= g_IS_temp;
        }
      }
      if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = psi_g_f[no_ps][  0] * g_IS[1][  0] * psi_g_f[no_ps][  1] * g_IS[1][  1] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_t[no_ps][  1] * g_IS[2][  1] * psi_g_t[no_ps][  2] * g_IS[2][  2];}
      if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = psi_g_f[no_ps][  2] * g_IS[1][  2] * psi_g_f[no_ps][  3] * g_IS[1][  3] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_t[no_ps][  3] * g_IS[2][  3] * psi_g_t[no_ps][  4] * g_IS[2][  4];}
      if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = psi_g_f[no_ps][  2] * g_IS[1][  2] * psi_g_f[no_ps][  3] * g_IS[1][  3] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_t[no_ps][  3] * g_IS[2][  3] * psi_g_t[no_ps][  5] * g_IS[2][  5];}
      if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = psi_g_f[no_ps][  4] * g_IS[1][  4] * psi_g_f[no_ps][  5] * g_IS[1][  5] * psi_g_t[no_ps][  6] * g_IS[2][  6] * psi_g_t[no_ps][  7] * g_IS[2][  7] * psi_g_t[no_ps][  8] * g_IS[2][  8];}
      if (psi_MC_alpha[zero +   4] != 0.){psi_MC_g_channel[zero +   4] = psi_g_f[no_ps][  0] * g_IS[1][  0] * psi_g_f[no_ps][  1] * g_IS[1][  1] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_t[no_ps][  1] * g_IS[2][  1] * psi_g_t[no_ps][  9] * g_IS[2][  9];}
      if (psi_MC_alpha[zero +   5] != 0.){psi_MC_g_channel[zero +   5] = psi_g_f[no_ps][  6] * g_IS[1][  6] * psi_g_f[no_ps][  7] * g_IS[1][  7] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_t[no_ps][ 10] * g_IS[2][ 10] * psi_g_t[no_ps][ 11] * g_IS[2][ 11];}
      if (psi_MC_alpha[zero +   6] != 0.){psi_MC_g_channel[zero +   6] = psi_g_f[no_ps][  6] * g_IS[1][  6] * psi_g_f[no_ps][  7] * g_IS[1][  7] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_t[no_ps][ 10] * g_IS[2][ 10] * psi_g_t[no_ps][ 12] * g_IS[2][ 12];}
      if (psi_MC_alpha[zero +   7] != 0.){psi_MC_g_channel[zero +   7] = psi_g_f[no_ps][  8] * g_IS[1][  8] * psi_g_f[no_ps][  9] * g_IS[1][  9] * psi_g_t[no_ps][  6] * g_IS[2][  6] * psi_g_t[no_ps][ 13] * g_IS[2][ 13] * psi_g_t[no_ps][ 14] * g_IS[2][ 14];}
      if (psi_MC_alpha[zero +   8] != 0.){psi_MC_g_channel[zero +   8] = psi_g_f[no_ps][  4] * g_IS[1][  4] * psi_g_f[no_ps][ 10] * g_IS[1][ 10] * psi_g_t[no_ps][ 15] * g_IS[2][ 15] * psi_g_t[no_ps][ 16] * g_IS[2][ 16] * psi_g_t[no_ps][ 17] * g_IS[2][ 17];}
      if (psi_MC_alpha[zero +   9] != 0.){psi_MC_g_channel[zero +   9] = psi_g_f[no_ps][ 11] * g_IS[1][ 11] * psi_g_f[no_ps][ 12] * g_IS[1][ 12] * psi_g_t[no_ps][ 15] * g_IS[2][ 15] * psi_g_t[no_ps][ 18] * g_IS[2][ 18] * psi_g_t[no_ps][ 19] * g_IS[2][ 19];}
      if (psi_MC_alpha[zero +  10] != 0.){psi_MC_g_channel[zero +  10] = psi_g_f[no_ps][ 11] * g_IS[1][ 11] * psi_g_f[no_ps][ 12] * g_IS[1][ 12] * psi_g_t[no_ps][ 15] * g_IS[2][ 15] * psi_g_t[no_ps][ 18] * g_IS[2][ 18] * psi_g_t[no_ps][ 20] * g_IS[2][ 20];}
      if (psi_MC_alpha[zero +  11] != 0.){psi_MC_g_channel[zero +  11] = psi_g_f[no_ps][  8] * g_IS[1][  8] * psi_g_f[no_ps][  9] * g_IS[1][  9] * psi_g_t[no_ps][  6] * g_IS[2][  6] * psi_g_t[no_ps][ 13] * g_IS[2][ 13] * psi_g_t[no_ps][ 21] * g_IS[2][ 21];}
      if (psi_MC_alpha[zero +  12] != 0.){psi_MC_g_channel[zero +  12] = psi_g_f[no_ps][  8] * g_IS[1][  8] * psi_g_f[no_ps][ 13] * g_IS[1][ 13] * psi_g_t[no_ps][ 22] * g_IS[2][ 22] * psi_g_t[no_ps][ 23] * g_IS[2][ 23] * psi_g_t[no_ps][ 24] * g_IS[2][ 24];}
      if (psi_MC_alpha[zero +  13] != 0.){psi_MC_g_channel[zero +  13] = psi_g_f[no_ps][ 11] * g_IS[1][ 11] * psi_g_f[no_ps][ 14] * g_IS[1][ 14] * psi_g_t[no_ps][ 22] * g_IS[2][ 22] * psi_g_t[no_ps][ 25] * g_IS[2][ 25] * psi_g_t[no_ps][ 26] * g_IS[2][ 26];}
      if (psi_MC_alpha[zero +  14] != 0.){psi_MC_g_channel[zero +  14] = psi_g_f[no_ps][ 11] * g_IS[1][ 11] * psi_g_f[no_ps][ 14] * g_IS[1][ 14] * psi_g_t[no_ps][ 22] * g_IS[2][ 22] * psi_g_t[no_ps][ 25] * g_IS[2][ 25] * psi_g_t[no_ps][ 27] * g_IS[2][ 27];}
      if (psi_MC_alpha[zero +  15] != 0.){psi_MC_g_channel[zero +  15] = psi_g_f[no_ps][  4] * g_IS[1][  4] * psi_g_f[no_ps][  5] * g_IS[1][  5] * psi_g_t[no_ps][  6] * g_IS[2][  6] * psi_g_t[no_ps][  7] * g_IS[2][  7] * psi_g_t[no_ps][ 28] * g_IS[2][ 28];}
      if (psi_MC_alpha[zero +  16] != 0.){psi_MC_g_channel[zero +  16] = psi_g_f[no_ps][  8] * g_IS[1][  8] * psi_g_f[no_ps][ 13] * g_IS[1][ 13] * psi_g_t[no_ps][ 22] * g_IS[2][ 22] * psi_g_t[no_ps][ 23] * g_IS[2][ 23] * psi_g_t[no_ps][ 29] * g_IS[2][ 29];}
      if (psi_MC_alpha[zero +  17] != 0.){psi_MC_g_channel[zero +  17] = psi_g_f[no_ps][  6] * g_IS[1][  6] * psi_g_f[no_ps][ 15] * g_IS[1][ 15] * psi_g_t[no_ps][ 22] * g_IS[2][ 22] * psi_g_t[no_ps][ 30] * g_IS[2][ 30] * psi_g_t[no_ps][ 31] * g_IS[2][ 31];}
      if (psi_MC_alpha[zero +  18] != 0.){psi_MC_g_channel[zero +  18] = psi_g_f[no_ps][  6] * g_IS[1][  6] * psi_g_f[no_ps][ 15] * g_IS[1][ 15] * psi_g_t[no_ps][ 22] * g_IS[2][ 22] * psi_g_t[no_ps][ 30] * g_IS[2][ 30] * psi_g_t[no_ps][ 32] * g_IS[2][ 32];}
      if (psi_MC_alpha[zero +  19] != 0.){psi_MC_g_channel[zero +  19] = psi_g_f[no_ps][  0] * g_IS[1][  0] * psi_g_f[no_ps][ 16] * g_IS[1][ 16] * psi_g_t[no_ps][  6] * g_IS[2][  6] * psi_g_t[no_ps][ 33] * g_IS[2][ 33] * psi_g_t[no_ps][ 34] * g_IS[2][ 34];}
      if (psi_MC_alpha[zero +  20] != 0.){psi_MC_g_channel[zero +  20] = psi_g_f[no_ps][  4] * g_IS[1][  4] * psi_g_f[no_ps][ 10] * g_IS[1][ 10] * psi_g_t[no_ps][ 15] * g_IS[2][ 15] * psi_g_t[no_ps][ 16] * g_IS[2][ 16] * psi_g_t[no_ps][ 35] * g_IS[2][ 35];}
      if (psi_MC_alpha[zero +  21] != 0.){psi_MC_g_channel[zero +  21] = psi_g_f[no_ps][  2] * g_IS[1][  2] * psi_g_f[no_ps][ 17] * g_IS[1][ 17] * psi_g_t[no_ps][ 15] * g_IS[2][ 15] * psi_g_t[no_ps][ 36] * g_IS[2][ 36] * psi_g_t[no_ps][ 37] * g_IS[2][ 37];}
      if (psi_MC_alpha[zero +  22] != 0.){psi_MC_g_channel[zero +  22] = psi_g_f[no_ps][  2] * g_IS[1][  2] * psi_g_f[no_ps][ 17] * g_IS[1][ 17] * psi_g_t[no_ps][ 15] * g_IS[2][ 15] * psi_g_t[no_ps][ 36] * g_IS[2][ 36] * psi_g_t[no_ps][ 38] * g_IS[2][ 38];}
      if (psi_MC_alpha[zero +  23] != 0.){psi_MC_g_channel[zero +  23] = psi_g_f[no_ps][  0] * g_IS[1][  0] * psi_g_f[no_ps][ 16] * g_IS[1][ 16] * psi_g_t[no_ps][  6] * g_IS[2][  6] * psi_g_t[no_ps][ 33] * g_IS[2][ 33] * psi_g_t[no_ps][ 39] * g_IS[2][ 39];}
      if (psi_MC_alpha[zero +  24] != 0.){psi_MC_g_channel[zero +  24] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_f[no_ps][ 15] * g_IS[1][ 15] * psi_g_t[no_ps][ 40] * g_IS[2][ 40] * psi_g_t[no_ps][ 41] * g_IS[2][ 41] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +  25] != 0.){psi_MC_g_channel[zero +  25] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_f[no_ps][  7] * g_IS[1][  7] * psi_g_t[no_ps][ 42] * g_IS[2][ 42] * psi_g_t[no_ps][ 43] * g_IS[2][ 43] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +  26] != 0.){psi_MC_g_channel[zero +  26] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_f[no_ps][  7] * g_IS[1][  7] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_t[no_ps][ 10] * g_IS[2][ 10] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +  27] != 0.){psi_MC_g_channel[zero +  27] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_f[no_ps][ 15] * g_IS[1][ 15] * psi_g_t[no_ps][ 22] * g_IS[2][ 22] * psi_g_t[no_ps][ 30] * g_IS[2][ 30] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +  28] != 0.){psi_MC_g_channel[zero +  28] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_f[no_ps][  7] * g_IS[1][  7] * psi_g_t[no_ps][  0] * g_IS[2][  0] * psi_g_t[no_ps][ 44] * g_IS[2][ 44] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
      if (psi_MC_alpha[zero +  29] != 0.){psi_MC_g_channel[zero +  29] = psi_g_p[no_ps][  0] * g_IS[0][  0] * psi_g_f[no_ps][ 15] * g_IS[1][ 15] * psi_g_t[no_ps][ 22] * g_IS[2][ 22] * psi_g_t[no_ps][ 45] * g_IS[2][ 45] * psi_g_d[no_ps][  0] * g_IS[3][  0];}
    }
  }

  else {
    if (psi_MC_alpha[zero +   0] != 0.){psi_MC_g_channel[zero +   0] = psi_g_f[no_ps][  0] * psi_g_f[no_ps][  1] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  1] * psi_g_t[no_ps][  2];}
    if (psi_MC_alpha[zero +   1] != 0.){psi_MC_g_channel[zero +   1] = psi_g_f[no_ps][  2] * psi_g_f[no_ps][  3] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  3] * psi_g_t[no_ps][  4];}
    if (psi_MC_alpha[zero +   2] != 0.){psi_MC_g_channel[zero +   2] = psi_g_f[no_ps][  2] * psi_g_f[no_ps][  3] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  3] * psi_g_t[no_ps][  5];}
    if (psi_MC_alpha[zero +   3] != 0.){psi_MC_g_channel[zero +   3] = psi_g_f[no_ps][  4] * psi_g_f[no_ps][  5] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][  7] * psi_g_t[no_ps][  8];}
    if (psi_MC_alpha[zero +   4] != 0.){psi_MC_g_channel[zero +   4] = psi_g_f[no_ps][  0] * psi_g_f[no_ps][  1] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][  1] * psi_g_t[no_ps][  9];}
    if (psi_MC_alpha[zero +   5] != 0.){psi_MC_g_channel[zero +   5] = psi_g_f[no_ps][  6] * psi_g_f[no_ps][  7] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][ 10] * psi_g_t[no_ps][ 11];}
    if (psi_MC_alpha[zero +   6] != 0.){psi_MC_g_channel[zero +   6] = psi_g_f[no_ps][  6] * psi_g_f[no_ps][  7] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][ 10] * psi_g_t[no_ps][ 12];}
    if (psi_MC_alpha[zero +   7] != 0.){psi_MC_g_channel[zero +   7] = psi_g_f[no_ps][  8] * psi_g_f[no_ps][  9] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][ 13] * psi_g_t[no_ps][ 14];}
    if (psi_MC_alpha[zero +   8] != 0.){psi_MC_g_channel[zero +   8] = psi_g_f[no_ps][  4] * psi_g_f[no_ps][ 10] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 16] * psi_g_t[no_ps][ 17];}
    if (psi_MC_alpha[zero +   9] != 0.){psi_MC_g_channel[zero +   9] = psi_g_f[no_ps][ 11] * psi_g_f[no_ps][ 12] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 18] * psi_g_t[no_ps][ 19];}
    if (psi_MC_alpha[zero +  10] != 0.){psi_MC_g_channel[zero +  10] = psi_g_f[no_ps][ 11] * psi_g_f[no_ps][ 12] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 18] * psi_g_t[no_ps][ 20];}
    if (psi_MC_alpha[zero +  11] != 0.){psi_MC_g_channel[zero +  11] = psi_g_f[no_ps][  8] * psi_g_f[no_ps][  9] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][ 13] * psi_g_t[no_ps][ 21];}
    if (psi_MC_alpha[zero +  12] != 0.){psi_MC_g_channel[zero +  12] = psi_g_f[no_ps][  8] * psi_g_f[no_ps][ 13] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 23] * psi_g_t[no_ps][ 24];}
    if (psi_MC_alpha[zero +  13] != 0.){psi_MC_g_channel[zero +  13] = psi_g_f[no_ps][ 11] * psi_g_f[no_ps][ 14] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 25] * psi_g_t[no_ps][ 26];}
    if (psi_MC_alpha[zero +  14] != 0.){psi_MC_g_channel[zero +  14] = psi_g_f[no_ps][ 11] * psi_g_f[no_ps][ 14] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 25] * psi_g_t[no_ps][ 27];}
    if (psi_MC_alpha[zero +  15] != 0.){psi_MC_g_channel[zero +  15] = psi_g_f[no_ps][  4] * psi_g_f[no_ps][  5] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][  7] * psi_g_t[no_ps][ 28];}
    if (psi_MC_alpha[zero +  16] != 0.){psi_MC_g_channel[zero +  16] = psi_g_f[no_ps][  8] * psi_g_f[no_ps][ 13] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 23] * psi_g_t[no_ps][ 29];}
    if (psi_MC_alpha[zero +  17] != 0.){psi_MC_g_channel[zero +  17] = psi_g_f[no_ps][  6] * psi_g_f[no_ps][ 15] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 30] * psi_g_t[no_ps][ 31];}
    if (psi_MC_alpha[zero +  18] != 0.){psi_MC_g_channel[zero +  18] = psi_g_f[no_ps][  6] * psi_g_f[no_ps][ 15] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 30] * psi_g_t[no_ps][ 32];}
    if (psi_MC_alpha[zero +  19] != 0.){psi_MC_g_channel[zero +  19] = psi_g_f[no_ps][  0] * psi_g_f[no_ps][ 16] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][ 33] * psi_g_t[no_ps][ 34];}
    if (psi_MC_alpha[zero +  20] != 0.){psi_MC_g_channel[zero +  20] = psi_g_f[no_ps][  4] * psi_g_f[no_ps][ 10] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 16] * psi_g_t[no_ps][ 35];}
    if (psi_MC_alpha[zero +  21] != 0.){psi_MC_g_channel[zero +  21] = psi_g_f[no_ps][  2] * psi_g_f[no_ps][ 17] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 36] * psi_g_t[no_ps][ 37];}
    if (psi_MC_alpha[zero +  22] != 0.){psi_MC_g_channel[zero +  22] = psi_g_f[no_ps][  2] * psi_g_f[no_ps][ 17] * psi_g_t[no_ps][ 15] * psi_g_t[no_ps][ 36] * psi_g_t[no_ps][ 38];}
    if (psi_MC_alpha[zero +  23] != 0.){psi_MC_g_channel[zero +  23] = psi_g_f[no_ps][  0] * psi_g_f[no_ps][ 16] * psi_g_t[no_ps][  6] * psi_g_t[no_ps][ 33] * psi_g_t[no_ps][ 39];}
    if (psi_MC_alpha[zero +  24] != 0.){psi_MC_g_channel[zero +  24] = psi_g_p[no_ps][  0] * psi_g_f[no_ps][ 15] * psi_g_t[no_ps][ 40] * psi_g_t[no_ps][ 41] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +  25] != 0.){psi_MC_g_channel[zero +  25] = psi_g_p[no_ps][  0] * psi_g_f[no_ps][  7] * psi_g_t[no_ps][ 42] * psi_g_t[no_ps][ 43] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +  26] != 0.){psi_MC_g_channel[zero +  26] = psi_g_p[no_ps][  0] * psi_g_f[no_ps][  7] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][ 10] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +  27] != 0.){psi_MC_g_channel[zero +  27] = psi_g_p[no_ps][  0] * psi_g_f[no_ps][ 15] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 30] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +  28] != 0.){psi_MC_g_channel[zero +  28] = psi_g_p[no_ps][  0] * psi_g_f[no_ps][  7] * psi_g_t[no_ps][  0] * psi_g_t[no_ps][ 44] * psi_g_d[no_ps][  0];}
    if (psi_MC_alpha[zero +  29] != 0.){psi_MC_g_channel[zero +  29] = psi_g_p[no_ps][  0] * psi_g_f[no_ps][ 15] * psi_g_t[no_ps][ 22] * psi_g_t[no_ps][ 45] * psi_g_d[no_ps][  0];}
  }

/*
  if (psi_MC_alpha[   0] != 0.){ag_channel_1111(g, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   1] != 0.){ag_channel_1111(g, 1, 2, 4, 8, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   2] != 0.){ag_channel_1111(g, 1, 2, 4, 32, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   3] != 0.){ag_channel_1111(g, 1, 2, 32, 4, 8, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   4] != 0.){ag_channel_1111(g, 1, 2, 4, 16, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   5] != 0.){ag_channel_1111(g, 1, 2, 4, 16, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   6] != 0.){ag_channel_1111(g, 1, 2, 4, 32, 16, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   7] != 0.){ag_channel_1111(g, 1, 2, 32, 4, 16, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   8] != 0.){ag_channel_1111(g, 1, 2, 16, 4, 8, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[   9] != 0.){ag_channel_1111(g, 1, 2, 16, 4, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  10] != 0.){ag_channel_1111(g, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  11] != 0.){ag_channel_1111(g, 1, 2, 32, 16, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  12] != 0.){ag_channel_1111(g, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  13] != 0.){ag_channel_1111(g, 1, 2, 8, 4, 32, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  14] != 0.){ag_channel_1111(g, 1, 2, 8, 32, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  15] != 0.){ag_channel_1111(g, 1, 2, 32, 8, 4, 16, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  16] != 0.){ag_channel_1111(g, 1, 2, 8, 16, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  17] != 0.){ag_channel_1111(g, 1, 2, 8, 16, 32, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  18] != 0.){ag_channel_1111(g, 1, 2, 8, 32, 16, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  19] != 0.){ag_channel_1111(g, 1, 2, 32, 8, 16, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  20] != 0.){ag_channel_1111(g, 1, 2, 16, 8, 4, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  21] != 0.){ag_channel_1111(g, 1, 2, 16, 8, 32, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  22] != 0.){ag_channel_1111(g, 1, 2, 16, 32, 8, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  23] != 0.){ag_channel_1111(g, 1, 2, 32, 16, 8, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  24] != 0.){ag_channel_2v11(g, 1, 2, 16, 32, 4, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  25] != 0.){ag_channel_2v11(g, 1, 2, 16, 32, 8, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  26] != 0.){ag_channel_12v1(g, 1, 2, 4, 16, 32, 8, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  27] != 0.){ag_channel_12v1(g, 1, 2, 8, 16, 32, 4, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  28] != 0.){ag_channel_112v(g, 1, 2, 4, 8, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  if (psi_MC_alpha[  29] != 0.){ag_channel_112v(g, 1, 2, 8, 4, 16, 32, p, s, sqrts, smin_opt, sqrtsmin_opt,   0,   0,   0, psi);}
  // channel    0: 1111(1, 2, 4, 8, 16, 32;   0,   0,   0)
  // channel    1: 1111(1, 2, 4, 8, 32, 16;   0,   0,   0)
  // channel    2: 1111(1, 2, 4, 32, 8, 16;   0,   0,   0)
  // channel    3: 1111(1, 2, 32, 4, 8, 16;   0,   0,   0)
  // channel    4: 1111(1, 2, 4, 16, 8, 32;   0,   0,   0)
  // channel    5: 1111(1, 2, 4, 16, 32, 8;   0,   0,   0)
  // channel    6: 1111(1, 2, 4, 32, 16, 8;   0,   0,   0)
  // channel    7: 1111(1, 2, 32, 4, 16, 8;   0,   0,   0)
  // channel    8: 1111(1, 2, 16, 4, 8, 32;   0,   0,   0)
  // channel    9: 1111(1, 2, 16, 4, 32, 8;   0,   0,   0)
  // channel   10: 1111(1, 2, 16, 32, 4, 8;   0,   0,   0)
  // channel   11: 1111(1, 2, 32, 16, 4, 8;   0,   0,   0)
  // channel   12: 1111(1, 2, 8, 4, 16, 32;   0,   0,   0)
  // channel   13: 1111(1, 2, 8, 4, 32, 16;   0,   0,   0)
  // channel   14: 1111(1, 2, 8, 32, 4, 16;   0,   0,   0)
  // channel   15: 1111(1, 2, 32, 8, 4, 16;   0,   0,   0)
  // channel   16: 1111(1, 2, 8, 16, 4, 32;   0,   0,   0)
  // channel   17: 1111(1, 2, 8, 16, 32, 4;   0,   0,   0)
  // channel   18: 1111(1, 2, 8, 32, 16, 4;   0,   0,   0)
  // channel   19: 1111(1, 2, 32, 8, 16, 4;   0,   0,   0)
  // channel   20: 1111(1, 2, 16, 8, 4, 32;   0,   0,   0)
  // channel   21: 1111(1, 2, 16, 8, 32, 4;   0,   0,   0)
  // channel   22: 1111(1, 2, 16, 32, 8, 4;   0,   0,   0)
  // channel   23: 1111(1, 2, 32, 16, 8, 4;   0,   0,   0)
  // channel   24: 2v11(1, 2, 16, 32, 4, 8;   0,   0,   0)
  // channel   25: 2v11(1, 2, 16, 32, 8, 4;   0,   0,   0)
  // channel   26: 12v1(1, 2, 4, 16, 32, 8;   0,   0,   0)
  // channel   27: 12v1(1, 2, 8, 16, 32, 4;   0,   0,   0)
  // channel   28: 112v(1, 2, 4, 8, 16, 32;   0,   0,   0)
  // channel   29: 112v(1, 2, 8, 4, 16, 32;   0,   0,   0)
*/

  logger << LOG_DEBUG_VERBOSE << "finished" << endl;
}
